
#ifndef  __PCB_MGR_H__
#define  __PCB_MGR_H__
#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
	PCB_PIN_TYPE_UNUSED = 0,
	PCB_PIN_TYPE_LSADC,
	PCB_PIN_TYPE_EMCU_GPIO,
	PCB_PIN_TYPE_GPIO,
	PCB_PIN_TYPE_ISO_GPIO,
	PCB_PIN_TYPE_UNIPWM,
	PCB_PIN_TYPE_ISO_UNIPWM,
	PCB_PIN_TYPE_PWM,
	PCB_PIN_TYPE_ISO_PWM,
	PCB_PIN_TYPE_AUDIO = 9,
	PCB_PIN_TYPE_ISO2_GPIO = 10,
	PCB_PIN_TYPE_GPI = 11,
	PCB_PIN_TYPE_GPO = 12,
	PCB_PIN_TYPE_ISO_GPI = 13,
	PCB_PIN_TYPE_ISO_GPO = 14,
	PCB_PIN_TYPE_UNDEF = 0xFF,
} PCB_PIN_TYPE_T;

typedef enum {
	PCB_GPIO_TYPE_INPUT,
	PCB_GPIO_TYPE_OUPUT,
	PCB_GPIO_TYPE_TRI_IO,
	PCB_GPIO_TYPE_UNDEF,
} PCB_GPIO_TYPE_T;

/* refer to /linux-4.4.3/include/uapi/linux/input-event-codes.h */
typedef enum {
    KEY_CODE_LEFT       = 105,
    KEY_CODE_RIGHT      = 106,
    KEY_CODE_SELECT     = 353,
    KEY_CODE_POWER      = 116,
    KEY_CODE_UP         = 103,
    KEY_CODE_DOWN       = 108,
    KEY_CODE_ENTER      = 28 ,
    KEY_CODE_BACK       = 158,
    KEY_CODE_VOLUMEDOWN = 114,
    KEY_CODE_VOLUMEUP   = 115,
    KEY_CODE_EXIT       = 174,
    KEY_CODE_MENU       = 139,
    KEY_CODE_ONEKEY     = 755,
}PCB_LSADC_KEY_CODE;

typedef enum {
	PCB_LSADC_TYPE_VOLTAGE,
	PCB_LSADC_TYPE_CURRENT,
	PCB_LSADC_TYPE_UNDEF,
} PCB_LSADC_TYPE_T;

typedef enum{
    ADC_NONE =0,
    /*In this mode lsadc interrupt trigger when the changed value is bigger than the thredhold value which you set */
    ADC_THREDHOLD_MODE = 1,
    /*In this mode lsadc interrupt trigger when value change to a block area which you */
    ADC_BLOCK_MODE = 2,
}PCB_LSADC_IRQ_MODE;

typedef enum {
	PCB_AUDIO_OUTPUT_AOUT_PAD,
	PCB_AUDIO_OUTPUT_SCART_PAD,
} PCB_AUDIO_OUTPUT_PAD_T;

typedef enum {
	PCB_AUDIO_OUPUT_TYPE_DAC0,      //DAC0
	PCB_AUDIO_OUPUT_TYPE_DAC1,      //DAC1
	PCB_AUDIO_OUPUT_TYPE_BYPASS,    //ADCFE1
	PCB_AUDIO_OUPUT_TYPE_UNUSED,
} PCB_AUDIO_OUPUT_TYPE_T;

typedef enum {
    DAC_SOURCE_PB_AF_AVC2_CH01,
    DAC_SOURCE_PB_AF_AVC2_CH23,
    DAC_SOURCE_PB_AF_AVC2_CH45,
    DAC_SOURCE_PB_AF_AVC2_CH67,
    DAC_SOURCE_TS_BF_DVC,
    DAC_SOURCE_TS_AF_DVC,
} PCB_AUDIO_DAC_SOURCE;

typedef enum {
	PCB_DDC_0 = 0,
	PCB_DDC_1,
	PCB_DDC_2,
	PCB_DDC_3,
	PCB_DDC_UNUSED,
} PCB_DDC_ENUM_T;

typedef enum {
	PCB_PWM_CLK_27MHZ = 0,
	PCB_PWM_CLK_196MHZ,
	PCB_PWM_D_CLK_DIV4,
} PWM_CLK_ENUM_T;

typedef enum {
	PCB_I2C_0 = 0,
	PCB_I2C_1,
	PCB_I2C_2,
	PCB_I2C_3,
	PCB_I2C_4,
	PCB_I2C_5,
	PCB_I2C_6,
	PCB_I2C_7,
	PCB_I2C_UNUSED,
} PCB_I2C_ENUM_T;

typedef enum {
	PCB_I2C_TYPE_HW_I2C,
	PCB_I2C_TYPE_GPIO_I2C,
	PCB_I2C_TYPE_UNDEF,
} PCB_I2C_TYPE_T;

typedef enum {
	PCB_I2C_PHY_0 = 0,
	PCB_I2C_PHY_1,
	PCB_I2C_PHY_2,
	PCB_I2C_PHY_3,
	PCB_I2C_PHY_4,
	PCB_I2C_PHY_5,
	PCB_I2C_PHY_UNUSED,
} PCB_I2C_PHY_T;

typedef enum {
	PCB_I2C_SUB_SRC_0 = 0,
	PCB_I2C_SUB_SRC_1,
	PCB_I2C_SUB_SRC_2,
	PCB_I2C_SUB_SRC_3,
	PCB_I2C_SUB_SRC_4,
	PCB_I2C_SUB_SRC_5,
	PCB_I2C_SUB_SRC_6,
	PCB_I2C_SUB_SRC_7,
	PCB_I2C_SUB_SRC_8,
	PCB_I2C_SUB_SRC_9,
	PCB_I2C_SUB_SRC_10,
	PCB_I2C_SUB_SRC_11,
	PCB_I2C_SUB_SRC_12,
	PCB_I2C_SUB_SRC_13,
	PCB_I2C_SUB_SRC_14,
	PCB_I2C_SUB_SRC_ANY,
} PCB_I2C_SUB_SRC_ENUM_T;


#define PCB_EMCU_IR_Key(ukey1,ukey2,ukey3,ukey4,ukey5,ukey6)    \
                                ((((unsigned long long)(ukey6 & 0x3ff)) << 50) | \
                                 (((unsigned long long)(ukey5 & 0x3ff)) << 40) | \
                                 (((unsigned long long)(ukey4 & 0x3ff)) << 30) | \
                                 (((unsigned long long)(ukey3 & 0x3ff)) << 20) | \
                                 (((unsigned long long)(ukey2 & 0x3ff)) << 10) | \
                                 (((unsigned long long)(ukey1 & 0x3ff)) <<  0) )

#define PCB_HW_I2C(phy, src)    (((unsigned long long) (PCB_I2C_TYPE_HW_I2C & 1)<<32) | \
                                 ((unsigned long long) (phy & 0x7) << 4) | \
                                  (unsigned long long) (src & 0xF))

#define PCB_GPIO_I2C(sda, scl)    (((unsigned long long) (PCB_I2C_TYPE_GPIO_I2C & 1)<<32) | \
                                   ((unsigned long long) (sda & 0xFFFF) << 16) | \
                                    (unsigned long long) (scl & 0xFFFF))

#define PCB_PINMUX_GPIO_INFO(pinmux_reg ,s_bit, e_bit, module_val, gpio_val, gpio_type, init_value, gpio_num) \
                                  ((((unsigned long long)(pinmux_reg) << 32)) | \
                                   (((unsigned long long)(s_bit) & 0x1F) << 27) | \
                                    (((unsigned long long)(e_bit) & 0x1F) << 22) | \
                                    (((unsigned long long)(module_val) & 0xF) << 18) | \
                                      (((unsigned long long)(gpio_val) & 0xF) << 14) | \
                                       (((unsigned long long)(gpio_type) & 0xF) << 10) | \
                                       (((unsigned long long)(init_value) & 0x1) << 9) | \
                                        (((unsigned long long)(gpio_num) & 0x1FF)))




#ifndef _HDMI_FUN_H

/*-----------------------------------------------------------------------
 *   HDMI related configuration
 *-----------------------------------------------------------------------*/
typedef enum {
	HDMI_PHY_PORT0 = 0,
	HDMI_PHY_PORT1,
	HDMI_PHY_PORT2,
	HDMI_PHY_PORT3,
	HDMI_PHY_TOTAL_NUM,
	HDMI_PHY_PORT_NOTUSED = HDMI_PHY_TOTAL_NUM
} HDMI_PHY_PORT_T;

typedef enum {
	HDMI_PHY_DDC_0 = 0,
	HDMI_PHY_DDC_1,
	HDMI_PHY_DDC_2,
	HDMI_PHY_DDC_3,
	HDMI_PHY_DDC_UNUSED,
} HDMI_PHY_DDC_T;

typedef enum {
	HDMI_MUX_IC_PORT0 = 0,
	HDMI_MUX_IC_PORT1,
	HDMI_MUX_IC_PORT2,
	HDMI_MUX_IC_PORT3,
	HDMI_MUX_IC_PORT4,
	HDMI_MUX_IC_PORT5,
	HDMI_MUX_IC_PORT6,
	HDMI_MUX_IC_PORT_NOTUSED
} HDMI_MUX_IC_PORT_T;


typedef enum {
	HDMI_EDID_ONCHIP = 0,
	HDMI_EDID_EEPROM,
	HDMI_EDID_I2CMUX,
	HDMI_EDID_DISABLE
} HDMI_EDID_TYPE_T;

typedef enum {
	HDMI_HPD_ONCHIP = 0,
	HDMI_HPD_I2CMUX,
	HDMI_HPD_DISABLE,
} HDMI_HPD_TYPE_T;

typedef enum {
	HDMI_MUX_PS331 = 0,
	HDMI_SWITCH_SiI9199,
	HDMI_MUX_IC_NOUSED,
	HDMI_MUX_NOUSED = HDMI_MUX_IC_NOUSED
} HDMI_MUX_IC_T;

typedef enum {
	HDMI_GPI = 0,
	HDMI_GPO,
	HDMI_GPIO_TYPE_MAX,
} HDMI_GPIO_TYPE_T;

typedef enum {
	NEGATIVE = 0,
	POSITIVE,
	HDMI_GPIO_POLARITY_MAX,
} HDMI_GPIO_POLARITY_T;


typedef enum {
	HDMI_MISC = 0,
	HDMI_ISO,
	HDMI_PIN_TYPE_MAX,
} HDMI_PIN_TYPE_T;

typedef enum {
	HDMI_MUX_PORT0 = 0,
	HDMI_MUX_PORT1,
	HDMI_MUX_PORT2,
	HDMI_MUX_PORT3,
	HDMI_MUX_PORT4,
	HDMI_MUX_PORT5,
	HDMI_MUX_PORT6,
	HDMI_MUX_PORT_NOTUSED
} HDMI_MUX_PORT_T;


/****************************************************************
 * Param   : HDMI_PORT_ORDER
 *
 * Desc    : This parameter is used to describe relation
 *           between logical HDMI channel (e.g. UI channel) and
 *           Physical HDMI port. if this pcb parameter absents,
 *           the HDMI driver will use 0x4321 as default value)
 *
 * Format  : D15:12  : HDMI4 PORT SEL : HDMI Port Config id 1~4
 *           D11:8   : HDMI2 PORT SEL : HDMI Port Config id 1~4
 *           D7:4    : HDMI2 PORT SEL : HDMI Port Config id 1~4
 *           D3:0    : HDMI1 PORT SEL : HDMI Port Config id 1~4
 *
 * Example : HDMI_PORT_ORDER = 0x1234 means
 *           HDMI CH1 = HDMI PORT4 (HDMI4_CFG)
 *           HDMI CH2 = HDMI PORT3 (HDMI3_CFG)
 *           HDMI CH3 = HDMI PORT2 (HDMI2_CFG)
 *           HDMI CH4 = HDMI PORT1 (HDMI1_CFG)
 *****************************************************************/
#define HDMI1_CH_SEL(x)         (x & 0xF)
#define HDMI2_CH_SEL(x)         ((x & 0xF)<<4)
#define HDMI3_CH_SEL(x)         ((x & 0xF)<<8)
#define HDMI4_CH_SEL(x)         ((x & 0xF)<<12)

/**********************HDMI_FLOW_CFG0 format************************
 *  D63:28 : Reserved
 *  D27:24 : HDMI_TMDS_CLK_TOL_MIN, tmds_clock_tolerance_min (0~15)
 *  D23:16 : HDMI_MEAS_ERR_CNT_THD (0~255)
 *  D15:8  : HDMI_STABLE_CNT_THD, stable_cnt_threshold (0~255)
 *  D7:2    : Reserved
 *  D1:0    : HDMI_FLOW_CFG0_VAILD    (0: not support, 1: support.)
 *****************************************************************/
#define HDMI_TMDS_CLK_TOL_MIN(x)          ((unsigned long long)(x & 0xF)<<24)
#define HDMI_MEAS_ERR_CNT_THD(x)          ((unsigned long long)(x & 0xFF)<<16)
#define HDMI_STABLE_CNT_THD(x)              ((unsigned long long)(x & 0xFF)<<8)
#define HDMI_FLOW_CFG0_VAILD(x)            ((unsigned long long) x & 0x1)

/**********************HDMI_FLOW_CFG1 format************************
 *  D63:24 : Reserved
 *  D23:16 : HDMI_DEF_STR_HPD_LOW_10MS    (0~255, Real is 0~2550 ms HPD For DC OFFON STR Resume. )
 *  D15:8  : HDMI_DEF_HPD_LOW_10MS            (0~255, Real is 0~2550 ms HPD For EDID Change )
 *  D7:2    : Reserved
 *  D1:0    : HDMI_FLOW_CFG1_VAILD      (0: not support, 1: support.)
 *****************************************************************/
#define HDMI_DEF_STR_HPD_LOW_10MS(x)   ((unsigned long long)(x & 0xFF)<<16)     //def_str_hpd_10ms
#define HDMI_DEF_HPD_LOW_10MS(x)           ((unsigned long long)(x & 0xFF)<<8)      //def_hpd_low_10ms
#define HDMI_FLOW_CFG1_VAILD(x)              ((unsigned long long) x & 0x1)

/**********************HDMIX_CFG format************************
 *  D63:60  : HDMI_PHY_PORT
 *  D59     : HDMI SUPPORT ARC
 *  D58:56  : HDMI_DDC
 *  D55:54  : HDMI_EDID_TYPE       (0: on chip, 1:EEPROM 2: with MUX, 3:Not used)
 *  D53     : Reserved
 *  D52     : BRSWAP               (0: no BRSWAP, 1: B/R Lane Swap)
 *  D51:49  : Reserved
 *  D48     : HDMI_SUPPORT_EARC
 *  D47:36  : Reserved
 *  D35:32  : Reserved
 *  D31     : DEDICATE_HPD_DET      (1 : use dedicate HPD/DET mothod, 0: use legacy GPIO HPD/DET)
 *  D30     : DEDICATE_HPD_INVERT   (0 : no invert, 1 : invert)
 *  D29:28  : DEDICATE_HPD_DET_SEL  (0~2)
 *  D27     : Reserved
 * ------ the following setting only valid when  DEDICATE_HPD_DET=0 ------
 *  D26     : Reserved
 *  D25     : DET_GPIO_POL     (0: negative, 1: positive)
 *  D24     : DET_GPIO_TYPE    (0: MISC, 1: ISO)
 *  D23:16  : DET_GPIO_ID      (GPIO ID of 5V detect)
 *  D15:12  : Reserved
 *  D11     : Reserved
 *  D10     : Reserved
 *  D9      : HPD_GPIO_POL     (0: negative, 1: positive)
 *  D8      : HPD_GPIO_TYPE    (0: MISC, 1: ISO)
 *  D7:0    : HPD_GPIO_ID      (GPIO ID of Hotplug GPIO)
 *****************************************************************/
#define HDMI_PHY(x)             ((unsigned long long)(x & 0xF)<<60)
#define HDMI_SUPPORT_ARC(x)     ((unsigned long long)(x & 0x1)<<59)
#define HDMI_DDC(x)             ((unsigned long long)(x & 0x7)<<56)
#define HDMI_EDID_TYPE(x)       ((unsigned long long)(x & 0x3)<<54)
#define BRSWAP(x)               ((unsigned long long)(x & 0x1)<<52)
#define HDMI_SUPPORT_EARC(x)    ((unsigned long long)(x & 0x1)<<48)
#define DEDICATE_HPD_DET        ((unsigned long long) 0x80000000)
#define DEDICATE_HPD_INVERT     ((unsigned long long) 0x40000000)
#define DEDICATE_HPD_DET_SEL(x) ((unsigned long long)(x & 0x3)<<28)

#define DET_GPIO_TYPE(x)        ((unsigned long long)(x & 0x1)<<24)
#define DET_GPIO_TYPE_ISO       DET_GPIO_TYPE(1)
#define DET_GPIO_TYPE_MIS       DET_GPIO_TYPE(0)
#define DET_GPIO_ID(x)          ((unsigned long long)(x & 0xFF)<<16)

#define HPD_GPIO_TYPE(x)        ((unsigned long long)(x & 0x1)<<8)
#define HPD_GPIO_TYPE_ISO       HPD_GPIO_TYPE(1)
#define HPD_GPIO_TYPE_MIS       HPD_GPIO_TYPE(0)
#define HPD_GPIO_ID(x)          ((unsigned long long) x & 0xFF)

/** SCx Command format
**************************************************************************
*   D31:24  : --
*   D23     : cmd_vcc_en        (0: no cmd_vcc_gpio, 1: with cmd_vcc_gpio)
*   D22     : cmd_vcc_polarity  (0: negative, 1: positive)
*   D21     : cmd_vcc_gpio_type (0: MISC, 1: ISO)
*   D20     : --
*   D19     : pwr_sel_en        (0: no cmd_vcc_gpio, 1: with cmd_vcc_gpio)
*   D18     : pwr_sel_polarity  (0: negative, 1: positive)
*   D17     : pwr_sel_gpio_type (0: MISC, 1: ISO)
*   D16     : --
*   D15:8   : cmd_vcc_gpio id
*   D7:0    : pwr_sel_gpio id
**************************************************************************/
#define CMD_VCC_GPIO_ID(x)       ((unsigned long long)(x & 0xFF)<<8)
#define CMD_VCC_EN(x)            ((unsigned long long)(x & 0x1)<<23)
#define CMD_VCC_POLARITY(x)      ((unsigned long long)(x & 0x1)<<22)
#define CMD_VCC_POLARITY_N       CMD_VCC_POLARITY(0)
#define CMD_VCC_POLARITY_P       CMD_VCC_POLARITY(1)
#define CMD_VCC_GPIO_TYPE(x)     ((unsigned long long)(x & 0x1)<<21)
#define CMD_VCC_GPIO_TYPE_ISO    CMD_VCC_GPIO_TYPE(1)
#define CMD_VCC_GPIO_TYPE_MISC   CMD_VCC_GPIO_TYPE(0)

#define PWR_SEL_GPIO_ID(x)       (unsigned long long)(x & 0xFF)
#define PWR_SEL_EN(x)            ((unsigned long long)(x & 0x1)<<19)
#define PWR_SEL_POLARITY(x)      ((unsigned long long)(x & 0x1)<<18)
#define PWR_SEL_POLARITY_N       PWR_SEL_POLARITY(0)
#define PWR_SEL_POLARITY_P       PWR_SEL_POLARITY(1)
#define PWR_SEL_GPIO_TYPE(x)     ((unsigned long long)(x & 0x1)<<17)
#define PWR_SEL_GPIO_TYPE_ISO    PWR_SEL_GPIO_TYPE(1)
#define PWR_SEL_GPIO_TYPE_MISC   PWR_SEL_GPIO_TYPE(0)

/** I2S CFG format
**************************************************************************
*   D63:56  : pinmux mask begin bit
*   D55:52  : pinmux i2S val
*   D51:48  : pinmux gpio val
*   D16:47  : i2s pinmux reg
*   D11:8   : i2s_gpio group
*   D7:0    : i2s_gpio id
**************************************************************************/
#define I2S_GPIO_ID(x)           (unsigned long long)(x & 0xFF)
#define I2S_GPIO_GROUP(x)        ((unsigned long long)(x & 0xF)<<8)
#define I2S_GPIO_GROUP_ISO       I2S_GPIO_GROUP(0)
#define I2S_GPIO_GROUP_MISC      I2S_GPIO_GROUP(1)
#define I2S_PINMUX_REG(x)        ((unsigned long long)(x & 0xFFFFFFFF)<<16)
#define I2S_PAD_GPIO_VAL(x)      ((unsigned long long)(x & 0xF)<<48)
#define I2S_PAD_VAL(x)           ((unsigned long long)(x & 0xF)<<52)
#define I2S_PINMUX_MASK_START_BIT(x)     ((unsigned long long)(x & 0xFF)<<56)

/** LSADC Added Command format
**************************************************************************
*   63:56     : thredhold value //change value > thredhold value,interrupt triger
*   55:48     : keypad type
*   47:40     : interrupt mode : 0: unused interrupt mode
*               1:thredHold_mode //need setting interrupt thred hold
*                  (taget area = {hitvalue - torrence,hitvalue + torrence})
*               2:block_mode  (block = {hitvalue - torrence,hitvalue + torrence})
**************************************************************************/
#define LSADC_INTERRUPT(x)          ((unsigned long long)(x & 0xFF)<<40)
#define LSADC_KEYPAD(x)             ((unsigned long long)(x & 0xFF)<<48)
#define LSADC_INTERRUPT_TREDHOLD(x) ((unsigned long long)(x & 0xFF)<<56)


// the following was old macro for old soc

#define PCB_HDMI_PORT_SET(phyport, ddcport, edidtype, hpdtype, muxport, muxic)    \
	                         (((unsigned long long) (phyport & 0xf) <<60)   | \
                                 ((unsigned long long) (ddcport & 0x7) << 56)   | \
                                 ((unsigned long long) (edidtype & 0x3) << 54) | \
                                 ((unsigned long long) (hpdtype & 0x3) << 52)  | \
                                 ((unsigned long long) (muxport & 0xf) << 36) | \
                                 ((unsigned long long) (muxic & 0xf) << 32) )

#define PCB_HDMI_5V_SET(det5vgpiotype, det5vgpioinit, det5vploarity, det5vpintype, det5vgpioidx)  \
	                          (((unsigned long long) (det5vgpiotype & 0xf) << 28)  | \
                                 ((unsigned long long) (det5vgpioinit & 0x1) << 26) | \
                                 ((unsigned long long) (det5vploarity & 0x1) << 25) | \
                                 ((unsigned long long) (det5vpintype & 0x1) << 24) | \
                                 ((unsigned long long) (det5vgpioidx & 0xff) << 16))

#define PCB_HDMI_HPD_SET(hpdgpiotype, hpdgpioinit,hdpploarity,hpdpintype,hpdgpioidx)  \
                                 (((unsigned long long) (hpdgpiotype & 0xf) << 12)  | \
                                 ((unsigned long long) (hpdgpioinit & 0x1) << 10) | \
                                 ((unsigned long long) (hdpploarity & 0x1) << 9) | \
                                 ((unsigned long long) (hdpploarity & 0x1) << 8) | \
                                 ((unsigned long long) (hpdgpioidx & 0xff) ) )

#endif

/****************************************************************************/
/*
 //TP_SRC
 INTERNAL_DEMOD:[0..3]
 EXTERNAL_TUNER0_SRC:[4..7]
 EXTERNAL_TUNER1_SRC:[8..11]
 EXTERNAL_CAM0_SRC:[12..15]
 EXTERNAL_CAM1_SRC:[16..20]
*/
/****************************************************************************/
#define TP_SRC_INTERNAL_DEMOD_SET(x)               (x&0xf)
#define TP_SRC_EXTERNAL_TUNER0_SET(x)             ((x&0xf)<<4)
#define TP_SRC_EXTERNAL_TUNER1_SET(x)             ((x&0xf)<<8)
#define TP_SRC_EXTERNAL_CAM0_SET(x)                 ((x&0xf)<<12)
#define TP_SRC_EXTERNAL_CAM1_SET(x)                 ((x&0xf)<<16)

typedef enum {
	TP_SRC_0 	= 0,
	TP_SRC_1	= 1,
	TP_SRC_2	= 2,
	TP_SRC_3	= 3,
	TP_SRC_INTERNAL=7,
	TP_SRC_UNUSED
} TP_SRC_TYPE_T;

/****************************************************************************/
/*
 //USB CONNECTOR MAP
 CONNECTOR1: [7..0]
 CONNECTOR2: [15..8]
 ....
 [1..0]: host controller number (start from 1)
 [4..2]: U2 port number (start from 1)
 [7..5]: U3 port number (start from 1)
 ....
 ex:
 Connector 1 is belongs to HCD 1 and bind to U2 port 2, U3 port 3:
 -> USB_CONNECTOR_N_MAP(1, 1, 2, 3);
 Connector 2 is belongs to HCD 2 and bind to U2 port 1, not support U3:
 -> USB_CONNECTOR_N_MAP(2, 2, 1, 0);
*/
/****************************************************************************/
#define USB_CONNECTOR_N_MAP(connector_num, hc_num, u2_num, u3_num) \
			((unsigned long long)((((u3_num & 0x7) << 5) | ((u2_num & 0x7) << 2) | (hc_num & 0x3)) << ((connector_num - 1) * 8)))


#define __PIN(type, index, param1, param2, param3, param4, param5, param6)		\
			(((unsigned long long) (type) & 0xFF) | (((unsigned long long) (index) & 0xFF) << 8) | (((unsigned long long) (param1) & 0xFF) << 16) | (((unsigned long long) (param2) & 0xFF) << 24)  |    \
			(((unsigned long long) (param3) & 0xFF) << 32) | (((unsigned long long) (param4) & 0xFF) << 40)  | (((unsigned long long) (param5) & 0xFF) << 48)  | (((unsigned long long) (param6) & 0xFF) << 56))

#define _AUDIO_MUX(sig, type, pad, pad_no)  \
		(((unsigned long long) (sig) & 0xFF) | (((unsigned long long) (type) & 0xFF) << 8) | (((unsigned long long) (pad) & 0xFF) << 16) | (((unsigned long long) (pad_no) & 0xFF) << 24))

#define GET_PIN_TYPE(x)		((PCB_PIN_TYPE_T) (x & 0xFF))
#define GET_PIN_INDEX(x)	((unsigned char) ((x >> 8) & 0xFF))
#define GET_PIN_PARAM1(x)	((unsigned char) ((x >> 16) & 0xFF))
#define GET_PIN_PARAM2(x)	((unsigned char) ((x >> 24) & 0xFF))
#define GET_PIN_PARAM3(x)	((unsigned char) ((x >> 32) & 0xFF))
#define GET_PIN_PARAM4(x)	((unsigned char) ((x >> 40) & 0xFF))
#define GET_PIN_PARAM5(x)	((unsigned char) ((x >> 48) & 0xFF))
#define GET_PIN_PARAM6(x)	((unsigned char) ((x >> 56) & 0xFF))

#define GET_LSADC_TYPE(x)			 ((PCB_LSADC_TYPE_T) GET_PIN_PARAM1(x))
#define GET_LSADC_HITVALUE(x) 		 GET_PIN_PARAM2(x)
#define GET_LSADC_TOLERANCE(x)	 	GET_PIN_PARAM3(x)

#define GET_GPIO_TYPE(x)	 		((PCB_GPIO_TYPE_T) GET_PIN_PARAM1(x))
#define GET_GPIO_INVERT(x)	 		GET_PIN_PARAM2(x)
#define GET_GPIO_INIT_VALUE(x) 		GET_PIN_PARAM3(x)

#define GET_PWM_INVERT(x)	 		((GET_PIN_PARAM1(x) >> 7) & 0x01)
#define GET_PWM_FREQ(x)			((((unsigned int) (GET_PIN_PARAM1(x) & 0x7F)) << 16) | (((unsigned int) GET_PIN_PARAM2(x)) << 8) | (GET_PIN_PARAM3(x)))
#define GET_PWM_DUTY_MAX(x)		GET_PIN_PARAM4(x)
#define GET_PWM_INIT_DUTY(x)		GET_PIN_PARAM5(x)
#define GET_PWM_CLK_SRC(x)		GET_PIN_PARAM6(x)
#define SET_PWM_CLK_SRC(x)		((unsigned long long)(x & 0xFF) << 56)

#define GET_UNIPWM_INVERT(x)	 	((GET_PIN_PARAM1(x) >> 7) & 0x01)
#define GET_UNIPWM_FREQ(x)			((((unsigned int) (GET_PIN_PARAM1(x) & 0x7F)) << 16) | (((unsigned int) GET_PIN_PARAM2(x)) << 8) | (GET_PIN_PARAM3(x)))
#define GET_UNIPWM_DUTY_MAX(x)		GET_PIN_PARAM4(x)
#define GET_UNIPWM_INIT_DUTY(x)		GET_PIN_PARAM5(x)
#define GET_UNIPWM_PWM_NUM(x)	 	GET_PIN_PARAM6(x)

#define GET_PINMUX_GPIO_INDEX(x)        ((unsigned char) (x & 0x1FF))
#define GET_PINMUX_GPIO_INIT_VALUE(x)        ((unsigned char) ((x >> 9) & 0x1))
#define GET_PINMUX_GPIO_TYPE(x)         ((PCB_PIN_TYPE_T) ((x >> 10) & 0xF))
#define GET_PINMUX_GPIO_VALUE(x)        ((unsigned char) ((x >> 14) & 0xF))
#define GET_PINMUX_MODULE_VALUE(x)      ((unsigned char) ((x >> 18) & 0xF))
#define GET_PINMUX_END_BIT(x)           ((unsigned char) ((x >> 22) & 0x1F))
#define GET_PINMUX_START_BIT(x)         ((unsigned char) ((x >> 27) & 0x1F))
#define GET_PINMUX_REG(x)               ((unsigned char) ((x >> 32) & 0xFFFFFFFF))

#define ABS(x, y)    ((x) > (y) ? ((x)-(y)) : ((y)-(x)))

/* Most/Least significant 32 bit from 64 bit double word */
#define HI32(data64)		  ((unsigned int)(data64 >> 32))
#define LO32(data64)		  ((unsigned int)(data64 & 0xFFFFFFFF))

typedef struct {
	unsigned long long info;
	char *name;
} PCB_ENUM_T;

extern void BISR_Repair(void);
#ifdef CONFIG_SYS_PIN_MUX
extern void PinMuxInit(void);
#endif

/*
  * Function: pcb_mgr_show_pin_enum_info
  *
  *	Description:
  *			if pcb enum is "PIN" enum
  *  			then this function can interpret PIN's value  into PIN's information such that PIN_TYPE....
  *
  *
  *	return :   -1 : means unkwon pin type ...
  *			0: success
  *
*/
extern int pcb_mgr_show_pin_enum_info(unsigned long long pin);

/*
	Function: pcb_mgr_show_all_enum_info

	Description:
			list  all pcb enum in text

	return :
*/
extern void pcb_mgr_show_all_enum_info(void);

/*
  * Function: pcb_mgr_init
  *
  *	Description:
  *			init pcb_mgr
  *
  *	return :   -1 : means error
  *			0: success
  *
*/
extern int pcb_mgr_init(void);
/*
	Function: pcb_mgr_get_enum_info_byname

	Description:
	  		pcb enum is a key-value pair structure,
	  		enum_name is the key and is a string
	  		the value is a unsigned long long variable
	  		pcb_mgr_get_enum_info_byname is given enum_name as the key to find corresponding value

	return :   -1 : means there is no pcb enum found
			0: success

*/
extern int pcb_mgr_get_enum_info_byname(char *enum_name, unsigned long long *value);
extern int pcb_mgr_set_enum_info_byname(char *enum_name, unsigned long long value);
/*
  * Function: pcb_enumeration
  *
  *	Description:
  *			enumerate pcb staff from /sys/realtek_boards/pcb
  *
  *   param:
  *		   pppin_enum : search result pointer
  *
  *	return :   -1 : means fail
  *			0: success
  *
*/
extern int pcb_enumeration(PCB_ENUM_T **pppin_enum);
extern int pcb_mgr_get_enum_info_num(int num, unsigned long long *value) ;

extern void pcb_gen_kernel_cmd_line(char *buffer, PCB_ENUM_T *ppcb_enum);
extern unsigned int pcb_get_boot_flash_type(void);
extern char *pcb_get_boot_flash_type_string(void);

/*
  * Function: IO_PWM_SetDuty
  *
  *	Description:
  *			given some "PIN_XX"'s value then setup pwm duty
  *
  *   param:
  *		   pin : the value corresponding to some "PIN_XXX"
  *			    pin include duty_max function
  *		   duty: PWM duty
  *	return :   -1 : means unkwon pin type ...
  *			0: success
  *
*/
extern int IO_PWM_SetDuty(unsigned long long pin, int duty);
/*
  * Function: IO_PWM_SetFreq
  *
  *	Description:
  *			given some "PIN_XX"'s value then setup pwm frequency
  *
  *   param:
  *		   pin : the value corresponding to some "PIN_XXX"
  *		   freq_hz: PWM frequency
  *	return :   -1 : means unkwon pin type ...
  *			0: success
  *
*/
extern int IO_PWM_SetFreq(unsigned long long pin, int freq_hz);
/*
  * Function: IO_Config
  *
  *	Description:
  *			given some "PIN_XX"'s value then initialze IO
  *                  if IO is lsadc then turn on LSADC and set to current mode / voltage mode
  *                  if IO is GPIO, then setup correct initial state
  *                  if IO is pwm, then setup freq and duty
  *
  *   param:
  *		   pin : the corresponding value  of some "PIN_XXX"
  *
  *	return :   -1 : means unkwon pin type ...
  *			0: success
  *
*/

extern int IO_Config(unsigned long long pin);
/*
  * Function: IO_Set
  *
  *	Description:
  *			given some "PIN_XX"'s value then setup IO value
  *                  if IO is pwm, then setup pwm duty
  *                  if IO is GPO, then setup high low
  *
  *
  *   param:
  *		   pin : the value corresponding to some "PIN_XXX"
  *
  *	return :   -1 : means unkwon pin type ...
  *			0: success
  *
*/
extern int IO_Set(unsigned long long pin, int value);

/*
  * Function: IO_Get
  *
  *	Description:
  *			given some "PIN_XX"'s value then setup IO value
  *                  if IO is lsadc then check if the ADC value hit the presetting ADC value
  *                  "PIN_XX"'s value include presetting ADC value
  *                  if IO is GPI, then get GPI high low
  *
  *
  *   param:
  *		   pin : the corresponding value  of some "PIN_XXX"
  *
  *	return :   -1 : means unkwon pin type ...
  *			0: success
  *
*/
extern int IO_Get(unsigned long long pin);



#ifdef __PCB_ENUM__
#define PCB_ENUM_START()     PCB_ENUM_T	pcb_enum[] = {
#define PCB_ENUM(x)					{ x, #x },
#define PCB_ENUM_END()		{0, 0}, };  PCB_ENUM_T *ppcb_enum = pcb_enum;
#else
extern PCB_ENUM_T pcb_enum[];
#define PCB_ENUM_START()    //
#define PCB_ENUM(x)			//
#define PCB_ENUM_END()		//
#endif
#ifdef __cplusplus
}
#endif

#endif


