#include <common.h>
#include <command.h>
#include <io.h>
#include <malloc.h>

#define MENU_LEVEL_MAX (10) //at most 10 level menus
#define MENU_NAME_LEN (16) //max length for menu name show in path
#define BOOT_PARAM_LEN_MAX (512)

#define FRED_START "\033[1;31;40m"
#define FGREEN_START "\033[1;32;40m"
#define FYELLOW_START "\033[1;33;40m"
#define FBLUE_START "\033[1;34;40m"
#define FPINK_START "\033[1;35;40m"
#define FCOLOR_END "\033[0m"

#define DBG_DFT(format, ...) do{ printf(format, ##__VA_ARGS__); }while(0)
#define DBG_RED(format, ...) do{ printf(FRED_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_GREEN(format, ...) do{ printf(FGREEN_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_YELLOW(format, ...) do{ printf(FYELLOW_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_BLUE(format, ...) do{ printf(FBLUE_START format FCOLOR_END, ##__VA_ARGS__); }while(0)

/*
menu format:
        menu index '0' is the whole menu name and description
        menu index '1' to 'end-1' should be sub-menu or item
        menu index 'end' should be all 'NULL' as {NULL, NULL, NULL, NULL}
*/

typedef struct setmenu
{
        char * name;//name
        char * desc;//description
        int (*func)(void);//name
        struct setmenu * father;//father menu
} setmenu;

typedef struct menu_state
{
        setmenu * menu;
        int level;
        char path[MENU_LEVEL_MAX][MENU_NAME_LEN];
} menu_state;


/*common function*/
extern char *getenv(const char *name);
extern int setenv(const char *varname, const char *varvalue);
extern int sscanf(const char *buf, const char *fmt, ...);
extern int fgets(char *s, int n);

/*hwmonitor variable*/
extern menu_state state;
extern setmenu top_menu[];

/*hwmonitor function*/
int go_up_menu(void);
void prepare_go_ahead(void);
int append_bootargs(char * str);
void show_boot_param(char * key);
int update_boot_param(char * key,char * buf);
int add_boot_param(char * key,char * buf);
int clear_boot_param(char * key);

/*dcmt variable*/
extern setmenu dcmt_root_menu[]; 

/*dcmt function*/
extern int hwmonitor_dcmt_set_cmd_check(char *dcmt_cmd);
extern int hwmonitor_dcmt_quick_set(char *dcmt_mode, char *dcmt_cmd);
extern int hwmonitor_sb2_quick_set(char *sb2_mode, char *sb2_cmd);

