#include <common.h>
#include <asm/arch/io.h>
#include <platform_lib/board/pcb.h>

extern int CusApi_env_readXmlFile(const char* pFileName, const char *pItemName, char *pParameter, size_t parameterLen);
#define MODEL_ENV_FILE_NAME		"tmp/factory/Model_Env.xml"
#define EARC_ARC_HW_VAR "earc_arc_hw_var"

void set_EARC_ARC_pinmux(void)
{
	//earc_arc_hw_var define:
	//0x00: set pin mux as ARC(SPDIF)
	//0x01: set pin mux as GPIO
	//0x02: set pin mux as GPIO
	//NULL: set pin mux as ARC(SPDIF)
	//default setting is ARC(SPDIF) defined in pcb_tv002_bga_Vulcan3
	char retStr[6]={0};
	if(CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME, "earc_arc_hw_var",retStr, sizeof(retStr)) != 0) {
		printf ("Failed to load %s from Model_Env.xml, keep default pin mux!\n", EARC_ARC_HW_VAR);
	}
	else {
		if (strcmp("0x00", retStr) != 0) {//no mount ARC circuit, ARC pin need to be set as GIPO
			rtd_maskl(0xB8060214, 0xFFFFFF00, (((0xF << 4) | (BGA_PIN_609_UP << 3) | (BGA_PIN_609_PD << 2) |(BGA_PIN_609_DS << 1) | (BGA_PIN_609_SR)) << 0));
			printf ("%s is %s, set as GIPO\n", EARC_ARC_HW_VAR, retStr);
		}
		else {
			printf ("%s is 0x00, keep default pin mux\n", EARC_ARC_HW_VAR);
		}
	}
}

void CusApi_post_pinmux_init(void)
{
	set_EARC_ARC_pinmux();
}

