#include <qc_verify_common.h>

//#if defined(CONFIG_RTD284X_QC)
#define IMEM_SIZE	65536	
#define SHARE_MEMORY_SIZE	128
//#else
//#define IMEM_SIZE	16384
//#define SHARE_MEMORY_SIZE	128
//#endif
#define PATTERN_OFFSET	 (IMEM_SIZE / 4)
#define PATTERN_DATA_IMEM	0x5aa5a5a5
#define IMAGE_SIZE	200

int QC_Verifier_8051(int flag)
{
	unsigned long cnt, value, i, value1;
	unsigned long tmpValue;

	unsigned int buf[] = {
		0xe4100190, 0xf004a3f0, 0xa3f004a3, 0xfe80f004, 0xfe80f004
	};
	
	tmpValue = rtd_inl(0x18060050);
	rtd_maskl(0x18060050,0xFFFFFFFF, 0x00000001);	// bit0 : 27Mhz crystal
	rtd_maskl(0x18060430,0xFFFFFFFF, 0x00000001);	// bit0: Make system cpu program emcu's IMEM/DMEM
//#if defined(CONFIG_RTD289X_QC)|| defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
	rtd_outl(0x18060034,0x00000600); 
	rtd_outl(0x18060044,0x00000201); // bit9 : CLKEN_EMCU_CORE = 1
	rtd_outl(0x18060044,0x00000200); // bit9 : CLKEN_EMCU_CORE = 0
	rtd_outl(0x18060410,0x00000001); // Core_clk_en_default=1
	rtd_outl(0x18060034,0x00000401); // release RSTN_EMCU_TOP
	rtd_outl(0x18060400,0x00002004); // EMCU timeout enable
//#else
//	rtd_maskl(0x18060044,0xFFFFFDFF, 0x00000000);	// bit9 : CLKEN_EMCU_CORE = 0
//	rtd_maskl(0x18060034,0xFFFFFDFF, 0x00000000);	// bit9 : RSTN_EMCU_CORE = 0
//	rtd_maskl(0x18060034,0xFFFFFBFF, 0x00000400);	// bit10 : release RSTN_EMCU_TOP
//#endif

	// printf("Write pattern data into emcu's IMEM\n");
	// set reload imem address to 0
#if CONFIG_FT
	for(i = 0; i < 4; i++) {
		rtd_outl(0x18060434, 0x00008000); //set reload is 1
		rtd_outl(0x18060444, 0x555 + PATTERN_OFFSET * i);
		rtd_outl(0x18060434, 0);
		rtd_outl(0x18060438, 0xaaaaaaaa);

		rtd_outl(0x18060434, 0x00008000); //set reload is 1
		rtd_outl(0x18060444, 0x8000 + 0xaaa + PATTERN_OFFSET * i);
		rtd_outl(0x18060434, 0);
		rtd_outl(0x18060438, 0x55555555);
	}
#else
	rtd_outl(0x18060444, 0);
	rtd_outl(0x18060434, 0);
	rtd_outl(0x18060434, 0x00008000); //set reload is 1
	rtd_outl(0x18060434, 0x00000000); //set reload is 0
	rtd_maskl(0x18060434, 0xFFFFBFFF, 0x00004000); // auto increase cur_imem_addr +4 when write imem_data
	// printk("1. Read [0x18060434] = %x\n", rtd_inl(0x18060434));
	for( i = 0; i < ((IMEM_SIZE * 2) / 4); i++){
		rtd_outl(0x18060438, PATTERN_DATA_IMEM);
	 }
#endif
	// printf("Read pattern data from emcu's IMEM\n");

	// set reload imem address to 0
	rtd_outl(0x18060444, 0);
	rtd_outl(0x18060434, 0);
	rtd_outl(0x18060434, 0x00008000); //set reload is 1
	rtd_outl(0x18060434, 0x00000000); //set reload is 0
#if CONFIG_FT
	for( i = 0; i < 4; i++) {
		rtd_outl(0x18060434, 0x00008000); //set reload is 1
		rtd_outl(0x18060444, 0x555 + PATTERN_OFFSET * i);
		rtd_outl(0x18060434, 0x00000000); //set reload is 0
		value = rtd_inl(0x18060438);

		rtd_outl(0x18060434, 0x00008000); //set reload is 1
		rtd_outl(0x18060444, 0x8000 + 0xaaa + PATTERN_OFFSET * i);
		rtd_outl(0x18060434, 0x00000000);
		value1 = rtd_inl(0x18060438);
		// printk("verify I_mem [Pattern-%x] = %x, %x for emcu\n", i, value, value1);
		if((value != 0xaaaaaaaa) || (value1 != 0x55555555)) {
			printk("1.Failure to verify I_mem [Pattern-%lx] = %lx, %lx for emcu\n", i, value, value1);
//#if defined(CONFIG_RTD289X_QC)||defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
			rtd_outl(0x18060044,0x00000600); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
			rtd_outl(0x18060034,0x00000600); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#else
//			rtd_maskl(0x18060044,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
//			rtd_maskl(0x18060034,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#endif
			rtd_outl(0x18060050, tmpValue);
			return FAILED;
		}
	}
	printk("%s-5\n", __FUNCTION__);
#else
	rtd_outl(0x18060444, 0);
	rtd_outl(0x18060434, 0);
	rtd_outl(0x18060434, 0x00008000); //set reload is 1
	rtd_outl(0x18060434, 0x00000000); //set reload is 0
	// printk("2. Read [0x18060434] = %x\n", rtd_inl(0x18060434));
	for( i = 0; i < ((IMEM_SIZE * 2) / 4); i++) {
		value = rtd_inl(0x18060438);
		if(value != PATTERN_DATA_IMEM) {
			printk("2.Failure to verify I_mem [Pattern-%lx] = %lx for emcu\n", i, value);
//#if defined(CONFIG_RTD289X_QC)||defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
			rtd_outl(0x18060044,0x00000600); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
			rtd_outl(0x18060034,0x00000600); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#else
//			rtd_maskl(0x18060044,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
//			rtd_maskl(0x18060034,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#endif
			rtd_outl(0x18060050, tmpValue);
			return FAILED;
		 }
	 }
#endif
//#if defined(CONFIG_RTD289X_QC)||defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
	rtd_outl(0x18060034,0x00000600); // bit9/bit10 : RSTN_EMCU_TOP = 0 & RSTN_EMCU_CORE = 0 (toggle reset)
//#else
//	rtd_maskl(0x18060034,0xFFFFF9FF, 0x00000000); // bit9/bit10 : RSTN_EMCU_TOP = 0 & RSTN_EMCU_CORE = 0 (toggle reset)
//#endif
	//printf("Write emcu code into emcu's IMEM\n");
	rtd_maskl(0x18060050,0xFFFFFFFF, 0x00000001);	// bit0 : 27Mhz crystal
	rtd_maskl(0x18060430,0xFFFFFFFF, 0x00000001);	// bit0: Make system cpu program emcu's IMEM/DMEM
//#if defined(CONFIG_RTD289X_QC)||defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
	rtd_outl(0x18060044,0x00000201); // bit9 : CLKEN_EMCU_CORE = 1
	rtd_outl(0x18060044,0x00000200); // bit9 : CLKEN_EMCU_CORE = 0
	rtd_outl(0x18060410,0x00000001); // Core_clk_en_default=1
	rtd_outl(0x18060034,0x00000401); // release RSTN_EMCU_TOP
	rtd_outl(0x18060400,0x00002004); // EMCU timeout enable
//#else
//	rtd_maskl(0x18060044,0xFFFFFDFF, 0x00000000); // bit9 : CLKEN_EMCU_CORE = 0
//	rtd_maskl(0x18060034,0xFFFFFDFF, 0x00000000); // bit9 : RSTN_EMCU_CORE = 0
//	rtd_maskl(0x18060034,0xFFFFFBFF, 0x00000400); // bit10 : release RSTN_EMCU_TOP
//#endif

	// set reload imem address to 0
	rtd_outl(0x18060444, 0);
	rtd_outl(0x18060434, 0);
	rtd_outl(0x18060434, 0x00008000); //set reload is 1
	rtd_outl(0x18060434, 0x00000000); //set reload is 0

	rtd_maskl(0x18060434, 0xFFFFBFFF,0x00004000); // auto increase cur_imem_addr +4 when write imem_data
	// printk("3. Read [0x18060434] = %x\n", rtd_inl(0x18060434));
	for(i = 0; i < 5; i++){
		value = buf[i];
		rtd_outl(0x18060438, value);
//		printk("write to value = %x\n", value);
	 }

	// printf("Read emcu code from emcu's IMEM\n");

	// set reload imem address to 0
	rtd_outl(0x18060444, 0);
	rtd_outl(0x18060434, 0);
	rtd_outl(0x18060434, 0x00008000); //set reload is 1
	rtd_outl(0x18060434, 0x00000000); //set reload is 0

	rtd_maskl(0x18060434, 0xFFFF3FFF, 0x00004000); // auto increase cur_imem_addr +4 when read imem_data
	// printk("4. Read [0x18060434] = %x\n", rtd_inl(0x18060434));
	for( i = 0; i < 5; i++) {
		value = buf[i];
		value1 = rtd_inl(0x18060438);
		if(value1 != value) {
			printf("3.Failure to verify I_mem [image-%lx] = %lx, orig=%lx for emcu\n", i, value1, value);
//#if defined(CONFIG_RTD289X_QC)||defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
			rtd_outl(0x18060044,0x00000600); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
			rtd_outl(0x18060034,0x00000600); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#else
//			rtd_maskl(0x18060044,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
//			rtd_maskl(0x18060034,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#endif
			rtd_outl(0x18060050, tmpValue);
			return FAILED;
		 }
	 }

	rtd_maskl(0x18060430, 0xFFFFFFFE, 0); // set sys_prog_en = 0
//#if defined(CONFIG_RTD289X_QC)||defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
	rtd_outl(0x18060044,0x00000201); // bit9 : CLKEN_EMCU_CORE = 1
	rtd_outl(0x18060034,0x00000201); // bit9 : RSTN_EMCU_CORE = 1
//#else
//	rtd_maskl(0x18060044,0xFFFFFDFF, 0x00000200); // bit9 : CLKEN_EMCU_CORE = 1
//	rtd_maskl(0x18060034,0xFFFFFDFF, 0x00000200); // bit9 : RSTN_EMCU_CORE = 1
//#endif
	mdelay(2);

	cnt = 1000;
	while(cnt--) {
//		if((rtd_inl(0xb8060500) == 0x03020100) && (rtd_inl(0xb806057c) == 0x7f7e7d7c)) {
		if(rtd_inl(0x18060110)){
			// printf("rtd_inl(0xb8060124) = %x\n", rtd_inl(0xb8060124));
			printf("QC_EMCU verify success.\n");
//#if defined(CONFIG_RTD289X_QC)||defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
			rtd_outl(0x18060044,0x00000600); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
			rtd_outl(0x18060034,0x00000600); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#else
//			rtd_maskl(0x18060044,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
//			rtd_maskl(0x18060034,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#endif
			rtd_outl(0x18060050, tmpValue);
			return SUCCESS;
		}
	}

	printf("rtd_inl(0x18060124) = %x\n", rtd_inl(0x18060124));
	printf("rtd_inl(0x1806057c) = %x\n", rtd_inl(0x1806057c));
	printf("QC_EMCU verify failure\n");

	rtd_outl(0x18060050, tmpValue);
//#if defined(CONFIG_RTD289X_QC)||defined(CONFIG_RTD289XP_QC) || defined(CONFIG_RTD284X_QC)
	rtd_outl(0x18060044,0x00000600); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
	rtd_outl(0x18060034,0x00000600); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#else
//	rtd_maskl(0x18060044,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : CLKEN_EMCU_CORE = 0
//	rtd_maskl(0x18060034,0xFFFFF9FF, 0x00000000); // bit10 & bit9 : RSTN_EMCU_CORE = 0
//#endif
	return FAILED;
}

