/*----------------------------------------------------------------------------
*
*The confidential and proprietary information contained in this file may
*only be used by a person authorised under and to the extent permitted
*by a subsisting licensing agreement from ARM Limited.
*
*        (C) COPYRIGHT 2008-2009,2011-2013 ARM Limited.
*             ALL RIGHTS RESERVED
*             
*This entire notice must be reproduced on all copies of this file
*and copies of this file may only be made by a person if such person is
*permitted to do so under the terms of a subsisting license agreement
*from ARM Limited.
*
*     SVN Information
*
*     Checked In          : $Date$
*
*     Revision            : $Revision$
*
*     Release Information : r0p0-00rel0
*
*-----------------------------------------------------------------------------
* 
*-----------------------------------------------------------------------------
* Abstract :Toplevel file implementing Main()
*-----------------------------------------------------------------------------
* Overview
*----------
* 
**************************************************************/
//#include <stdio.h>

#include <qc_verify_common.h>

#include "MaliFns.h"

#if 0
#ifdef TESTNAME
	aaaaa
#else
//#define TESTNAME RunMaliTest_test
  #define TESTNAME RunMaliTest_prf1_t720
#endif
#endif//0

#define TESTNAME RunMaliTest_prf1_t720

extern int RunMaliTest_prf1_t720 (int init);


typedef int (*MaliFunctionPtr)(int);
//int TESTNAME (int init);

/* Interrupt call backs */
void MaliIntCallBack (int IntNum, int IntSrc);
void MaliIntMMU (int IntNum, int IntSrc);

static MaliFunctionPtr mali_currentfunction_ptr;

static volatile int Mali_FinishedFlag = 0;
static int Mali_ReturnCode   = 0;

void scpu_isr();

/********************************************************************************
 * Main routine for Mali Test.
 *
 * 1. Setup all interrupts
 * 2. Run first part of test. Remainder of test parts operate in interrupt handler.
 * 3. Spin until FinishedFlag is set.
 ********************************************************************************/

#if 0
#define write32(offset,val)            (*(volatile unsigned long *)(offset) = val)
#define rtd_outl(offset,val)            (*(volatile unsigned long *)(offset) = val)
#define read32(addr) (*(volatile unsigned int *)(addr))
#endif//0

#define SYS_CLKEN1_reg (0xb8000114)
#define SYS_CLKEN1_clken_3d_gde_mask  (0x00000008)
#define SYS_SRST1_reg	(0xb8000104)
#define SYS_SRST1_rstn_3d_gde_mask	(0x00000008)


void rt_reset_gpu(void)
{
// CLKEN=0 -> RSTN=0 -> RSTN=1 -> CLKEN=1
  rtd_outl(SYS_CLKEN1_reg, rtd_inl(SYS_CLKEN1_reg) & ~(SYS_CLKEN1_clken_3d_gde_mask)); 
  udelay(1000);

  //RSTN = 0
  rtd_outl(SYS_SRST1_reg, rtd_inl(SYS_SRST1_reg) & ~(SYS_SRST1_rstn_3d_gde_mask)); 
  udelay(1000);

  //RSTN = 1
  rtd_outl(SYS_SRST1_reg, rtd_inl(SYS_SRST1_reg) | (SYS_SRST1_rstn_3d_gde_mask)); 
  udelay(1000);

   //CLKEN = 1
  rtd_outl(SYS_CLKEN1_reg, rtd_inl(SYS_CLKEN1_reg) | (SYS_CLKEN1_clken_3d_gde_mask)); 

}

int MaliTop(void) {
	int ret = -1;

   unsigned int test ;
  *((unsigned int volatile*) 0xb801a600) = 0 ; //DV set dummy reg


	rt_reset_gpu();

	printf("0xB804e060=0x%x\n", read32(0xB804e060) );
		
//  read32(0xa0003020);

  write32(0xB804e060,0x00000001);


  //test = jump_to_addr(0xa4000000);
  jump_to_addr(0xa4000000);
  write32(0xB804e060,test);

  
  rtd_outl (0xB804e048,0x00000001);//endian
  rtd_outl (0xB804e04c,0x00000000);
  rtd_outl (0xB804e004,0x00000001);//disable barrier
  


//  rtd_outl (0xB804e050,0x00000001); //open GPU Wrapper Interrupt

//  ((void(*)())(0x80003000))();

//  printf("Installing interrupt handler\n");

  /* 1. Disable CPU interrupts; and initalise any interrupt controller */
  /* 2. Install mali interrupt handlers */
  /* 3. Install interrupt handlers for mali interrupts */
  CPU_DisableInterrupts();
  write32(0xB804e060,0x00000002); 
  CPU_InitialiseInterrupts();

  write32(0xB804e060,0x00000003);

//  #ifndef MAC3
  Mali_InstallIntHandlers(&MaliIntCallBack,
                          &MaliIntCallBack,
                          &MaliIntCallBack
                          );
//  #else
  // searched from include/saturn.h
//  *((volatile int*) 0xa056a0b8) = (int) MaliIntCallBack;
//  write32(0xB804e060,0x00000004);
//  #endif

  /* 4. Identify GPU core */
  Mali_Identify();
  write32(0xB804e060,0x00000005);

  /* Raise a fault either GPU or MMU raise an interrupt */
  Mali_SetInterruptErrMask(1,0xFFFFFFFF);
  write32(0xB804e060,0x00000006);
  Mali_SetInterruptErrMask(2,0xFFFFFFFF);
  write32(0xB804e060,0x00000007);

  /* 5. Run the first part of this test. */
  /*    Note this can trigger an interrupt; hence we run this whilst interrupts */
  /*    are disabled. If interrupt masking cannot be done - then create another */
  /*    system to mali interrupts until after this routine has returned.        */
  /* 6. Enable interrupts */
  mali_currentfunction_ptr = &TESTNAME;
  write32(0xB804e060,0x00000008);
  Mali_ReturnCode = (*mali_currentfunction_ptr)(1);
  write32(0xB804e060,0x00000009);
  if ((Mali_ReturnCode != 254) & (Mali_ReturnCode != 255)) {
    Mali_FinishedFlag = 1;
  write32(0xB804e060,0x0000000a);
  };
  CPU_EnableInterrupts();
  write32(0xB804e060,0x0000000b);

  /* Do whatever you like - mali now runs from within interrupt handler
     For reference we have an infinite loop with a wait for interrupt instruction
     inside - waiting until all Mali jobs are finished.
     ............
   */
  
  while (!Mali_FinishedFlag) {
   Mali_WaitForInterrupt();
   MaliIntCallBack (0x5,0x5 ); 

   write32(0xB804e060,0x0000001c);   
   write32(0xB804e060,Mali_FinishedFlag);
   write32(0xB804e060,0x0000000c);
  };

#ifdef MAC3
//#define read32(addr) (*(volatile unsigned int *)(addr))
  write32(0xB804e060,0x0000000d);
#endif


  write32(0xB804e060,0x0000000e);
  if (Mali_ReturnCode != 0) {
    write32(0xB804e060,0x0000000f);
    printf ("TEST FAILED\n");
	#ifdef MAC3
	  jump_to_addr(0xa0003020);
	#endif

	ret = -1;
	
  } else {
    write32(0xB804e060,0x00000010);
    printf ("TEST PASSED\n");
	#ifdef MAC3
	  jump_to_addr(0xa0003000);
       //   read32(0xa0003000);
       //   read32(0xa0003000);
       //   write32(0xB804e060,0x76543210); 
	#endif

	ret = 0;
  };

	return ret;
};

/********************************************************************************
 * This is the mali interrupt handler for expected interrupts
 *
 * 1. acknowledge the interrupt 
 * 2. call the next part in this test 
 * 3. set finished flag if not returning with wait for interrupt return code
 ********************************************************************************/
void MaliIntCallBack (int IntNum, int IntSrc) {
  /* Only run next step if we have not finished */
  /* This ensures that if the callback is executed when no mali interrupts */
  /* are actually pending; the test still works */
  /* Debug */
  /* printf (">>>Start of MaliIntCallBack IntNum=%d IntSrc=%d Mali_FinishedFlag=%d >>>\n", IntNum, IntSrc, Mali_FinishedFlag); */
  if (Mali_FinishedFlag == 0) {
   do {
      Mali_ReturnCode = (*mali_currentfunction_ptr)(0);
 //     printf (">>> MaliIntCallBack Mali_Returncode=%d <<<\n", Mali_ReturnCode);
      write32(0xB804e060,0x00000566);     
    } while(Mali_ReturnCode == 254);
  };
  if (Mali_ReturnCode != 255) {
    Mali_FinishedFlag = 1;
  };
  /* Debug */
  /* printf ("<<< End of MaliIntCallBack IntNum=%d IntSrc=%d Mali_FinishedFlag=%d Mali_ReturnCode=%d <<<\n", IntNum, IntSrc, Mali_FinishedFlag, Mali_ReturnCode); */
};


void scpu_isr(){

  rtd_outl (0xB804e050,0x00000000) ;//close INT
  rtd_outl (0xB804e060,0x0000001a) ;

}



