;;----------------------------------------------------------------------------
;;
;;The confidential and proprietary information contained in this file may
;;only be used by a person authorised under and to the extent permitted
;;by a subsisting licensing agreement from ARM Limited.
;;
;;        (C) COPYRIGHT 2008-2009,2011,2013 ARM Limited.
;;             ALL RIGHTS RESERVED
;;             
;;This entire notice must be reproduced on all copies of this file
;;and copies of this file may only be made by a person if such person is
;;permitted to do so under the terms of a subsisting license agreement
;;from ARM Limited.
;;
;;    SVN Information
;;
;;    Checked In          : $Date$
;;
;;    Revision            : $Revision$
;;
;;    Release Information : r0p0-00rel0
;;
;;-----------------------------------------------------------------------------
;; 
;;-----------------------------------------------------------------------------
;; Abstract :Low level helper functions
;;-----------------------------------------------------------------------------
;; Overview
;;----------
;; 
;;
;; 
;; 
;;----------------------------------------------------------------------------

    ; Lowlevel routines systembench environment

    AREA    lowlevel, CODE

  EXPORT  call_wfi
  EXPORT  enable_irq
  EXPORT  disable_irq
  
call_wfi
    [ ARMv6                
    mcr  p15, 0, r0, c7, c0, 4
    |
    WFI
    ]
    bx     lr
    
        ;----------------------------------------------------------------------------
        ; Enable interrupts
        ; And give a small stack space to IRQ vector
        ;----------------------------------------------------------------------------
I_Bit           EQU     0x80 ; when I bit is set, IRQ is disabled
Mode_IRQ        EQU     0x12
Mode_SVC        EQU     0x13
	
enable_irq  
	; Enable IRQs
        MRS     r2,CPSR
        BIC     r2,r2,#I_Bit
        MSR     CPSR_c,r2
        BX      r14
	
disable_irq  
       ; Disable IRQs
       MRS     r2,CPSR
       ORR     r2,r2,#I_Bit
       MSR     CPSR_c,r2
       BX      r14
	

  END
