
#include "rtk_crt.h"
#define tv_osal_usleep(x) udelay(x)
#define tv_osal_msleep(x) mdelay(x)
#define RTK_DEMOD_INFO(fmt, args...)
#define pr_warn(fmt, args...) 


enum FUNCTION_RETURN_STATUS {
	FUNCTION_SUCCESS,			///<   Execute function successfully.
	FUNCTION_ERROR,				///<   Execute function unsuccessfully.
};

typedef struct sDEMOD {
	unsigned char I2CAddr;
} DEMOD;

typedef struct{
	double imag;
	double real;
} complex_t;

typedef struct{
	double SNDR;
	double ENOB_SNDR;
} perform_t;
int test(void);
unsigned int IsAtsc3McmPackage(void);
int ExtAtsc3DemodInitialization(void);
void ExtAtsc3PowOffOn(unsigned char on);
int TvFrontendPowerControl(unsigned char On);
int DtvIAdcIPgaPowerSetting(unsigned char On);
int REALTEK_R_ATSC3_System_Init(DEMOD* pDemod);
int REALTEK_R_ATSC3_PLL_Default(DEMOD* pDemod);
int REALTEK_R_ATSC3_ADC_Default(DEMOD* pDemod);
int REALTEK_R_ATSC3_Register(DEMOD* pDemod);
void demod_i2c_init(DEMOD* pDemod);
int rtd_4bytes_i2c_mask(DEMOD *pDemod, unsigned int addr, unsigned int mask, unsigned int data);
int rtd_4bytes_i2c_rd(DEMOD *pDemod, unsigned int addr, unsigned int* data);
int rtd_4bytes_i2c_wr(DEMOD *pDemod, unsigned int addr, unsigned int data);
double my_floor(double f);
double my_fmod(double f, double n);
double sin_t(double t);
double cos_t(double t);
void _fft(complex_t *buf, complex_t *out, int n, int step);
void fft(complex_t *buf, int n);
void power(complex_t *input, double *output, int size);
void DC_cancel(complex_t *input, int size);
void hamming_window(complex_t *buf, int size);
double mylog10(double input);
int mmax(double *buf, double *max, int *max_num, int size);
int mmin(double *buf, double *min, int size);
void normalbymax(double *buf, double max, int size);
void logproc(double *buf, int size);
double summ(double *buf, int start, int end);
perform_t SNRperform(double *buf, int size);
void _colleyFFT(complex_t *x, int N);
void colleyFFT(complex_t *x_in, complex_t *x_out, int N);
void GPIOout(int SNR);
int ADCdump(complex_t *SRAMdata_comp, double *SRAMdata);
int ADCdumpIDNL(void);
int ADCdumpSNR(void);
int my_rand(void);