#include <peripheral_common.h>

static PinShare_Info pinshare_info;
static UINT32 nAddr_GPO_IO;
static UINT8  N_bit_GPO;
static UINT32 nAddr_GPO_HL;

void Set_Pinshare(UINT32 Pinshare_addr,UINT8 Pinshare_msb,UINT8 Pinshare_lsb,UINT32 Pinshare_val)
{

	pinshare_info.addr = Pinshare_addr;
	pinshare_info.msb = Pinshare_msb;
	pinshare_info.lsb = Pinshare_lsb;
	pinshare_info.val = Pinshare_val;	

	//pinshare
    rtd_maskl(pinshare_info.addr,GetMaskAnd(pinshare_info.msb ,pinshare_info.lsb),pinshare_info.val<<pinshare_info.lsb ); 
}


//Init GPIO Addr used and Pinshare Info.
void SetGPIOOut(UINT8 nGPIO_Num,bool bISO,UINT32 Pinshare_addr,UINT8 Pinshare_msb,UINT8 Pinshare_lsb,UINT32 Pinshare_val,UINT8 bInitOut)
{
    UINT32 GP0DIR;
    UINT32 GP0DATO;
    if(bISO)
    {    
	    	GP0DIR = GP0DIR_ISO;
          	GP0DATO = GP0DATO_ISO;
    }
    else
    {
		GP0DIR = GP0DIR_Misc;
	    	GP0DATO = GP0DATO_Misc;
    }


       nAddr_GPO_IO = GP0DIR + (nGPIO_Num/31)*4;
	nAddr_GPO_HL = GP0DATO + (nGPIO_Num/31)*4;
   	N_bit_GPO = nGPIO_Num - (nGPIO_Num/31)*31+1; 
   
	Set_Pinshare(Pinshare_addr,Pinshare_msb,Pinshare_lsb,Pinshare_val);//1.Pinshare
       rtd_maskl(nAddr_GPO_IO,GetMaskAnd(N_bit_GPO,N_bit_GPO)& 0xfffffffe, (1<<N_bit_GPO)+1);//2   //GPIO Set to GPO, 1:GPO, 0,GPI

	if(bInitOut!=2)
		rtd_maskl(nAddr_GPO_HL,GetMaskAnd(N_bit_GPO,N_bit_GPO)& 0xfffffffe, (1<<N_bit_GPO)+bInitOut);   //Init=> init GPO output Val
}

void SetGPOHL(bool bHL)
{   
    	rtd_maskl(nAddr_GPO_HL,GetMaskAnd(N_bit_GPO,N_bit_GPO)& 0xfffffffe, (1<<N_bit_GPO) + bHL);   //GPO set to H/L
}



/*=============================================================
 * Copyright C        Realtek Semiconductor Corporation, 2013 *
 * All rights reserved.                                       *
 *============================================================*/

/*======================= Description ========================*/
/**
 * @file: for some global function like math, etc.
 
 * @Author: Sophia_xu
 
 * @date 2013/12/16
 
 * @version { 2.0 }
 *
 */

#include <qc_verify_common.h>

/*
double fabs(double x)
{
	double result;

	if(x>0)
		result = x;
	else
		result = 0-x;

	return result;
}


 
int abs(int x)
{
	int result;

	if(x>0)
		result = x;
	else
		result = 0-x;

	return result;
}
*/

/*
* eva_sun
* Get part bits data of  Value Readed
*/

//Input Register value, and msb,lsb, Get the value of msb to lsb
//ex. GetFieldValue(0xABCD,7,4)=>get value:0x00C0
UINT32  GetFieldValue(UINT32 Val,UINT8 msb, UINT8 lsb)
{
    int i ;
    UINT32 FieldVal;
    UINT32 SetML=0;
    for(i = lsb;i<=msb;i++)
        SetML|=(1<<i);
    FieldVal = Val&SetML;
    return  FieldVal;
}


/*
* eva_sun
* Replace part bits of data 
*/

//Input Register value, msb,lsb,and replace date(lsb to msb),Get the all value of being replaced
//ex. SetFieldValue(0xABCD,3,0,0xE)=>get value:0xABCE
UINT32 SetFieldValue(UINT32 Val,UINT8 msb, UINT8 lsb,UINT32 Replace)
{
    int i;
    UINT32 FieldVal;
    UINT32 SetML=0xFFFFFFFF;
    for( i= lsb;i<=msb;i++)
        SetML&=~(1<<i);
    FieldVal = Val&SetML;
    return (FieldVal+(Replace<<lsb));
}


/*
* eva_sun
* get maskval for rtd_maskl(addr, maskval, orval);
*
*/

UINT32 GetMaskAnd(UINT32 msb,UINT32 lsb)
{
	UINT32 i;
   	UINT32 SetML=0xFFFFFFFF;
	
   	for(i = lsb;i<=msb;i++)
        	SetML&=~(1<<i);
	
	return SetML;
}


/************************************************************************
 *
 *                          qc_timer_delay
 *  Description : 
 *  ---------------
 *  choose one timer(0/1) to delay certion time.
 *
 *
 *  Return values :
 *  ---------------
 *  
 *  
 *
 *  None
 *
 ************************************************************************/

/*
void qc_timer_delay(UINT8 nTimer, UINT16 counter, UINT8 delay_time)
{

	UINT32 value;
	UINT32 addr_TMR_DR;
	UINT32 addr_TMR_VR;
	UINT32 addr_TMR_CR;
	UINT32 addr_TMR_DBR;
	UINT32 val_check;

	if(nTimer==0)
	{
		addr_TMR_DR = 0x0ea0;
		addr_TMR_VR = 0x0ea4;
	       addr_TMR_CR = 0x0ea8;
	       addr_TMR_DBR = 	0x0eac;
	}
	else
	{
		addr_TMR_DR = 0x0eb0;
		addr_TMR_VR = 0x0eb4;
	       addr_TMR_CR = 0x0eb8;
	       addr_TMR_DBR = 	0x0ebc;
	}
	
       //RTD_Log(LOGGER_INFO,"Begin Delay...\n");
	   
	if(counter != 0){
		value = counter * delay_time;
		rtdf_outl(addr_TMR_DR, value<<8);//set range
		rtdf_outl(addr_TMR_DBR, 0x06960000);//timer clock:1ms

		//rtdf_setBits(addr_TMR_VR, _BIT0);//write clear
		//rtdf_setBits(addr_TMR_CR, _BIT31);//enable counter

		rtd_maskl(addr_TMR_VR,GetMaskAnd(0,0),0x1);//write clear
		rtdf_outl(addr_TMR_CR,0xa0000000);//enable counter;counter mode

		while(!(rtdf_inl(addr_TMR_VR) & _BIT0)){
		}
	}
	
	//RTD_Log(LOGGER_INFO,"End Delay...\n");
}
*/

