//#include <columbus.h>
//#include <rtd_types.h>
//--#include <rtd_lib.h>
//--#include <asm/addrspace.h>


//#include <asm/arch/system.h>

//#include "linux/compat.h"  //printk

//#include <rtd_types.h>


#include <common.h>
#include "linux/compat.h"
#include <asm/arch/system.h>
#include <rtd_types_qc.h>
#include "usb/read_define.h"


#if defined(CONFIG_BOOT_TIMER)
#include <timer.h>
#endif

#if !defined(CONFIG_FPGA)
//#include <rtd2885_pll.h>
#endif

#include "rl5829_reg.h"
#include "rtd_usb.h"

#if 0
#define  WRAP_BASE                           RTD_WRAP_BASE
#define  WRAP_VStatusOut                     (WRAP_BASE + 0x04)
#define  WRAP_VStatusOut_set_vstatus(data)   (0x000000FF&(data))
#define  USBIPINPUT_REG						(WRAP_BASE + 0x8)
#define  RESET_UTMI_REG						(WRAP_BASE + 0xC)

#define  WRAP_BASE1                           (RTD_WRAP_BASE+0x20)
#define  WRAP_VStatusOut1                     (WRAP_BASE1 + 0x04)
#define  USBIPINPUT_REG1					  (WRAP_BASE1 + 0x8)
#define  RESET_UTMI_REG1					  (WRAP_BASE1 + 0xC)

#define  EHCI_INSNREG01                       (RTD_EHCI_BASE + 0x94)
#define  INSNREG01_IN_THRESHOLD(x)			  (x&0xffff)
#define  INSNREG01_OUT_THRESHOLD(x)			  ((x&0xffff)<<16)

#define  EHCI_INSNREG03                       (RTD_EHCI_BASE + 0x9C)
#define  INSNREG03_BREAK_MEM_TRAN_EN		  (1)

#define  EHCI_INSNREG05                               (RTD_EHCI_BASE + 0xa4)
#define  EHCI_INSNREG05_set_VPort(data)               (0x0001E000&((data)<<13))
#define  EHCI_INSNREG05_bit_VLoadM                    (0x00001000)
#define  EHCI_INSNREG05_set_VLoadM(data)              (0x00001000&((data)<<12))
#define  EHCI_INSNREG05_bit_VCtrl                     (0x00000F00)
#define  EHCI_INSNREG05_set_VCtrl(data)               (0x00000F00&((data)<<8))
#define  EHCI_INSNREG05_get_VBusy(data)               ((0x00020000&(data))>>17)
#define  EHCI_INSNREG05_get_VStatus(data)             (0x000000FF&(data))



#define writel(val,addr)	rtd_outl(addr,val)
#define readl(addr)		rtd_inl(addr)

// #define CONFIG_REALTEK_VENUS_USB_1261_ECO 				1
#define CONFIG_REALTEK_VENUS_USB_1261			1

void UTMI_VendorIF_Init(void){

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VPort[3:0] = 0001, VLoadM = 1, VControl[3:0] = 0000
   writel((readl((UINT32 *) EHCI_INSNREG05) & 
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl(0x0),
   				(UINT32 *) EHCI_INSNREG05);
}


void USBPHY_SetReg(UINT8 addr, UINT8 data){

   // write data out first
   writel((UINT32)WRAP_VStatusOut_set_vstatus(data), WRAP_VStatusOut);

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = low nibble of addr, VLoadM = 0
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x0) |
   				EHCI_INSNREG05_set_VCtrl((0x0f & addr)),
   				EHCI_INSNREG05);

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = low nibble of addr, VLoadM = 1
   writel((readl( EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl((0x0f & addr)),
   				EHCI_INSNREG05);

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = high nibble of addr, VLoadM = 0
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x0) |
   				EHCI_INSNREG05_set_VCtrl(((0xf0 & addr) >> 4)),
   				EHCI_INSNREG05);	 
	 
   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = high nibble of addr, VLoadM = 1
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl(((0xf0 & addr) >> 4)),
   				EHCI_INSNREG05);


   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
}

void USBPHY1_SetReg(UINT8 addr, UINT8 data){

   // write data out first
   writel((UINT32)WRAP_VStatusOut_set_vstatus(data), WRAP_VStatusOut1);

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = low nibble of addr, VLoadM = 0
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x2) |
   				EHCI_INSNREG05_set_VLoadM(0x0) |
   				EHCI_INSNREG05_set_VCtrl((0x0f & addr)),
   				EHCI_INSNREG05);

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = low nibble of addr, VLoadM = 1
   writel((readl( EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x2) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl((0x0f & addr)),
   				EHCI_INSNREG05);

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = high nibble of addr, VLoadM = 0
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x2) |
   				EHCI_INSNREG05_set_VLoadM(0x0) |
   				EHCI_INSNREG05_set_VCtrl(((0xf0 & addr) >> 4)),
   				EHCI_INSNREG05);	 
	 
   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = high nibble of addr, VLoadM = 1
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x2) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl(((0xf0 & addr) >> 4)),
   				EHCI_INSNREG05);


   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
}

UINT8 USBPHY_GetReg(UINT8 addr){
	

   if((USBPHY_30 == addr) | (USBPHY_31 == addr) | (USBPHY_32 == addr) |
      (USBPHY_33 == addr) | (USBPHY_34 == addr) | (USBPHY_35 == addr) |
      (USBPHY_36 == addr) | (USBPHY_38 == addr) ){
      while(1){
         // invalid address access, these registers should not be read 
      }
   }
  
   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = low nibble of addr, VLoadM = 0
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x0) |
   				EHCI_INSNREG05_set_VCtrl((0x0f & addr)),
   				EHCI_INSNREG05);   
   
   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = low nibble of addr, VLoadM = 1
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl(((0xf0 & addr) >> 4)),
   				EHCI_INSNREG05);
	 

	// polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = high nibble of addr, VLoadM = 0
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x0) |
   				EHCI_INSNREG05_set_VCtrl(((0xf0 & addr) >> 4)),
   				EHCI_INSNREG05);
	 
   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = high nibble of addr, VLoadM = 1
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x1) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl((0x0f & addr)),
   				EHCI_INSNREG05);   

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));

   return((UINT8)EHCI_INSNREG05_get_VStatus(readl(EHCI_INSNREG05)));
}

UINT8 USBPHY1_GetReg(UINT8 addr){
	

   if((USBPHY_30 == addr) | (USBPHY_31 == addr) | (USBPHY_32 == addr) |
      (USBPHY_33 == addr) | (USBPHY_34 == addr) | (USBPHY_35 == addr) |
      (USBPHY_36 == addr) | (USBPHY_38 == addr) ){
      while(1){
         // invalid address access, these registers should not be read 
      }
   }
  
   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = low nibble of addr, VLoadM = 0
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x2) |
   				EHCI_INSNREG05_set_VLoadM(0x0) |
   				EHCI_INSNREG05_set_VCtrl((0x0f & addr)),
   				EHCI_INSNREG05);   
   
   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = low nibble of addr, VLoadM = 1
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x2) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl(((0xf0 & addr) >> 4)),
   				EHCI_INSNREG05);
	 

	// polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = high nibble of addr, VLoadM = 0
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x2) |
   				EHCI_INSNREG05_set_VLoadM(0x0) |
   				EHCI_INSNREG05_set_VCtrl(((0xf0 & addr) >> 4)),
   				EHCI_INSNREG05);
	 
   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));
   // VCtrl = high nibble of addr, VLoadM = 1
   writel((readl(EHCI_INSNREG05) &
   				(~ EHCI_INSNREG05_bit_VLoadM) &
   				(~ EHCI_INSNREG05_bit_VCtrl)) |
   				EHCI_INSNREG05_set_VPort(0x2) |
   				EHCI_INSNREG05_set_VLoadM(0x1) |
   				EHCI_INSNREG05_set_VCtrl((0x0f & addr)),
   				EHCI_INSNREG05);   

   // polling until VBusy == 0
   while(EHCI_INSNREG05_get_VBusy(readl(EHCI_INSNREG05)));

   return((UINT8)EHCI_INSNREG05_get_VStatus(readl(EHCI_INSNREG05)));
}
void USBPHY_SetReg_Default_30(void)
{
   USBPHY_SetReg(USBPHY_30, USBPHY_30_set_xcvr_autok(0x1) |       // POR = 1
                            USBPHY_30_set_xcvr_SC(0x3) |          // POR = 3, PLL_C
                            USBPHY_30_set_xcvr_CP(0x1));          // POR = 1
}


void USBPHY_SetReg_Default_31(void)
{
   USBPHY_SetReg(USBPHY_31, USBPHY_31_set_xcvr_call_host(0x1) |   // POR = 1
                            USBPHY_31_set_xcvr_zeres_sel(0x0) |   // POR = 0
                            USBPHY_31_set_xcvr_zo_en(0x1) |       // POR = 1
                            USBPHY_31_set_xcvr_SD(0x1) |          // POR = 1
                            USBPHY_31_set_xcvr_SR(0x4));          // POR = 4, PLL_R
}


void USBPHY_SetReg_Default_32(int sh)
{
   USBPHY_SetReg(USBPHY_32, USBPHY_32_set_SEN(0x8) |              // POR = 8
                            USBPHY_32_set_SH((sh & 0xf)));        // POR = 5, swing
}


void USBPHY_SetReg_Default_33(void)
{
   USBPHY_SetReg(USBPHY_33, USBPHY_33_set_HSXMPTPDEN(0x1) |       // POR = 1, hi-speed XCVR power down enable
                            USBPHY_33_set_xcvr_CAL(0x1) |         // POR = 1

#ifdef CONFIG_REALTEK_VENUS_USB_1261
			    USBPHY_33_set_xcvr_DR(0x1)  	  // POR = 0, 1 for LS FIB
#endif /* CONFIG_REALTEK_VENUS_USB_1261 */

#ifdef CONFIG_REALTEK_VENUS_USB_1261_ECO
			    USBPHY_33_set_xcvr_DR(0x0)  	  // POR = 0
#endif /* CONFIG_REALTEK_VENUS_USB_1261_ECO */
			    );
			    
}


void USBPHY_SetReg_Default_34(void)
{
   USBPHY_SetReg(USBPHY_34, USBPHY_34_set_TPA_EN(0x0) |      // POR = 0
                            USBPHY_34_set_TPB_EN(0x0) |      // POR = 0
                            USBPHY_34_set_xcvr_TS(0x0) |          // POR = 0
                            USBPHY_34_set_xcvr_SE(0x2));          // POR = 2
}


void USBPHY_SetReg_Default_35(int src)
{
   USBPHY_SetReg(USBPHY_35, USBPHY_35_set_TPC_EN(0x0) |          // POR = 0
                            USBPHY_35_set_xcvr_SP(0x0) |          // POR = 0
                            USBPHY_35_set_xcvr_SRC((src & 0x7)) | // POR = 7,  slew rate control
                            USBPHY_35_set_HSTESTEN(0x0) |         // POR = 0
                            USBPHY_35_set_xcvr_nsqdly(0x1));      // POR = 1
}


void USBPHY_SetReg_Default_36(int senh)
{
   USBPHY_SetReg(USBPHY_36, USBPHY_36_set_xcvr_senh((senh & 0xf)) | // POR = 9,  sensitivity for host, for HS disconnect detect (EOP) 
                            USBPHY_36_set_xcvr_adjr(0x8));          // POR = 8
}


void USBPHY_SetReg_Default_38(int slb_en)
{
   if(slb_en != 0)
   	slb_en = 1;
   USBPHY_SetReg(USBPHY_38, USBPHY_38_set_dbnc_en(0x1) |          // POR = 1
                            USBPHY_38_set_discon_enable(0x1) |    // POR = 1
                            USBPHY_38_set_EN_ERR_UNDERRUN(0x1) |  // POR = 1
                            USBPHY_38_set_LATE_DLLEN(0x1) |       // POR = 1
                            USBPHY_38_set_INTG(0x1) |             // POR = 0
                            USBPHY_38_set_SOP_KK(0x1) |           // POR = 1
                            USBPHY_38_set_SLB_INNER(0x0) |        // POR = 0
                            USBPHY_38_set_SLB_EN((slb_en & 0x1)));        // POR = 0
}


#endif


void USB3PHY_Setting(void)
{

printk("set usb phy3....\n");
	rtd_outl(0xb8013210,0xa000190d);
udelay(300);    
   
// write 0x1b -> "a027"
rtd_outl(0xb8013210,0xa0271b0d);
udelay(300); 

// write 0x0a -> "9240"
rtd_outl(0xb8013210,0x92400a0d);
udelay(300); 

// write 0x00 -> "1238"
rtd_outl(0xb8013210,0x1238000d);
udelay(300);   

// write 0x01 -> "0003"
rtd_outl(0xb8013210,0x0003010d);
udelay(300);  

// write 0x02 -> "2d18"
rtd_outl(0xb8013210,0x2d18020d);
udelay(300); 

// write 0x03 -> "6d70"
rtd_outl(0xb8013210,0x6d70030d);
udelay(300); 

// write 0x04 -> "597b"
rtd_outl(0xb8013210,0x597b040d);
udelay(300); 

// write 0x05 -> "02c6"
rtd_outl(0xb8013210,0x02c6050d);
udelay(300); 

// write 0x06 -> "a0a4"
rtd_outl(0xb8013210,0xa0a4060d);
udelay(300); 

// write 0x07 -> "4ec1"
rtd_outl(0xb8013210,0x4ec1070d);
udelay(300);  

// write 0x08 -> "3592"
rtd_outl(0xb8013210,0x3592080d);
udelay(300); 

// write 0x09 -> "923c"
rtd_outl(0xb8013210,0x923c090d);
udelay(300);  

// write 0x0b -> "c51d"
rtd_outl(0xb8013210,0xc51d0b0d);
udelay(300); 

// write 0x0c -> "68ab"
rtd_outl(0xb8013210,0x68ab0c0d);
udelay(300); 

// write 0x0d -> "256e"
rtd_outl(0xb8013210,0x256e0d0d);
udelay(300); 

// write 0x0e -> "9b01"
rtd_outl(0xb8013210,0x9b010e0d);
udelay(300); 

// write 0x0f -> "051a"
rtd_outl(0xb8013210,0x051a0f0d);
udelay(300); 

// write 0x10 -> "000c"
rtd_outl(0xb8013210,0x000c100d);
udelay(300); 

// write 0x11 -> "4c00"
rtd_outl(0xb8013210,0x4c00110d);
udelay(300); 

// write 0x12 -> "fc00"
rtd_outl(0xb8013210,0xfc00120d);
udelay(300); 

// write 0x13 -> "0c81"
rtd_outl(0xb8013210,0x0c81130d);
udelay(300); 

// write 0x14 -> "de01"
rtd_outl(0xb8013210,0xde01140d);
udelay(300); 

// write 0x1a -> "6de1"
rtd_outl(0xb8013210,0x6de11a0d);
udelay(300); 

// write 0x1c -> "cb00"
rtd_outl(0xb8013210,0xcb001c0d);
udelay(300); 

// write 0x1d -> "a07f"
rtd_outl(0xb8013210,0xa07f1d0d);
udelay(300); 

// write 0x1e -> "c2a0"
rtd_outl(0xb8013210,0xc2a01e0d);
udelay(300); 

// write 0x20 -> "e38f"
rtd_outl(0xb8013210,0xe38f200d);
udelay(300); 

// write 0x21 -> "d51f"
rtd_outl(0xb8013210,0xd51f210d);
udelay(300); 

// write 0x22 -> "0836"
rtd_outl(0xb8013210,0x0836220d);
udelay(300);  

// write 0x23 -> "8fb4"
rtd_outl(0xb8013210,0x8fb4230d);
udelay(300); 

// write 0x24 -> "13f1"
rtd_outl(0xb8013210,0x13f1240d);
udelay(300);  

// write 0x25 -> "03dd"
rtd_outl(0xb8013210,0x03dd250d);
udelay(300);  

// write 0x26 -> "6cca"
rtd_outl(0xb8013210,0x6cca260d);
udelay(300); 

// write 0x27 -> "00d6"
rtd_outl(0xb8013210,0x00d6270d);
udelay(300); 

// write 0x28 -> "48b0"
rtd_outl(0xb8013210,0x48b0280d);
udelay(300); 

// write 0x2a -> "3080"
rtd_outl(0xb8013210,0x30802a0d);
udelay(300);  

// write 0x2b -> "2018"
rtd_outl(0xb8013210,0x20182b0d);
udelay(300); 

// write 0x04 -> "797b"
rtd_outl(0xb8013210,0x797b040d);
udelay(300); 

// write 0x20 -> "e18f"
rtd_outl(0xb8013210,0xe18f200d);
udelay(300); 

// write 0x20 -> "e38f"
rtd_outl(0xb8013210,0xe38f200d);
udelay(300);  

// write 0x0a -> "9a40"
rtd_outl(0xb8013210,0x9a400a0d);
udelay(300);  

// write 0x0a -> "9a44"
rtd_outl(0xb8013210,0x9a440a0d);
udelay(300); 

// write 0x0a -> "9240"
rtd_outl(0xb8013210,0x92400a0d);
udelay(300);  

// write 0x09 -> "923c"
rtd_outl(0xb8013210,0x923c090d);
udelay(300);  

// write 0x09 -> "903c"
rtd_outl(0xb8013210,0x903c090d);
udelay(300);   

// write 0x09 -> "923c"
rtd_outl(0xb8013210,0x923c090d);
udelay(300); 

}

#if 0
void USB3PHY_Setting(void)
{

	printk("set usb phy3....\n");
//0x00
//dv "set PHY 0x00\n"
rtd_outl(0xb8013210,0x00000000) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x12780001);
rtd_outl(0xb8013210,0x00000000);
rtd_inl(0xb8013210);

//0x01
//dv "set PHY 0x01\n"
rtd_outl(0xb8013210,0x00000100) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00030101);
rtd_outl(0xb8013210,0x00000100);
rtd_inl(0xb8013210);

//0x02
//dv "set PHY 0x02\n"
rtd_outl(0xb8013210,0x00000200) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x2d180201);
rtd_outl(0xb8013210,0x00000200);
rtd_inl(0xb8013210);

//0x03
//dv "set PHY 0x03\n"
rtd_outl(0xb8013210,0x00000300);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x6d660301);
rtd_outl(0xb8013210,0x00000300);
rtd_inl(0xb8013210);

//0x04
//dv "set PHY 0x04\n"
rtd_outl(0xb8013210,0x00000400);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x597b0401);
rtd_outl(0xb8013210,0x00000400);
rtd_inl(0xb8013210);

//0x05
//dv "set PHY 0x05\n"
rtd_outl(0xb8013210,0x00000500);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x02c60501);       
rtd_outl(0xb8013210,0x00000500);
rtd_inl(0xb8013210);

//0x06
//dv "set PHY 0x06\n"
rtd_outl(0xb8013210,0x00000600);
rtd_inl(0xb8013210) ;       
rtd_outl(0xb8013210,0x20a40601) ;      
rtd_outl(0xb8013210,0x00000600);
rtd_inl(0xb8013210);

//0x07
//dv "set PHY 0x07\n"
rtd_outl(0xb8013210,0x00000700);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x5ec10701);
rtd_outl(0xb8013210,0x00000700);
rtd_inl(0xb8013210);

//0x08
//dv "set PHY 0x08\n"
rtd_outl(0xb8013210,0x00000800);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x35920801);
rtd_outl(0xb8013210,0x00000800);
rtd_inl(0xb8013210);

//0x09
//dv "set PHY 0x09\n"
rtd_outl(0xb8013210,0x00000900);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x921c0901);
rtd_outl(0xb8013210,0x00000900);
rtd_inl(0xb8013210);

//0x0a
//dv "set PHY 0x0a\n"
rtd_outl(0xb8013210,0x00000a00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x52800a01);
rtd_outl(0xb8013210,0x00000a00);
rtd_inl(0xb8013210);

//0x0b
//dv "set PHY 0x0b\n"
rtd_outl(0xb8013210,0x00000b00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xc51d0b01);
rtd_outl(0xb8013210,0x00000b00);
rtd_inl(0xb8013210);

//0x0c
//dv "set PHY 0x0c\n"
rtd_outl(0xb8013210,0x00000c00);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xa8ab0c01);
rtd_outl(0xb8013210,0x00000c00);
rtd_inl(0xb8013210);

//0x0d
//dv "set PHY 0x0d\n"
rtd_outl(0xb8013210,0x00000d00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x27a60d01);
rtd_outl(0xb8013210,0x00000d00);
rtd_inl(0xb8013210);

//0x0e
//dv "set PHY 0x0e\n"
rtd_outl(0xb8013210,0x00000e00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x94c50e01);
rtd_outl(0xb8013210,0x00000e00);
rtd_inl(0xb8013210);

//0x0f
//dv "set PHY 0x0f\n"
rtd_outl(0xb8013210,0x00000f00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x051a0f01);
rtd_outl(0xb8013210,0x00000f00);
rtd_inl(0xb8013210);

//0x10
//dv "set PHY 0x10\n"
rtd_outl(0xb8013210,0x00001000) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x000c1001);
rtd_outl(0xb8013210,0x00001000);
rtd_inl(0xb8013210);

//0x11
//dv "set PHY 0x11\n"
rtd_outl(0xb8013210,0x00001100); 
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x4c001101);
rtd_outl(0xb8013210,0x00001100);
rtd_inl(0xb8013210);

//0x12
//dv "set PHY 0x12\n"
rtd_outl(0xb8013210,0x00001200); 
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xfc001201);
rtd_outl(0xb8013210,0x00001200);
rtd_inl(0xb8013210);

//0x13
//dv "set PHY 0x13\n"
rtd_outl(0xb8013210,0x00001300); 
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x0c811301);
rtd_outl(0xb8013210,0x00001300);
rtd_inl(0xb8013210);

//0x14
//dv "set PHY 0x14\n"
rtd_outl(0xb8013210,0x00001400);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xde011401);
rtd_outl(0xb8013210,0x00001400);
rtd_inl(0xb8013210);

//0x15
//dv "set PHY 0x15\n"
rtd_outl(0xb8013210,0x00001500);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00001501);
rtd_outl(0xb8013210,0x00001500);
rtd_inl(0xb8013210);

//0x16
//dv "set PHY 0x16\n"
rtd_outl(0xb8013210,0x00001600); 
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00001601);
rtd_outl(0xb8013210,0x00001600);
rtd_inl(0xb8013210);

//0x17
//dv "set PHY 0x17\n"
rtd_outl(0xb8013210,0x00001700) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00001701);
rtd_outl(0xb8013210,0x00001700);
rtd_inl(0xb8013210);

//0x18
//dv "set PHY 0x18\n"
rtd_outl(0xb8013210,0x00001800);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00001801);
rtd_outl(0xb8013210,0x00001800);
rtd_inl(0xb8013210);

//0x19
//dv "set PHY 0x19\n"
rtd_outl(0xb8013210,0x00001900);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xa0001901);
rtd_outl(0xb8013210,0x00001900);
rtd_inl(0xb8013210);

//0x1a
//dv "set PHY 0x1a\n"
rtd_outl(0xb8013210,0x00001a00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x6de11a01);
rtd_outl(0xb8013210,0x00001a00);
rtd_inl(0xb8013210);

//0x1b
//dv "set PHY 0x1b\n"
rtd_outl(0xb8013210,0x00001b00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x3f001b01);
rtd_outl(0xb8013210,0x00001b00);
rtd_inl(0xb8013210);

//0x1c
//dv "set PHY 0x1c\n"
rtd_outl(0xb8013210,0x00001c00);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xc3001c01);
rtd_outl(0xb8013210,0x00001c00);
rtd_inl(0xb8013210);

//0x1d
//dv "set PHY 0x1d\n"
rtd_outl(0xb8013210,0x00001d00);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xa03e1d01);
rtd_outl(0xb8013210,0x00001d00);
rtd_inl(0xb8013210);

//0x1e
//dv "set PHY 0x1e\n"
rtd_outl(0xb8013210,0x00001e00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xc2a01e01);
rtd_outl(0xb8013210,0x00001e00);
rtd_inl(0xb8013210);

//0x1f
//dv "set PHY 0x1f\n"
rtd_outl(0xb8013210,0x00001f00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00001f01);
rtd_outl(0xb8013210,0x00001f00);
rtd_inl(0xb8013210);

//0x20
//dv "set PHY 0x20\n"
rtd_outl(0xb8013210,0x00002000); 
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xe39f2001);
rtd_outl(0xb8013210,0x00002000);
rtd_inl(0xb8013210);

//0x21
//dv "set PHY 0x21\n"
rtd_outl(0xb8013210,0x00002100) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0xd51b2101);
rtd_outl(0xb8013210,0x00002100);
rtd_inl(0xb8013210);

//0x22
//dv "set PHY 0x22\n"
rtd_outl(0xb8013210,0x00002200) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x08362201);
rtd_outl(0xb8013210,0x00002200);
rtd_inl(0xb8013210);

//0x23
//dv "set PHY 0x23\n"
rtd_outl(0xb8013210,0x00002300); 
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x4fa22301);
rtd_outl(0xb8013210,0x00002300);
rtd_inl(0xb8013210);

//0x24
//dv "set PHY 0x24\n"
rtd_outl(0xb8013210,0x00002400);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x13f12401);
rtd_outl(0xb8013210,0x00002400);
rtd_inl(0xb8013210);

//0x25
//dv "set PHY 0x25\n"
rtd_outl(0xb8013210,0x00002500); 
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x03dd2501);
rtd_outl(0xb8013210,0x00002500);
rtd_inl(0xb8013210);

//0x26
//dv "set PHY 0x26\n"
rtd_outl(0xb8013210,0x00002600) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x6dba2601);
rtd_outl(0xb8013210,0x00002600);
rtd_inl(0xb8013210);

//0x27
//dv "set PHY 0x27\n"
rtd_outl(0xb8013210,0x00002700) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00d62701);
rtd_outl(0xb8013210,0x00002700);
rtd_inl(0xb8013210);

//0x28
//dv "set PHY 0x28\n"
rtd_outl(0xb8013210,0x00002800) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x48b02801);
rtd_outl(0xb8013210,0x00002800);
rtd_inl(0xb8013210);

//0x2a
//dv "set PHY 0x2a\n"
rtd_outl(0xb8013210,0x00002a00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x30002a01);
rtd_outl(0xb8013210,0x00002a00);
rtd_inl(0xb8013210);

//0x2b
//dv "set PHY 0x2b\n"
rtd_outl(0xb8013210,0x00002b00);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00002b01);
rtd_outl(0xb8013210,0x00002b00);
rtd_inl(0xb8013210);

//0x2f
//dv "set PHY 0x2f\n"
rtd_outl(0xb8013210,0x00002f00);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x00002f01);
rtd_outl(0xb8013210,0x00002f00);
rtd_inl(0xb8013210);

//0x04
//dv "set PHY 0x04\n"
rtd_outl(0xb8013210,0x00000400);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x597b0401);
rtd_outl(0xb8013210,0x00000400);
rtd_inl(0xb8013210);

//0x0a
//dv "set PHY 0x0a\n"
rtd_outl(0xb8013210,0x00000a00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x5a800a01);
rtd_outl(0xb8013210,0x00000a00);
rtd_inl(0xb8013210);

//0x0a
//dv "set PHY 0x0a\n"
rtd_outl(0xb8013210,0x00000a00);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x5a840a01);
rtd_outl(0xb8013210,0x00000a00);
rtd_inl(0xb8013210);

//0x0a
//dv "set PHY 0x0a\n"
rtd_outl(0xb8013210,0x00000a00); 
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x52800a01);
rtd_outl(0xb8013210,0x00000a00);
rtd_inl(0xb8013210);

//0x0a
//dv "set PHY 0x0a\n"
rtd_outl(0xb8013210,0x00000a00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x52800a01);
rtd_outl(0xb8013210,0x00000a00);
rtd_inl(0xb8013210);

//0x0a
//dv "set PHY 0x0a\n"
rtd_outl(0xb8013210,0x00000a00) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x52800a01);
rtd_outl(0xb8013210,0x00000a00);
rtd_inl(0xb8013210);

//0x09
//dv "set PHY 0x09\n"
rtd_outl(0xb8013210,0x00000900);
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x921c0901);
rtd_outl(0xb8013210,0x00000900);
rtd_inl(0xb8013210);

//0x09
//dv "set PHY 0x09\n"
rtd_outl(0xb8013210,0x00000900) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x901c0901);
rtd_outl(0xb8013210,0x00000900);
rtd_inl(0xb8013210);

//0x09
//dv "set PHY 0x09\n"
rtd_outl(0xb8013210,0x00000900) ;
rtd_inl(0xb8013210);
rtd_outl(0xb8013210,0x921c0901);
rtd_outl(0xb8013210,0x00000900);
rtd_inl(0xb8013210);



}

#endif

void USBPHY_Register_Setting(void){


#if 0 //check after

   int param[3];//, value, i = 0, index = 0;
   int count=0;
   unsigned long value=0;

   param[0] = 0x5;// 0x5;		// reg 32 sh, POR = 5, 4bit;
   param[1] = 0x7;// 0x7;		// reg 35 src, POR = 7, 3bit;
   param[2] = 0xd;		// reg 36 senh, POR = 9, 4bit;

   //fox
   //rtd_outl(0xb8000650,rtd_inl(0xb8000650)|(1<<9));
   //udelay(1000);  

//--   rtd_outl(0xb80008b4,(rtd_inl(0xb80008b4) | (1<<2) )& (~(1<<3)));
//--   rtd_outl(0xb80008b8,(rtd_inl(0xb80008b8) | (1<<26) )& (~(1<<27)));

#if !defined(CONFIG_FPGA)
/*
#define USB_CLKEN	 (1<<15)
#define USB_RSTN_PHY (1<<15)
#define USB_RSTN	 (1<<14)
*/

#define RSTN_USB2_DIV (1<<20)
#define RSTN_USB2_MAC (1<<19)
#define RSTN_USB_ARB (1<<18)
#define USB_CLKEN	 (1<<18)

#define USB3_PHY_CTRL (0xb8000230)
#define USB2_PHY_P1_RSTN  (1 << 5)
#define USB2_PHY_P0_RSTN (1 << 4)
#define USB3_PHY_RSTN (1 << 3)
#define USB3_MAC_RSTN (1<< 2)
#define USB3_P0_MDIO_RSTN (1<<1)

printk("[a] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
   /* Open USB's clock gating. */
#if 0
   rtd_outl(BOOTREG_SYS_SRST2,rtd_inl(BOOTREG_SYS_SRST2) & ~(USB_RSTN_PHY|USB_RSTN));
#else
   rtd_outl(BOOTREG_SYS_SRST2,rtd_inl(BOOTREG_SYS_SRST2) & ~(RSTN_USB2_DIV|RSTN_USB2_MAC|RSTN_USB_ARB));

   rtd_outl(USB3_PHY_CTRL,rtd_inl(USB3_PHY_CTRL) & ~(USB2_PHY_P1_RSTN|USB2_PHY_P0_RSTN | USB3_PHY_RSTN | USB3_MAC_RSTN | USB3_P0_MDIO_RSTN));
#endif
   udelay(5000); 

printk("[b] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
#if 0
   //set RSTN_USB_PHY= 1'b1;
   rtd_outl(BOOTREG_SYS_SRST2,rtd_inl(BOOTREG_SYS_SRST2) | USB_RSTN);
   udelay(2000); 
   //turn-on CLK_EN_USB
   rtd_outl(BOOTREG_SYS_CLKEN1,rtd_inl(BOOTREG_SYS_CLKEN1) | USB_CLKEN);
   udelay(1000); 
   //turn-off CLK_EN_USB
   rtd_outl(BOOTREG_SYS_CLKEN1,rtd_inl(BOOTREG_SYS_CLKEN1) & ~USB_CLKEN);
   udelay(1000); 
   rtd_outl(BOOTREG_SYS_SRST2,rtd_inl(BOOTREG_SYS_SRST2) | USB_RSTN|USB_RSTN_PHY);
   udelay(1000); 
   //turn-on CLK_EN_USB
   rtd_outl(BOOTREG_SYS_CLKEN1,rtd_inl(BOOTREG_SYS_CLKEN1) | USB_CLKEN);
   udelay(1000); 
#else
   //set RSTN_USB_PHY= 1'b1;
   rtd_outl(USB3_PHY_CTRL,rtd_inl(USB3_PHY_CTRL) | USB2_PHY_P1_RSTN | USB2_PHY_P0_RSTN | USB3_PHY_RSTN );
   udelay(3000); 

printk("[c] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
   
   //turn-on CLK_EN_USB
   rtd_outl(BOOTREG_SYS_CLKEN3,rtd_inl(BOOTREG_SYS_CLKEN3) | USB_CLKEN);
   udelay(1000); 

   printk("[d] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
   //turn-off CLK_EN_USB
   rtd_outl(BOOTREG_SYS_CLKEN3,rtd_inl(BOOTREG_SYS_CLKEN3) & ~USB_CLKEN);
   udelay(1000); 
   printk("[e] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
    //set RSTN_USB= 1'b1;
   rtd_outl(BOOTREG_SYS_SRST2,rtd_inl(BOOTREG_SYS_SRST2) | RSTN_USB2_MAC);
	printk("[f] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
   rtd_outl(USB3_PHY_CTRL,rtd_inl(USB3_PHY_CTRL) | USB3_MAC_RSTN | USB3_P0_MDIO_RSTN);
   printk("[g] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
     rtd_outl(BOOTREG_SYS_SRST2,rtd_inl(BOOTREG_SYS_SRST2) |RSTN_USB2_DIV|RSTN_USB_ARB);
	 printk("[h] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
   udelay(1000);
   //turn-on CLK_EN_USB
   rtd_outl(BOOTREG_SYS_CLKEN3,rtd_inl(BOOTREG_SYS_CLKEN3) | USB_CLKEN);
   printk("[i] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
   udelay(1000); 
#endif
   //rtd_outl(0xb8013834,rtd_inl(0xb8013834)|0x01);
   //udelay(1000); 
//--   rtd_outl(0xb8000650,rtd_inl(0xb8000650)|(1<<9));
//--   udelay(1000);
#endif      



//HDMI band gap
rtd_outl(0xb800da40,0x02800202);
udelay(100 * 100);
printk("[j] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
#if 1

//-- check after   rtd_outl(0xb8013808,0x4000A081/* 0x4400A081 0x0400A081*/);
   rtd_outl(0xb801380c,0x1);     

printk("[k] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
   udelay(100*1000);   
   /* In columbus, we use usb phy default value */
//-- check after   rtd_outl(0xb8013828,0x4000A081/*  0x4400A081 0x0400A081*/);

   rtd_outl(0xb801382c,0x1);  
   //rtd_outl(RESET_UTMI_REG1,0x1);  
   udelay(100*1000);

printk("[l] %x %x\n",rtd_inl(0xb8050420),rtd_inl(0xb8050430));
   
#endif


#endif



#if 0
    /* HS Self loop-back mode. */
    printk("FS/LS Self loop-back mode fun=%s line=%d \r\n",__FUNCTION__,__LINE__);
    // USBPHY_SetReg(USBPHY_35, 0xFF);
    //USBPHY_SetReg(USBPHY_38, 0xFD);
    /* Endless-loop pattern gerate.*/ 
    for(count=0;count<10;count++)
    {
       //rtd_outl(0xb80f3810,/*0x3c0*/ 0x7c0 /*0xbc2*/);
       rtd_outl(0xb80f3810,0xbc0);//0x7c0,0x7c1 ,0x7c2--> ok
       rtd_outl(0xb80f380c,0x4);
       rtd_outl(0xb80f380c,0x0);
       rtd_outl(0xb80f380c,0x2);	
       udelay(3000);
       while(1)
       {
            udelay(300*1000);
            value = rtd_inl(0xb80f3810);
            if(value&0x2000)
            {
                if(value&0x1000)
                {
                    printk("Success fun=%s line=%d value=%x\r\n",__FUNCTION__,__LINE__,value);
                    break;
                }
                else
                {
                    printk("fial fun=%s line=%d value=%x\r\n",__FUNCTION__,__LINE__,value);
                    break;
                }
            }
            else
            {
                printk("fial fun=%s line=%d value=%x\r\n",__FUNCTION__,__LINE__,value);
                break;
            }
       }
    };
    
    /* HS Self loop-back mode. */
    printk("HS Self loop-back mode fun=%s line=%d \r\n",__FUNCTION__,__LINE__);
    // USBPHY_SetReg(USBPHY_35, 0xFF);
    //USBPHY_SetReg(USBPHY_38, 0xFD);
    /* Endless-loop pattern gerate.*/ 
    for(count=0;count<10;count++)
    {
       //rtd_outl(0xb80f3810,/*0x3c0*/ 0x7c0 /*0xbc2*/);
       rtd_outl(0xb80f3810,0x7c0);//0x7c0,0x7c1 ,0x7c2--> ok
       rtd_outl(0xb80f380c,0x4);
       rtd_outl(0xb80f380c,0x0);
       rtd_outl(0xb80f380c,0x2);
       while(1)
       {
            udelay(300*1000);
            value = rtd_inl(0xb80f3810);
            if(value&0x2000)
            {
                if(value&0x1000)
                {
                    printk("Success fun=%s line=%d value=%x\r\n",__FUNCTION__,__LINE__,value);
                    break;
                }
                else
                {
                    printk("fial fun=%s line=%d value=%x\r\n",__FUNCTION__,__LINE__,value);
                    break;
                }
            }
            else
            {
                printk("fial fun=%s line=%d value=%x\r\n",__FUNCTION__,__LINE__,value);
                break;
            }
       }
    };
#endif

#if 0
   UTMI_VendorIF_Init();
   
   USBPHY_SetReg_Default_30();

   USBPHY_SetReg_Default_31();

   USBPHY_SetReg_Default_32(param[0]);

   USBPHY_SetReg_Default_33();

   USBPHY_SetReg_Default_34();

   USBPHY_SetReg_Default_35(param[1]);

   USBPHY_SetReg_Default_36(param[2]);

   USBPHY_SetReg_Default_38(0);

   //fox
   //rtd_outl(0xB8007180,rtd_inl(0xB8007180) | (1<<31) | (0xc<<8) );
   //rtd_outl(0xB80f3800,rtd_inl(0xB80f3800) | (0x10<<1));
 

   // LX debug pin.
   /*
   rtd_outl(0xB8007180,rtd_inl(0xB8007180) | (0xf<<28) );
   rtd_outl(0xB8007180,rtd_inl(0xB8007180) | (0x5<<8) );
   rtd_outl(0xB8001038,rtd_inl(0xB8001038) | (0x7<<0));
   */

   // printk("0xB8007180 = 0x%x , 0xB80f3800 = 0x%x\n",rtd_inl(0xB8007180) ,rtd_inl(0xB80f3800));
#if 0
/* HS Self loop-back mode. */
   // USBPHY_SetReg(USBPHY_35, 0xFF);
   USBPHY_SetReg(USBPHY_38, 0xFD);

/* Endless-loop pattern gerate.*/ 
while(1) {
   rtd_outl(0xb80f3810,/*0x3c0*/ 0x7c0 /*0xbc2*/);
   rtd_outl(0xb80f380c,0x4);
   rtd_outl(0xb80f380c,0x0);
   rtd_outl(0xb80f380c,0x2);	
};
#endif
   // printk("usbphy reg 38 = 0x%x\n" , USBPHY_GetReg(USBPHY_38));

#if 0
   printk("usbphy reg 32, set sh = 0x%x, get sh = 0x%x, 4bit\n", \
		   param[0], USBPHY_GetReg(USBPHY_22) & 0xf);
   printk("usbphy reg 35, set src = 0x%x, get src = 0x%x, 3bit\n", \
		   param[1], (USBPHY_GetReg(USBPHY_25)>>2) & 0x7);
   printk("usbphy reg 36, set senh = 0x%x, get senh = 0x%x, 4bit\n", \
		   param[2], (USBPHY_GetReg(USBPHY_26)>>4) & 0xf);
			   
   rtd_outl(EHCI_INSNREG01,INSNREG01_IN_THRESHOLD(0x40) | INSNREG01_OUT_THRESHOLD(0x40));		   
   rtd_outl(EHCI_INSNREG03,INSNREG03_BREAK_MEM_TRAN_EN);
#endif

 
#endif 
}

