#include <qc_verify_common.h>
#include <qc_verify.h>
#include <linux/bitops.h>
#include <../include/VD/Mac7p/rbusVDPQReg.h>
#include "VDC_PQ_qc.h"



#define VDC_MEM0_ADDR_INI_VADDR (0xb8019870)
#define VDC_MEM1_ADDR_INI_VADDR (0xb8019874)
#define VDC_MEM2_ADDR_INI_VADDR (0xb8019878)
#define VDC_MEM3_ADDR_INI_VADDR (0xb801987c)
#define VDC_MEM0_ADDR_END_VADDR (0xb8019880)
#define VDC_MEM1_ADDR_END_VADDR (0xb8019884)
#define VDC_MEM2_ADDR_END_VADDR (0xb8019888)
#define VDC_MEM3_ADDR_END_VADDR (0xb801988c)

void module_vdc_init_clock(void)
{
	trace_f();

	rtd_maskl(0xb8000104, 0xFF9FF7Fe, 0x00608801); //[22]RSTN_VDEC[21]RSTN_VDEC2[15]RSTN_IFADC[11]RSTN_APLL_ADC
	rtd_maskl(0xb8000108, 0xF3FFFFFe, 0x0C000001); //[27]RSTN_ATVIN2[26]RSTN_ATVIN
	rtd_maskl(0xb8000114, 0xFFBFF7Fe, 0x00408801); //[22]CLKEN_VDEC[15]CLKEN_IFADC[11]CLKEN_APLL_ADC
	rtd_maskl(0xb8000118, 0xF3BFFFFe, 0x0C400001); //[27]CLKEN_ATVIN_VD[26]CLKEN_ATVIN_IFD
	rtd_maskl(0xb8000204, 0xFFFCFFFF, 0x00020000); //[17]ATVIN_CLK_SEL] = 0x1, 0x0: IFD, 0x1: VD [16]ATVIN_VD_CLK_SEL = 0x0, 0x0: 108MHz 0x1: 27MHz
	rtd_maskl(0xb80004D0, 0xFFFFFFE0, 0x0000000E); //432MHzPLL27X_M[6:0] = 0x0E
	rtd_maskl(0xb80004D4, 0xFFFFFFFF, 0x00000000); // do nothing
	rtd_maskl(0xb80004DC, 0xFDFC0FFF, 0x0201F000); //[25]PLL_L2H_CML_POW [17:16]PLL27X_CK108M_DIV = 0x1, divide by 4 (use when VCO=432MHz) [15:14]PLL27X_YPPADC_CKO_SEL = 0x3,YPPADC clock outpu 11:108M [13]PLL27X_YPPADC_CKO_EN[12]PLL27X_YPPADC_CK54M_EN
	rtd_maskl(0xb80004D8, 0x00000000, 0x00000000); //Power off and rst PLL27x
	rtd_maskl(0xb80004D8, 0x00000000, 0x00000017); //Power on PLL27x [4]PLL27X_PS_EN[3]PLL27X_PS_DIV2 = 0x0 use VCO = 540,324,432M[2]PLL27X_VCORSTB[1]PLL27X_RSTB[0]PLL27X_POW
}

static void module_vdc_reset(void)
{
	rtd_outl(0xb8000104, _BIT22|_BIT21);
	udelay(1000000);
	rtd_outl(0xb8000104, _BIT22|_BIT21|_BIT0);
}

int module_vdc_Test_Memory(void)
{
	UINT32 i;
	UINT32 nRegAddr;
	UINT8 memory_test;

    trace_f();
	module_vdc_reset();
	nRegAddr = 0x0e80000;

	// frame 0 start
	rtd_outl(VDC_MEM0_ADDR_INI_VADDR, (nRegAddr & 0x1fffffff));
	// frame 0 end
	nRegAddr = nRegAddr + _3D_One_Frame_Use - 1;
	rtd_outl(VDC_MEM0_ADDR_END_VADDR, (nRegAddr & 0x1fffffff));

	// frame 1 start
	nRegAddr = nRegAddr + 1;
	rtd_outl(VDC_MEM1_ADDR_INI_VADDR, (nRegAddr & 0x1fffffff));
	// frame 1 end
	nRegAddr = nRegAddr + _3D_One_Frame_Use - 1;
	rtd_outl(VDC_MEM1_ADDR_END_VADDR, (nRegAddr & 0x1fffffff));

	// frame 2 start
	nRegAddr = nRegAddr + 1;
	rtd_outl(VDC_MEM2_ADDR_INI_VADDR, (nRegAddr & 0x1fffffff));
	// frame 2 end
	nRegAddr = nRegAddr + _3D_One_Frame_Use - 1;
	rtd_outl(VDC_MEM2_ADDR_END_VADDR, (nRegAddr & 0x1fffffff));

	// frame 3 start
	nRegAddr = nRegAddr + 1;
	rtd_outl(VDC_MEM3_ADDR_INI_VADDR, (nRegAddr & 0x1fffffff));
	// frame 3 end
	nRegAddr = nRegAddr + _3D_One_Frame_Use - 1;
	rtd_outl(VDC_MEM3_ADDR_END_VADDR, (nRegAddr & 0x1fffffff));

	rtd_outl(VDPQ_VD_SRAM_ON_OFF_VADDR, 0x03); //CRC bypass memory enable
	rtd_outl(VDPQ_DMA_CTRL5_VADDR, 0x02);      //open memory and test

	for (i = 0; i < 100; i++) {
		udelay(300);
		memory_test = (UINT8)rtd_inl(VDPQ_DMA_CTRL5_VADDR);
		memory_test = 0x03 & memory_test;
		if (memory_test == 0x03) {
			break;
		}
	}

	memory_test = (UINT8)rtd_inl(VDPQ_DMA_CTRL5_VADDR);
	if (memory_test != 0x03) {
		printk("vd test memory is fail  the memory test value==>%x \n", memory_test);
		rtd_outl(VDPQ_DMA_CTRL5_VADDR, 0x04); //off memory
		return _FAILED;
	} else {
		printk("[TEST_MEMORY] memory test OK \n");
	}
	rtd_outl(VDPQ_DMA_CTRL5_VADDR, 0x04); //off memory

	return _SUCCESS;
}




int QC_Verifier_VDC_PQ_EQC(void)
{
	module_vdc_init_clock();
	if(module_vdc_Test_Memory()==_SUCCESS)
	{
		return _SUCCESS;
	} else {
		return _FAILED;
	}
}

int QC_Verifier_VDC_PQ(void)
{
	trace("%s()\n", __FUNCTION__);

	if (QC_Verifier_VDC_PQ_EQC() == _SUCCESS) {
		trace("[VDC QC in EQC Test is ok]\n");
		return _SUCCESS;
	} else {
		return _FAILED;
	}
	return _SUCCESS;
}


