#ifndef _VDC_QC_H
#define _VDC_QC_H

#ifdef __cplusplus
extern "C" {
#endif

#define showbug 0
#define showtrace 0
#define exe_module_vdc_PathSelect 1
#define exe_module_vdc_Test_BIst 0
#define exe_module_vdc_Test_CRC 1
#define exe_module_vdc_Test_DRF_BIst 0
#define exe_module_vdc_Test_FIFO 0
#define hard_code_path 0
#define VCO_432MHz
#undef VCO_540MHz
#undef VCO_324MHz

//mac3plus
#undef mac3plus_bga

#define _SUCCESS 0
#define _FAILED 1
#define _NOP ((void)0)

#if showbug
#define dmsg(fmt, ...) printk(fmt, ##__VA_ARGS__)
#else
#define dmsg(fmt, ...) _NOP
#endif

#if showtrace
#define trace(fmt, ...) printk(fmt, ##__VA_ARGS__)
#define trace_r(addr)                           \
    (void)({                                    \
        unsigned int _0 = (unsigned int)(addr); \
        unsigned int _1 = rtd_inl(_0);          \
        printk("<08%x> 0x%08x\r\n", _0, _1);    \
        0;                                      \
    })
#define trace_f() printk("+ %s()\r\n", __FUNCTION__)
#else
#define trace(fmt, ...) _NOP
#define trace_r(addr) _NOP
#define trace_f() _NOP
#endif

#define AD_YorCVBS 0
#define AD_BorPb 1
#define AD_CorRorPr 2
#define AD_G 3

#define _3D_One_Frame_Use 0x01b11a

#define CVBS_PatternGen_2D_PAL_QC
#define CVBS_PatternGen_2D_NTSC_QC
#define CVBS_PatternGen_2D_PAL_MP
#define CVBS_PatternGen_2D_NTSC_MP

/**
 * Address definitions
 */
#define VBI_VBI_DMA_CTRL_VADDR (0xb8034c0c)
#define DI_IM_DI_WEAVE_WINDOW_CONTROL_VADDR (0xb8024010)
#define v_cpu_non_cache_addr_base (0x00000000)
#define vdc_mem_dump_dma_start_addr (v_cpu_non_cache_addr_base | 0x0b290000)
#define vdc_mem_dump_dma_size (0x10000)
#define vdc_mem_dump_dma_end_addr (vdc_mem_dump_dma_start_addr + vdc_mem_dump_dma_size - 1)

#define INPUT_FILTER_TABLE_SIZE (72)

enum {
    VDC_TEST_CASE_0 = 0,
    VDC_TEST_CASE_1,
    VDC_TEST_CASE_2,
    VDC_TEST_CASE_3,
    VDC_TEST_CASE_4,
    VDC_TEST_CASE_5,
    VDC_TEST_CASE_SIZE,
};

typedef enum cvbs_mode_s {
    NTSC_ = 0x0,
    PALI_
} cvbs_mode_t;

typedef enum crc_sel_s {
    QC_ = 0x0,
    MP_
} crc_sel_s_t;

typedef enum v0v1v2_sel_s {
    dc_v_all_enable = 0x7,
    dc_v_all_disble = 0x0
} v0v1v2_sel_t;

typedef enum updn_pos_sel_s {
    updn_pos_v0 = 0x1,
    updn_pos_v1 = 0x2,
    updn_pos_v2 = 0x4,
    updn_pos_v_all_enable = 0x7,
    updn_pos_v_all_disble = 0x0
} updn_pos_sel_t;

typedef enum updn_neg_sel_s {
    updn_neg_v0 = 0x1,
    updn_neg_v1 = 0x2,
    updn_neg_v2 = 0x4,
    updn_neg_v_all_enable = 0x7,
    updn_neg_v_all_disble = 0x0
} updn_neg_sel_t;

typedef enum Ypp_input_pin_s {
    VIN_4P = 0x1,
    VIN_7P = 0x2,
    VIN_8P = 0x3
} Ypp_input_pin_t;

typedef enum VDC_DMA_MODE_SEL {
    DMA_VD_M0 = 0,
    DMA_VD_M1,
    DMA_VD_M2,
    DMA_VD_M3,
    DMA_VD_M4,
    DMA_VD_M5,
    DMA_VD_M6,
    DMA_VD_M7,
    DMA_VD_M8,
    DMA_VD_M9,
    DMA_VD_MA,
    DMA_VD_MB,
    DMA_IFD,
    DMA_VBI,
    DMA_REG
} VDC_DMA_MODE_SEL;

typedef enum VDC_DMA_DEBUG_MODE_SEL {
    DMA_VD_MODE = 0,
    DMA_IFD_MODE,
    DMA_VBI_MODE,
    DMA_REG_MODE,
} VDC_DMA_DEBUG_MODE_SEL;

typedef enum VDC_SET_CONTROL_REG {
    /**
     * VIDEO_STATUS_REG1 0x1801_9000
     */
    VDC_hv_delay_on, ///< VIDEO_STATUS_REG1[7]
    VDC_hv_delay_off,
    VDC_set_Vline_625, ///< VIDEO_STATUS_REG1[4]
    VDC_set_Vline_525,
    VDC_set_Colour_mode_NTSC, ///< VIDEO_STATUS_REG1[3:1]
    VDC_set_Colour_mode_NTSC443,
    VDC_set_Colour_mode_PAL60,

    /**
     * VIDEO_STATUS_REG2 0x1801_9004
     */
    VDC_set_src_AV, ///< VIDEO_STATUS_REG2[6:5]
    VDC_set_src_YPP,
    VDC_set_src_SV,
    VDC_ped_on, ///< VIDEO_STATUS_REG2[0]
    VDC_ped_off,
} VDC_SET_CONTROL_REG;

typedef enum VDC_VIDEO_CONTROL2 {
	VDC_CONTROL2_ClearAll = 0,
	VDC_hagc_enable,	        /* [0] = 0 */
	VDC_hagc_disable,	        /* [0] = 1 */
	VDC_cagc_enable,	        /* [1] = 0 */
	VDC_cagc_disable,	        /* [1] = 1 */
	VDC_bgate_raw_sel_disable,	/* [2] = 0 */
	VDC_bgate_raw_sel_enable,	/* [2] = 1 */
	VDC_dc_clamp_mode_auto,		/* [5:4] = 00 */
	VDC_dc_clamp_mode_bk_porch,	/* [5:4] = 01 */
	VDC_dc_clamp_mode_synctip,	/* [5:4] = 10 */
	VDC_dc_clamp_mode_off,		/* [5:4] = 11 */
	VDC_mv_hagc_mode_off,	    /* [6] = 0 */
	VDC_mv_hagc_mode_on,	    /* [6] = 1 */
	VDC_hagc_field_mode_off,	/* [7] = 0 */
	VDC_hagc_field_mode_on,	    /* [7] = 1 */
	VDC_fix_dgain_disable,	    /* [28] = 0 */
	VDC_fix_dgain_enable,	    /* [28] = 1 */
	VDC_mv_detect_sel_hpll,	    /* [29] = 0 */
	VDC_mv_detect_sel_vpll,	    /* [29] = 1 */
} VDC_VIDEO_CONTROL2;

//VDC SIGNAL POSITIVE PATH
typedef enum {
    VIDEO_INPUT0 = 0,
    VIDEO_INPUT1,
    VIDEO_INPUT2,
    VIDEO_INPUT3,
    VIDEO_INPUT4,
    VIDEO_INPUT5,
    VIDEO_INPUT6,
    VIDEO_INPUT7,
    VIDEO_INPUT8,
    VIDEO_INPUT9,
    VIDEO_INPUT10,
    VIDEO_INPUT11,
    VIDEO_INPUT12,
    VIDEO_INPUT13,
    VIDEO_INPUT14,
    TV_INPUT,
} VIDEO_PATH;

typedef enum {
    VIDEO_GNDA0 = 0x30,
    VIDEO_GNDA1 = 0x31,
    VIDEO_GNDA2 = 0x32,
    VIDEO_BN = 0x00,
    VIDEO_Y0N = 0x21,
    VIDEO_Y1N = 0x22,
    //  VIDEO_RN = 0x20,        // no support
    //  VIDEO_GN = 0x10,        // no support
} VIDEO_GND_PATH;

typedef enum {
    _NTSC = 0,
    _PALM,
    _NTSC50,
    _PALN,
    _NTSC443,
    _PAL60,
    _PALI,
    _SECAM,
} VIDEO_MODE;

typedef enum {
    VIDEO_SV_NORMAL,
    VIDEO_SV_SWAP,
} VIDEO_SV_FUNC;

enum CRT_CLK {
	CLK_ON = 0,
	CLK_OFF = 1,
};

typedef enum VDC_PLL27x_CLK_REG {
	VDC_PLL27x_CLK_540M = 0x00,	    // 00: divide by 5 (use when VCO=540MHz)
	VDC_PLL27x_CLK_432M,	        // 01: divide by 4 (use when VCO=432MHz)
	VDC_PLL27x_CLK_324M,	        // 10: divide by 3 (use when VCO=324MHz)
	VDC_PLL27x_CLK_648M,	        // 11: divide by 6 (use when VCO=648MHz)
} VDC_PLL27x_CLK_REG;

typedef enum VDC_CLAMP_TYPE {
	CLAMP_CVBS = 0,
	CLAMP_IFD = 1,
} VDC_CLAMP_TYPE;

typedef enum VDC_VIDEO_108M_FrontDigitalFilter {
	VDC_108M_FDF_85MHZ = 0,
	VDC_108M_FDF_55MHZ,
	VDC_108M_FDF_60MHZ,
	VDC_108M_FDF_65MHZ,
	VDC_108M_FDF_70MHZ,
	VDC_108M_FDF_75MHZ,
	VDC_108M_FDF_80MHZ,
	VDC_108M_FDF_BYPASS,
} VDC_VIDEO_108M_FrontDigitalFilter;

typedef int (*vdc_test_case_t)(void);
typedef void (*vdc_init_clock)(void);
typedef void (*vdc_init_power)(void);

#if 1
unsigned short INPUT_FILTER_55MHZ[72] = {
	0x0000,	0x0080,//00
	0x0770,	0x0320,
	0x09c0,	0x0028,
	0x1ff3,	0x1fe1,
	0x1FD1,	0x1FD1,//10
	0x1FE8,	0x0010,
	0x0039,	0x0048,
	0x0030,	0x1FF4,
	0x1FAF,	0x1F86,//20
	0x1F9C,	0x1FF1,
	0x0067,	0x00C0,
	0x00C0,	0x004D,
	0x1F86,	0x1EC4,//30
	0x1E79,	0x1F07,
	0x0086,	0x02B7,
	0x0509,	0x06CD,
	0x0776,	0x0000,//40
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//50
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//60
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//70
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//80
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
};

unsigned short INPUT_FILTER_60MHZ[72] = {
	0x0000,	0x0070,//00
	0x0310,	0x0780,
	0x09e0,	0x000a,
	0x003E,	0x0018,
	0x0006,	0x1FE3,//10
	0x1FCC,	0x1FD2,
	0x1FFA,	0x0031,
	0x0056,	0x0049,
	0x0008,	0x1FB0,//20
	0x1F77,	0x1F8D,
	0x1FF6,	0x0084,
	0x00DF,	0x00BC,
	0x000B,	0x1F14,//30
	0x1E65,	0x1E95,
	0x1FF4,	0x0256,
	0x0510,	0x073A,
	0x080C,	0x0000,//40
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//50
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//60
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//70
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//80
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
};

unsigned short INPUT_FILTER_65MHZ[72] = {
	0x0000,	0x0030,//00
	0x02c0,	0x07c0,
	0x0a90,	0x1FDB,
	0x0012,	0x0026,
	0x0031,	0x0022,//10
	0x1FFA,	0x1FCF,
	0x1FC2,	0x1FE3,
	0x0025,	0x005D,
	0x005C,	0x0014,//20
	0x1FA9,	0x1F66,
	0x1F89,	0x0012,
	0x00B4,	0x00FA,
	0x008F,	0x1F8C,//30
	0x1E82,	0x1E40,
	0x1F61,	0x01E1,
	0x0506,	0x07A2,
	0x08A5,	0x0000,//40
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//50
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//60
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//70
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//80
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
};

unsigned short INPUT_FILTER_70MHZ[72] = {
	0x0000,	0x0020,//00
	0x02b0,	0x07d0,
	0x0ab0,	0x1FF3,
	0x1FC2,	0x1FEF,
	0x0008,	0x002A,//10
	0x002E,	0x000B,
	0x1FD3,	0x1FB4,
	0x1FCF,	0x001D,
	0x0066,	0x0068,//20
	0x0011,	0x1F93,
	0x1F53,	0x1F9A,
	0x004F,	0x00F4,
	0x00F4,	0x0015,//30
	0x1ECC,	0x1E12,
	0x1ED8,	0x0160,
	0x04EA,	0x0802,
	0x093C,	0x0000,//40
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//50
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//60
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//70
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//80
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
};

unsigned short INPUT_FILTER_75MHZ[72] = {
	0x0000,	0x0010,//00
	0x0290,	0x07d0,
	0x0ad0,	0x0023,
	0x1FE8,	0x1FD4,
	0x1FD2,	0x1FF2,//10
	0x0021,	0x0039,
	0x001C,	0x1FDA,
	0x1FAA,	0x1FC2,
	0x001D,	0x0073,//20
	0x006E,	0x1FFC,
	0x1F6F,	0x1F4A,
	0x1FCF,	0x00AD,
	0x0125,	0x009D,//30
	0x1F3D,	0x1E0D,
	0x1E5E,	0x00D2,
	0x04BD,	0x085C,
	0x09D4,	0x0000,//40
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//50
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//60
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//70
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//80
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
};

unsigned short INPUT_FILTER_80MHZ[72] = {
	0x0000,  0x1eb1, // 00
	0x0090,  0x0930,
	0x0f00,  0x0007,
	0x0001,  0x1ff9,
	0x1ff2,  0x1ff7, // 10
	0x000a,  0x001d,
	0x0017,  0x1ff5,
	0x1fcf,  0x1fcf,
	0x0004,  0x004c, // 20
	0x005d,  0x0012,
	0x1f98,  0x1f5f,
	0x1fbd,  0x0086,
	0x010f,  0x00ad, // 30
	0x1f63,  0x1e23,
	0x1e4f,  0x00af,
	0x04ac,  0x086f,
	0x09f9,  0x0000, //40
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//50
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//60
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//70
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//80
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
};

unsigned short INPUT_FILTER_85MHZ[72] = {
	0x0000,  0x1eb1, // 00
	0x0090,  0x0930,
	0x0f00,  0x0000,
	0x0003,  0x0004,
	0x0000,  0x1ff9, // 10
	0x1ff5,  0x0000,
	0x0014,  0x001a,
	0x0000,  0x1fd9,
	0x1fcf,  0x0000, // 20
	0x004a,  0x0059,
	0x0000,  0x1f81,
	0x1f68,  0x0000,
	0x00dd,  0x010c, // 30
	0x0000,  0x1e66,
	0x1dee,  0x0000,
	0x0458,  0x08c9,
	0x0aaa,  0x0000, //40
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//50
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//60
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//70
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,//80
	0x0000,	0x0000,
	0x0000,	0x0000,
	0x0000,	0x0000,
};
#endif

/**
 * -----------------------------------------------------------------------------
 * Function declarations
 * -----------------------------------------------------------------------------
 */
int QC_Verifier_VDC_EQC(void);
void module_vdc_SetInput_Y(unsigned char Y_path, unsigned char Y_Gnd_path);
int module_vdc_PathSelect(void);
int module_vdc_Test_BIst(void);
int module_vdc_Test_CRC(void);
int module_vdc_Test_DRF_BIst(void);
int module_vdc_Test_FIFO(void);
void module_vdc_switch_av_2_tv_and_disable_ifd_clamp(void);
void module_vdc_adc_setting(void);
void vdc_initialize(void);
void vdc_initialize_clock(void);
void vdc_initialize_power(void);
void drvif_module_vdc_Initial(void);
void drvif_module_vdc_SoftReset(void);
//void drvif_module_vdc_VDCReset(void);
void module_Debug_CRC_Registers(void);
void drvif_module_vdc_clock_enable(bool on_off);
void vdc_dc_restore_enable(unsigned char v0v1v2);
void vdc_clamp_updn_enable(unsigned int positive, unsigned int negative);
void vdc_dump_register(void);
void vdc_open_vin7p_for_ifd_loopback_test(void);
UINT8 VDC_CVBS_PatternGen_Enable(UINT8 num);
unsigned char module_vdc_SetADCPath(unsigned char path_signal, unsigned char path_gnd);
void module_vdc_ClampType_set(unsigned char ClampTpye, unsigned char ClampADC);
void drvif_video_set_control_reg(VDC_SET_CONTROL_REG status);
void drvif_module_vdc_set_Control2_Register(VDC_VIDEO_CONTROL2 mode);
void drvif_module_Set_pll27x_source(VDC_PLL27x_CLK_REG freq);
bool module_vdc_check_video_status(unsigned char Y_path, unsigned char Y_Gnd_path);
bool drvif_module_vdc_read_Clamping_path(void);
void drvif_module_vdc_108M_FrontDigitalFilterEnable(VDC_VIDEO_108M_FrontDigitalFilter mode);
void drvif_module_vdc_input_filter_sel(bool enable, UINT16 * table);

#ifdef __cplusplus
}
#endif

#endif //_VDC_QC_H
