/**
* @file Mac7p-DesignSpec_vd_ifd_input
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_VD_IFD_INPUT_REG_H_
#define _RBUS_VD_IFD_INPUT_REG_H_

#include "rbusTypes.h"



//  VD_IFD_INPUT Register Address



#define  VD_IFD_INPUT_INPUT_FILTER_SET_VADDR                	(0xb8018094)
#define  VD_IFD_INPUT_IFD_ADC_CLK_POLAR_VADDR               	(0xb8018098)
#define  VD_IFD_INPUT_IFD_CP_TEST_ENABLE_VADDR              	(0xb801809c)
#define  VD_IFD_INPUT_VD_IN_DELAY_SEL1_VADDR                	(0xb80180a0)
#define  VD_IFD_INPUT_VD_IN_DELAY_SEL2_VADDR                	(0xb80180a4)
#define  VD_IFD_INPUT_VD_ADC_LSB_CTRL_VADDR                 	(0xb80180a8)
#define  VD_IFD_INPUT_VD_INOUT_CTRL_VADDR                   	(0xb80180ac)
#define  VD_IFD_INPUT_CRC_EN_VADDR                          	(0xb80180b0)
#define  VD_IFD_INPUT_CRC_108MHZ_RESULT1_VADDR              	(0xb80180b4)
#define  VD_IFD_INPUT_CRC_108MHZ_RESULT2_VADDR              	(0xb80180b8)
#define  VD_IFD_INPUT_INPUT_DEBUG_VADDR                     	(0xb80180bc)
#define  VD_IFD_INPUT_IF_PATTERNGEN_VADDR                   	(0xb80180c0)
#define  VD_IFD_INPUT_IFD_INPUT_FIFO_STATUS_VADDR           	(0xb80180d0)
#define  VD_IFD_INPUT_VD_INPUT_FIFO_STATUS1_VADDR           	(0xb80180d4)
#define  VD_IFD_INPUT_VD_INPUT_FIFO_STATUS2_VADDR           	(0xb80180d8)
#define  VD_IFD_INPUT_IFD_INPUT_FIFO_STATUS3_VADDR          	(0xb80180dc)
#define  VD_IFD_INPUT_IFD_FIFO_CRC_VADDR                    	(0xb80180e0)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======VD_IFD_INPUT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  adc_fifo_in_sel:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  adc_clk_sel:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  input_dn_filter_sel:3;
    };
}vd_ifd_input_input_filter_set_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  clk54_polar:1;
    };
}vd_ifd_input_ifd_adc_clk_polar_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  cp_test_enable:1;
    };
}vd_ifd_input_ifd_cp_test_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ad4_input_delay:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  ad3_input_delay:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  ad2_input_delay:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  ad1_input_delay:5;
    };
}vd_ifd_input_vd_in_delay_sel1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cvbs_tve_mux:1;
        RBus_UInt32  res1:18;
        RBus_UInt32  ad5_input_delay:5;
        RBus_UInt32  res2:4;
        RBus_UInt32  sv_sel:2;
        RBus_UInt32  sv_yc_switch:1;
        RBus_UInt32  sv_in_one_adc:1;
    };
}vd_ifd_input_vd_in_delay_sel2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  scart_input_delay_108:4;
        RBus_UInt32  yppb_input_delay_108:4;
        RBus_UInt32  yppg_input_delay_108:4;
        RBus_UInt32  yppr_input_delay_108:4;
        RBus_UInt32  vdadc_input_delay_108:4;
        RBus_UInt32  adc3_lsb_force0_num:2;
        RBus_UInt32  adc2_lsb_force0_num:2;
        RBus_UInt32  adc1_lsb_force0_num:2;
        RBus_UInt32  adc0_lsb_force0_num:2;
    };
}vd_ifd_input_vd_adc_lsb_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fe_fil_sel:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  adc27_mod:1;
    };
}vd_ifd_input_vd_inout_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vd_read_only:1;
        RBus_UInt32  res1:30;
        RBus_UInt32  crc_108mhz_en:1;
    };
}vd_ifd_input_crc_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_108mhz_result_1:32;
    };
}vd_ifd_input_crc_108mhz_result1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_108mhz_result_2:32;
    };
}vd_ifd_input_crc_108mhz_result2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  input_debug_sel:2;
    };
}vd_ifd_input_input_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  if_patterngen_nco:16;
        RBus_UInt32  res2:2;
        RBus_UInt32  if_patterngen_mod_sel:1;
        RBus_UInt32  if_patterngen_en:1;
    };
}vd_ifd_input_if_patterngen_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  input_fifo_pg_full_clr:1;
        RBus_UInt32  input_fifo_pg_empty_clr:1;
        RBus_UInt32  input_fifo_pg_clr:1;
        RBus_UInt32  input_fifo_pg_full:1;
        RBus_UInt32  input_fifo_pg_empty:1;
        RBus_UInt32  res2:11;
        RBus_UInt32  input_fifo_full_clr:1;
        RBus_UInt32  input_fifo_empty_clr:1;
        RBus_UInt32  input_fifo_clr:1;
        RBus_UInt32  input_fifo_full:1;
        RBus_UInt32  input_fifo_empty:1;
    };
}vd_ifd_input_ifd_input_fifo_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ad_debug_full:1;
        RBus_UInt32  ad_debug_empty:1;
        RBus_UInt32  ad5_fifo_full:1;
        RBus_UInt32  ad5_fifo_empty:1;
        RBus_UInt32  adc_sync_fifo_clr:1;
        RBus_UInt32  vdadc_sync_fifo_full:1;
        RBus_UInt32  vdadc_sync_fifo_empty:1;
        RBus_UInt32  ypp_blu_sync_fifo_full:1;
        RBus_UInt32  ypp_blu_sync_fifo_empty:1;
        RBus_UInt32  ypp_grn_sync_fifo_full:1;
        RBus_UInt32  ypp_grn_sync_fifo_empty:1;
        RBus_UInt32  ypp_red_sync_fifo_full:1;
        RBus_UInt32  ypp_red_sync_fifo_empty:1;
        RBus_UInt32  scart_sync_fifo_full:1;
        RBus_UInt32  scart_sync_fifo_empty:1;
        RBus_UInt32  ycref_sync_fifo_full:1;
        RBus_UInt32  ycref_sync_fifo_empty:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  vd_fifo_clr:1;
        RBus_UInt32  ad1_fifo_full:1;
        RBus_UInt32  ad1_fifo_empty:1;
        RBus_UInt32  ad2_fifo_full:1;
        RBus_UInt32  ad2_fifo_empty:1;
        RBus_UInt32  ad3_fifo_full:1;
        RBus_UInt32  ad3_fifo_empty:1;
        RBus_UInt32  ad4_fifo_full:1;
        RBus_UInt32  ad4_fifo_empty:1;
    };
}vd_ifd_input_vd_input_fifo_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ad_debug_full_clr:1;
        RBus_UInt32  ad_debug_empty_clr:1;
        RBus_UInt32  ad5_fifo_full_clr:1;
        RBus_UInt32  ad5_fifo_empty_clr:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  vdadc_sync_fifo_full_clr:1;
        RBus_UInt32  vdadc_sync_fifo_empty_clr:1;
        RBus_UInt32  ypp_blu_sync_fifo_full_clr:1;
        RBus_UInt32  ypp_blu_sync_fifo_empty_clr:1;
        RBus_UInt32  ypp_grn_sync_fifo_full_clr:1;
        RBus_UInt32  ypp_grn_sync_fifo_empty_clr:1;
        RBus_UInt32  ypp_red_sync_fifo_full_clr:1;
        RBus_UInt32  ypp_red_sync_fifo_empty_clr:1;
        RBus_UInt32  scart_sync_fifo_full_clr:1;
        RBus_UInt32  scart_sync_fifo_empty_clr:1;
        RBus_UInt32  ycref_sync_fifo_full_clr:1;
        RBus_UInt32  ycref_sync_fifo_empty_clr:1;
        RBus_UInt32  res3:4;
        RBus_UInt32  ad1_fifo_full_clr:1;
        RBus_UInt32  ad1_fifo_empty_clr:1;
        RBus_UInt32  ad2_fifo_full_clr:1;
        RBus_UInt32  ad2_fifo_empty_clr:1;
        RBus_UInt32  ad3_fifo_full_clr:1;
        RBus_UInt32  ad3_fifo_empty_clr:1;
        RBus_UInt32  ad4_fifo_full_clr:1;
        RBus_UInt32  ad4_fifo_empty_clr:1;
    };
}vd_ifd_input_vd_input_fifo_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  fifo_recover_depth:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  fifo_recover_thr:3;
        RBus_UInt32  res3:3;
        RBus_UInt32  fifo_recover_en:1;
    };
}vd_ifd_input_ifd_input_fifo_status3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  fifo_crc_en:1;
    };
}vd_ifd_input_ifd_fifo_crc_RBUS;

#else //apply LITTLE_ENDIAN

//======VD_IFD_INPUT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  input_dn_filter_sel:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  adc_clk_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  adc_fifo_in_sel:1;
        RBus_UInt32  res3:23;
    };
}vd_ifd_input_input_filter_set_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  clk54_polar:1;
        RBus_UInt32  res1:31;
    };
}vd_ifd_input_ifd_adc_clk_polar_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_test_enable:1;
        RBus_UInt32  res1:31;
    };
}vd_ifd_input_ifd_cp_test_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ad1_input_delay:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  ad2_input_delay:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  ad3_input_delay:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  ad4_input_delay:5;
        RBus_UInt32  res4:3;
    };
}vd_ifd_input_vd_in_delay_sel1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sv_in_one_adc:1;
        RBus_UInt32  sv_yc_switch:1;
        RBus_UInt32  sv_sel:2;
        RBus_UInt32  res1:4;
        RBus_UInt32  ad5_input_delay:5;
        RBus_UInt32  res2:18;
        RBus_UInt32  cvbs_tve_mux:1;
    };
}vd_ifd_input_vd_in_delay_sel2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc0_lsb_force0_num:2;
        RBus_UInt32  adc1_lsb_force0_num:2;
        RBus_UInt32  adc2_lsb_force0_num:2;
        RBus_UInt32  adc3_lsb_force0_num:2;
        RBus_UInt32  vdadc_input_delay_108:4;
        RBus_UInt32  yppr_input_delay_108:4;
        RBus_UInt32  yppg_input_delay_108:4;
        RBus_UInt32  yppb_input_delay_108:4;
        RBus_UInt32  scart_input_delay_108:4;
        RBus_UInt32  res1:4;
    };
}vd_ifd_input_vd_adc_lsb_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc27_mod:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  fe_fil_sel:3;
        RBus_UInt32  res2:25;
    };
}vd_ifd_input_vd_inout_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_108mhz_en:1;
        RBus_UInt32  res1:30;
        RBus_UInt32  vd_read_only:1;
    };
}vd_ifd_input_crc_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_108mhz_result_1:32;
    };
}vd_ifd_input_crc_108mhz_result1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_108mhz_result_2:32;
    };
}vd_ifd_input_crc_108mhz_result2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  input_debug_sel:2;
        RBus_UInt32  res1:30;
    };
}vd_ifd_input_input_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  if_patterngen_en:1;
        RBus_UInt32  if_patterngen_mod_sel:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  if_patterngen_nco:16;
        RBus_UInt32  res2:12;
    };
}vd_ifd_input_if_patterngen_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  input_fifo_empty:1;
        RBus_UInt32  input_fifo_full:1;
        RBus_UInt32  input_fifo_clr:1;
        RBus_UInt32  input_fifo_empty_clr:1;
        RBus_UInt32  input_fifo_full_clr:1;
        RBus_UInt32  res1:11;
        RBus_UInt32  input_fifo_pg_empty:1;
        RBus_UInt32  input_fifo_pg_full:1;
        RBus_UInt32  input_fifo_pg_clr:1;
        RBus_UInt32  input_fifo_pg_empty_clr:1;
        RBus_UInt32  input_fifo_pg_full_clr:1;
        RBus_UInt32  res2:11;
    };
}vd_ifd_input_ifd_input_fifo_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ad4_fifo_empty:1;
        RBus_UInt32  ad4_fifo_full:1;
        RBus_UInt32  ad3_fifo_empty:1;
        RBus_UInt32  ad3_fifo_full:1;
        RBus_UInt32  ad2_fifo_empty:1;
        RBus_UInt32  ad2_fifo_full:1;
        RBus_UInt32  ad1_fifo_empty:1;
        RBus_UInt32  ad1_fifo_full:1;
        RBus_UInt32  vd_fifo_clr:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  ycref_sync_fifo_empty:1;
        RBus_UInt32  ycref_sync_fifo_full:1;
        RBus_UInt32  scart_sync_fifo_empty:1;
        RBus_UInt32  scart_sync_fifo_full:1;
        RBus_UInt32  ypp_red_sync_fifo_empty:1;
        RBus_UInt32  ypp_red_sync_fifo_full:1;
        RBus_UInt32  ypp_grn_sync_fifo_empty:1;
        RBus_UInt32  ypp_grn_sync_fifo_full:1;
        RBus_UInt32  ypp_blu_sync_fifo_empty:1;
        RBus_UInt32  ypp_blu_sync_fifo_full:1;
        RBus_UInt32  vdadc_sync_fifo_empty:1;
        RBus_UInt32  vdadc_sync_fifo_full:1;
        RBus_UInt32  adc_sync_fifo_clr:1;
        RBus_UInt32  ad5_fifo_empty:1;
        RBus_UInt32  ad5_fifo_full:1;
        RBus_UInt32  ad_debug_empty:1;
        RBus_UInt32  ad_debug_full:1;
        RBus_UInt32  res2:3;
    };
}vd_ifd_input_vd_input_fifo_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ad4_fifo_empty_clr:1;
        RBus_UInt32  ad4_fifo_full_clr:1;
        RBus_UInt32  ad3_fifo_empty_clr:1;
        RBus_UInt32  ad3_fifo_full_clr:1;
        RBus_UInt32  ad2_fifo_empty_clr:1;
        RBus_UInt32  ad2_fifo_full_clr:1;
        RBus_UInt32  ad1_fifo_empty_clr:1;
        RBus_UInt32  ad1_fifo_full_clr:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  ycref_sync_fifo_empty_clr:1;
        RBus_UInt32  ycref_sync_fifo_full_clr:1;
        RBus_UInt32  scart_sync_fifo_empty_clr:1;
        RBus_UInt32  scart_sync_fifo_full_clr:1;
        RBus_UInt32  ypp_red_sync_fifo_empty_clr:1;
        RBus_UInt32  ypp_red_sync_fifo_full_clr:1;
        RBus_UInt32  ypp_grn_sync_fifo_empty_clr:1;
        RBus_UInt32  ypp_grn_sync_fifo_full_clr:1;
        RBus_UInt32  ypp_blu_sync_fifo_empty_clr:1;
        RBus_UInt32  ypp_blu_sync_fifo_full_clr:1;
        RBus_UInt32  vdadc_sync_fifo_empty_clr:1;
        RBus_UInt32  vdadc_sync_fifo_full_clr:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  ad5_fifo_empty_clr:1;
        RBus_UInt32  ad5_fifo_full_clr:1;
        RBus_UInt32  ad_debug_empty_clr:1;
        RBus_UInt32  ad_debug_full_clr:1;
        RBus_UInt32  res3:3;
    };
}vd_ifd_input_vd_input_fifo_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_recover_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  fifo_recover_thr:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  fifo_recover_depth:2;
        RBus_UInt32  res3:22;
    };
}vd_ifd_input_ifd_input_fifo_status3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_crc_en:1;
        RBus_UInt32  res1:31;
    };
}vd_ifd_input_ifd_fifo_crc_RBUS;




#endif 


#endif 
