/**
* @file Mac6-DesignSpec-D-Domain_PCID
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/10/12
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_PCID_REG_H_
#define _RBUS_PCID_REG_H_

#include "rbusTypes.h"



//  PCID Register Address



#define  PCID_PCID_DITHER_CTRL_VADDR                        	(0xb802ef00)
#define  PCID_PCID_DITHER_SEQ_R_00_15_VADDR                 	(0xb802ef04)
#define  PCID_PCID_DITHER_SEQ_R_16_31_VADDR                 	(0xb802ef08)
#define  PCID_PCID_DITHER_SEQ_G_00_15_VADDR                 	(0xb802ef0c)
#define  PCID_PCID_DITHER_SEQ_G_16_31_VADDR                 	(0xb802ef10)
#define  PCID_PCID_DITHER_SEQ_B_00_15_VADDR                 	(0xb802ef14)
#define  PCID_PCID_DITHER_SEQ_B_16_31_VADDR                 	(0xb802ef18)
#define  PCID_PCID_DITHER_TB_R_01_VADDR                     	(0xb802ef1c)
#define  PCID_PCID_DITHER_TB_R_23_VADDR                     	(0xb802ef20)
#define  PCID_PCID_DITHER_TB_G_01_VADDR                     	(0xb802ef24)
#define  PCID_PCID_DITHER_TB_G_23_VADDR                     	(0xb802ef28)
#define  PCID_PCID_DITHER_TB_B_01_VADDR                     	(0xb802ef2c)
#define  PCID_PCID_DITHER_TB_B_23_VADDR                     	(0xb802ef30)
#define  PCID_PCID_DITHER_TEMP_VADDR                        	(0xb802ef34)
#define  PCID_PCID_CTRL_VADDR                               	(0xb802ef40)
#define  PCID_PCID_CTRL_2_VADDR                             	(0xb802ef44)
#define  PCID_PCID_CTRL_3_VADDR                             	(0xb802ef48)
#define  PCID_PCID_LINE_1_VADDR                             	(0xb802ef50)
#define  PCID_PCID_LINE_2_VADDR                             	(0xb802ef54)
#define  PCID_PCID_LINE_3_VADDR                             	(0xb802ef58)
#define  PCID_PCID_LINE_4_VADDR                             	(0xb802ef5c)
#define  PCID_PCID2_POLARITY_R_1_VADDR                      	(0xb802ef70)
#define  PCID_PCID2_POLARITY_R_2_VADDR                      	(0xb802ef74)
#define  PCID_PCID2_POLARITY_R_3_VADDR                      	(0xb802ef78)
#define  PCID_PCID2_POLARITY_R_4_VADDR                      	(0xb802ef7c)
#define  PCID_PCID2_POLARITY_G_1_VADDR                      	(0xb802ef80)
#define  PCID_PCID2_POLARITY_G_2_VADDR                      	(0xb802ef84)
#define  PCID_PCID2_POLARITY_G_3_VADDR                      	(0xb802ef88)
#define  PCID_PCID2_POLARITY_G_4_VADDR                      	(0xb802ef8c)
#define  PCID_PCID2_POLARITY_B_1_VADDR                      	(0xb802ef90)
#define  PCID_PCID2_POLARITY_B_2_VADDR                      	(0xb802ef94)
#define  PCID_PCID2_POLARITY_B_3_VADDR                      	(0xb802ef98)
#define  PCID_PCID2_POLARITY_B_4_VADDR                      	(0xb802ef9c)
#define  PCID_PCID_VALC_CTRL_VADDR                          	(0xb802efa0)
#define  PCID_PCID_VALC_HPF_0_VADDR                         	(0xb802efa4)
#define  PCID_PCID_VALC_HPF_1_VADDR                         	(0xb802efa8)
#define  PCID_PCID_VALC_SAT_0_VADDR                         	(0xb802efac)
#define  PCID_PCID_VALC_SAT_1_VADDR                         	(0xb802efb0)
#define  PCID_PCID_RM_VADDR                                 	(0xb802efb4)
#define  PCID_PCID_RME_LS_VADDR                             	(0xb802efb8)
#define  PCID_PCID_FAIL_VADDR                               	(0xb802efbc)
#define  PCID_PCID_TESTRWM_VADDR                            	(0xb802efc0)
#define  PCID_PCID_LUT_ADDR_VADDR                           	(0xb802efd0)
#define  PCID_PCID_LUT_DATA_VADDR                           	(0xb802efd4)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======PCID register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  pcid_dither_en:1;
        RBus_UInt32  pcid_temporal_enable:1;
        RBus_UInt32  pcid_value_sign:1;
        RBus_UInt32  res2:3;
    };
}pcid_pcid_dither_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_r_15:2;
        RBus_UInt32  pcid_seq_r_14:2;
        RBus_UInt32  pcid_seq_r_13:2;
        RBus_UInt32  pcid_seq_r_12:2;
        RBus_UInt32  pcid_seq_r_11:2;
        RBus_UInt32  pcid_seq_r_10:2;
        RBus_UInt32  pcid_seq_r_9:2;
        RBus_UInt32  pcid_seq_r_8:2;
        RBus_UInt32  pcid_seq_r_7:2;
        RBus_UInt32  pcid_seq_r_6:2;
        RBus_UInt32  pcid_seq_r_5:2;
        RBus_UInt32  pcid_seq_r_4:2;
        RBus_UInt32  pcid_seq_r_3:2;
        RBus_UInt32  pcid_seq_r_2:2;
        RBus_UInt32  pcid_seq_r_1:2;
        RBus_UInt32  pcid_seq_r_0:2;
    };
}pcid_pcid_dither_seq_r_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_r_31:2;
        RBus_UInt32  pcid_seq_r_30:2;
        RBus_UInt32  pcid_seq_r_29:2;
        RBus_UInt32  pcid_seq_r_28:2;
        RBus_UInt32  pcid_seq_r_27:2;
        RBus_UInt32  pcid_seq_r_26:2;
        RBus_UInt32  pcid_seq_r_25:2;
        RBus_UInt32  pcid_seq_r_24:2;
        RBus_UInt32  pcid_seq_r_23:2;
        RBus_UInt32  pcid_seq_r_22:2;
        RBus_UInt32  pcid_seq_r_21:2;
        RBus_UInt32  pcid_seq_r_20:2;
        RBus_UInt32  pcid_seq_r_19:2;
        RBus_UInt32  pcid_seq_r_18:2;
        RBus_UInt32  pcid_seq_r_17:2;
        RBus_UInt32  pcid_seq_r_16:2;
    };
}pcid_pcid_dither_seq_r_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_g_15:2;
        RBus_UInt32  pcid_seq_g_14:2;
        RBus_UInt32  pcid_seq_g_13:2;
        RBus_UInt32  pcid_seq_g_12:2;
        RBus_UInt32  pcid_seq_g_11:2;
        RBus_UInt32  pcid_seq_g_10:2;
        RBus_UInt32  pcid_seq_g_9:2;
        RBus_UInt32  pcid_seq_g_8:2;
        RBus_UInt32  pcid_seq_g_7:2;
        RBus_UInt32  pcid_seq_g_6:2;
        RBus_UInt32  pcid_seq_g_5:2;
        RBus_UInt32  pcid_seq_g_4:2;
        RBus_UInt32  pcid_seq_g_3:2;
        RBus_UInt32  pcid_seq_g_2:2;
        RBus_UInt32  pcid_seq_g_1:2;
        RBus_UInt32  pcid_seq_g_0:2;
    };
}pcid_pcid_dither_seq_g_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_g_31:2;
        RBus_UInt32  pcid_seq_g_30:2;
        RBus_UInt32  pcid_seq_g_29:2;
        RBus_UInt32  pcid_seq_g_28:2;
        RBus_UInt32  pcid_seq_g_27:2;
        RBus_UInt32  pcid_seq_g_26:2;
        RBus_UInt32  pcid_seq_g_25:2;
        RBus_UInt32  pcid_seq_g_24:2;
        RBus_UInt32  pcid_seq_g_23:2;
        RBus_UInt32  pcid_seq_g_22:2;
        RBus_UInt32  pcid_seq_g_21:2;
        RBus_UInt32  pcid_seq_g_20:2;
        RBus_UInt32  pcid_seq_g_19:2;
        RBus_UInt32  pcid_seq_g_18:2;
        RBus_UInt32  pcid_seq_g_17:2;
        RBus_UInt32  pcid_seq_g_16:2;
    };
}pcid_pcid_dither_seq_g_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_b_15:2;
        RBus_UInt32  pcid_seq_b_14:2;
        RBus_UInt32  pcid_seq_b_13:2;
        RBus_UInt32  pcid_seq_b_12:2;
        RBus_UInt32  pcid_seq_b_11:2;
        RBus_UInt32  pcid_seq_b_10:2;
        RBus_UInt32  pcid_seq_b_9:2;
        RBus_UInt32  pcid_seq_b_8:2;
        RBus_UInt32  pcid_seq_b_7:2;
        RBus_UInt32  pcid_seq_b_6:2;
        RBus_UInt32  pcid_seq_b_5:2;
        RBus_UInt32  pcid_seq_b_4:2;
        RBus_UInt32  pcid_seq_b_3:2;
        RBus_UInt32  pcid_seq_b_2:2;
        RBus_UInt32  pcid_seq_b_1:2;
        RBus_UInt32  pcid_seq_b_0:2;
    };
}pcid_pcid_dither_seq_b_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_b_31:2;
        RBus_UInt32  pcid_seq_b_30:2;
        RBus_UInt32  pcid_seq_b_29:2;
        RBus_UInt32  pcid_seq_b_28:2;
        RBus_UInt32  pcid_seq_b_27:2;
        RBus_UInt32  pcid_seq_b_26:2;
        RBus_UInt32  pcid_seq_b_25:2;
        RBus_UInt32  pcid_seq_b_24:2;
        RBus_UInt32  pcid_seq_b_23:2;
        RBus_UInt32  pcid_seq_b_22:2;
        RBus_UInt32  pcid_seq_b_21:2;
        RBus_UInt32  pcid_seq_b_20:2;
        RBus_UInt32  pcid_seq_b_19:2;
        RBus_UInt32  pcid_seq_b_18:2;
        RBus_UInt32  pcid_seq_b_17:2;
        RBus_UInt32  pcid_seq_b_16:2;
    };
}pcid_pcid_dither_seq_b_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_r_13:4;
        RBus_UInt32  pcid_tab_r_12:4;
        RBus_UInt32  pcid_tab_r_11:4;
        RBus_UInt32  pcid_tab_r_10:4;
        RBus_UInt32  pcid_tab_r_03:4;
        RBus_UInt32  pcid_tab_r_02:4;
        RBus_UInt32  pcid_tab_r_01:4;
        RBus_UInt32  pcid_tab_r_00:4;
    };
}pcid_pcid_dither_tb_r_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_r_33:4;
        RBus_UInt32  pcid_tab_r_32:4;
        RBus_UInt32  pcid_tab_r_31:4;
        RBus_UInt32  pcid_tab_r_30:4;
        RBus_UInt32  pcid_tab_r_23:4;
        RBus_UInt32  pcid_tab_r_22:4;
        RBus_UInt32  pcid_tab_r_21:4;
        RBus_UInt32  pcid_tab_r_20:4;
    };
}pcid_pcid_dither_tb_r_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_g_13:4;
        RBus_UInt32  pcid_tab_g_12:4;
        RBus_UInt32  pcid_tab_g_11:4;
        RBus_UInt32  pcid_tab_g_10:4;
        RBus_UInt32  pcid_tab_g_03:4;
        RBus_UInt32  pcid_tab_g_02:4;
        RBus_UInt32  pcid_tab_g_01:4;
        RBus_UInt32  pcid_tab_g_00:4;
    };
}pcid_pcid_dither_tb_g_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_g_33:4;
        RBus_UInt32  pcid_tab_g_32:4;
        RBus_UInt32  pcid_tab_g_31:4;
        RBus_UInt32  pcid_tab_g_30:4;
        RBus_UInt32  pcid_tab_g_23:4;
        RBus_UInt32  pcid_tab_g_22:4;
        RBus_UInt32  pcid_tab_g_21:4;
        RBus_UInt32  pcid_tab_g_20:4;
    };
}pcid_pcid_dither_tb_g_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_b_13:4;
        RBus_UInt32  pcid_tab_b_12:4;
        RBus_UInt32  pcid_tab_b_11:4;
        RBus_UInt32  pcid_tab_b_10:4;
        RBus_UInt32  pcid_tab_b_03:4;
        RBus_UInt32  pcid_tab_b_02:4;
        RBus_UInt32  pcid_tab_b_01:4;
        RBus_UInt32  pcid_tab_b_00:4;
    };
}pcid_pcid_dither_tb_b_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_b_33:4;
        RBus_UInt32  pcid_tab_b_32:4;
        RBus_UInt32  pcid_tab_b_31:4;
        RBus_UInt32  pcid_tab_b_30:4;
        RBus_UInt32  pcid_tab_b_23:4;
        RBus_UInt32  pcid_tab_b_22:4;
        RBus_UInt32  pcid_tab_b_21:4;
        RBus_UInt32  pcid_tab_b_20:4;
    };
}pcid_pcid_dither_tb_b_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_temp_offset_15:2;
        RBus_UInt32  pcid_temp_offset_14:2;
        RBus_UInt32  pcid_temp_offset_13:2;
        RBus_UInt32  pcid_temp_offset_12:2;
        RBus_UInt32  pcid_temp_offset_11:2;
        RBus_UInt32  pcid_temp_offset_10:2;
        RBus_UInt32  pcid_temp_offset_9:2;
        RBus_UInt32  pcid_temp_offset_8:2;
        RBus_UInt32  pcid_temp_offset_7:2;
        RBus_UInt32  pcid_temp_offset_6:2;
        RBus_UInt32  pcid_temp_offset_5:2;
        RBus_UInt32  pcid_temp_offset_4:2;
        RBus_UInt32  pcid_temp_offset_3:2;
        RBus_UInt32  pcid_temp_offset_2:2;
        RBus_UInt32  pcid_temp_offset_1:2;
        RBus_UInt32  pcid_temp_offset_0:2;
    };
}pcid_pcid_dither_temp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ef40_31_14:18;
        RBus_UInt32  lsb_add_nr_thd:6;
        RBus_UInt32  res1:1;
        RBus_UInt32  lsb_add_slope_check_en:1;
        RBus_UInt32  lsb_add_nr_en:1;
        RBus_UInt32  lsb_add_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  boundary_mode:1;
    };
}pcid_pcid_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab2_xtr_en:1;
        RBus_UInt32  pcid_tab1_xtr_en:1;
        RBus_UInt32  pcid_thd_mode:1;
        RBus_UInt32  pcid_thd_en:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  pcid_tab1_b_thd:8;
        RBus_UInt32  pcid_tab1_g_thd:8;
        RBus_UInt32  pcid_tab1_r_thd:8;
    };
}pcid_pcid_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ef48_31_24:8;
        RBus_UInt32  pcid_tab2_b_thd:8;
        RBus_UInt32  pcid_tab2_g_thd:8;
        RBus_UInt32  pcid_tab2_r_thd:8;
    };
}pcid_pcid_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line1_odd_b_color_select:2;
        RBus_UInt32  line1_odd_g_color_select:2;
        RBus_UInt32  line1_odd_r_color_select:2;
        RBus_UInt32  line1_odd_b_point_select:2;
        RBus_UInt32  line1_odd_g_point_select:2;
        RBus_UInt32  line1_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line1_odd_b_line_select:1;
        RBus_UInt32  line1_odd_g_line_select:1;
        RBus_UInt32  line1_odd_r_line_select:1;
        RBus_UInt32  line1_even_b_color_select:2;
        RBus_UInt32  line1_even_g_color_select:2;
        RBus_UInt32  line1_even_r_color_select:2;
        RBus_UInt32  line1_even_b_point_select:2;
        RBus_UInt32  line1_even_g_point_select:2;
        RBus_UInt32  line1_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line1_even_b_line_select:1;
        RBus_UInt32  line1_even_g_line_select:1;
        RBus_UInt32  line1_even_r_line_select:1;
    };
}pcid_pcid_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line2_odd_b_color_select:2;
        RBus_UInt32  line2_odd_g_color_select:2;
        RBus_UInt32  line2_odd_r_color_select:2;
        RBus_UInt32  line2_odd_b_point_select:2;
        RBus_UInt32  line2_odd_g_point_select:2;
        RBus_UInt32  line2_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line2_odd_b_line_select:1;
        RBus_UInt32  line2_odd_g_line_select:1;
        RBus_UInt32  line2_odd_r_line_select:1;
        RBus_UInt32  line2_even_b_color_select:2;
        RBus_UInt32  line2_even_g_color_select:2;
        RBus_UInt32  line2_even_r_color_select:2;
        RBus_UInt32  line2_even_b_point_select:2;
        RBus_UInt32  line2_even_g_point_select:2;
        RBus_UInt32  line2_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line2_even_b_line_select:1;
        RBus_UInt32  line2_even_g_line_select:1;
        RBus_UInt32  line2_even_r_line_select:1;
    };
}pcid_pcid_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line3_odd_b_color_select:2;
        RBus_UInt32  line3_odd_g_color_select:2;
        RBus_UInt32  line3_odd_r_color_select:2;
        RBus_UInt32  line3_odd_b_point_select:2;
        RBus_UInt32  line3_odd_g_point_select:2;
        RBus_UInt32  line3_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line3_odd_b_line_select:1;
        RBus_UInt32  line3_odd_g_line_select:1;
        RBus_UInt32  line3_odd_r_line_select:1;
        RBus_UInt32  line3_even_b_color_select:2;
        RBus_UInt32  line3_even_g_color_select:2;
        RBus_UInt32  line3_even_r_color_select:2;
        RBus_UInt32  line3_even_b_point_select:2;
        RBus_UInt32  line3_even_g_point_select:2;
        RBus_UInt32  line3_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line3_even_b_line_select:1;
        RBus_UInt32  line3_even_g_line_select:1;
        RBus_UInt32  line3_even_r_line_select:1;
    };
}pcid_pcid_line_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line4_odd_b_color_select:2;
        RBus_UInt32  line4_odd_g_color_select:2;
        RBus_UInt32  line4_odd_r_color_select:2;
        RBus_UInt32  line4_odd_b_point_select:2;
        RBus_UInt32  line4_odd_g_point_select:2;
        RBus_UInt32  line4_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line4_odd_b_line_select:1;
        RBus_UInt32  line4_odd_g_line_select:1;
        RBus_UInt32  line4_odd_r_line_select:1;
        RBus_UInt32  line4_even_b_color_select:2;
        RBus_UInt32  line4_even_g_color_select:2;
        RBus_UInt32  line4_even_r_color_select:2;
        RBus_UInt32  line4_even_b_point_select:2;
        RBus_UInt32  line4_even_g_point_select:2;
        RBus_UInt32  line4_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line4_even_b_line_select:1;
        RBus_UInt32  line4_even_g_line_select:1;
        RBus_UInt32  line4_even_r_line_select:1;
    };
}pcid_pcid_line_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line2:16;
        RBus_UInt32  r_po_line1:16;
    };
}pcid_pcid2_polarity_r_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line4:16;
        RBus_UInt32  r_po_line3:16;
    };
}pcid_pcid2_polarity_r_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line6:16;
        RBus_UInt32  r_po_line5:16;
    };
}pcid_pcid2_polarity_r_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line8:16;
        RBus_UInt32  r_po_line7:16;
    };
}pcid_pcid2_polarity_r_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line2:16;
        RBus_UInt32  g_po_line1:16;
    };
}pcid_pcid2_polarity_g_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line4:16;
        RBus_UInt32  g_po_line3:16;
    };
}pcid_pcid2_polarity_g_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line6:16;
        RBus_UInt32  g_po_line5:16;
    };
}pcid_pcid2_polarity_g_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line8:16;
        RBus_UInt32  g_po_line7:16;
    };
}pcid_pcid2_polarity_g_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line2:16;
        RBus_UInt32  b_po_line1:16;
    };
}pcid_pcid2_polarity_b_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line4:16;
        RBus_UInt32  b_po_line3:16;
    };
}pcid_pcid2_polarity_b_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line6:16;
        RBus_UInt32  b_po_line5:16;
    };
}pcid_pcid2_polarity_b_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line8:16;
        RBus_UInt32  b_po_line7:16;
    };
}pcid_pcid2_polarity_b_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802efa0_31_12:20;
        RBus_UInt32  valc_dbg_region:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  valc_dbg_sel:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  valc_hpf_clip:2;
        RBus_UInt32  valc_en:1;
    };
}pcid_pcid_valc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_hpf_w15:4;
        RBus_UInt32  valc_hpf_w14:4;
        RBus_UInt32  valc_hpf_w13:4;
        RBus_UInt32  valc_hpf_w12:4;
        RBus_UInt32  valc_hpf_w11:4;
        RBus_UInt32  valc_hpf_w10:4;
        RBus_UInt32  valc_hpf_w9:4;
        RBus_UInt32  valc_hpf_w8:4;
    };
}pcid_pcid_valc_hpf_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_hpf_w7:4;
        RBus_UInt32  valc_hpf_w6:4;
        RBus_UInt32  valc_hpf_w5:4;
        RBus_UInt32  valc_hpf_w4:4;
        RBus_UInt32  valc_hpf_w3:4;
        RBus_UInt32  valc_hpf_w2:4;
        RBus_UInt32  valc_hpf_w1:4;
        RBus_UInt32  valc_hpf_w0:4;
    };
}pcid_pcid_valc_hpf_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_sat_w15:4;
        RBus_UInt32  valc_sat_w14:4;
        RBus_UInt32  valc_sat_w13:4;
        RBus_UInt32  valc_sat_w12:4;
        RBus_UInt32  valc_sat_w11:4;
        RBus_UInt32  valc_sat_w10:4;
        RBus_UInt32  valc_sat_w9:4;
        RBus_UInt32  valc_sat_w8:4;
    };
}pcid_pcid_valc_sat_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_sat_w7:4;
        RBus_UInt32  valc_sat_w6:4;
        RBus_UInt32  valc_sat_w5:4;
        RBus_UInt32  valc_sat_w4:4;
        RBus_UInt32  valc_sat_w3:4;
        RBus_UInt32  valc_sat_w2:4;
        RBus_UInt32  valc_sat_w1:4;
        RBus_UInt32  valc_sat_w0:4;
    };
}pcid_pcid_valc_sat_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  pcid_tab_rm_2:4;
        RBus_UInt32  pcid_tab_rm_1:4;
        RBus_UInt32  pcid_tab_rm_0:4;
        RBus_UInt32  res2:8;
        RBus_UInt32  pcid_lb_rm_1:4;
        RBus_UInt32  pcid_lb_rm_0:4;
    };
}pcid_pcid_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  pcid_tab_ls_2:1;
        RBus_UInt32  pcid_tab_ls_1:1;
        RBus_UInt32  pcid_tab_ls_0:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  pcid_lb_ls_1:1;
        RBus_UInt32  pcid_lb_ls_0:1;
        RBus_UInt32  res3:9;
        RBus_UInt32  pcid_tab_rme_2:1;
        RBus_UInt32  pcid_tab_rme_1:1;
        RBus_UInt32  pcid_tab_rme_0:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  pcid_lb_rme_1:1;
        RBus_UInt32  pcid_lb_rme_0:1;
    };
}pcid_pcid_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  pcid_tab_drf_fail_2:1;
        RBus_UInt32  pcid_tab_drf_fail_1:1;
        RBus_UInt32  pcid_tab_drf_fail_0:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  pcid_lb_drf_fail_1:1;
        RBus_UInt32  pcid_lb_drf_fail_0:1;
        RBus_UInt32  res3:9;
        RBus_UInt32  pcid_tab_bist_fail_2:1;
        RBus_UInt32  pcid_tab_bist_fail_1:1;
        RBus_UInt32  pcid_tab_bist_fail_0:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  pcid_lb_bist_fail_1:1;
        RBus_UInt32  pcid_lb_bist_fail_0:1;
    };
}pcid_pcid_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pcid_lb_testrwm_1:1;
        RBus_UInt32  pcid_lb_testrwm_0:1;
    };
}pcid_pcid_testrwm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  pcid_lut_ax_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  pcid_lut_adr_mode:1;
        RBus_UInt32  pcid_lut_sel:2;
        RBus_UInt32  pcid_lut_row_addr:6;
        RBus_UInt32  pcid_lut_column_addr:6;
    };
}pcid_pcid_lut_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lut_data:32;
    };
}pcid_pcid_lut_data_RBUS;

#else //apply LITTLE_ENDIAN

//======PCID register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  pcid_value_sign:1;
        RBus_UInt32  pcid_temporal_enable:1;
        RBus_UInt32  pcid_dither_en:1;
        RBus_UInt32  res2:26;
    };
}pcid_pcid_dither_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_r_0:2;
        RBus_UInt32  pcid_seq_r_1:2;
        RBus_UInt32  pcid_seq_r_2:2;
        RBus_UInt32  pcid_seq_r_3:2;
        RBus_UInt32  pcid_seq_r_4:2;
        RBus_UInt32  pcid_seq_r_5:2;
        RBus_UInt32  pcid_seq_r_6:2;
        RBus_UInt32  pcid_seq_r_7:2;
        RBus_UInt32  pcid_seq_r_8:2;
        RBus_UInt32  pcid_seq_r_9:2;
        RBus_UInt32  pcid_seq_r_10:2;
        RBus_UInt32  pcid_seq_r_11:2;
        RBus_UInt32  pcid_seq_r_12:2;
        RBus_UInt32  pcid_seq_r_13:2;
        RBus_UInt32  pcid_seq_r_14:2;
        RBus_UInt32  pcid_seq_r_15:2;
    };
}pcid_pcid_dither_seq_r_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_r_16:2;
        RBus_UInt32  pcid_seq_r_17:2;
        RBus_UInt32  pcid_seq_r_18:2;
        RBus_UInt32  pcid_seq_r_19:2;
        RBus_UInt32  pcid_seq_r_20:2;
        RBus_UInt32  pcid_seq_r_21:2;
        RBus_UInt32  pcid_seq_r_22:2;
        RBus_UInt32  pcid_seq_r_23:2;
        RBus_UInt32  pcid_seq_r_24:2;
        RBus_UInt32  pcid_seq_r_25:2;
        RBus_UInt32  pcid_seq_r_26:2;
        RBus_UInt32  pcid_seq_r_27:2;
        RBus_UInt32  pcid_seq_r_28:2;
        RBus_UInt32  pcid_seq_r_29:2;
        RBus_UInt32  pcid_seq_r_30:2;
        RBus_UInt32  pcid_seq_r_31:2;
    };
}pcid_pcid_dither_seq_r_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_g_0:2;
        RBus_UInt32  pcid_seq_g_1:2;
        RBus_UInt32  pcid_seq_g_2:2;
        RBus_UInt32  pcid_seq_g_3:2;
        RBus_UInt32  pcid_seq_g_4:2;
        RBus_UInt32  pcid_seq_g_5:2;
        RBus_UInt32  pcid_seq_g_6:2;
        RBus_UInt32  pcid_seq_g_7:2;
        RBus_UInt32  pcid_seq_g_8:2;
        RBus_UInt32  pcid_seq_g_9:2;
        RBus_UInt32  pcid_seq_g_10:2;
        RBus_UInt32  pcid_seq_g_11:2;
        RBus_UInt32  pcid_seq_g_12:2;
        RBus_UInt32  pcid_seq_g_13:2;
        RBus_UInt32  pcid_seq_g_14:2;
        RBus_UInt32  pcid_seq_g_15:2;
    };
}pcid_pcid_dither_seq_g_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_g_16:2;
        RBus_UInt32  pcid_seq_g_17:2;
        RBus_UInt32  pcid_seq_g_18:2;
        RBus_UInt32  pcid_seq_g_19:2;
        RBus_UInt32  pcid_seq_g_20:2;
        RBus_UInt32  pcid_seq_g_21:2;
        RBus_UInt32  pcid_seq_g_22:2;
        RBus_UInt32  pcid_seq_g_23:2;
        RBus_UInt32  pcid_seq_g_24:2;
        RBus_UInt32  pcid_seq_g_25:2;
        RBus_UInt32  pcid_seq_g_26:2;
        RBus_UInt32  pcid_seq_g_27:2;
        RBus_UInt32  pcid_seq_g_28:2;
        RBus_UInt32  pcid_seq_g_29:2;
        RBus_UInt32  pcid_seq_g_30:2;
        RBus_UInt32  pcid_seq_g_31:2;
    };
}pcid_pcid_dither_seq_g_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_b_0:2;
        RBus_UInt32  pcid_seq_b_1:2;
        RBus_UInt32  pcid_seq_b_2:2;
        RBus_UInt32  pcid_seq_b_3:2;
        RBus_UInt32  pcid_seq_b_4:2;
        RBus_UInt32  pcid_seq_b_5:2;
        RBus_UInt32  pcid_seq_b_6:2;
        RBus_UInt32  pcid_seq_b_7:2;
        RBus_UInt32  pcid_seq_b_8:2;
        RBus_UInt32  pcid_seq_b_9:2;
        RBus_UInt32  pcid_seq_b_10:2;
        RBus_UInt32  pcid_seq_b_11:2;
        RBus_UInt32  pcid_seq_b_12:2;
        RBus_UInt32  pcid_seq_b_13:2;
        RBus_UInt32  pcid_seq_b_14:2;
        RBus_UInt32  pcid_seq_b_15:2;
    };
}pcid_pcid_dither_seq_b_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_seq_b_16:2;
        RBus_UInt32  pcid_seq_b_17:2;
        RBus_UInt32  pcid_seq_b_18:2;
        RBus_UInt32  pcid_seq_b_19:2;
        RBus_UInt32  pcid_seq_b_20:2;
        RBus_UInt32  pcid_seq_b_21:2;
        RBus_UInt32  pcid_seq_b_22:2;
        RBus_UInt32  pcid_seq_b_23:2;
        RBus_UInt32  pcid_seq_b_24:2;
        RBus_UInt32  pcid_seq_b_25:2;
        RBus_UInt32  pcid_seq_b_26:2;
        RBus_UInt32  pcid_seq_b_27:2;
        RBus_UInt32  pcid_seq_b_28:2;
        RBus_UInt32  pcid_seq_b_29:2;
        RBus_UInt32  pcid_seq_b_30:2;
        RBus_UInt32  pcid_seq_b_31:2;
    };
}pcid_pcid_dither_seq_b_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_r_00:4;
        RBus_UInt32  pcid_tab_r_01:4;
        RBus_UInt32  pcid_tab_r_02:4;
        RBus_UInt32  pcid_tab_r_03:4;
        RBus_UInt32  pcid_tab_r_10:4;
        RBus_UInt32  pcid_tab_r_11:4;
        RBus_UInt32  pcid_tab_r_12:4;
        RBus_UInt32  pcid_tab_r_13:4;
    };
}pcid_pcid_dither_tb_r_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_r_20:4;
        RBus_UInt32  pcid_tab_r_21:4;
        RBus_UInt32  pcid_tab_r_22:4;
        RBus_UInt32  pcid_tab_r_23:4;
        RBus_UInt32  pcid_tab_r_30:4;
        RBus_UInt32  pcid_tab_r_31:4;
        RBus_UInt32  pcid_tab_r_32:4;
        RBus_UInt32  pcid_tab_r_33:4;
    };
}pcid_pcid_dither_tb_r_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_g_00:4;
        RBus_UInt32  pcid_tab_g_01:4;
        RBus_UInt32  pcid_tab_g_02:4;
        RBus_UInt32  pcid_tab_g_03:4;
        RBus_UInt32  pcid_tab_g_10:4;
        RBus_UInt32  pcid_tab_g_11:4;
        RBus_UInt32  pcid_tab_g_12:4;
        RBus_UInt32  pcid_tab_g_13:4;
    };
}pcid_pcid_dither_tb_g_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_g_20:4;
        RBus_UInt32  pcid_tab_g_21:4;
        RBus_UInt32  pcid_tab_g_22:4;
        RBus_UInt32  pcid_tab_g_23:4;
        RBus_UInt32  pcid_tab_g_30:4;
        RBus_UInt32  pcid_tab_g_31:4;
        RBus_UInt32  pcid_tab_g_32:4;
        RBus_UInt32  pcid_tab_g_33:4;
    };
}pcid_pcid_dither_tb_g_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_b_00:4;
        RBus_UInt32  pcid_tab_b_01:4;
        RBus_UInt32  pcid_tab_b_02:4;
        RBus_UInt32  pcid_tab_b_03:4;
        RBus_UInt32  pcid_tab_b_10:4;
        RBus_UInt32  pcid_tab_b_11:4;
        RBus_UInt32  pcid_tab_b_12:4;
        RBus_UInt32  pcid_tab_b_13:4;
    };
}pcid_pcid_dither_tb_b_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab_b_20:4;
        RBus_UInt32  pcid_tab_b_21:4;
        RBus_UInt32  pcid_tab_b_22:4;
        RBus_UInt32  pcid_tab_b_23:4;
        RBus_UInt32  pcid_tab_b_30:4;
        RBus_UInt32  pcid_tab_b_31:4;
        RBus_UInt32  pcid_tab_b_32:4;
        RBus_UInt32  pcid_tab_b_33:4;
    };
}pcid_pcid_dither_tb_b_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_temp_offset_0:2;
        RBus_UInt32  pcid_temp_offset_1:2;
        RBus_UInt32  pcid_temp_offset_2:2;
        RBus_UInt32  pcid_temp_offset_3:2;
        RBus_UInt32  pcid_temp_offset_4:2;
        RBus_UInt32  pcid_temp_offset_5:2;
        RBus_UInt32  pcid_temp_offset_6:2;
        RBus_UInt32  pcid_temp_offset_7:2;
        RBus_UInt32  pcid_temp_offset_8:2;
        RBus_UInt32  pcid_temp_offset_9:2;
        RBus_UInt32  pcid_temp_offset_10:2;
        RBus_UInt32  pcid_temp_offset_11:2;
        RBus_UInt32  pcid_temp_offset_12:2;
        RBus_UInt32  pcid_temp_offset_13:2;
        RBus_UInt32  pcid_temp_offset_14:2;
        RBus_UInt32  pcid_temp_offset_15:2;
    };
}pcid_pcid_dither_temp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  boundary_mode:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  lsb_add_en:1;
        RBus_UInt32  lsb_add_nr_en:1;
        RBus_UInt32  lsb_add_slope_check_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  lsb_add_nr_thd:6;
        RBus_UInt32  dummy1802ef40_31_14:18;
    };
}pcid_pcid_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab1_r_thd:8;
        RBus_UInt32  pcid_tab1_g_thd:8;
        RBus_UInt32  pcid_tab1_b_thd:8;
        RBus_UInt32  res1:4;
        RBus_UInt32  pcid_thd_en:1;
        RBus_UInt32  pcid_thd_mode:1;
        RBus_UInt32  pcid_tab1_xtr_en:1;
        RBus_UInt32  pcid_tab2_xtr_en:1;
    };
}pcid_pcid_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab2_r_thd:8;
        RBus_UInt32  pcid_tab2_g_thd:8;
        RBus_UInt32  pcid_tab2_b_thd:8;
        RBus_UInt32  dummy1802ef48_31_24:8;
    };
}pcid_pcid_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line1_even_r_line_select:1;
        RBus_UInt32  line1_even_g_line_select:1;
        RBus_UInt32  line1_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line1_even_r_point_select:2;
        RBus_UInt32  line1_even_g_point_select:2;
        RBus_UInt32  line1_even_b_point_select:2;
        RBus_UInt32  line1_even_r_color_select:2;
        RBus_UInt32  line1_even_g_color_select:2;
        RBus_UInt32  line1_even_b_color_select:2;
        RBus_UInt32  line1_odd_r_line_select:1;
        RBus_UInt32  line1_odd_g_line_select:1;
        RBus_UInt32  line1_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line1_odd_r_point_select:2;
        RBus_UInt32  line1_odd_g_point_select:2;
        RBus_UInt32  line1_odd_b_point_select:2;
        RBus_UInt32  line1_odd_r_color_select:2;
        RBus_UInt32  line1_odd_g_color_select:2;
        RBus_UInt32  line1_odd_b_color_select:2;
    };
}pcid_pcid_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line2_even_r_line_select:1;
        RBus_UInt32  line2_even_g_line_select:1;
        RBus_UInt32  line2_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line2_even_r_point_select:2;
        RBus_UInt32  line2_even_g_point_select:2;
        RBus_UInt32  line2_even_b_point_select:2;
        RBus_UInt32  line2_even_r_color_select:2;
        RBus_UInt32  line2_even_g_color_select:2;
        RBus_UInt32  line2_even_b_color_select:2;
        RBus_UInt32  line2_odd_r_line_select:1;
        RBus_UInt32  line2_odd_g_line_select:1;
        RBus_UInt32  line2_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line2_odd_r_point_select:2;
        RBus_UInt32  line2_odd_g_point_select:2;
        RBus_UInt32  line2_odd_b_point_select:2;
        RBus_UInt32  line2_odd_r_color_select:2;
        RBus_UInt32  line2_odd_g_color_select:2;
        RBus_UInt32  line2_odd_b_color_select:2;
    };
}pcid_pcid_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line3_even_r_line_select:1;
        RBus_UInt32  line3_even_g_line_select:1;
        RBus_UInt32  line3_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line3_even_r_point_select:2;
        RBus_UInt32  line3_even_g_point_select:2;
        RBus_UInt32  line3_even_b_point_select:2;
        RBus_UInt32  line3_even_r_color_select:2;
        RBus_UInt32  line3_even_g_color_select:2;
        RBus_UInt32  line3_even_b_color_select:2;
        RBus_UInt32  line3_odd_r_line_select:1;
        RBus_UInt32  line3_odd_g_line_select:1;
        RBus_UInt32  line3_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line3_odd_r_point_select:2;
        RBus_UInt32  line3_odd_g_point_select:2;
        RBus_UInt32  line3_odd_b_point_select:2;
        RBus_UInt32  line3_odd_r_color_select:2;
        RBus_UInt32  line3_odd_g_color_select:2;
        RBus_UInt32  line3_odd_b_color_select:2;
    };
}pcid_pcid_line_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line4_even_r_line_select:1;
        RBus_UInt32  line4_even_g_line_select:1;
        RBus_UInt32  line4_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line4_even_r_point_select:2;
        RBus_UInt32  line4_even_g_point_select:2;
        RBus_UInt32  line4_even_b_point_select:2;
        RBus_UInt32  line4_even_r_color_select:2;
        RBus_UInt32  line4_even_g_color_select:2;
        RBus_UInt32  line4_even_b_color_select:2;
        RBus_UInt32  line4_odd_r_line_select:1;
        RBus_UInt32  line4_odd_g_line_select:1;
        RBus_UInt32  line4_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line4_odd_r_point_select:2;
        RBus_UInt32  line4_odd_g_point_select:2;
        RBus_UInt32  line4_odd_b_point_select:2;
        RBus_UInt32  line4_odd_r_color_select:2;
        RBus_UInt32  line4_odd_g_color_select:2;
        RBus_UInt32  line4_odd_b_color_select:2;
    };
}pcid_pcid_line_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line1:16;
        RBus_UInt32  r_po_line2:16;
    };
}pcid_pcid2_polarity_r_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line3:16;
        RBus_UInt32  r_po_line4:16;
    };
}pcid_pcid2_polarity_r_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line5:16;
        RBus_UInt32  r_po_line6:16;
    };
}pcid_pcid2_polarity_r_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line7:16;
        RBus_UInt32  r_po_line8:16;
    };
}pcid_pcid2_polarity_r_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line1:16;
        RBus_UInt32  g_po_line2:16;
    };
}pcid_pcid2_polarity_g_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line3:16;
        RBus_UInt32  g_po_line4:16;
    };
}pcid_pcid2_polarity_g_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line5:16;
        RBus_UInt32  g_po_line6:16;
    };
}pcid_pcid2_polarity_g_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line7:16;
        RBus_UInt32  g_po_line8:16;
    };
}pcid_pcid2_polarity_g_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line1:16;
        RBus_UInt32  b_po_line2:16;
    };
}pcid_pcid2_polarity_b_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line3:16;
        RBus_UInt32  b_po_line4:16;
    };
}pcid_pcid2_polarity_b_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line5:16;
        RBus_UInt32  b_po_line6:16;
    };
}pcid_pcid2_polarity_b_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line7:16;
        RBus_UInt32  b_po_line8:16;
    };
}pcid_pcid2_polarity_b_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_en:1;
        RBus_UInt32  valc_hpf_clip:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  valc_dbg_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  valc_dbg_region:4;
        RBus_UInt32  dummy1802efa0_31_12:20;
    };
}pcid_pcid_valc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_hpf_w8:4;
        RBus_UInt32  valc_hpf_w9:4;
        RBus_UInt32  valc_hpf_w10:4;
        RBus_UInt32  valc_hpf_w11:4;
        RBus_UInt32  valc_hpf_w12:4;
        RBus_UInt32  valc_hpf_w13:4;
        RBus_UInt32  valc_hpf_w14:4;
        RBus_UInt32  valc_hpf_w15:4;
    };
}pcid_pcid_valc_hpf_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_hpf_w0:4;
        RBus_UInt32  valc_hpf_w1:4;
        RBus_UInt32  valc_hpf_w2:4;
        RBus_UInt32  valc_hpf_w3:4;
        RBus_UInt32  valc_hpf_w4:4;
        RBus_UInt32  valc_hpf_w5:4;
        RBus_UInt32  valc_hpf_w6:4;
        RBus_UInt32  valc_hpf_w7:4;
    };
}pcid_pcid_valc_hpf_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_sat_w8:4;
        RBus_UInt32  valc_sat_w9:4;
        RBus_UInt32  valc_sat_w10:4;
        RBus_UInt32  valc_sat_w11:4;
        RBus_UInt32  valc_sat_w12:4;
        RBus_UInt32  valc_sat_w13:4;
        RBus_UInt32  valc_sat_w14:4;
        RBus_UInt32  valc_sat_w15:4;
    };
}pcid_pcid_valc_sat_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_sat_w0:4;
        RBus_UInt32  valc_sat_w1:4;
        RBus_UInt32  valc_sat_w2:4;
        RBus_UInt32  valc_sat_w3:4;
        RBus_UInt32  valc_sat_w4:4;
        RBus_UInt32  valc_sat_w5:4;
        RBus_UInt32  valc_sat_w6:4;
        RBus_UInt32  valc_sat_w7:4;
    };
}pcid_pcid_valc_sat_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_rm_0:4;
        RBus_UInt32  pcid_lb_rm_1:4;
        RBus_UInt32  res1:8;
        RBus_UInt32  pcid_tab_rm_0:4;
        RBus_UInt32  pcid_tab_rm_1:4;
        RBus_UInt32  pcid_tab_rm_2:4;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_rme_0:1;
        RBus_UInt32  pcid_lb_rme_1:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  pcid_tab_rme_0:1;
        RBus_UInt32  pcid_tab_rme_1:1;
        RBus_UInt32  pcid_tab_rme_2:1;
        RBus_UInt32  res2:9;
        RBus_UInt32  pcid_lb_ls_0:1;
        RBus_UInt32  pcid_lb_ls_1:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  pcid_tab_ls_0:1;
        RBus_UInt32  pcid_tab_ls_1:1;
        RBus_UInt32  pcid_tab_ls_2:1;
        RBus_UInt32  res4:9;
    };
}pcid_pcid_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_bist_fail_0:1;
        RBus_UInt32  pcid_lb_bist_fail_1:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  pcid_tab_bist_fail_0:1;
        RBus_UInt32  pcid_tab_bist_fail_1:1;
        RBus_UInt32  pcid_tab_bist_fail_2:1;
        RBus_UInt32  res2:9;
        RBus_UInt32  pcid_lb_drf_fail_0:1;
        RBus_UInt32  pcid_lb_drf_fail_1:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  pcid_tab_drf_fail_0:1;
        RBus_UInt32  pcid_tab_drf_fail_1:1;
        RBus_UInt32  pcid_tab_drf_fail_2:1;
        RBus_UInt32  res4:9;
    };
}pcid_pcid_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_testrwm_0:1;
        RBus_UInt32  pcid_lb_testrwm_1:1;
        RBus_UInt32  res1:30;
    };
}pcid_pcid_testrwm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lut_column_addr:6;
        RBus_UInt32  pcid_lut_row_addr:6;
        RBus_UInt32  pcid_lut_sel:2;
        RBus_UInt32  pcid_lut_adr_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  pcid_lut_ax_en:1;
        RBus_UInt32  res2:15;
    };
}pcid_pcid_lut_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lut_data:32;
    };
}pcid_pcid_lut_data_RBUS;




#endif 


#endif 
