/**
* @file Mac7p-DesignSpec-D-Domain_GDMA_BIST_BISR_control
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DISPD_OSD_BIST_REG_H_
#define _RBUS_DISPD_OSD_BIST_REG_H_

#include "rbusTypes.h"



//  DISPD_OSD_BIST Register Address



#define  DISPD_OSD_BIST_GDMA_BIST_MODE_VADDR                	(0xb8029e00)
#define  DISPD_OSD_BIST_GDMA_BIST_DONE_VADDR                	(0xb8029e04)
#define  DISPD_OSD_BIST_GDMA_BIST_FAIL_GROUP_VADDR          	(0xb8029e08)
#define  DISPD_OSD_BIST_GDMA_DRF_MODE_VADDR                 	(0xb8029e0c)
#define  DISPD_OSD_BIST_GDMA_DRF_RESUME_VADDR               	(0xb8029e10)
#define  DISPD_OSD_BIST_GDMA_DRF_DONE_VADDR                 	(0xb8029e14)
#define  DISPD_OSD_BIST_GDMA_DRF_PAUSE_VADDR                	(0xb8029e18)
#define  DISPD_OSD_BIST_GDMA_DRF_FAIL_GROUP_VADDR           	(0xb8029e1c)
#define  DISPD_OSD_BIST_DISPD_BISR_SECOND_RUN_EN_VADDR      	(0xb8029e20)
#define  DISPD_OSD_BIST_DISPD_BISR_FAIL_GROUP_VADDR         	(0xb8029e24)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_MODE_VADDR           	(0xb8029e28)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_RESUME_VADDR         	(0xb8029e2c)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_DONE_VADDR           	(0xb8029e30)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_PAUSE_VADDR          	(0xb8029e34)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_FAIL_GROUP_VADDR     	(0xb8029e38)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DISPD_OSD_BIST register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  gdma_afbc_header_bist_mode:1;
        RBus_UInt32  gdma_osd_gamma1_bist_mode:1;
        RBus_UInt32  gdma_osd_gamma2_bist_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_sr_lb_bist_mode:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  gdma_osd_rbuf_share_bist_mode:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_mode:1;
    };
}dispd_osd_bist_gdma_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  gdma_afbc_header_bist_done:1;
        RBus_UInt32  gdma_osd_gamma1_bist_done:1;
        RBus_UInt32  gdma_osd_gamma2_bist_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_sr_lb_bist_done:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  gdma_osd_rbuf_share_bist_done:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_done:1;
    };
}dispd_osd_bist_gdma_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  gdma_afbc_header_bist_fail_group:1;
        RBus_UInt32  gdma_osd_gamma1_bist_fail_group:1;
        RBus_UInt32  gdma_osd_gamma2_bist_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_sr_lb_bist_fail_group:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  gdma_osd_rbuf_share_bist_fail_group:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_fail_group:1;
    };
}dispd_osd_bist_gdma_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  gdma_afbc_header_drf_mode:1;
        RBus_UInt32  gdma_osd_gamma1_drf_mode:1;
        RBus_UInt32  gdma_osd_gamma2_drf_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_sr_lb_drf_mode:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  gdma_osd_rbuf_share_drf_mode:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_mode:1;
    };
}dispd_osd_bist_gdma_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  gdma_afbc_header_drf_resume:1;
        RBus_UInt32  gdma_osd_gamma1_drf_resume:1;
        RBus_UInt32  gdma_osd_gamma2_drf_resume:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_sr_lb_drf_resume:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  gdma_osd_rbuf_share_drf_resume:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_resume:1;
    };
}dispd_osd_bist_gdma_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  gdma_afbc_header_drf_done:1;
        RBus_UInt32  gdma_osd_gamma1_drf_done:1;
        RBus_UInt32  gdma_osd_gamma2_drf_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_sr_lb_drf_done:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  gdma_osd_rbuf_share_drf_done:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_done:1;
    };
}dispd_osd_bist_gdma_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  gdma_afbc_header_drf_pause:1;
        RBus_UInt32  gdma_osd_gamma1_drf_pause:1;
        RBus_UInt32  gdma_osd_gamma2_drf_pause:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_sr_lb_drf_pause:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  gdma_osd_rbuf_share_drf_pause:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_pause:1;
    };
}dispd_osd_bist_gdma_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  gdma_afbc_header_drf_fail_group:1;
        RBus_UInt32  gdma_osd_gamma1_drf_fail_group:1;
        RBus_UInt32  gdma_osd_gamma2_drf_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_sr_lb_drf_fail_group:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  gdma_osd_rbuf_share_drf_fail_group:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_fail_group:1;
    };
}dispd_osd_bist_gdma_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  gdma_afbc_bisr_second_run_en:1;
    };
}dispd_osd_bist_dispd_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  gdma_afbc_bisr_fail_group:1;
    };
}dispd_osd_bist_dispd_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  gdma_afbc_drf_bisr_mode:1;
    };
}dispd_osd_bist_dispd_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  gdma_afbc_drf_bisr_test_resume:1;
    };
}dispd_osd_bist_dispd_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  gdma_afbc_drf_bisr_done:1;
    };
}dispd_osd_bist_dispd_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  gdma_afbc_drf_bisr_start_pause:1;
    };
}dispd_osd_bist_dispd_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  gdma_afbc_drf_bisr_fail_group:1;
    };
}dispd_osd_bist_dispd_bisr_drf_fail_group_RBUS;

#else //apply LITTLE_ENDIAN

//======DISPD_OSD_BIST register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_mode:1;
        RBus_UInt32  gdma_osd_rbuf_share_bist_mode:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdma_sr_lb_bist_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_osd_gamma2_bist_mode:1;
        RBus_UInt32  gdma_osd_gamma1_bist_mode:1;
        RBus_UInt32  gdma_afbc_header_bist_mode:1;
        RBus_UInt32  res3:22;
    };
}dispd_osd_bist_gdma_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_done:1;
        RBus_UInt32  gdma_osd_rbuf_share_bist_done:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdma_sr_lb_bist_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_osd_gamma2_bist_done:1;
        RBus_UInt32  gdma_osd_gamma1_bist_done:1;
        RBus_UInt32  gdma_afbc_header_bist_done:1;
        RBus_UInt32  res3:22;
    };
}dispd_osd_bist_gdma_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_share_bist_fail_group:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdma_sr_lb_bist_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_osd_gamma2_bist_fail_group:1;
        RBus_UInt32  gdma_osd_gamma1_bist_fail_group:1;
        RBus_UInt32  gdma_afbc_header_bist_fail_group:1;
        RBus_UInt32  res3:22;
    };
}dispd_osd_bist_gdma_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_mode:1;
        RBus_UInt32  gdma_osd_rbuf_share_drf_mode:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdma_sr_lb_drf_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_osd_gamma2_drf_mode:1;
        RBus_UInt32  gdma_osd_gamma1_drf_mode:1;
        RBus_UInt32  gdma_afbc_header_drf_mode:1;
        RBus_UInt32  res3:22;
    };
}dispd_osd_bist_gdma_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_resume:1;
        RBus_UInt32  gdma_osd_rbuf_share_drf_resume:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdma_sr_lb_drf_resume:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_osd_gamma2_drf_resume:1;
        RBus_UInt32  gdma_osd_gamma1_drf_resume:1;
        RBus_UInt32  gdma_afbc_header_drf_resume:1;
        RBus_UInt32  res3:22;
    };
}dispd_osd_bist_gdma_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_done:1;
        RBus_UInt32  gdma_osd_rbuf_share_drf_done:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdma_sr_lb_drf_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_osd_gamma2_drf_done:1;
        RBus_UInt32  gdma_osd_gamma1_drf_done:1;
        RBus_UInt32  gdma_afbc_header_drf_done:1;
        RBus_UInt32  res3:22;
    };
}dispd_osd_bist_gdma_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_pause:1;
        RBus_UInt32  gdma_osd_rbuf_share_drf_pause:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdma_sr_lb_drf_pause:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_osd_gamma2_drf_pause:1;
        RBus_UInt32  gdma_osd_gamma1_drf_pause:1;
        RBus_UInt32  gdma_afbc_header_drf_pause:1;
        RBus_UInt32  res3:22;
    };
}dispd_osd_bist_gdma_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_share_drf_fail_group:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdma_sr_lb_drf_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gdma_osd_gamma2_drf_fail_group:1;
        RBus_UInt32  gdma_osd_gamma1_drf_fail_group:1;
        RBus_UInt32  gdma_afbc_header_drf_fail_group:1;
        RBus_UInt32  res3:22;
    };
}dispd_osd_bist_gdma_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_afbc_bisr_second_run_en:1;
        RBus_UInt32  res1:31;
    };
}dispd_osd_bist_dispd_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_afbc_bisr_fail_group:1;
        RBus_UInt32  res1:31;
    };
}dispd_osd_bist_dispd_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_afbc_drf_bisr_mode:1;
        RBus_UInt32  res1:31;
    };
}dispd_osd_bist_dispd_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_afbc_drf_bisr_test_resume:1;
        RBus_UInt32  res1:31;
    };
}dispd_osd_bist_dispd_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_afbc_drf_bisr_done:1;
        RBus_UInt32  res1:31;
    };
}dispd_osd_bist_dispd_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_afbc_drf_bisr_start_pause:1;
        RBus_UInt32  res1:31;
    };
}dispd_osd_bist_dispd_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_afbc_drf_bisr_fail_group:1;
        RBus_UInt32  res1:31;
    };
}dispd_osd_bist_dispd_bisr_drf_fail_group_RBUS;




#endif 


#endif 
