/**
* @file Mac7p-DesignSpec-D-Domain_GDMA_osd
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_GDMA_REG_H_
#define _RBUS_GDMA_REG_H_

#include "rbusTypes.h"



//  GDMA Register Address



#define  GDMA_UPDATE_VADDR                                  	(0xb802ff00)
#define  GDMA_CTRL_VADDR                                    	(0xb802ff04)
#define  GDMA_LINE_BUFFER_STA_VADDR                         	(0xb802ff10)
#define  GDMA_LINE_BUFFER_SIZE_VADDR                        	(0xb802ff14)
#define  GDMA_LINE_BUFFER_END_VADDR                         	(0xb802ff18)
#define  GDMA_OSD_STATUS_VADDR                              	(0xb802ff20)
#define  GDMA_RTL_IMPROVE_VADDR                             	(0xb802ff30)
#define  GDMA_OSD1_CTRL_VADDR                               	(0xb802f200)
#define  GDMA_OSD1_VADDR                                    	(0xb802f204)
#define  GDMA_OSD1_START_VADDR                              	(0xb802f208)
#define  GDMA_OSD1_WI_VADDR                                 	(0xb802f210)
#define  GDMA_OSD1_WI_3D_VADDR                              	(0xb802f214)
#define  GDMA_OSD1_SIZE_VADDR                               	(0xb802f218)
#define  GDMA_OSD1_CC1_VADDR                                	(0xb802f21c)
#define  GDMA_OSD1_CC2_VADDR                                	(0xb802f220)
#define  GDMA_OSD1_CC3_VADDR                                	(0xb802f224)
#define  GDMA_OSD1_CC4_VADDR                                	(0xb802f228)
#define  GDMA_OSD1_CC5_VADDR                                	(0xb802f22c)
#define  GDMA_OSD1_CC6_VADDR                                	(0xb802f230)
#define  GDMA_OSD1_CC7_VADDR                                	(0xb802f234)
#define  GDMA_OSD1_CLEAR1_VADDR                             	(0xb802f280)
#define  GDMA_OSD1_CLEAR2_VADDR                             	(0xb802f284)
#define  GDMA_OSD2_CTRL_VADDR                               	(0xb802f300)
#define  GDMA_OSD2_VADDR                                    	(0xb802f304)
#define  GDMA_OSD2_START_VADDR                              	(0xb802f308)
#define  GDMA_OSD2_WI_VADDR                                 	(0xb802f310)
#define  GDMA_OSD2_WI_3D_VADDR                              	(0xb802f314)
#define  GDMA_OSD2_SIZE_VADDR                               	(0xb802f318)
#define  GDMA_OSD2_CC1_VADDR                                	(0xb802f31c)
#define  GDMA_OSD2_CC2_VADDR                                	(0xb802f320)
#define  GDMA_OSD2_CC3_VADDR                                	(0xb802f324)
#define  GDMA_OSD2_CC4_VADDR                                	(0xb802f328)
#define  GDMA_OSD2_CC5_VADDR                                	(0xb802f32c)
#define  GDMA_OSD2_CC6_VADDR                                	(0xb802f330)
#define  GDMA_OSD2_CC7_VADDR                                	(0xb802f334)
#define  GDMA_OSD2_CLEAR1_VADDR                             	(0xb802f380)
#define  GDMA_OSD2_CLEAR2_VADDR                             	(0xb802f384)
#define  GDMA_OSD3_CTRL_VADDR                               	(0xb802f400)
#define  GDMA_OSD3_VADDR                                    	(0xb802f404)
#define  GDMA_OSD3_START_VADDR                              	(0xb802f408)
#define  GDMA_OSD3_WI_VADDR                                 	(0xb802f410)
#define  GDMA_OSD3_WI_3D_VADDR                              	(0xb802f414)
#define  GDMA_OSD3_SIZE_VADDR                               	(0xb802f418)
#define  GDMA_OSD3_CC1_VADDR                                	(0xb802f41c)
#define  GDMA_OSD3_CC2_VADDR                                	(0xb802f420)
#define  GDMA_OSD3_CC3_VADDR                                	(0xb802f424)
#define  GDMA_OSD3_CC4_VADDR                                	(0xb802f428)
#define  GDMA_OSD3_CC5_VADDR                                	(0xb802f42c)
#define  GDMA_OSD3_CC6_VADDR                                	(0xb802f430)
#define  GDMA_OSD3_CC7_VADDR                                	(0xb802f434)
#define  GDMA_OSD3_CLEAR1_VADDR                             	(0xb802f480)
#define  GDMA_OSD3_CLEAR2_VADDR                             	(0xb802f484)
#define  GDMA_AFBC1_IRQ_ST_VADDR                            	(0xb802f800)
#define  GDMA_AFBC1_CNT_ST_VADDR                            	(0xb802f804)
#define  GDMA_AFBC1_FIFO_WATER_ST_VADDR                     	(0xb802f808)
#define  GDMA_AFBC1_FIFO_ST_VADDR                           	(0xb802f80c)
#define  GDMA_AFBC2_IRQ_ST_VADDR                            	(0xb802f810)
#define  GDMA_AFBC2_CNT_ST_VADDR                            	(0xb802f814)
#define  GDMA_AFBC2_FIFO_WATER_ST_VADDR                     	(0xb802f818)
#define  GDMA_AFBC2_FIFO_ST_VADDR                           	(0xb802f81c)
#define  GDMA_AFBC1_DATA_SRAM_BASE_VADDR                    	(0xb802f820)
#define  GDMA_OSD1_AFBC1_MAX_VADDR                          	(0xb802f824)
#define  GDMA_OSD1_AFBC1_MIN_VADDR                          	(0xb802f828)
#define  GDMA_AFBC2_DATA_SRAM_BASE_VADDR                    	(0xb802f82c)
#define  GDMA_OSD2_AFBC2_MAX_VADDR                          	(0xb802f830)
#define  GDMA_OSD2_AFBC2_MIN_VADDR                          	(0xb802f834)
#define  GDMA_OSD3_MAX_VADDR                                	(0xb802f838)
#define  GDMA_OSD3_MIN_VADDR                                	(0xb802f83c)
#define  GDMA_DMA_BL_2_VADDR                                	(0xb802f924)
#define  GDMA_DMA_VADDR                                     	(0xb802f928)
#define  GDMA_DMA_SWAP_VADDR                                	(0xb802f92c)
#define  GDMA_DMA_OSD1_WI_VADDR                             	(0xb802f930)
#define  GDMA_DMA_OSD1_D0_VADDR                             	(0xb802f934)
#define  GDMA_DMA_OSD1_D1_VADDR                             	(0xb802f938)
#define  GDMA_DMA_OSD2_WI_VADDR                             	(0xb802f93c)
#define  GDMA_DMA_OSD2_D0_VADDR                             	(0xb802f940)
#define  GDMA_DMA_OSD2_D1_VADDR                             	(0xb802f944)
#define  GDMA_DMA_OSD3_WI_VADDR                             	(0xb802f948)
#define  GDMA_DMA_OSD3_D0_VADDR                             	(0xb802f94c)
#define  GDMA_DMA_OSD3_D1_VADDR                             	(0xb802f950)
#define  GDMA_M422_SWAP_VADDR                               	(0xb802f988)
#define  GDMA_OSD_INTEN_VADDR                               	(0xb802fc00)
#define  GDMA_OSD_INTST_VADDR                               	(0xb802fc04)
#define  GDMA_OSD_INTEN_3D_VADDR                            	(0xb802fc08)
#define  GDMA_OSD_INTST_3D_VADDR                            	(0xb802fc0c)
#define  GDMA_DMA_INTEN_VADDR                               	(0xb802fc10)
#define  GDMA_DMA_INTST_VADDR                               	(0xb802fc14)
#define  GDMA_DMA_INTEN_3D_VADDR                            	(0xb802fc18)
#define  GDMA_DMA_INTST_3D_VADDR                            	(0xb802fc1c)
#define  GDMA_MBIST_VADDR                                   	(0xb802fdc0)
#define  GDMA_MBIST_FAIL_VADDR                              	(0xb802fdc4)
#define  GDMA_MBIST_DRF_FAIL_VADDR                          	(0xb802fdcc)
#define  GDMA_MBISR_FAIL_VADDR                              	(0xb802fdd0)
#define  GDMA_MBISR_DRF_FAIL_VADDR                          	(0xb802fdd4)
#define  GDMA_MBISR_REPAIRED_VADDR                          	(0xb802fdd8)
#define  GDMA_DBG_VADDR                                     	(0xb802fd00)
#define  GDMA_DBG_WI_INFO_VADDR                             	(0xb802fd0c)
#define  GDMA_DBG_OSD_WI_0_VADDR                            	(0xb802fd10)
#define  GDMA_DBG_OSD_WI_1_VADDR                            	(0xb802fd14)
#define  GDMA_DBG_OSD_WI_2_VADDR                            	(0xb802fd18)
#define  GDMA_DBG_OSD_WI_3_VADDR                            	(0xb802fd1c)
#define  GDMA_DBG_OSD_WI_4_VADDR                            	(0xb802fd20)
#define  GDMA_DBG_OSD_WI_5_VADDR                            	(0xb802fd2c)
#define  GDMA_DBG_OSD_WI_6_VADDR                            	(0xb802fd30)
#define  GDMA_DBG_OSD_WI_7_VADDR                            	(0xb802fd34)
#define  GDMA_DBG_OSD_WI_8_VADDR                            	(0xb802fd38)
#define  GDMA_DMY_0_VADDR                                   	(0xb802fdfc)
#define  GDMA_DMY_1_VADDR                                   	(0xb802fe00)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======GDMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  gating_enable:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  osd3_bypass_acc_sync_fix:1;
        RBus_UInt32  osd2_bypass_acc_sync_fix:1;
        RBus_UInt32  osd1_bypass_acc_sync_fix:1;
        RBus_UInt32  res3:7;
        RBus_UInt32  osd_sel:1;
        RBus_UInt32  write_data:1;
    };
}gdma_update_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  osd3_prog_done:1;
        RBus_UInt32  osd2_prog_done:1;
        RBus_UInt32  osd1_prog_done:1;
        RBus_UInt32  write_data:1;
    };
}gdma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  l5:4;
        RBus_UInt32  l4:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  l2:4;
        RBus_UInt32  l1:4;
    };
}gdma_line_buffer_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  l5:4;
        RBus_UInt32  l4:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  l2:4;
        RBus_UInt32  l1:4;
    };
}gdma_line_buffer_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  clut_layer_sel:2;
        RBus_UInt32  res2:10;
    };
}gdma_line_buffer_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  osd2_afbc_en:1;
        RBus_UInt32  osd1_afbc_en:1;
        RBus_UInt32  res1:24;
        RBus_UInt32  osd3_status:2;
        RBus_UInt32  osd2_status:2;
        RBus_UInt32  osd1_status:2;
    };
}gdma_osd_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  rbuf_share_off:1;
        RBus_UInt32  gating_off:1;
    };
}gdma_rtl_improve_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  d3_mode:1;
        RBus_UInt32  rotate:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  osd1_en:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd1_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  wi_endian:1;
        RBus_UInt32  rgb_out:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  osd:1;
        RBus_UInt32  res3:14;
        RBus_UInt32  clear_region_en:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  th:13;
    };
}gdma_osd1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd1_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd1_wi_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  w:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  h:13;
    };
}gdma_osd1_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m01:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m00:14;
    };
}gdma_osd1_cc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m10:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m02:14;
    };
}gdma_osd1_cc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m12:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m11:14;
    };
}gdma_osd1_cc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m21:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m20:14;
    };
}gdma_osd1_cc4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  m22:14;
    };
}gdma_osd1_cc5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  a2:9;
        RBus_UInt32  a1:9;
        RBus_UInt32  a0:9;
    };
}gdma_osd1_cc6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  b2:9;
        RBus_UInt32  b1:9;
        RBus_UInt32  b0:9;
    };
}gdma_osd1_cc7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  x_end:13;
    };
}gdma_osd1_clear1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  y_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y_end:13;
    };
}gdma_osd1_clear2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  d3_mode:1;
        RBus_UInt32  rotate:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  res3:2;
        RBus_UInt32  osd2_en:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  wi_endian:1;
        RBus_UInt32  rgb_out:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  osd:1;
        RBus_UInt32  res3:14;
        RBus_UInt32  clear_region_en:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  th:13;
    };
}gdma_osd2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd2_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd2_wi_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  w:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  h:13;
    };
}gdma_osd2_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m01:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m00:14;
    };
}gdma_osd2_cc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m10:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m02:14;
    };
}gdma_osd2_cc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m12:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m11:14;
    };
}gdma_osd2_cc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m21:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m20:14;
    };
}gdma_osd2_cc4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  m22:14;
    };
}gdma_osd2_cc5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  a2:9;
        RBus_UInt32  a1:9;
        RBus_UInt32  a0:9;
    };
}gdma_osd2_cc6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  b2:9;
        RBus_UInt32  b1:9;
        RBus_UInt32  b0:9;
    };
}gdma_osd2_cc7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  x_end:13;
    };
}gdma_osd2_clear1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  y_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y_end:13;
    };
}gdma_osd2_clear2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  d3_mode:1;
        RBus_UInt32  rotate:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  res3:2;
        RBus_UInt32  osd3_en:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd3_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  wi_endian:1;
        RBus_UInt32  rgb_out:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  osd:1;
        RBus_UInt32  res3:14;
        RBus_UInt32  clear_region_en:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  th:13;
    };
}gdma_osd3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd3_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd3_wi_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  w:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  h:13;
    };
}gdma_osd3_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m01:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m00:14;
    };
}gdma_osd3_cc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m10:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m02:14;
    };
}gdma_osd3_cc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m12:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m11:14;
    };
}gdma_osd3_cc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m21:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  m20:14;
    };
}gdma_osd3_cc4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  m22:14;
    };
}gdma_osd3_cc5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  a2:9;
        RBus_UInt32  a1:9;
        RBus_UInt32  a0:9;
    };
}gdma_osd3_cc6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  b2:9;
        RBus_UInt32  b1:9;
        RBus_UInt32  b0:9;
    };
}gdma_osd3_cc7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  x_end:13;
    };
}gdma_osd3_clear1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  y_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y_end:13;
    };
}gdma_osd3_clear2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  sel_fifo_overflow_st:1;
        RBus_UInt32  sel_fifo_underflow_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  data_info_fifo_overflow_st:1;
        RBus_UInt32  data_info_fifo_underflow_st:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  head_info_fifo_overflow_st:1;
        RBus_UInt32  head_info_fifo_underflow_st:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  cmd_fifo_overflow_st:1;
        RBus_UInt32  cmd_fifo_underflow_st:1;
    };
}gdma_afbc1_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  osd1_line_cnt:13;
        RBus_UInt32  res2:1;
        RBus_UInt32  tile_y_cnt:11;
        RBus_UInt32  head_fsm_state:4;
    };
}gdma_afbc1_cnt_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  data_fifo_water:10;
        RBus_UInt32  head_fifo_water:4;
        RBus_UInt32  cmd_fifo_water:4;
        RBus_UInt32  sel_fifo_water:4;
    };
}gdma_afbc1_fifo_water_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  sel_fifo_empty:1;
        RBus_UInt32  sel_fifo_full:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  data_fifo_empty:1;
        RBus_UInt32  data_fifo_full:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  head_info_fifo_empty:1;
        RBus_UInt32  head_info_fifo_full:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  cmd_fifo_empty:1;
        RBus_UInt32  cmd_fifo_full:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  data_timing_error:1;
        RBus_UInt32  head_timing_error:1;
        RBus_UInt32  solid_timing_error:1;
    };
}gdma_afbc1_fifo_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  sel_fifo_overflow_st:1;
        RBus_UInt32  sel_fifo_underflow_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  data_info_fifo_overflow_st:1;
        RBus_UInt32  data_info_fifo_underflow_st:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  head_info_fifo_overflow_st:1;
        RBus_UInt32  head_info_fifo_underflow_st:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  cmd_fifo_overflow_st:1;
        RBus_UInt32  cmd_fifo_underflow_st:1;
    };
}gdma_afbc2_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  osd2_line_cnt:13;
        RBus_UInt32  res2:1;
        RBus_UInt32  tile_y_cnt:11;
        RBus_UInt32  head_fsm_state:4;
    };
}gdma_afbc2_cnt_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  data_fifo_water:10;
        RBus_UInt32  head_fifo_water:4;
        RBus_UInt32  cmd_fifo_water:4;
        RBus_UInt32  sel_fifo_water:4;
    };
}gdma_afbc2_fifo_water_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  sel_fifo_empty:1;
        RBus_UInt32  sel_fifo_full:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  data_fifo_empty:1;
        RBus_UInt32  data_fifo_full:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  head_info_fifo_empty:1;
        RBus_UInt32  head_info_fifo_full:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  cmd_fifo_empty:1;
        RBus_UInt32  cmd_fifo_full:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  data_timing_error:1;
        RBus_UInt32  head_timing_error:1;
        RBus_UInt32  solid_timing_error:1;
    };
}gdma_afbc2_fifo_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  size:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  addr:9;
    };
}gdma_afbc1_data_sram_base_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd1_afbc1_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd1_afbc1_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  size:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  addr:9;
    };
}gdma_afbc2_data_sram_base_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd2_afbc2_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd2_afbc2_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd3_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd3_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  osd3_bl:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  osd2_bl:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  osd1_bl:7;
        RBus_UInt32  res4:8;
    };
}gdma_dma_bl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  afbc2_mask:1;
        RBus_UInt32  afbc1_mask:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  osd3_mask:1;
        RBus_UInt32  osd2_mask:1;
        RBus_UInt32  osd1_mask:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  afbc2_req_num:4;
        RBus_UInt32  afbc1_req_num:4;
        RBus_UInt32  osd3_req_num:2;
        RBus_UInt32  osd2_req_num:2;
        RBus_UInt32  osd1_req_num:2;
        RBus_UInt32  res4:2;
    };
}gdma_dma_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  afbc2_1b:1;
        RBus_UInt32  afbc2_2b:1;
        RBus_UInt32  afbc2_4b:1;
        RBus_UInt32  afbc2_8b:1;
        RBus_UInt32  afbc1_1b:1;
        RBus_UInt32  afbc1_2b:1;
        RBus_UInt32  afbc1_4b:1;
        RBus_UInt32  afbc1_8b:1;
        RBus_UInt32  res1:8;
        RBus_UInt32  osd3_1b:1;
        RBus_UInt32  osd3_2b:1;
        RBus_UInt32  osd3_4b:1;
        RBus_UInt32  osd3_8b:1;
        RBus_UInt32  osd2_1b:1;
        RBus_UInt32  osd2_2b:1;
        RBus_UInt32  osd2_4b:1;
        RBus_UInt32  osd2_8b:1;
        RBus_UInt32  osd1_1b:1;
        RBus_UInt32  osd1_2b:1;
        RBus_UInt32  osd1_4b:1;
        RBus_UInt32  osd1_8b:1;
        RBus_UInt32  res2:4;
    };
}gdma_dma_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd1_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd1_d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd1_d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd2_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd2_d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd2_d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd3_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd3_d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  depth:12;
        RBus_UInt32  sa:12;
    };
}gdma_dma_osd3_d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  m422_cb_cr_swap:1;
    };
}gdma_m422_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  afbc2_ov_range:1;
        RBus_UInt32  afbc1_ov_range:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  osd3_ov_range:1;
        RBus_UInt32  osd2_ov_range:1;
        RBus_UInt32  osd1_ov_range:1;
        RBus_UInt32  osd3_fin:1;
        RBus_UInt32  osd2_fin:1;
        RBus_UInt32  osd1_fin:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  osd3_vact_end:1;
        RBus_UInt32  osd2_vact_end:1;
        RBus_UInt32  osd1_vact_end:1;
        RBus_UInt32  res4:5;
        RBus_UInt32  osd3_vsync:1;
        RBus_UInt32  osd2_vsync:1;
        RBus_UInt32  osd1_vsync:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd_inten_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  afbc2_ov_range:1;
        RBus_UInt32  afbc1_ov_range:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  osd3_ov_range:1;
        RBus_UInt32  osd2_ov_range:1;
        RBus_UInt32  osd1_ov_range:1;
        RBus_UInt32  osd3_fin:1;
        RBus_UInt32  osd2_fin:1;
        RBus_UInt32  osd1_fin:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  osd3_vact_end:1;
        RBus_UInt32  osd2_vact_end:1;
        RBus_UInt32  osd1_vact_end:1;
        RBus_UInt32  res4:5;
        RBus_UInt32  osd3_vsync:1;
        RBus_UInt32  osd2_vsync:1;
        RBus_UInt32  osd1_vsync:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd_intst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  osd3_fin:1;
        RBus_UInt32  osd2_fin:1;
        RBus_UInt32  osd1_fin:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  osd3_vact_end:1;
        RBus_UInt32  osd2_vact_end:1;
        RBus_UInt32  osd1_vact_end:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  osd3_vsync:1;
        RBus_UInt32  osd2_vsync:1;
        RBus_UInt32  osd1_vsync:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd_inten_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  osd3_fin:1;
        RBus_UInt32  osd2_fin:1;
        RBus_UInt32  osd1_fin:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  osd3_vact_end:1;
        RBus_UInt32  osd2_vact_end:1;
        RBus_UInt32  osd1_vact_end:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  osd3_vsync:1;
        RBus_UInt32  osd2_vsync:1;
        RBus_UInt32  osd1_vsync:1;
        RBus_UInt32  write_data:1;
    };
}gdma_osd_intst_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  afbc2_acc_sync:1;
        RBus_UInt32  afbc1_acc_sync:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  osd3_acc_sync:1;
        RBus_UInt32  osd2_acc_sync:1;
        RBus_UInt32  osd1_acc_sync:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  osd3_udfl:1;
        RBus_UInt32  osd2_udfl:1;
        RBus_UInt32  osd1_udfl:1;
        RBus_UInt32  write_data:1;
    };
}gdma_dma_inten_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  afbc2_acc_sync:1;
        RBus_UInt32  afbc1_acc_sync:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  osd3_acc_sync:1;
        RBus_UInt32  osd2_acc_sync:1;
        RBus_UInt32  osd1_acc_sync:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  osd3_udfl:1;
        RBus_UInt32  osd2_udfl:1;
        RBus_UInt32  osd1_udfl:1;
        RBus_UInt32  write_data:1;
    };
}gdma_dma_intst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  osd3_acc_sync:1;
        RBus_UInt32  osd2_acc_sync:1;
        RBus_UInt32  osd1_acc_sync:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  osd3_udfl:1;
        RBus_UInt32  osd2_udfl:1;
        RBus_UInt32  osd1_udfl:1;
        RBus_UInt32  write_data:1;
    };
}gdma_dma_inten_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  osd3_acc_sync:1;
        RBus_UInt32  osd2_acc_sync:1;
        RBus_UInt32  osd1_acc_sync:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  osd3_udfl:1;
        RBus_UInt32  osd2_udfl:1;
        RBus_UInt32  osd1_udfl:1;
        RBus_UInt32  write_data:1;
    };
}gdma_dma_intst_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  test_rwm:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  afbc_header_ls:1;
        RBus_UInt32  afbc_ls:1;
        RBus_UInt32  sr_ls:1;
        RBus_UInt32  res3:9;
        RBus_UInt32  test1:1;
        RBus_UInt32  rme:1;
        RBus_UInt32  rm:4;
    };
}gdma_mbist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  sr_lb:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  afbc_header:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  dispbuf:4;
        RBus_UInt32  rbuf_share:6;
    };
}gdma_mbist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  sr_lb:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  afbc_header:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  dispbuf:4;
        RBus_UInt32  rbuf_share:6;
    };
}gdma_mbist_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  afbc_lb:8;
        RBus_UInt32  res1:24;
    };
}gdma_mbisr_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  afbc_lb:8;
        RBus_UInt32  res1:24;
    };
}gdma_mbisr_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  afbc_lb:1;
        RBus_UInt32  res1:31;
    };
}gdma_mbisr_repaired_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  write_en3:1;
        RBus_UInt32  sel1:9;
        RBus_UInt32  res2:2;
        RBus_UInt32  write_en2:1;
        RBus_UInt32  sel0:9;
        RBus_UInt32  res3:2;
        RBus_UInt32  write_en1:1;
        RBus_UInt32  en:1;
    };
}gdma_dbg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sel:2;
    };
}gdma_dbg_wi_info_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  height:16;
        RBus_UInt32  width:16;
    };
}gdma_dbg_osd_wi_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  extension_mode:1;
        RBus_UInt32  rgb_order:3;
        RBus_UInt32  alpha_replace_type:1;
        RBus_UInt32  const_alpha_enable:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  object_type:1;
        RBus_UInt32  alpha:8;
        RBus_UInt32  res2:5;
        RBus_UInt32  clut_format:1;
        RBus_UInt32  endian:1;
        RBus_UInt32  keep_prev_clut:1;
        RBus_UInt32  compress:1;
        RBus_UInt32  img_compress:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  colortype:5;
    };
}gdma_dbg_osd_wi_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  top_addr:32;
    };
}gdma_dbg_osd_wi_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bot_addr:32;
    };
}gdma_dbg_osd_wi_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pitch:32;
    };
}gdma_dbg_osd_wi_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_win_30:32;
    };
}gdma_dbg_osd_wi_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_win_34:32;
    };
}gdma_dbg_osd_wi_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_win_38:32;
    };
}gdma_dbg_osd_wi_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_win_3c:32;
    };
}gdma_dbg_osd_wi_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802fdfc_31_2:30;
        RBus_UInt32  eco_afbc_xst_off:1;
        RBus_UInt32  eco_rbuf_off:1;
    };
}gdma_dmy_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802fe00_31_2:30;
        RBus_UInt32  eco_afbc_xst_off:1;
        RBus_UInt32  eco_rbuf_off:1;
    };
}gdma_dmy_1_RBUS;

#else //apply LITTLE_ENDIAN

//======GDMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd_sel:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  osd1_bypass_acc_sync_fix:1;
        RBus_UInt32  osd2_bypass_acc_sync_fix:1;
        RBus_UInt32  osd3_bypass_acc_sync_fix:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  gating_enable:1;
        RBus_UInt32  res3:15;
    };
}gdma_update_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_prog_done:1;
        RBus_UInt32  osd2_prog_done:1;
        RBus_UInt32  osd3_prog_done:1;
        RBus_UInt32  res1:28;
    };
}gdma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  l1:4;
        RBus_UInt32  l2:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  l4:4;
        RBus_UInt32  l5:4;
        RBus_UInt32  res2:12;
    };
}gdma_line_buffer_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  l1:4;
        RBus_UInt32  l2:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  l4:4;
        RBus_UInt32  l5:4;
        RBus_UInt32  res2:12;
    };
}gdma_line_buffer_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  clut_layer_sel:2;
        RBus_UInt32  res2:20;
    };
}gdma_line_buffer_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  osd1_status:2;
        RBus_UInt32  osd2_status:2;
        RBus_UInt32  osd3_status:2;
        RBus_UInt32  res1:24;
        RBus_UInt32  osd1_afbc_en:1;
        RBus_UInt32  osd2_afbc_en:1;
    };
}gdma_osd_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gating_off:1;
        RBus_UInt32  rbuf_share_off:1;
        RBus_UInt32  res1:30;
    };
}gdma_rtl_improve_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  rotate:1;
        RBus_UInt32  d3_mode:1;
        RBus_UInt32  res2:22;
    };
}gdma_osd1_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  clear_region_en:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  osd:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  rgb_out:1;
        RBus_UInt32  wi_endian:1;
        RBus_UInt32  res3:6;
    };
}gdma_osd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th:13;
        RBus_UInt32  res1:19;
    };
}gdma_osd1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd1_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd1_wi_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  h:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  w:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd1_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m00:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m01:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd1_cc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m02:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m10:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd1_cc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m11:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m12:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd1_cc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m20:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m21:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd1_cc4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m22:14;
        RBus_UInt32  res1:18;
    };
}gdma_osd1_cc5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  a0:9;
        RBus_UInt32  a1:9;
        RBus_UInt32  a2:9;
        RBus_UInt32  res1:5;
    };
}gdma_osd1_cc6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b0:9;
        RBus_UInt32  b1:9;
        RBus_UInt32  b2:9;
        RBus_UInt32  res1:5;
    };
}gdma_osd1_cc7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  x_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x_sta:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd1_clear1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  y_sta:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd1_clear2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd2_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  res2:4;
        RBus_UInt32  rotate:1;
        RBus_UInt32  d3_mode:1;
        RBus_UInt32  res3:22;
    };
}gdma_osd2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  clear_region_en:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  osd:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  rgb_out:1;
        RBus_UInt32  wi_endian:1;
        RBus_UInt32  res3:6;
    };
}gdma_osd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th:13;
        RBus_UInt32  res1:19;
    };
}gdma_osd2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd2_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd2_wi_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  h:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  w:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd2_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m00:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m01:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd2_cc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m02:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m10:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd2_cc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m11:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m12:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd2_cc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m20:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m21:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd2_cc4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m22:14;
        RBus_UInt32  res1:18;
    };
}gdma_osd2_cc5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  a0:9;
        RBus_UInt32  a1:9;
        RBus_UInt32  a2:9;
        RBus_UInt32  res1:5;
    };
}gdma_osd2_cc6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b0:9;
        RBus_UInt32  b1:9;
        RBus_UInt32  b2:9;
        RBus_UInt32  res1:5;
    };
}gdma_osd2_cc7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  x_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x_sta:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd2_clear1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  y_sta:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd2_clear2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd3_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  res2:4;
        RBus_UInt32  rotate:1;
        RBus_UInt32  d3_mode:1;
        RBus_UInt32  res3:22;
    };
}gdma_osd3_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  clear_region_en:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  osd:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  rgb_out:1;
        RBus_UInt32  wi_endian:1;
        RBus_UInt32  res3:6;
    };
}gdma_osd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th:13;
        RBus_UInt32  res1:19;
    };
}gdma_osd3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd3_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd3_wi_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  h:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  w:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd3_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m00:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m01:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd3_cc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m02:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m10:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd3_cc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m11:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m12:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd3_cc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m20:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  m21:14;
        RBus_UInt32  res2:2;
    };
}gdma_osd3_cc4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m22:14;
        RBus_UInt32  res1:18;
    };
}gdma_osd3_cc5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  a0:9;
        RBus_UInt32  a1:9;
        RBus_UInt32  a2:9;
        RBus_UInt32  res1:5;
    };
}gdma_osd3_cc6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b0:9;
        RBus_UInt32  b1:9;
        RBus_UInt32  b2:9;
        RBus_UInt32  res1:5;
    };
}gdma_osd3_cc7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  x_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x_sta:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd3_clear1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  y_sta:13;
        RBus_UInt32  res2:3;
    };
}gdma_osd3_clear2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmd_fifo_underflow_st:1;
        RBus_UInt32  cmd_fifo_overflow_st:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  head_info_fifo_underflow_st:1;
        RBus_UInt32  head_info_fifo_overflow_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  data_info_fifo_underflow_st:1;
        RBus_UInt32  data_info_fifo_overflow_st:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  sel_fifo_underflow_st:1;
        RBus_UInt32  sel_fifo_overflow_st:1;
        RBus_UInt32  res4:18;
    };
}gdma_afbc1_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  head_fsm_state:4;
        RBus_UInt32  tile_y_cnt:11;
        RBus_UInt32  res1:1;
        RBus_UInt32  osd1_line_cnt:13;
        RBus_UInt32  res2:3;
    };
}gdma_afbc1_cnt_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sel_fifo_water:4;
        RBus_UInt32  cmd_fifo_water:4;
        RBus_UInt32  head_fifo_water:4;
        RBus_UInt32  data_fifo_water:10;
        RBus_UInt32  res1:10;
    };
}gdma_afbc1_fifo_water_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  solid_timing_error:1;
        RBus_UInt32  head_timing_error:1;
        RBus_UInt32  data_timing_error:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cmd_fifo_full:1;
        RBus_UInt32  cmd_fifo_empty:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  head_info_fifo_full:1;
        RBus_UInt32  head_info_fifo_empty:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  data_fifo_full:1;
        RBus_UInt32  data_fifo_empty:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  sel_fifo_full:1;
        RBus_UInt32  sel_fifo_empty:1;
        RBus_UInt32  res5:14;
    };
}gdma_afbc1_fifo_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmd_fifo_underflow_st:1;
        RBus_UInt32  cmd_fifo_overflow_st:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  head_info_fifo_underflow_st:1;
        RBus_UInt32  head_info_fifo_overflow_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  data_info_fifo_underflow_st:1;
        RBus_UInt32  data_info_fifo_overflow_st:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  sel_fifo_underflow_st:1;
        RBus_UInt32  sel_fifo_overflow_st:1;
        RBus_UInt32  res4:18;
    };
}gdma_afbc2_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  head_fsm_state:4;
        RBus_UInt32  tile_y_cnt:11;
        RBus_UInt32  res1:1;
        RBus_UInt32  osd2_line_cnt:13;
        RBus_UInt32  res2:3;
    };
}gdma_afbc2_cnt_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sel_fifo_water:4;
        RBus_UInt32  cmd_fifo_water:4;
        RBus_UInt32  head_fifo_water:4;
        RBus_UInt32  data_fifo_water:10;
        RBus_UInt32  res1:10;
    };
}gdma_afbc2_fifo_water_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  solid_timing_error:1;
        RBus_UInt32  head_timing_error:1;
        RBus_UInt32  data_timing_error:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cmd_fifo_full:1;
        RBus_UInt32  cmd_fifo_empty:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  head_info_fifo_full:1;
        RBus_UInt32  head_info_fifo_empty:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  data_fifo_full:1;
        RBus_UInt32  data_fifo_empty:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  sel_fifo_full:1;
        RBus_UInt32  sel_fifo_empty:1;
        RBus_UInt32  res5:14;
    };
}gdma_afbc2_fifo_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  size:9;
        RBus_UInt32  res2:7;
    };
}gdma_afbc1_data_sram_base_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd1_afbc1_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd1_afbc1_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  size:9;
        RBus_UInt32  res2:7;
    };
}gdma_afbc2_data_sram_base_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd2_afbc2_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd2_afbc2_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd3_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}gdma_osd3_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  osd1_bl:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  osd2_bl:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  osd3_bl:7;
        RBus_UInt32  res4:1;
    };
}gdma_dma_bl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  osd1_req_num:2;
        RBus_UInt32  osd2_req_num:2;
        RBus_UInt32  osd3_req_num:2;
        RBus_UInt32  afbc1_req_num:4;
        RBus_UInt32  afbc2_req_num:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  osd1_mask:1;
        RBus_UInt32  osd2_mask:1;
        RBus_UInt32  osd3_mask:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  afbc1_mask:1;
        RBus_UInt32  afbc2_mask:1;
        RBus_UInt32  res4:8;
    };
}gdma_dma_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  osd1_8b:1;
        RBus_UInt32  osd1_4b:1;
        RBus_UInt32  osd1_2b:1;
        RBus_UInt32  osd1_1b:1;
        RBus_UInt32  osd2_8b:1;
        RBus_UInt32  osd2_4b:1;
        RBus_UInt32  osd2_2b:1;
        RBus_UInt32  osd2_1b:1;
        RBus_UInt32  osd3_8b:1;
        RBus_UInt32  osd3_4b:1;
        RBus_UInt32  osd3_2b:1;
        RBus_UInt32  osd3_1b:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  afbc1_8b:1;
        RBus_UInt32  afbc1_4b:1;
        RBus_UInt32  afbc1_2b:1;
        RBus_UInt32  afbc1_1b:1;
        RBus_UInt32  afbc2_8b:1;
        RBus_UInt32  afbc2_4b:1;
        RBus_UInt32  afbc2_2b:1;
        RBus_UInt32  afbc2_1b:1;
    };
}gdma_dma_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd1_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd1_d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd1_d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd2_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd2_d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd2_d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd3_wi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd3_d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sa:12;
        RBus_UInt32  depth:12;
        RBus_UInt32  res1:8;
    };
}gdma_dma_osd3_d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m422_cb_cr_swap:1;
        RBus_UInt32  res1:31;
    };
}gdma_m422_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_vsync:1;
        RBus_UInt32  osd2_vsync:1;
        RBus_UInt32  osd3_vsync:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  osd1_vact_end:1;
        RBus_UInt32  osd2_vact_end:1;
        RBus_UInt32  osd3_vact_end:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  osd1_fin:1;
        RBus_UInt32  osd2_fin:1;
        RBus_UInt32  osd3_fin:1;
        RBus_UInt32  osd1_ov_range:1;
        RBus_UInt32  osd2_ov_range:1;
        RBus_UInt32  osd3_ov_range:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  afbc1_ov_range:1;
        RBus_UInt32  afbc2_ov_range:1;
        RBus_UInt32  res4:6;
    };
}gdma_osd_inten_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_vsync:1;
        RBus_UInt32  osd2_vsync:1;
        RBus_UInt32  osd3_vsync:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  osd1_vact_end:1;
        RBus_UInt32  osd2_vact_end:1;
        RBus_UInt32  osd3_vact_end:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  osd1_fin:1;
        RBus_UInt32  osd2_fin:1;
        RBus_UInt32  osd3_fin:1;
        RBus_UInt32  osd1_ov_range:1;
        RBus_UInt32  osd2_ov_range:1;
        RBus_UInt32  osd3_ov_range:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  afbc1_ov_range:1;
        RBus_UInt32  afbc2_ov_range:1;
        RBus_UInt32  res4:6;
    };
}gdma_osd_intst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_vsync:1;
        RBus_UInt32  osd2_vsync:1;
        RBus_UInt32  osd3_vsync:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  osd1_vact_end:1;
        RBus_UInt32  osd2_vact_end:1;
        RBus_UInt32  osd3_vact_end:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  osd1_fin:1;
        RBus_UInt32  osd2_fin:1;
        RBus_UInt32  osd3_fin:1;
        RBus_UInt32  res3:12;
    };
}gdma_osd_inten_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_vsync:1;
        RBus_UInt32  osd2_vsync:1;
        RBus_UInt32  osd3_vsync:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  osd1_vact_end:1;
        RBus_UInt32  osd2_vact_end:1;
        RBus_UInt32  osd3_vact_end:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  osd1_fin:1;
        RBus_UInt32  osd2_fin:1;
        RBus_UInt32  osd3_fin:1;
        RBus_UInt32  res3:12;
    };
}gdma_osd_intst_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_udfl:1;
        RBus_UInt32  osd2_udfl:1;
        RBus_UInt32  osd3_udfl:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  osd1_acc_sync:1;
        RBus_UInt32  osd2_acc_sync:1;
        RBus_UInt32  osd3_acc_sync:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  afbc1_acc_sync:1;
        RBus_UInt32  afbc2_acc_sync:1;
        RBus_UInt32  res3:10;
    };
}gdma_dma_inten_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_udfl:1;
        RBus_UInt32  osd2_udfl:1;
        RBus_UInt32  osd3_udfl:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  osd1_acc_sync:1;
        RBus_UInt32  osd2_acc_sync:1;
        RBus_UInt32  osd3_acc_sync:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  afbc1_acc_sync:1;
        RBus_UInt32  afbc2_acc_sync:1;
        RBus_UInt32  res3:10;
    };
}gdma_dma_intst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_udfl:1;
        RBus_UInt32  osd2_udfl:1;
        RBus_UInt32  osd3_udfl:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  osd1_acc_sync:1;
        RBus_UInt32  osd2_acc_sync:1;
        RBus_UInt32  osd3_acc_sync:1;
        RBus_UInt32  res2:20;
    };
}gdma_dma_inten_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:1;
        RBus_UInt32  osd1_udfl:1;
        RBus_UInt32  osd2_udfl:1;
        RBus_UInt32  osd3_udfl:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  osd1_acc_sync:1;
        RBus_UInt32  osd2_acc_sync:1;
        RBus_UInt32  osd3_acc_sync:1;
        RBus_UInt32  res2:20;
    };
}gdma_dma_intst_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm:4;
        RBus_UInt32  rme:1;
        RBus_UInt32  test1:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  sr_ls:1;
        RBus_UInt32  afbc_ls:1;
        RBus_UInt32  afbc_header_ls:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  test_rwm:1;
        RBus_UInt32  res3:7;
    };
}gdma_mbist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rbuf_share:6;
        RBus_UInt32  dispbuf:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  afbc_header:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  sr_lb:8;
        RBus_UInt32  res3:8;
    };
}gdma_mbist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rbuf_share:6;
        RBus_UInt32  dispbuf:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  afbc_header:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  sr_lb:8;
        RBus_UInt32  res3:8;
    };
}gdma_mbist_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  afbc_lb:8;
    };
}gdma_mbisr_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  afbc_lb:8;
    };
}gdma_mbisr_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  afbc_lb:1;
    };
}gdma_mbisr_repaired_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  en:1;
        RBus_UInt32  write_en1:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  sel0:9;
        RBus_UInt32  write_en2:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  sel1:9;
        RBus_UInt32  write_en3:1;
        RBus_UInt32  res3:6;
    };
}gdma_dbg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sel:2;
        RBus_UInt32  res1:30;
    };
}gdma_dbg_wi_info_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  width:16;
        RBus_UInt32  height:16;
    };
}gdma_dbg_osd_wi_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  colortype:5;
        RBus_UInt32  res1:1;
        RBus_UInt32  img_compress:1;
        RBus_UInt32  compress:1;
        RBus_UInt32  keep_prev_clut:1;
        RBus_UInt32  endian:1;
        RBus_UInt32  clut_format:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  alpha:8;
        RBus_UInt32  object_type:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  const_alpha_enable:1;
        RBus_UInt32  alpha_replace_type:1;
        RBus_UInt32  rgb_order:3;
        RBus_UInt32  extension_mode:1;
    };
}gdma_dbg_osd_wi_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  top_addr:32;
    };
}gdma_dbg_osd_wi_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bot_addr:32;
    };
}gdma_dbg_osd_wi_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pitch:32;
    };
}gdma_dbg_osd_wi_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_win_30:32;
    };
}gdma_dbg_osd_wi_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_win_34:32;
    };
}gdma_dbg_osd_wi_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_win_38:32;
    };
}gdma_dbg_osd_wi_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_win_3c:32;
    };
}gdma_dbg_osd_wi_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eco_rbuf_off:1;
        RBus_UInt32  eco_afbc_xst_off:1;
        RBus_UInt32  dummy1802fdfc_31_2:30;
    };
}gdma_dmy_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eco_rbuf_off:1;
        RBus_UInt32  eco_afbc_xst_off:1;
        RBus_UInt32  dummy1802fe00_31_2:30;
    };
}gdma_dmy_1_RBUS;




#endif 


#endif 
