/**
* @file Mac7p-DesignSpec-D-Domain_Panel_Compensation
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_INVOUTPUTGAMMA_REG_H_
#define _RBUS_INVOUTPUTGAMMA_REG_H_

#include "rbusTypes.h"



//  INVOUTPUTGAMMA Register Address



#define  INVOUTPUTGAMMA_INV_OUT_GAMMA_PORT_VADDR            	(0xb802c820)
#define  INVOUTPUTGAMMA_INV_OUT_GAMMA_CTRL_1_VADDR          	(0xb802c824)
#define  INVOUTPUTGAMMA_INV_OUT_GAMMA_BIST_CTRL_1_VADDR     	(0xb802c828)
#define  INVOUTPUTGAMMA_INV_OUT_GAMMA_BIST_CTRL_3_VADDR     	(0xb802c830)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======INVOUTPUTGAMMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  inv_out_gamma_tab_index:12;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_tab_d0:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  inv_out_gamma_tab_d1:7;
    };
}invoutputgamma_inv_out_gamma_port_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  inv_out_gamma_tab_addr:7;
        RBus_UInt32  res2:7;
        RBus_UInt32  inv_out_gamma_ax_rw_sel:2;
        RBus_UInt32  inv_out_gamma_ax_ch_sel:2;
        RBus_UInt32  inv_out_gamma_fifo_empty:1;
        RBus_UInt32  inv_out_gamma_fifo_full:1;
        RBus_UInt32  inv_out_gamma_wr_error:1;
        RBus_UInt32  dummy1802c824_1:1;
        RBus_UInt32  inv_out_gamma_en:1;
    };
}invoutputgamma_inv_out_gamma_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  test1:1;
        RBus_UInt32  ls:1;
        RBus_UInt32  rme:1;
        RBus_UInt32  rm:4;
    };
}invoutputgamma_inv_out_gamma_bist_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  inv_out_gamma_r_drf_bist_fail:1;
        RBus_UInt32  inv_out_gamma_g_drf_bist_fail:1;
        RBus_UInt32  inv_out_gamma_b_drf_bist_fail:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  inv_out_gamma_r_bist_fail:1;
        RBus_UInt32  inv_out_gamma_g_bist_fail:1;
        RBus_UInt32  inv_out_gamma_b_bist_fail:1;
    };
}invoutputgamma_inv_out_gamma_bist_ctrl_3_RBUS;

#else //apply LITTLE_ENDIAN

//======INVOUTPUTGAMMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inv_out_gamma_tab_d1:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  inv_out_gamma_tab_d0:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_tab_index:12;
        RBus_UInt32  res3:4;
    };
}invoutputgamma_inv_out_gamma_port_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inv_out_gamma_en:1;
        RBus_UInt32  dummy1802c824_1:1;
        RBus_UInt32  inv_out_gamma_wr_error:1;
        RBus_UInt32  inv_out_gamma_fifo_full:1;
        RBus_UInt32  inv_out_gamma_fifo_empty:1;
        RBus_UInt32  inv_out_gamma_ax_ch_sel:2;
        RBus_UInt32  inv_out_gamma_ax_rw_sel:2;
        RBus_UInt32  res1:7;
        RBus_UInt32  inv_out_gamma_tab_addr:7;
        RBus_UInt32  res2:9;
    };
}invoutputgamma_inv_out_gamma_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm:4;
        RBus_UInt32  rme:1;
        RBus_UInt32  ls:1;
        RBus_UInt32  test1:1;
        RBus_UInt32  res1:25;
    };
}invoutputgamma_inv_out_gamma_bist_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inv_out_gamma_b_bist_fail:1;
        RBus_UInt32  inv_out_gamma_g_bist_fail:1;
        RBus_UInt32  inv_out_gamma_r_bist_fail:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  inv_out_gamma_b_drf_bist_fail:1;
        RBus_UInt32  inv_out_gamma_g_drf_bist_fail:1;
        RBus_UInt32  inv_out_gamma_r_drf_bist_fail:1;
        RBus_UInt32  res2:21;
    };
}invoutputgamma_inv_out_gamma_bist_ctrl_3_RBUS;




#endif 


#endif 
