/**
* @file Mac7p-DesignSpec-D-Domain_P2P
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_P2P_REG_H_
#define _RBUS_P2P_REG_H_

#include "rbusTypes.h"



//  P2P Register Address



#define  P2P_P2P_EN_VADDR                                   	(0xb802dd00)
#define  P2P_P2P_FSM_VADDR                                  	(0xb802dd04)
#define  P2P_P2P_CLOCK_PATTERN_VADDR                        	(0xb802dd08)
#define  P2P_P2P_K12_VADDR                                  	(0xb802dd0c)
#define  P2P_P2P_K34_VADDR                                  	(0xb802dd10)
#define  P2P_P2P_G12_VADDR                                  	(0xb802dd14)
#define  P2P_P2P_G34_VADDR                                  	(0xb802dd18)
#define  P2P_P2P_LSP_K3_LOC00_VADDR                         	(0xb802dd1c)
#define  P2P_P2P_LSP_K3_LOC04_VADDR                         	(0xb802dd20)
#define  P2P_P2P_LSP_K3_LOC08_VADDR                         	(0xb802dd24)
#define  P2P_P2P_TCON_SEL0_VADDR                            	(0xb802dd28)
#define  P2P_P2P_TCON_SEL1_VADDR                            	(0xb802dd2c)
#define  P2P_P2P_CTRL_L_BYTE0_00_VADDR                      	(0xb802dd30)
#define  P2P_P2P_CTRL_L_BYTE0_04_VADDR                      	(0xb802dd34)
#define  P2P_P2P_CTRL_L_BYTE0_08_VADDR                      	(0xb802dd38)
#define  P2P_P2P_CTRL_L_BYTE1_EVEN00_VADDR                  	(0xb802dd3c)
#define  P2P_P2P_CTRL_L_BYTE1_EVEN04_VADDR                  	(0xb802dd40)
#define  P2P_P2P_CTRL_L_BYTE1_EVEN08_VADDR                  	(0xb802dd44)
#define  P2P_P2P_CTRL_L_BYTE1_ODD00_VADDR                   	(0xb802dd48)
#define  P2P_P2P_CTRL_L_BYTE1_ODD04_VADDR                   	(0xb802dd4c)
#define  P2P_P2P_CTRL_L_BYTE1_ODD08_VADDR                   	(0xb802dd50)
#define  P2P_P2P_CTRL_L_BYTE2_EVEN00_VADDR                  	(0xb802dd54)
#define  P2P_P2P_CTRL_L_BYTE2_EVEN04_VADDR                  	(0xb802dd58)
#define  P2P_P2P_CTRL_L_BYTE2_EVEN08_VADDR                  	(0xb802dd5c)
#define  P2P_P2P_CTRL_L_BYTE2_ODD00_VADDR                   	(0xb802dd60)
#define  P2P_P2P_CTRL_L_BYTE2_ODD04_VADDR                   	(0xb802dd64)
#define  P2P_P2P_CTRL_L_BYTE2_ODD08_VADDR                   	(0xb802dd68)
#define  P2P_P2P_CTRL_L_BYTE3_00_VADDR                      	(0xb802dd6c)
#define  P2P_P2P_CTRL_L_BYTE3_04_VADDR                      	(0xb802dd70)
#define  P2P_P2P_CTRL_L_BYTE3_08_VADDR                      	(0xb802dd74)
#define  P2P_P2P_CTRL_L_BYTE4_00_VADDR                      	(0xb802dd78)
#define  P2P_P2P_CTRL_L_BYTE4_04_VADDR                      	(0xb802dd7c)
#define  P2P_P2P_CTRL_L_BYTE4_08_VADDR                      	(0xb802dd80)
#define  P2P_P2P_CTRL_F_BYTE00_VADDR                        	(0xb802dd84)
#define  P2P_P2P_CTRL_F_BYTE04_VADDR                        	(0xb802dd88)
#define  P2P_P2P_CTRL_F_BYTE08_VADDR                        	(0xb802dd8c)
#define  P2P_P2P_CTRL_F_BYTE12_VADDR                        	(0xb802dd90)
#define  P2P_P2P_CTRL_F_BYTE16_VADDR                        	(0xb802dd94)
#define  P2P_P2P_CTRL_F_BYTE20_VADDR                        	(0xb802dd98)
#define  P2P_P2P_CTRL_F_BYTE24_VADDR                        	(0xb802dd9c)
#define  P2P_P2P_CTRL_F_BYTE28_VADDR                        	(0xb802dda0)
#define  P2P_P2P_CTRL_F_BYTE32_VADDR                        	(0xb802dda4)
#define  P2P_P2P_CTRL_F_BYTE36_VADDR                        	(0xb802dda8)
#define  P2P_P2P_CTRL_F_BYTE40_VADDR                        	(0xb802ddac)
#define  P2P_P2P_CTRL_F_BYTE44_VADDR                        	(0xb802ddb0)
#define  P2P_P2P_CTRL_F_BYTE48_VADDR                        	(0xb802ddb4)
#define  P2P_P2P_CTRL_F_BYTE52_VADDR                        	(0xb802ddb8)
#define  P2P_P2P_CTRL_F_BYTE56_VADDR                        	(0xb802ddbc)
#define  P2P_P2P_SCRAMBLER_MODE_VADDR                       	(0xb802ddc0)
#define  P2P_P2P_BCC_TX_DATA_0_VADDR                        	(0xb802ddc4)
#define  P2P_P2P_BCC_TX_DATA_1_VADDR                        	(0xb802ddc8)
#define  P2P_P2P_BCC_RX_DATA_0_VADDR                        	(0xb802ddcc)
#define  P2P_P2P_BCC_CTL_0_VADDR                            	(0xb802ddd0)
#define  P2P_P2P_BCC_CTL_1_VADDR                            	(0xb802ddd4)
#define  P2P_P2P_BCC_CTL_2_VADDR                            	(0xb802ddd8)
#define  P2P_P2P_BCC_CTL_3_VADDR                            	(0xb802dddc)
#define  P2P_P2P_BCC_CTL_4_VADDR                            	(0xb802dde0)
#define  P2P_P2P_BCC_STATUS_0_VADDR                         	(0xb802dde4)
#define  P2P_P2P_BCC_DEBOUNCE_VADDR                         	(0xb802dde8)
#define  P2P_P2P_DBG_VADDR                                  	(0xb802ddec)
#define  P2P_P2P_CRC_CTRL_VADDR                             	(0xb802ddf0)
#define  P2P_P2P_CRC_RESULT_VADDR                           	(0xb802ddf4)
#define  P2P_P2P_CRC_GOLDEN_VADDR                           	(0xb802ddf8)
#define  P2P_P2P_DGB_READ_VADDR                             	(0xb802ddfc)
#define  P2P_P2P_DMY_LINE0_VADDR                            	(0xb802de00)
#define  P2P_P2P_DMY_LINE1_VADDR                            	(0xb802de04)
#define  P2P_P2P_CTRL_F_BYTE02_01_VADDR                     	(0xb802de08)
#define  P2P_P2P_CTRL_F_BYTE04_01_VADDR                     	(0xb802de0c)
#define  P2P_P2P_CTRL_F_BYTE02_02_VADDR                     	(0xb802de10)
#define  P2P_P2P_CTRL_F_BYTE04_02_VADDR                     	(0xb802de14)
#define  P2P_P2P_CTRL_F_BYTE02_03_VADDR                     	(0xb802de18)
#define  P2P_P2P_CTRL_F_BYTE04_03_VADDR                     	(0xb802de1c)
#define  P2P_P2P_CTRL_F_BYTE02_04_VADDR                     	(0xb802de20)
#define  P2P_P2P_CTRL_F_BYTE04_04_VADDR                     	(0xb802de24)
#define  P2P_P2P_CTRL_F_BYTE02_05_VADDR                     	(0xb802de28)
#define  P2P_P2P_CTRL_F_BYTE04_05_VADDR                     	(0xb802de2c)
#define  P2P_P2P_CTRL_F_BYTE02_06_VADDR                     	(0xb802de30)
#define  P2P_P2P_CTRL_F_BYTE04_06_VADDR                     	(0xb802de34)
#define  P2P_P2P_CTRL_F_BYTE02_07_VADDR                     	(0xb802de38)
#define  P2P_P2P_CTRL_F_BYTE04_07_VADDR                     	(0xb802de3c)
#define  P2P_P2P_CTRL_F_BYTE02_08_VADDR                     	(0xb802de40)
#define  P2P_P2P_CTRL_F_BYTE04_08_VADDR                     	(0xb802de44)
#define  P2P_P2P_CTRL_F_BYTE02_09_VADDR                     	(0xb802de48)
#define  P2P_P2P_CTRL_F_BYTE04_09_VADDR                     	(0xb802de4c)
#define  P2P_P2P_CTRL_F_BYTE02_10_VADDR                     	(0xb802de50)
#define  P2P_P2P_CTRL_F_BYTE04_10_VADDR                     	(0xb802de54)
#define  P2P_P2P_CTRL_F_BYTE02_11_VADDR                     	(0xb802de58)
#define  P2P_P2P_CTRL_F_BYTE04_11_VADDR                     	(0xb802de5c)
#define  P2P_P2P_POL_INV_0_VADDR                            	(0xb802de60)
#define  P2P_P2P_POL_INV_1_VADDR                            	(0xb802de64)
#define  P2P_P2P_K3_LOC_0_VADDR                             	(0xb802de68)
#define  P2P_P2P_K3_LOC_1_VADDR                             	(0xb802de6c)
#define  P2P_P2P_FIFO_BIST_VADDR                            	(0xb802de70)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======P2P register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  phy_clk_div:9;
        RBus_UInt32  res2:6;
        RBus_UInt32  p2p_bit_mode:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  p2p_lane_mode:2;
        RBus_UInt32  res4:3;
        RBus_UInt32  p2p_en:1;
    };
}p2p_p2p_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_force_mode3:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  standby_time_10us:5;
        RBus_UInt32  res2:2;
        RBus_UInt32  training_time_500us:10;
        RBus_UInt32  lsp_times:4;
    };
}p2p_p2p_fsm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  clock_pattern:10;
        RBus_UInt32  dummy1802dd08_19_1:19;
        RBus_UInt32  dis_clock_at_bcc:1;
    };
}p2p_p2p_clock_pattern_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802dd0c_31_28:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  k1_symbol:10;
        RBus_UInt32  dummy1802dd0c_15_12:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  k2_symbol:10;
    };
}p2p_p2p_k12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802dd10_31_28:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  k3_symbol:10;
        RBus_UInt32  dummy1802dd10_15_12:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  k4_symbol:10;
    };
}p2p_p2p_k34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802dd14_31_28:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  g1_symbol:10;
        RBus_UInt32  dummy1802dd14_15_12:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  g2_symbol:10;
    };
}p2p_p2p_g12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802dd18_31_28:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  g3_symbol:10;
        RBus_UInt32  dummy1802dd18_15_12:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  g4_symbol:10;
    };
}p2p_p2p_g34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lsp_k3_loc00:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lsp_k3_loc01:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lsp_k3_loc02:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lsp_k3_loc03:5;
    };
}p2p_p2p_lsp_k3_loc00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lsp_k3_loc04:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lsp_k3_loc05:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lsp_k3_loc06:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lsp_k3_loc07:5;
    };
}p2p_p2p_lsp_k3_loc04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lsp_k3_loc08:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lsp_k3_loc09:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lsp_k3_loc10:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lsp_k3_loc11:5;
    };
}p2p_p2p_lsp_k3_loc08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802dd28_31_24:8;
        RBus_UInt32  res1:3;
        RBus_UInt32  tcon_sel_fsync:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  tcon_sel_pol:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  tcon_sel_polc:5;
    };
}p2p_p2p_tcon_sel0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802dd2c_31_24:8;
        RBus_UInt32  res1:3;
        RBus_UInt32  tcon_sel_bkdu:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  tcon_sel_pol2:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  tcon_sel_pol3:5;
    };
}p2p_p2p_tcon_sel1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte0_00:8;
        RBus_UInt32  ctrl_l_byte0_01:8;
        RBus_UInt32  ctrl_l_byte0_02:8;
        RBus_UInt32  ctrl_l_byte0_03:8;
    };
}p2p_p2p_ctrl_l_byte0_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte0_04:8;
        RBus_UInt32  ctrl_l_byte0_05:8;
        RBus_UInt32  ctrl_l_byte0_06:8;
        RBus_UInt32  ctrl_l_byte0_07:8;
    };
}p2p_p2p_ctrl_l_byte0_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte0_08:8;
        RBus_UInt32  ctrl_l_byte0_09:8;
        RBus_UInt32  ctrl_l_byte0_10:8;
        RBus_UInt32  ctrl_l_byte0_11:8;
    };
}p2p_p2p_ctrl_l_byte0_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_even00:8;
        RBus_UInt32  ctrl_l_byte1_even01:8;
        RBus_UInt32  ctrl_l_byte1_even02:8;
        RBus_UInt32  ctrl_l_byte1_even03:8;
    };
}p2p_p2p_ctrl_l_byte1_even00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_even04:8;
        RBus_UInt32  ctrl_l_byte1_even05:8;
        RBus_UInt32  ctrl_l_byte1_even06:8;
        RBus_UInt32  ctrl_l_byte1_even07:8;
    };
}p2p_p2p_ctrl_l_byte1_even04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_even08:8;
        RBus_UInt32  ctrl_l_byte1_even09:8;
        RBus_UInt32  ctrl_l_byte1_even10:8;
        RBus_UInt32  ctrl_l_byte1_even11:8;
    };
}p2p_p2p_ctrl_l_byte1_even08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_odd00:8;
        RBus_UInt32  ctrl_l_byte1_odd01:8;
        RBus_UInt32  ctrl_l_byte1_odd02:8;
        RBus_UInt32  ctrl_l_byte1_odd03:8;
    };
}p2p_p2p_ctrl_l_byte1_odd00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_odd04:8;
        RBus_UInt32  ctrl_l_byte1_odd05:8;
        RBus_UInt32  ctrl_l_byte1_odd06:8;
        RBus_UInt32  ctrl_l_byte1_odd07:8;
    };
}p2p_p2p_ctrl_l_byte1_odd04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_odd08:8;
        RBus_UInt32  ctrl_l_byte1_odd09:8;
        RBus_UInt32  ctrl_l_byte1_odd10:8;
        RBus_UInt32  ctrl_l_byte1_odd11:8;
    };
}p2p_p2p_ctrl_l_byte1_odd08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_even00:8;
        RBus_UInt32  ctrl_l_byte2_even01:8;
        RBus_UInt32  ctrl_l_byte2_even02:8;
        RBus_UInt32  ctrl_l_byte2_even03:8;
    };
}p2p_p2p_ctrl_l_byte2_even00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_even04:8;
        RBus_UInt32  ctrl_l_byte2_even05:8;
        RBus_UInt32  ctrl_l_byte2_even06:8;
        RBus_UInt32  ctrl_l_byte2_even07:8;
    };
}p2p_p2p_ctrl_l_byte2_even04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_even08:8;
        RBus_UInt32  ctrl_l_byte2_even09:8;
        RBus_UInt32  ctrl_l_byte2_even10:8;
        RBus_UInt32  ctrl_l_byte2_even11:8;
    };
}p2p_p2p_ctrl_l_byte2_even08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_odd00:8;
        RBus_UInt32  ctrl_l_byte2_odd01:8;
        RBus_UInt32  ctrl_l_byte2_odd02:8;
        RBus_UInt32  ctrl_l_byte2_odd03:8;
    };
}p2p_p2p_ctrl_l_byte2_odd00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_odd04:8;
        RBus_UInt32  ctrl_l_byte2_odd05:8;
        RBus_UInt32  ctrl_l_byte2_odd06:8;
        RBus_UInt32  ctrl_l_byte2_odd07:8;
    };
}p2p_p2p_ctrl_l_byte2_odd04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_odd08:8;
        RBus_UInt32  ctrl_l_byte2_odd09:8;
        RBus_UInt32  ctrl_l_byte2_odd10:8;
        RBus_UInt32  ctrl_l_byte2_odd11:8;
    };
}p2p_p2p_ctrl_l_byte2_odd08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte3_00:8;
        RBus_UInt32  ctrl_l_byte3_01:8;
        RBus_UInt32  ctrl_l_byte3_02:8;
        RBus_UInt32  ctrl_l_byte3_03:8;
    };
}p2p_p2p_ctrl_l_byte3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte3_04:8;
        RBus_UInt32  ctrl_l_byte3_05:8;
        RBus_UInt32  ctrl_l_byte3_06:8;
        RBus_UInt32  ctrl_l_byte3_07:8;
    };
}p2p_p2p_ctrl_l_byte3_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte3_08:8;
        RBus_UInt32  ctrl_l_byte3_09:8;
        RBus_UInt32  ctrl_l_byte3_10:8;
        RBus_UInt32  ctrl_l_byte3_11:8;
    };
}p2p_p2p_ctrl_l_byte3_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte4_00:8;
        RBus_UInt32  ctrl_l_byte4_01:8;
        RBus_UInt32  ctrl_l_byte4_02:8;
        RBus_UInt32  ctrl_l_byte4_03:8;
    };
}p2p_p2p_ctrl_l_byte4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte4_04:8;
        RBus_UInt32  ctrl_l_byte4_05:8;
        RBus_UInt32  ctrl_l_byte4_06:8;
        RBus_UInt32  ctrl_l_byte4_07:8;
    };
}p2p_p2p_ctrl_l_byte4_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte4_08:8;
        RBus_UInt32  ctrl_l_byte4_09:8;
        RBus_UInt32  ctrl_l_byte4_10:8;
        RBus_UInt32  ctrl_l_byte4_11:8;
    };
}p2p_p2p_ctrl_l_byte4_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte00:8;
        RBus_UInt32  ctrl_f_byte01:8;
        RBus_UInt32  ctrl_f_byte02:8;
        RBus_UInt32  ctrl_f_byte03:8;
    };
}p2p_p2p_ctrl_f_byte00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte04:8;
        RBus_UInt32  ctrl_f_byte05:8;
        RBus_UInt32  ctrl_f_byte06:8;
        RBus_UInt32  ctrl_f_byte07:8;
    };
}p2p_p2p_ctrl_f_byte04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte08:8;
        RBus_UInt32  ctrl_f_byte09:8;
        RBus_UInt32  ctrl_f_byte10:8;
        RBus_UInt32  ctrl_f_byte11:8;
    };
}p2p_p2p_ctrl_f_byte08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte12:8;
        RBus_UInt32  ctrl_f_byte13:8;
        RBus_UInt32  ctrl_f_byte14:8;
        RBus_UInt32  ctrl_f_byte15:8;
    };
}p2p_p2p_ctrl_f_byte12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte16:8;
        RBus_UInt32  ctrl_f_byte17:8;
        RBus_UInt32  ctrl_f_byte18:8;
        RBus_UInt32  ctrl_f_byte19:8;
    };
}p2p_p2p_ctrl_f_byte16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte20:8;
        RBus_UInt32  ctrl_f_byte21:8;
        RBus_UInt32  ctrl_f_byte22:8;
        RBus_UInt32  ctrl_f_byte23:8;
    };
}p2p_p2p_ctrl_f_byte20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte24:8;
        RBus_UInt32  ctrl_f_byte25:8;
        RBus_UInt32  ctrl_f_byte26:8;
        RBus_UInt32  ctrl_f_byte27:8;
    };
}p2p_p2p_ctrl_f_byte24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte28:8;
        RBus_UInt32  ctrl_f_byte29:8;
        RBus_UInt32  ctrl_f_byte30:8;
        RBus_UInt32  ctrl_f_byte31:8;
    };
}p2p_p2p_ctrl_f_byte28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte32:8;
        RBus_UInt32  ctrl_f_byte33:8;
        RBus_UInt32  ctrl_f_byte34:8;
        RBus_UInt32  ctrl_f_byte35:8;
    };
}p2p_p2p_ctrl_f_byte32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte36:8;
        RBus_UInt32  ctrl_f_byte37:8;
        RBus_UInt32  ctrl_f_byte38:8;
        RBus_UInt32  ctrl_f_byte39:8;
    };
}p2p_p2p_ctrl_f_byte36_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte40:8;
        RBus_UInt32  ctrl_f_byte41:8;
        RBus_UInt32  ctrl_f_byte42:8;
        RBus_UInt32  ctrl_f_byte43:8;
    };
}p2p_p2p_ctrl_f_byte40_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte44:8;
        RBus_UInt32  ctrl_f_byte45:8;
        RBus_UInt32  ctrl_f_byte46:8;
        RBus_UInt32  ctrl_f_byte47:8;
    };
}p2p_p2p_ctrl_f_byte44_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte48:8;
        RBus_UInt32  ctrl_f_byte49:8;
        RBus_UInt32  ctrl_f_byte50:8;
        RBus_UInt32  ctrl_f_byte51:8;
    };
}p2p_p2p_ctrl_f_byte48_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte52:8;
        RBus_UInt32  ctrl_f_byte53:8;
        RBus_UInt32  ctrl_f_byte54:8;
        RBus_UInt32  ctrl_f_byte55:8;
    };
}p2p_p2p_ctrl_f_byte52_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte56:8;
        RBus_UInt32  ctrl_f_byte57:8;
        RBus_UInt32  ctrl_f_byte58:8;
        RBus_UInt32  ctrl_f_byte59:8;
    };
}p2p_p2p_ctrl_f_byte56_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ext_pixel_sel_00:1;
        RBus_UInt32  ext_pixel_sel_01:1;
        RBus_UInt32  ext_pixel_sel_02:1;
        RBus_UInt32  ext_pixel_sel_03:1;
        RBus_UInt32  ext_pixel_sel_04:1;
        RBus_UInt32  ext_pixel_sel_05:1;
        RBus_UInt32  ext_pixel_sel_06:1;
        RBus_UInt32  ext_pixel_sel_07:1;
        RBus_UInt32  ext_pixel_sel_08:1;
        RBus_UInt32  ext_pixel_sel_09:1;
        RBus_UInt32  ext_pixel_sel_10:1;
        RBus_UInt32  ext_pixel_sel_11:1;
        RBus_UInt32  dummy1802ddc0_19_12:8;
        RBus_UInt32  res1:3;
        RBus_UInt32  scrambler_auto_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  initial_8b10b:1;
        RBus_UInt32  disable_8b10b:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  scrambler_mode:2;
    };
}p2p_p2p_scrambler_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_tx_byte_3:8;
        RBus_UInt32  bcc_tx_byte_2:8;
        RBus_UInt32  bcc_tx_byte_1:8;
        RBus_UInt32  bcc_tx_byte_0:8;
    };
}p2p_p2p_bcc_tx_data_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ddc8_31_16:16;
        RBus_UInt32  bcc_tx_byte_5:8;
        RBus_UInt32  bcc_tx_byte_4:8;
    };
}p2p_p2p_bcc_tx_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  bcc_rx_byte_2:8;
        RBus_UInt32  bcc_rx_byte_1:8;
        RBus_UInt32  bcc_rx_byte_0:8;
    };
}p2p_p2p_bcc_rx_data_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  bcc_rx_error_wait_time:10;
        RBus_UInt32  res2:2;
        RBus_UInt32  bcc_rx_reply_time:10;
        RBus_UInt32  res3:3;
        RBus_UInt32  bcc_tx_preamble_num:5;
    };
}p2p_p2p_bcc_ctl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_trigger:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  dummy1802ddd4_27_13:15;
        RBus_UInt32  bcc_trigger_hw:1;
        RBus_UInt32  bcc_clk_div:12;
    };
}p2p_p2p_bcc_ctl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_reset:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  dummy1802ddd8_27_20:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  bcc_irq_threshould_8us:10;
        RBus_UInt32  res3:3;
        RBus_UInt32  bcc_mode2_enable:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  bcc_sw_chksum:1;
        RBus_UInt32  bcc_tx_done_announce:1;
        RBus_UInt32  bcc_enable:1;
    };
}p2p_p2p_bcc_ctl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_manual_sample:1;
        RBus_UInt32  bcc_in_sample_2:11;
        RBus_UInt32  bcc_in_sample_1:10;
        RBus_UInt32  bcc_in_sample_0:10;
    };
}p2p_p2p_bcc_ctl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802dde0_31_29:3;
        RBus_UInt32  bcc_measure_point:5;
        RBus_UInt32  bcc_in_sample_4:12;
        RBus_UInt32  bcc_in_sample_3:12;
    };
}p2p_p2p_bcc_ctl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802dde4_31_28:4;
        RBus_UInt32  bcc_irq_irq_en:1;
        RBus_UInt32  p2p_training_fail_irq_en:1;
        RBus_UInt32  p2p_bcc_bc_trigger_irq_en:1;
        RBus_UInt32  stop_high_err_irq_en:1;
        RBus_UInt32  data_lead_bit_err_irq_en:1;
        RBus_UInt32  start_low_err_en_irq_en:1;
        RBus_UInt32  preamble_le8_err_irq_en:1;
        RBus_UInt32  preamble_bh_bl_err_irq_en:1;
        RBus_UInt32  dummy1802dde4_19:1;
        RBus_UInt32  bcc_rx_done_irq_en:1;
        RBus_UInt32  bcc_tx_done_irq_en:1;
        RBus_UInt32  bcc_rx_reply_time_out_irq_en:1;
        RBus_UInt32  dummy1802dde4_15_12:4;
        RBus_UInt32  bcc_irq:1;
        RBus_UInt32  p2p_training_fail:1;
        RBus_UInt32  p2p_bcc_bc_trigger:1;
        RBus_UInt32  stop_high_err:1;
        RBus_UInt32  data_lead_bit_err:1;
        RBus_UInt32  start_low_err:1;
        RBus_UInt32  preamble_le8_err:1;
        RBus_UInt32  preamble_bh_bl_err:1;
        RBus_UInt32  dummy1802dde4_3:1;
        RBus_UInt32  bcc_rx_done:1;
        RBus_UInt32  bcc_tx_done:1;
        RBus_UInt32  bcc_rx_reply_time_out:1;
    };
}p2p_p2p_bcc_status_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_debounce_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  bcc_manual_mode:1;
        RBus_UInt32  bcc_manual_value:1;
        RBus_UInt32  dummy1802dde8_27_22:6;
        RBus_UInt32  bcc_measure_cnt:10;
        RBus_UInt32  res2:3;
        RBus_UInt32  bcc_debounce_threshold:9;
    };
}p2p_p2p_bcc_debounce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ddec_31_12:20;
        RBus_UInt32  res1:2;
        RBus_UInt32  dbg_sel:6;
        RBus_UInt32  dbg_part_sel:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  dbg_en:1;
    };
}p2p_p2p_dbg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_err_cnt:16;
        RBus_UInt32  crc_port_en:12;
        RBus_UInt32  res1:1;
        RBus_UInt32  crc_auto_cmp_en:1;
        RBus_UInt32  crc_conti:1;
        RBus_UInt32  crc_start:1;
    };
}p2p_p2p_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}p2p_p2p_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_golden:32;
    };
}p2p_p2p_crc_golden_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  p2p_tst_out:32;
    };
}p2p_p2p_dgb_read_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dmy_length:12;
        RBus_UInt32  res1:1;
        RBus_UInt32  ldmy_enable:1;
        RBus_UInt32  ldmy_color_sel:1;
        RBus_UInt32  fdmy_color_sel:9;
        RBus_UInt32  fdmy_line_num:4;
        RBus_UInt32  bdmy_line_num:4;
    };
}p2p_p2p_dmy_line0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dmy_color1:8;
        RBus_UInt32  dmy_color0:8;
        RBus_UInt32  hs_to_den_distance:8;
        RBus_UInt32  bdmy_color_sel:8;
    };
}p2p_p2p_dmy_line1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_01:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_01:8;
        RBus_UInt32  ctrl_f_byte03_01:8;
    };
}p2p_p2p_ctrl_f_byte02_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_01:8;
        RBus_UInt32  ctrl_f_byte05_01:8;
    };
}p2p_p2p_ctrl_f_byte04_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_02:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_02:8;
        RBus_UInt32  ctrl_f_byte03_02:8;
    };
}p2p_p2p_ctrl_f_byte02_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_02:8;
        RBus_UInt32  ctrl_f_byte05_02:8;
    };
}p2p_p2p_ctrl_f_byte04_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_03:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_03:8;
        RBus_UInt32  ctrl_f_byte03_03:8;
    };
}p2p_p2p_ctrl_f_byte02_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_03:8;
        RBus_UInt32  ctrl_f_byte05_03:8;
    };
}p2p_p2p_ctrl_f_byte04_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_04:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_04:8;
        RBus_UInt32  ctrl_f_byte03_04:8;
    };
}p2p_p2p_ctrl_f_byte02_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_04:8;
        RBus_UInt32  ctrl_f_byte05_04:8;
    };
}p2p_p2p_ctrl_f_byte04_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_05:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_05:8;
        RBus_UInt32  ctrl_f_byte03_05:8;
    };
}p2p_p2p_ctrl_f_byte02_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_05:8;
        RBus_UInt32  ctrl_f_byte05_05:8;
    };
}p2p_p2p_ctrl_f_byte04_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_06:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_06:8;
        RBus_UInt32  ctrl_f_byte03_06:8;
    };
}p2p_p2p_ctrl_f_byte02_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_06:8;
        RBus_UInt32  ctrl_f_byte05_06:8;
    };
}p2p_p2p_ctrl_f_byte04_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_07:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_07:8;
        RBus_UInt32  ctrl_f_byte03_07:8;
    };
}p2p_p2p_ctrl_f_byte02_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_07:8;
        RBus_UInt32  ctrl_f_byte05_07:8;
    };
}p2p_p2p_ctrl_f_byte04_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_08:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_08:8;
        RBus_UInt32  ctrl_f_byte03_08:8;
    };
}p2p_p2p_ctrl_f_byte02_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_08:8;
        RBus_UInt32  ctrl_f_byte05_08:8;
    };
}p2p_p2p_ctrl_f_byte04_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_09:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_09:8;
        RBus_UInt32  ctrl_f_byte03_09:8;
    };
}p2p_p2p_ctrl_f_byte02_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_09:8;
        RBus_UInt32  ctrl_f_byte05_09:8;
    };
}p2p_p2p_ctrl_f_byte04_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_10:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_10:8;
        RBus_UInt32  ctrl_f_byte03_10:8;
    };
}p2p_p2p_ctrl_f_byte02_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_10:8;
        RBus_UInt32  ctrl_f_byte05_10:8;
    };
}p2p_p2p_ctrl_f_byte04_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ctrl_f_byte01_11:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  ctrl_f_byte02_11:8;
        RBus_UInt32  ctrl_f_byte03_11:8;
    };
}p2p_p2p_ctrl_f_byte02_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctrl_f_byte04_11:8;
        RBus_UInt32  ctrl_f_byte05_11:8;
    };
}p2p_p2p_ctrl_f_byte04_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  pol_inv:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  polc_inv:12;
    };
}p2p_p2p_pol_inv_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  pol2_inv:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  pol3_inv:12;
    };
}p2p_p2p_pol_inv_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k3_line_start_00:4;
        RBus_UInt32  k3_line_start_01:4;
        RBus_UInt32  k3_line_start_02:4;
        RBus_UInt32  k3_line_start_03:4;
        RBus_UInt32  k3_line_start_04:4;
        RBus_UInt32  k3_line_start_05:4;
        RBus_UInt32  k3_line_start_06:4;
        RBus_UInt32  k3_line_start_07:4;
    };
}p2p_p2p_k3_loc_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k3_line_start_08:4;
        RBus_UInt32  k3_line_start_09:4;
        RBus_UInt32  k3_line_start_10:4;
        RBus_UInt32  k3_line_start_11:4;
        RBus_UInt32  res1:12;
        RBus_UInt32  k3_line_period:4;
    };
}p2p_p2p_k3_loc_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  p2p_bist_enable:1;
        RBus_UInt32  p2p_bist_done:1;
        RBus_UInt32  p2p_bist_result:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  p2p_bist_length:20;
    };
}p2p_p2p_fifo_bist_RBUS;

#else //apply LITTLE_ENDIAN

//======P2P register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  p2p_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  p2p_lane_mode:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  p2p_bit_mode:2;
        RBus_UInt32  res3:6;
        RBus_UInt32  phy_clk_div:9;
        RBus_UInt32  res4:7;
    };
}p2p_p2p_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lsp_times:4;
        RBus_UInt32  training_time_500us:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  standby_time_10us:5;
        RBus_UInt32  res2:10;
        RBus_UInt32  fsm_force_mode3:1;
    };
}p2p_p2p_fsm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dis_clock_at_bcc:1;
        RBus_UInt32  dummy1802dd08_19_1:19;
        RBus_UInt32  clock_pattern:10;
        RBus_UInt32  res1:2;
    };
}p2p_p2p_clock_pattern_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k2_symbol:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  dummy1802dd0c_15_12:4;
        RBus_UInt32  k1_symbol:10;
        RBus_UInt32  res2:2;
        RBus_UInt32  dummy1802dd0c_31_28:4;
    };
}p2p_p2p_k12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k4_symbol:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  dummy1802dd10_15_12:4;
        RBus_UInt32  k3_symbol:10;
        RBus_UInt32  res2:2;
        RBus_UInt32  dummy1802dd10_31_28:4;
    };
}p2p_p2p_k34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g2_symbol:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  dummy1802dd14_15_12:4;
        RBus_UInt32  g1_symbol:10;
        RBus_UInt32  res2:2;
        RBus_UInt32  dummy1802dd14_31_28:4;
    };
}p2p_p2p_g12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g4_symbol:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  dummy1802dd18_15_12:4;
        RBus_UInt32  g3_symbol:10;
        RBus_UInt32  res2:2;
        RBus_UInt32  dummy1802dd18_31_28:4;
    };
}p2p_p2p_g34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lsp_k3_loc03:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lsp_k3_loc02:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lsp_k3_loc01:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lsp_k3_loc00:5;
        RBus_UInt32  res4:3;
    };
}p2p_p2p_lsp_k3_loc00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lsp_k3_loc07:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lsp_k3_loc06:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lsp_k3_loc05:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lsp_k3_loc04:5;
        RBus_UInt32  res4:3;
    };
}p2p_p2p_lsp_k3_loc04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lsp_k3_loc11:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lsp_k3_loc10:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lsp_k3_loc09:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lsp_k3_loc08:5;
        RBus_UInt32  res4:3;
    };
}p2p_p2p_lsp_k3_loc08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_sel_polc:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  tcon_sel_pol:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  tcon_sel_fsync:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  dummy1802dd28_31_24:8;
    };
}p2p_p2p_tcon_sel0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_sel_pol3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  tcon_sel_pol2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  tcon_sel_bkdu:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  dummy1802dd2c_31_24:8;
    };
}p2p_p2p_tcon_sel1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte0_03:8;
        RBus_UInt32  ctrl_l_byte0_02:8;
        RBus_UInt32  ctrl_l_byte0_01:8;
        RBus_UInt32  ctrl_l_byte0_00:8;
    };
}p2p_p2p_ctrl_l_byte0_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte0_07:8;
        RBus_UInt32  ctrl_l_byte0_06:8;
        RBus_UInt32  ctrl_l_byte0_05:8;
        RBus_UInt32  ctrl_l_byte0_04:8;
    };
}p2p_p2p_ctrl_l_byte0_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte0_11:8;
        RBus_UInt32  ctrl_l_byte0_10:8;
        RBus_UInt32  ctrl_l_byte0_09:8;
        RBus_UInt32  ctrl_l_byte0_08:8;
    };
}p2p_p2p_ctrl_l_byte0_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_even03:8;
        RBus_UInt32  ctrl_l_byte1_even02:8;
        RBus_UInt32  ctrl_l_byte1_even01:8;
        RBus_UInt32  ctrl_l_byte1_even00:8;
    };
}p2p_p2p_ctrl_l_byte1_even00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_even07:8;
        RBus_UInt32  ctrl_l_byte1_even06:8;
        RBus_UInt32  ctrl_l_byte1_even05:8;
        RBus_UInt32  ctrl_l_byte1_even04:8;
    };
}p2p_p2p_ctrl_l_byte1_even04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_even11:8;
        RBus_UInt32  ctrl_l_byte1_even10:8;
        RBus_UInt32  ctrl_l_byte1_even09:8;
        RBus_UInt32  ctrl_l_byte1_even08:8;
    };
}p2p_p2p_ctrl_l_byte1_even08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_odd03:8;
        RBus_UInt32  ctrl_l_byte1_odd02:8;
        RBus_UInt32  ctrl_l_byte1_odd01:8;
        RBus_UInt32  ctrl_l_byte1_odd00:8;
    };
}p2p_p2p_ctrl_l_byte1_odd00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_odd07:8;
        RBus_UInt32  ctrl_l_byte1_odd06:8;
        RBus_UInt32  ctrl_l_byte1_odd05:8;
        RBus_UInt32  ctrl_l_byte1_odd04:8;
    };
}p2p_p2p_ctrl_l_byte1_odd04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte1_odd11:8;
        RBus_UInt32  ctrl_l_byte1_odd10:8;
        RBus_UInt32  ctrl_l_byte1_odd09:8;
        RBus_UInt32  ctrl_l_byte1_odd08:8;
    };
}p2p_p2p_ctrl_l_byte1_odd08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_even03:8;
        RBus_UInt32  ctrl_l_byte2_even02:8;
        RBus_UInt32  ctrl_l_byte2_even01:8;
        RBus_UInt32  ctrl_l_byte2_even00:8;
    };
}p2p_p2p_ctrl_l_byte2_even00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_even07:8;
        RBus_UInt32  ctrl_l_byte2_even06:8;
        RBus_UInt32  ctrl_l_byte2_even05:8;
        RBus_UInt32  ctrl_l_byte2_even04:8;
    };
}p2p_p2p_ctrl_l_byte2_even04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_even11:8;
        RBus_UInt32  ctrl_l_byte2_even10:8;
        RBus_UInt32  ctrl_l_byte2_even09:8;
        RBus_UInt32  ctrl_l_byte2_even08:8;
    };
}p2p_p2p_ctrl_l_byte2_even08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_odd03:8;
        RBus_UInt32  ctrl_l_byte2_odd02:8;
        RBus_UInt32  ctrl_l_byte2_odd01:8;
        RBus_UInt32  ctrl_l_byte2_odd00:8;
    };
}p2p_p2p_ctrl_l_byte2_odd00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_odd07:8;
        RBus_UInt32  ctrl_l_byte2_odd06:8;
        RBus_UInt32  ctrl_l_byte2_odd05:8;
        RBus_UInt32  ctrl_l_byte2_odd04:8;
    };
}p2p_p2p_ctrl_l_byte2_odd04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte2_odd11:8;
        RBus_UInt32  ctrl_l_byte2_odd10:8;
        RBus_UInt32  ctrl_l_byte2_odd09:8;
        RBus_UInt32  ctrl_l_byte2_odd08:8;
    };
}p2p_p2p_ctrl_l_byte2_odd08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte3_03:8;
        RBus_UInt32  ctrl_l_byte3_02:8;
        RBus_UInt32  ctrl_l_byte3_01:8;
        RBus_UInt32  ctrl_l_byte3_00:8;
    };
}p2p_p2p_ctrl_l_byte3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte3_07:8;
        RBus_UInt32  ctrl_l_byte3_06:8;
        RBus_UInt32  ctrl_l_byte3_05:8;
        RBus_UInt32  ctrl_l_byte3_04:8;
    };
}p2p_p2p_ctrl_l_byte3_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte3_11:8;
        RBus_UInt32  ctrl_l_byte3_10:8;
        RBus_UInt32  ctrl_l_byte3_09:8;
        RBus_UInt32  ctrl_l_byte3_08:8;
    };
}p2p_p2p_ctrl_l_byte3_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte4_03:8;
        RBus_UInt32  ctrl_l_byte4_02:8;
        RBus_UInt32  ctrl_l_byte4_01:8;
        RBus_UInt32  ctrl_l_byte4_00:8;
    };
}p2p_p2p_ctrl_l_byte4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte4_07:8;
        RBus_UInt32  ctrl_l_byte4_06:8;
        RBus_UInt32  ctrl_l_byte4_05:8;
        RBus_UInt32  ctrl_l_byte4_04:8;
    };
}p2p_p2p_ctrl_l_byte4_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_l_byte4_11:8;
        RBus_UInt32  ctrl_l_byte4_10:8;
        RBus_UInt32  ctrl_l_byte4_09:8;
        RBus_UInt32  ctrl_l_byte4_08:8;
    };
}p2p_p2p_ctrl_l_byte4_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03:8;
        RBus_UInt32  ctrl_f_byte02:8;
        RBus_UInt32  ctrl_f_byte01:8;
        RBus_UInt32  ctrl_f_byte00:8;
    };
}p2p_p2p_ctrl_f_byte00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte07:8;
        RBus_UInt32  ctrl_f_byte06:8;
        RBus_UInt32  ctrl_f_byte05:8;
        RBus_UInt32  ctrl_f_byte04:8;
    };
}p2p_p2p_ctrl_f_byte04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte11:8;
        RBus_UInt32  ctrl_f_byte10:8;
        RBus_UInt32  ctrl_f_byte09:8;
        RBus_UInt32  ctrl_f_byte08:8;
    };
}p2p_p2p_ctrl_f_byte08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte15:8;
        RBus_UInt32  ctrl_f_byte14:8;
        RBus_UInt32  ctrl_f_byte13:8;
        RBus_UInt32  ctrl_f_byte12:8;
    };
}p2p_p2p_ctrl_f_byte12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte19:8;
        RBus_UInt32  ctrl_f_byte18:8;
        RBus_UInt32  ctrl_f_byte17:8;
        RBus_UInt32  ctrl_f_byte16:8;
    };
}p2p_p2p_ctrl_f_byte16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte23:8;
        RBus_UInt32  ctrl_f_byte22:8;
        RBus_UInt32  ctrl_f_byte21:8;
        RBus_UInt32  ctrl_f_byte20:8;
    };
}p2p_p2p_ctrl_f_byte20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte27:8;
        RBus_UInt32  ctrl_f_byte26:8;
        RBus_UInt32  ctrl_f_byte25:8;
        RBus_UInt32  ctrl_f_byte24:8;
    };
}p2p_p2p_ctrl_f_byte24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte31:8;
        RBus_UInt32  ctrl_f_byte30:8;
        RBus_UInt32  ctrl_f_byte29:8;
        RBus_UInt32  ctrl_f_byte28:8;
    };
}p2p_p2p_ctrl_f_byte28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte35:8;
        RBus_UInt32  ctrl_f_byte34:8;
        RBus_UInt32  ctrl_f_byte33:8;
        RBus_UInt32  ctrl_f_byte32:8;
    };
}p2p_p2p_ctrl_f_byte32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte39:8;
        RBus_UInt32  ctrl_f_byte38:8;
        RBus_UInt32  ctrl_f_byte37:8;
        RBus_UInt32  ctrl_f_byte36:8;
    };
}p2p_p2p_ctrl_f_byte36_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte43:8;
        RBus_UInt32  ctrl_f_byte42:8;
        RBus_UInt32  ctrl_f_byte41:8;
        RBus_UInt32  ctrl_f_byte40:8;
    };
}p2p_p2p_ctrl_f_byte40_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte47:8;
        RBus_UInt32  ctrl_f_byte46:8;
        RBus_UInt32  ctrl_f_byte45:8;
        RBus_UInt32  ctrl_f_byte44:8;
    };
}p2p_p2p_ctrl_f_byte44_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte51:8;
        RBus_UInt32  ctrl_f_byte50:8;
        RBus_UInt32  ctrl_f_byte49:8;
        RBus_UInt32  ctrl_f_byte48:8;
    };
}p2p_p2p_ctrl_f_byte48_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte55:8;
        RBus_UInt32  ctrl_f_byte54:8;
        RBus_UInt32  ctrl_f_byte53:8;
        RBus_UInt32  ctrl_f_byte52:8;
    };
}p2p_p2p_ctrl_f_byte52_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte59:8;
        RBus_UInt32  ctrl_f_byte58:8;
        RBus_UInt32  ctrl_f_byte57:8;
        RBus_UInt32  ctrl_f_byte56:8;
    };
}p2p_p2p_ctrl_f_byte56_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scrambler_mode:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  disable_8b10b:1;
        RBus_UInt32  initial_8b10b:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  scrambler_auto_en:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  dummy1802ddc0_19_12:8;
        RBus_UInt32  ext_pixel_sel_11:1;
        RBus_UInt32  ext_pixel_sel_10:1;
        RBus_UInt32  ext_pixel_sel_09:1;
        RBus_UInt32  ext_pixel_sel_08:1;
        RBus_UInt32  ext_pixel_sel_07:1;
        RBus_UInt32  ext_pixel_sel_06:1;
        RBus_UInt32  ext_pixel_sel_05:1;
        RBus_UInt32  ext_pixel_sel_04:1;
        RBus_UInt32  ext_pixel_sel_03:1;
        RBus_UInt32  ext_pixel_sel_02:1;
        RBus_UInt32  ext_pixel_sel_01:1;
        RBus_UInt32  ext_pixel_sel_00:1;
    };
}p2p_p2p_scrambler_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_tx_byte_0:8;
        RBus_UInt32  bcc_tx_byte_1:8;
        RBus_UInt32  bcc_tx_byte_2:8;
        RBus_UInt32  bcc_tx_byte_3:8;
    };
}p2p_p2p_bcc_tx_data_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_tx_byte_4:8;
        RBus_UInt32  bcc_tx_byte_5:8;
        RBus_UInt32  dummy1802ddc8_31_16:16;
    };
}p2p_p2p_bcc_tx_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_rx_byte_0:8;
        RBus_UInt32  bcc_rx_byte_1:8;
        RBus_UInt32  bcc_rx_byte_2:8;
        RBus_UInt32  res1:8;
    };
}p2p_p2p_bcc_rx_data_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_tx_preamble_num:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  bcc_rx_reply_time:10;
        RBus_UInt32  res2:2;
        RBus_UInt32  bcc_rx_error_wait_time:10;
        RBus_UInt32  res3:2;
    };
}p2p_p2p_bcc_ctl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_clk_div:12;
        RBus_UInt32  bcc_trigger_hw:1;
        RBus_UInt32  dummy1802ddd4_27_13:15;
        RBus_UInt32  res1:3;
        RBus_UInt32  bcc_trigger:1;
    };
}p2p_p2p_bcc_ctl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_enable:1;
        RBus_UInt32  bcc_tx_done_announce:1;
        RBus_UInt32  bcc_sw_chksum:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  bcc_mode2_enable:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  bcc_irq_threshould_8us:10;
        RBus_UInt32  res3:2;
        RBus_UInt32  dummy1802ddd8_27_20:8;
        RBus_UInt32  res4:3;
        RBus_UInt32  bcc_reset:1;
    };
}p2p_p2p_bcc_ctl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_in_sample_0:10;
        RBus_UInt32  bcc_in_sample_1:10;
        RBus_UInt32  bcc_in_sample_2:11;
        RBus_UInt32  bcc_manual_sample:1;
    };
}p2p_p2p_bcc_ctl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_in_sample_3:12;
        RBus_UInt32  bcc_in_sample_4:12;
        RBus_UInt32  bcc_measure_point:5;
        RBus_UInt32  dummy1802dde0_31_29:3;
    };
}p2p_p2p_bcc_ctl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_rx_reply_time_out:1;
        RBus_UInt32  bcc_tx_done:1;
        RBus_UInt32  bcc_rx_done:1;
        RBus_UInt32  dummy1802dde4_3:1;
        RBus_UInt32  preamble_bh_bl_err:1;
        RBus_UInt32  preamble_le8_err:1;
        RBus_UInt32  start_low_err:1;
        RBus_UInt32  data_lead_bit_err:1;
        RBus_UInt32  stop_high_err:1;
        RBus_UInt32  p2p_bcc_bc_trigger:1;
        RBus_UInt32  p2p_training_fail:1;
        RBus_UInt32  bcc_irq:1;
        RBus_UInt32  dummy1802dde4_15_12:4;
        RBus_UInt32  bcc_rx_reply_time_out_irq_en:1;
        RBus_UInt32  bcc_tx_done_irq_en:1;
        RBus_UInt32  bcc_rx_done_irq_en:1;
        RBus_UInt32  dummy1802dde4_19:1;
        RBus_UInt32  preamble_bh_bl_err_irq_en:1;
        RBus_UInt32  preamble_le8_err_irq_en:1;
        RBus_UInt32  start_low_err_en_irq_en:1;
        RBus_UInt32  data_lead_bit_err_irq_en:1;
        RBus_UInt32  stop_high_err_irq_en:1;
        RBus_UInt32  p2p_bcc_bc_trigger_irq_en:1;
        RBus_UInt32  p2p_training_fail_irq_en:1;
        RBus_UInt32  bcc_irq_irq_en:1;
        RBus_UInt32  dummy1802dde4_31_28:4;
    };
}p2p_p2p_bcc_status_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcc_debounce_threshold:9;
        RBus_UInt32  res1:3;
        RBus_UInt32  bcc_measure_cnt:10;
        RBus_UInt32  dummy1802dde8_27_22:6;
        RBus_UInt32  bcc_manual_value:1;
        RBus_UInt32  bcc_manual_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  bcc_debounce_en:1;
    };
}p2p_p2p_bcc_debounce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  dbg_part_sel:1;
        RBus_UInt32  dbg_sel:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  dummy1802ddec_31_12:20;
    };
}p2p_p2p_dbg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_start:1;
        RBus_UInt32  crc_conti:1;
        RBus_UInt32  crc_auto_cmp_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  crc_port_en:12;
        RBus_UInt32  crc_err_cnt:16;
    };
}p2p_p2p_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}p2p_p2p_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_golden:32;
    };
}p2p_p2p_crc_golden_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  p2p_tst_out:32;
    };
}p2p_p2p_dgb_read_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bdmy_line_num:4;
        RBus_UInt32  fdmy_line_num:4;
        RBus_UInt32  fdmy_color_sel:9;
        RBus_UInt32  ldmy_color_sel:1;
        RBus_UInt32  ldmy_enable:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  dmy_length:12;
    };
}p2p_p2p_dmy_line0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bdmy_color_sel:8;
        RBus_UInt32  hs_to_den_distance:8;
        RBus_UInt32  dmy_color0:8;
        RBus_UInt32  dmy_color1:8;
    };
}p2p_p2p_dmy_line1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_01:8;
        RBus_UInt32  ctrl_f_byte02_01:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_01:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_01:8;
        RBus_UInt32  ctrl_f_byte04_01:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_02:8;
        RBus_UInt32  ctrl_f_byte02_02:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_02:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_02:8;
        RBus_UInt32  ctrl_f_byte04_02:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_03:8;
        RBus_UInt32  ctrl_f_byte02_03:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_03:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_03:8;
        RBus_UInt32  ctrl_f_byte04_03:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_04:8;
        RBus_UInt32  ctrl_f_byte02_04:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_04:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_04:8;
        RBus_UInt32  ctrl_f_byte04_04:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_05:8;
        RBus_UInt32  ctrl_f_byte02_05:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_05:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_05:8;
        RBus_UInt32  ctrl_f_byte04_05:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_06:8;
        RBus_UInt32  ctrl_f_byte02_06:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_06:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_06:8;
        RBus_UInt32  ctrl_f_byte04_06:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_07:8;
        RBus_UInt32  ctrl_f_byte02_07:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_07:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_07:8;
        RBus_UInt32  ctrl_f_byte04_07:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_08:8;
        RBus_UInt32  ctrl_f_byte02_08:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_08:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_08:8;
        RBus_UInt32  ctrl_f_byte04_08:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_09:8;
        RBus_UInt32  ctrl_f_byte02_09:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_09:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_09:8;
        RBus_UInt32  ctrl_f_byte04_09:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_10:8;
        RBus_UInt32  ctrl_f_byte02_10:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_10:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_10:8;
        RBus_UInt32  ctrl_f_byte04_10:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte03_11:8;
        RBus_UInt32  ctrl_f_byte02_11:8;
        RBus_UInt32  res1:6;
        RBus_UInt32  ctrl_f_byte01_11:2;
        RBus_UInt32  res2:8;
    };
}p2p_p2p_ctrl_f_byte02_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctrl_f_byte05_11:8;
        RBus_UInt32  ctrl_f_byte04_11:8;
        RBus_UInt32  res1:16;
    };
}p2p_p2p_ctrl_f_byte04_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  polc_inv:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  pol_inv:12;
        RBus_UInt32  res2:4;
    };
}p2p_p2p_pol_inv_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pol3_inv:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  pol2_inv:12;
        RBus_UInt32  res2:4;
    };
}p2p_p2p_pol_inv_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k3_line_start_07:4;
        RBus_UInt32  k3_line_start_06:4;
        RBus_UInt32  k3_line_start_05:4;
        RBus_UInt32  k3_line_start_04:4;
        RBus_UInt32  k3_line_start_03:4;
        RBus_UInt32  k3_line_start_02:4;
        RBus_UInt32  k3_line_start_01:4;
        RBus_UInt32  k3_line_start_00:4;
    };
}p2p_p2p_k3_loc_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k3_line_period:4;
        RBus_UInt32  res1:12;
        RBus_UInt32  k3_line_start_11:4;
        RBus_UInt32  k3_line_start_10:4;
        RBus_UInt32  k3_line_start_09:4;
        RBus_UInt32  k3_line_start_08:4;
    };
}p2p_p2p_k3_loc_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  p2p_bist_length:20;
        RBus_UInt32  res1:9;
        RBus_UInt32  p2p_bist_result:1;
        RBus_UInt32  p2p_bist_done:1;
        RBus_UInt32  p2p_bist_enable:1;
    };
}p2p_p2p_fifo_bist_RBUS;




#endif 


#endif 
