/**
* @file Mac7p-DesignSpec-D-Domain_PCID
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_PCID_REG_H_
#define _RBUS_PCID_REG_H_

#include "rbusTypes.h"



//  PCID Register Address



#define  PCID_PCID_CTRL_VADDR                               	(0xb802ef40)
#define  PCID_PCID_CTRL_2_VADDR                             	(0xb802ef44)
#define  PCID_PCID_CTRL_3_VADDR                             	(0xb802ef48)
#define  PCID_PCID_LINE_1_VADDR                             	(0xb802ef50)
#define  PCID_PCID_LINE_2_VADDR                             	(0xb802ef54)
#define  PCID_PCID_LINE_3_VADDR                             	(0xb802ef58)
#define  PCID_PCID_LINE_4_VADDR                             	(0xb802ef5c)
#define  PCID_PCID2_POLARITY_R_1_VADDR                      	(0xb802ef70)
#define  PCID_PCID2_POLARITY_R_2_VADDR                      	(0xb802ef74)
#define  PCID_PCID2_POLARITY_R_3_VADDR                      	(0xb802ef78)
#define  PCID_PCID2_POLARITY_R_4_VADDR                      	(0xb802ef7c)
#define  PCID_PCID2_POLARITY_G_1_VADDR                      	(0xb802ef80)
#define  PCID_PCID2_POLARITY_G_2_VADDR                      	(0xb802ef84)
#define  PCID_PCID2_POLARITY_G_3_VADDR                      	(0xb802ef88)
#define  PCID_PCID2_POLARITY_G_4_VADDR                      	(0xb802ef8c)
#define  PCID_PCID2_POLARITY_B_1_VADDR                      	(0xb802ef90)
#define  PCID_PCID2_POLARITY_B_2_VADDR                      	(0xb802ef94)
#define  PCID_PCID2_POLARITY_B_3_VADDR                      	(0xb802ef98)
#define  PCID_PCID2_POLARITY_B_4_VADDR                      	(0xb802ef9c)
#define  PCID_PCID_VALC_CTRL_VADDR                          	(0xb802efa0)
#define  PCID_PCID_VALC_HPF_0_VADDR                         	(0xb802efa4)
#define  PCID_PCID_VALC_HPF_1_VADDR                         	(0xb802efa8)
#define  PCID_PCID_VALC_SAT_0_VADDR                         	(0xb802efac)
#define  PCID_PCID_VALC_SAT_1_VADDR                         	(0xb802efb0)
#define  PCID_PCID_RM_VADDR                                 	(0xb802efb4)
#define  PCID_PCID_RME_LS_VADDR                             	(0xb802efb8)
#define  PCID_PCID_FAIL_VADDR                               	(0xb802efbc)
#define  PCID_PCID_TESTRWM_VADDR                            	(0xb802efc0)
#define  PCID_PCID_LUT_ADDR_VADDR                           	(0xb802efd0)
#define  PCID_PCID_LUT_DATA_VADDR                           	(0xb802efd4)
#define  PCID_PCID_ACCESSDATA_CTRL_VADDR                    	(0xb802efd8)
#define  PCID_PCID_ACCESSDATA_POSCTRL_VADDR                 	(0xb802efdc)
#define  PCID_PCID_ACCESSDATA_R_VADDR                       	(0xb802efe0)
#define  PCID_PCID_ACCESSDATA_G_VADDR                       	(0xb802efe4)
#define  PCID_PCID_ACCESSDATA_B_VADDR                       	(0xb802efe8)
#define  PCID_PCID_REGIONALWEIGHT_CTRL_VADDR                	(0xb802ee00)
#define  PCID_PCID_REGIONALWEIGHT_HOR_0_VADDR               	(0xb802ee04)
#define  PCID_PCID_REGIONALWEIGHT_HOR_1_VADDR               	(0xb802ee08)
#define  PCID_PCID_REGIONALWEIGHT_HOR_2_VADDR               	(0xb802ee0c)
#define  PCID_PCID_REGIONALWEIGHT_HOR_3_VADDR               	(0xb802ee10)
#define  PCID_PCID_REGIONALWEIGHT_VER_0_VADDR               	(0xb802ee14)
#define  PCID_PCID_REGIONALWEIGHT_VER_1_VADDR               	(0xb802ee18)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======PCID register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ef40_31_2:30;
        RBus_UInt32  intp_bit_sel:1;
        RBus_UInt32  boundary_mode:1;
    };
}pcid_pcid_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab2_xtr_en:1;
        RBus_UInt32  pcid_tab1_xtr_en:1;
        RBus_UInt32  pcid_thd_mode:1;
        RBus_UInt32  pcid_thd_en:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  pcid_tab1_b_thd:8;
        RBus_UInt32  pcid_tab1_g_thd:8;
        RBus_UInt32  pcid_tab1_r_thd:8;
    };
}pcid_pcid_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ef48_31_24:8;
        RBus_UInt32  pcid_tab2_b_thd:8;
        RBus_UInt32  pcid_tab2_g_thd:8;
        RBus_UInt32  pcid_tab2_r_thd:8;
    };
}pcid_pcid_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line1_odd_b_color_select:2;
        RBus_UInt32  line1_odd_g_color_select:2;
        RBus_UInt32  line1_odd_r_color_select:2;
        RBus_UInt32  line1_odd_b_point_select:2;
        RBus_UInt32  line1_odd_g_point_select:2;
        RBus_UInt32  line1_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line1_odd_b_line_select:1;
        RBus_UInt32  line1_odd_g_line_select:1;
        RBus_UInt32  line1_odd_r_line_select:1;
        RBus_UInt32  line1_even_b_color_select:2;
        RBus_UInt32  line1_even_g_color_select:2;
        RBus_UInt32  line1_even_r_color_select:2;
        RBus_UInt32  line1_even_b_point_select:2;
        RBus_UInt32  line1_even_g_point_select:2;
        RBus_UInt32  line1_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line1_even_b_line_select:1;
        RBus_UInt32  line1_even_g_line_select:1;
        RBus_UInt32  line1_even_r_line_select:1;
    };
}pcid_pcid_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line2_odd_b_color_select:2;
        RBus_UInt32  line2_odd_g_color_select:2;
        RBus_UInt32  line2_odd_r_color_select:2;
        RBus_UInt32  line2_odd_b_point_select:2;
        RBus_UInt32  line2_odd_g_point_select:2;
        RBus_UInt32  line2_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line2_odd_b_line_select:1;
        RBus_UInt32  line2_odd_g_line_select:1;
        RBus_UInt32  line2_odd_r_line_select:1;
        RBus_UInt32  line2_even_b_color_select:2;
        RBus_UInt32  line2_even_g_color_select:2;
        RBus_UInt32  line2_even_r_color_select:2;
        RBus_UInt32  line2_even_b_point_select:2;
        RBus_UInt32  line2_even_g_point_select:2;
        RBus_UInt32  line2_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line2_even_b_line_select:1;
        RBus_UInt32  line2_even_g_line_select:1;
        RBus_UInt32  line2_even_r_line_select:1;
    };
}pcid_pcid_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line3_odd_b_color_select:2;
        RBus_UInt32  line3_odd_g_color_select:2;
        RBus_UInt32  line3_odd_r_color_select:2;
        RBus_UInt32  line3_odd_b_point_select:2;
        RBus_UInt32  line3_odd_g_point_select:2;
        RBus_UInt32  line3_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line3_odd_b_line_select:1;
        RBus_UInt32  line3_odd_g_line_select:1;
        RBus_UInt32  line3_odd_r_line_select:1;
        RBus_UInt32  line3_even_b_color_select:2;
        RBus_UInt32  line3_even_g_color_select:2;
        RBus_UInt32  line3_even_r_color_select:2;
        RBus_UInt32  line3_even_b_point_select:2;
        RBus_UInt32  line3_even_g_point_select:2;
        RBus_UInt32  line3_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line3_even_b_line_select:1;
        RBus_UInt32  line3_even_g_line_select:1;
        RBus_UInt32  line3_even_r_line_select:1;
    };
}pcid_pcid_line_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line4_odd_b_color_select:2;
        RBus_UInt32  line4_odd_g_color_select:2;
        RBus_UInt32  line4_odd_r_color_select:2;
        RBus_UInt32  line4_odd_b_point_select:2;
        RBus_UInt32  line4_odd_g_point_select:2;
        RBus_UInt32  line4_odd_r_point_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  line4_odd_b_line_select:1;
        RBus_UInt32  line4_odd_g_line_select:1;
        RBus_UInt32  line4_odd_r_line_select:1;
        RBus_UInt32  line4_even_b_color_select:2;
        RBus_UInt32  line4_even_g_color_select:2;
        RBus_UInt32  line4_even_r_color_select:2;
        RBus_UInt32  line4_even_b_point_select:2;
        RBus_UInt32  line4_even_g_point_select:2;
        RBus_UInt32  line4_even_r_point_select:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  line4_even_b_line_select:1;
        RBus_UInt32  line4_even_g_line_select:1;
        RBus_UInt32  line4_even_r_line_select:1;
    };
}pcid_pcid_line_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line2:16;
        RBus_UInt32  r_po_line1:16;
    };
}pcid_pcid2_polarity_r_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line4:16;
        RBus_UInt32  r_po_line3:16;
    };
}pcid_pcid2_polarity_r_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line6:16;
        RBus_UInt32  r_po_line5:16;
    };
}pcid_pcid2_polarity_r_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line8:16;
        RBus_UInt32  r_po_line7:16;
    };
}pcid_pcid2_polarity_r_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line2:16;
        RBus_UInt32  g_po_line1:16;
    };
}pcid_pcid2_polarity_g_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line4:16;
        RBus_UInt32  g_po_line3:16;
    };
}pcid_pcid2_polarity_g_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line6:16;
        RBus_UInt32  g_po_line5:16;
    };
}pcid_pcid2_polarity_g_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line8:16;
        RBus_UInt32  g_po_line7:16;
    };
}pcid_pcid2_polarity_g_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line2:16;
        RBus_UInt32  b_po_line1:16;
    };
}pcid_pcid2_polarity_b_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line4:16;
        RBus_UInt32  b_po_line3:16;
    };
}pcid_pcid2_polarity_b_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line6:16;
        RBus_UInt32  b_po_line5:16;
    };
}pcid_pcid2_polarity_b_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line8:16;
        RBus_UInt32  b_po_line7:16;
    };
}pcid_pcid2_polarity_b_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802efa0_31_12:20;
        RBus_UInt32  valc_dbg_region:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  valc_dbg_sel:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  valc_hpf_clip:2;
        RBus_UInt32  valc_en:1;
    };
}pcid_pcid_valc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_hpf_w15:4;
        RBus_UInt32  valc_hpf_w14:4;
        RBus_UInt32  valc_hpf_w13:4;
        RBus_UInt32  valc_hpf_w12:4;
        RBus_UInt32  valc_hpf_w11:4;
        RBus_UInt32  valc_hpf_w10:4;
        RBus_UInt32  valc_hpf_w9:4;
        RBus_UInt32  valc_hpf_w8:4;
    };
}pcid_pcid_valc_hpf_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_hpf_w7:4;
        RBus_UInt32  valc_hpf_w6:4;
        RBus_UInt32  valc_hpf_w5:4;
        RBus_UInt32  valc_hpf_w4:4;
        RBus_UInt32  valc_hpf_w3:4;
        RBus_UInt32  valc_hpf_w2:4;
        RBus_UInt32  valc_hpf_w1:4;
        RBus_UInt32  valc_hpf_w0:4;
    };
}pcid_pcid_valc_hpf_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_sat_w15:4;
        RBus_UInt32  valc_sat_w14:4;
        RBus_UInt32  valc_sat_w13:4;
        RBus_UInt32  valc_sat_w12:4;
        RBus_UInt32  valc_sat_w11:4;
        RBus_UInt32  valc_sat_w10:4;
        RBus_UInt32  valc_sat_w9:4;
        RBus_UInt32  valc_sat_w8:4;
    };
}pcid_pcid_valc_sat_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_sat_w7:4;
        RBus_UInt32  valc_sat_w6:4;
        RBus_UInt32  valc_sat_w5:4;
        RBus_UInt32  valc_sat_w4:4;
        RBus_UInt32  valc_sat_w3:4;
        RBus_UInt32  valc_sat_w2:4;
        RBus_UInt32  valc_sat_w1:4;
        RBus_UInt32  valc_sat_w0:4;
    };
}pcid_pcid_valc_sat_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  pcid_tab_test1_2:1;
        RBus_UInt32  pcid_tab_test1_1:1;
        RBus_UInt32  pcid_tab_test1_0:1;
        RBus_UInt32  pcid_tab_rm_2:4;
        RBus_UInt32  pcid_tab_rm_1:4;
        RBus_UInt32  pcid_tab_rm_0:4;
        RBus_UInt32  res2:11;
        RBus_UInt32  pcid_lb_test1:1;
        RBus_UInt32  pcid_lb_rm:4;
    };
}pcid_pcid_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  pcid_tab_ls_2:1;
        RBus_UInt32  pcid_tab_ls_1:1;
        RBus_UInt32  pcid_tab_ls_0:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  pcid_lb_ls:1;
        RBus_UInt32  res3:9;
        RBus_UInt32  pcid_tab_rme_2:1;
        RBus_UInt32  pcid_tab_rme_1:1;
        RBus_UInt32  pcid_tab_rme_0:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  pcid_lb_rme:1;
    };
}pcid_pcid_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  tab_drf_fail_11:1;
        RBus_UInt32  tab_drf_fail_10:1;
        RBus_UInt32  tab_drf_fail_9:1;
        RBus_UInt32  tab_drf_fail_8:1;
        RBus_UInt32  tab_drf_fail_7:1;
        RBus_UInt32  tab_drf_fail_6:1;
        RBus_UInt32  tab_drf_fail_5:1;
        RBus_UInt32  tab_drf_fail_4:1;
        RBus_UInt32  tab_drf_fail_3:1;
        RBus_UInt32  tab_drf_fail_2:1;
        RBus_UInt32  tab_drf_fail_1:1;
        RBus_UInt32  tab_drf_fail_0:1;
        RBus_UInt32  lb_drf_fail_1:1;
        RBus_UInt32  lb_drf_fail_0:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  tab_bist_fail_11:1;
        RBus_UInt32  tab_bist_fail_10:1;
        RBus_UInt32  tab_bist_fail_9:1;
        RBus_UInt32  tab_bist_fail_8:1;
        RBus_UInt32  tab_bist_fail_7:1;
        RBus_UInt32  tab_bist_fail_6:1;
        RBus_UInt32  tab_bist_fail_5:1;
        RBus_UInt32  tab_bist_fail_4:1;
        RBus_UInt32  tab_bist_fail_3:1;
        RBus_UInt32  tab_bist_fail_2:1;
        RBus_UInt32  tab_bist_fail_1:1;
        RBus_UInt32  tab_bist_fail_0:1;
        RBus_UInt32  lb_bist_fail_1:1;
        RBus_UInt32  lb_bist_fail_0:1;
    };
}pcid_pcid_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  pcid_lb_testrwm:1;
    };
}pcid_pcid_testrwm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  pcid_lut_ax_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  pcid_lut_adr_mode:1;
        RBus_UInt32  pcid_lut_sel:2;
        RBus_UInt32  pcid_lut_row_addr:6;
        RBus_UInt32  pcid_lut_column_addr:6;
    };
}pcid_pcid_lut_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lut_data:32;
    };
}pcid_pcid_lut_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  access_location_sel:1;
        RBus_UInt32  access_cross_bar_en:1;
        RBus_UInt32  access_write_en:1;
        RBus_UInt32  access_read_en:1;
    };
}pcid_pcid_accessdata_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_starty:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_startx:12;
    };
}pcid_pcid_accessdata_posctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_r:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_write_r:12;
    };
}pcid_pcid_accessdata_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_g:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_write_g:12;
    };
}pcid_pcid_accessdata_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_b:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_write_b:12;
    };
}pcid_pcid_accessdata_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_start_y:12;
        RBus_UInt32  rw_start_x:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  rw_shift_sel:2;
        RBus_UInt32  rw_input_size:1;
        RBus_UInt32  regional_weight_en:1;
    };
}pcid_pcid_regionalweight_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_hor_w7:4;
        RBus_UInt32  rw_hor_w6:4;
        RBus_UInt32  rw_hor_w5:4;
        RBus_UInt32  rw_hor_w4:4;
        RBus_UInt32  rw_hor_w3:4;
        RBus_UInt32  rw_hor_w2:4;
        RBus_UInt32  rw_hor_w1:4;
        RBus_UInt32  rw_hor_w0:4;
    };
}pcid_pcid_regionalweight_hor_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_hor_w15:4;
        RBus_UInt32  rw_hor_w14:4;
        RBus_UInt32  rw_hor_w13:4;
        RBus_UInt32  rw_hor_w12:4;
        RBus_UInt32  rw_hor_w11:4;
        RBus_UInt32  rw_hor_w10:4;
        RBus_UInt32  rw_hor_w9:4;
        RBus_UInt32  rw_hor_w8:4;
    };
}pcid_pcid_regionalweight_hor_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_hor_w23:4;
        RBus_UInt32  rw_hor_w22:4;
        RBus_UInt32  rw_hor_w21:4;
        RBus_UInt32  rw_hor_w20:4;
        RBus_UInt32  rw_hor_w19:4;
        RBus_UInt32  rw_hor_w18:4;
        RBus_UInt32  rw_hor_w17:4;
        RBus_UInt32  rw_hor_w16:4;
    };
}pcid_pcid_regionalweight_hor_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  rw_hor_w24:4;
    };
}pcid_pcid_regionalweight_hor_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_ver_w7:4;
        RBus_UInt32  rw_ver_w6:4;
        RBus_UInt32  rw_ver_w5:4;
        RBus_UInt32  rw_ver_w4:4;
        RBus_UInt32  rw_ver_w3:4;
        RBus_UInt32  rw_ver_w2:4;
        RBus_UInt32  rw_ver_w1:4;
        RBus_UInt32  rw_ver_w0:4;
    };
}pcid_pcid_regionalweight_ver_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  rw_ver_w9:4;
        RBus_UInt32  rw_ver_w8:4;
    };
}pcid_pcid_regionalweight_ver_1_RBUS;

#else //apply LITTLE_ENDIAN

//======PCID register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  boundary_mode:1;
        RBus_UInt32  intp_bit_sel:1;
        RBus_UInt32  dummy1802ef40_31_2:30;
    };
}pcid_pcid_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab1_r_thd:8;
        RBus_UInt32  pcid_tab1_g_thd:8;
        RBus_UInt32  pcid_tab1_b_thd:8;
        RBus_UInt32  res1:4;
        RBus_UInt32  pcid_thd_en:1;
        RBus_UInt32  pcid_thd_mode:1;
        RBus_UInt32  pcid_tab1_xtr_en:1;
        RBus_UInt32  pcid_tab2_xtr_en:1;
    };
}pcid_pcid_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_tab2_r_thd:8;
        RBus_UInt32  pcid_tab2_g_thd:8;
        RBus_UInt32  pcid_tab2_b_thd:8;
        RBus_UInt32  dummy1802ef48_31_24:8;
    };
}pcid_pcid_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line1_even_r_line_select:1;
        RBus_UInt32  line1_even_g_line_select:1;
        RBus_UInt32  line1_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line1_even_r_point_select:2;
        RBus_UInt32  line1_even_g_point_select:2;
        RBus_UInt32  line1_even_b_point_select:2;
        RBus_UInt32  line1_even_r_color_select:2;
        RBus_UInt32  line1_even_g_color_select:2;
        RBus_UInt32  line1_even_b_color_select:2;
        RBus_UInt32  line1_odd_r_line_select:1;
        RBus_UInt32  line1_odd_g_line_select:1;
        RBus_UInt32  line1_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line1_odd_r_point_select:2;
        RBus_UInt32  line1_odd_g_point_select:2;
        RBus_UInt32  line1_odd_b_point_select:2;
        RBus_UInt32  line1_odd_r_color_select:2;
        RBus_UInt32  line1_odd_g_color_select:2;
        RBus_UInt32  line1_odd_b_color_select:2;
    };
}pcid_pcid_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line2_even_r_line_select:1;
        RBus_UInt32  line2_even_g_line_select:1;
        RBus_UInt32  line2_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line2_even_r_point_select:2;
        RBus_UInt32  line2_even_g_point_select:2;
        RBus_UInt32  line2_even_b_point_select:2;
        RBus_UInt32  line2_even_r_color_select:2;
        RBus_UInt32  line2_even_g_color_select:2;
        RBus_UInt32  line2_even_b_color_select:2;
        RBus_UInt32  line2_odd_r_line_select:1;
        RBus_UInt32  line2_odd_g_line_select:1;
        RBus_UInt32  line2_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line2_odd_r_point_select:2;
        RBus_UInt32  line2_odd_g_point_select:2;
        RBus_UInt32  line2_odd_b_point_select:2;
        RBus_UInt32  line2_odd_r_color_select:2;
        RBus_UInt32  line2_odd_g_color_select:2;
        RBus_UInt32  line2_odd_b_color_select:2;
    };
}pcid_pcid_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line3_even_r_line_select:1;
        RBus_UInt32  line3_even_g_line_select:1;
        RBus_UInt32  line3_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line3_even_r_point_select:2;
        RBus_UInt32  line3_even_g_point_select:2;
        RBus_UInt32  line3_even_b_point_select:2;
        RBus_UInt32  line3_even_r_color_select:2;
        RBus_UInt32  line3_even_g_color_select:2;
        RBus_UInt32  line3_even_b_color_select:2;
        RBus_UInt32  line3_odd_r_line_select:1;
        RBus_UInt32  line3_odd_g_line_select:1;
        RBus_UInt32  line3_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line3_odd_r_point_select:2;
        RBus_UInt32  line3_odd_g_point_select:2;
        RBus_UInt32  line3_odd_b_point_select:2;
        RBus_UInt32  line3_odd_r_color_select:2;
        RBus_UInt32  line3_odd_g_color_select:2;
        RBus_UInt32  line3_odd_b_color_select:2;
    };
}pcid_pcid_line_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line4_even_r_line_select:1;
        RBus_UInt32  line4_even_g_line_select:1;
        RBus_UInt32  line4_even_b_line_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  line4_even_r_point_select:2;
        RBus_UInt32  line4_even_g_point_select:2;
        RBus_UInt32  line4_even_b_point_select:2;
        RBus_UInt32  line4_even_r_color_select:2;
        RBus_UInt32  line4_even_g_color_select:2;
        RBus_UInt32  line4_even_b_color_select:2;
        RBus_UInt32  line4_odd_r_line_select:1;
        RBus_UInt32  line4_odd_g_line_select:1;
        RBus_UInt32  line4_odd_b_line_select:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  line4_odd_r_point_select:2;
        RBus_UInt32  line4_odd_g_point_select:2;
        RBus_UInt32  line4_odd_b_point_select:2;
        RBus_UInt32  line4_odd_r_color_select:2;
        RBus_UInt32  line4_odd_g_color_select:2;
        RBus_UInt32  line4_odd_b_color_select:2;
    };
}pcid_pcid_line_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line1:16;
        RBus_UInt32  r_po_line2:16;
    };
}pcid_pcid2_polarity_r_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line3:16;
        RBus_UInt32  r_po_line4:16;
    };
}pcid_pcid2_polarity_r_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line5:16;
        RBus_UInt32  r_po_line6:16;
    };
}pcid_pcid2_polarity_r_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_po_line7:16;
        RBus_UInt32  r_po_line8:16;
    };
}pcid_pcid2_polarity_r_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line1:16;
        RBus_UInt32  g_po_line2:16;
    };
}pcid_pcid2_polarity_g_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line3:16;
        RBus_UInt32  g_po_line4:16;
    };
}pcid_pcid2_polarity_g_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line5:16;
        RBus_UInt32  g_po_line6:16;
    };
}pcid_pcid2_polarity_g_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_po_line7:16;
        RBus_UInt32  g_po_line8:16;
    };
}pcid_pcid2_polarity_g_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line1:16;
        RBus_UInt32  b_po_line2:16;
    };
}pcid_pcid2_polarity_b_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line3:16;
        RBus_UInt32  b_po_line4:16;
    };
}pcid_pcid2_polarity_b_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line5:16;
        RBus_UInt32  b_po_line6:16;
    };
}pcid_pcid2_polarity_b_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_po_line7:16;
        RBus_UInt32  b_po_line8:16;
    };
}pcid_pcid2_polarity_b_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_en:1;
        RBus_UInt32  valc_hpf_clip:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  valc_dbg_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  valc_dbg_region:4;
        RBus_UInt32  dummy1802efa0_31_12:20;
    };
}pcid_pcid_valc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_hpf_w8:4;
        RBus_UInt32  valc_hpf_w9:4;
        RBus_UInt32  valc_hpf_w10:4;
        RBus_UInt32  valc_hpf_w11:4;
        RBus_UInt32  valc_hpf_w12:4;
        RBus_UInt32  valc_hpf_w13:4;
        RBus_UInt32  valc_hpf_w14:4;
        RBus_UInt32  valc_hpf_w15:4;
    };
}pcid_pcid_valc_hpf_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_hpf_w0:4;
        RBus_UInt32  valc_hpf_w1:4;
        RBus_UInt32  valc_hpf_w2:4;
        RBus_UInt32  valc_hpf_w3:4;
        RBus_UInt32  valc_hpf_w4:4;
        RBus_UInt32  valc_hpf_w5:4;
        RBus_UInt32  valc_hpf_w6:4;
        RBus_UInt32  valc_hpf_w7:4;
    };
}pcid_pcid_valc_hpf_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_sat_w8:4;
        RBus_UInt32  valc_sat_w9:4;
        RBus_UInt32  valc_sat_w10:4;
        RBus_UInt32  valc_sat_w11:4;
        RBus_UInt32  valc_sat_w12:4;
        RBus_UInt32  valc_sat_w13:4;
        RBus_UInt32  valc_sat_w14:4;
        RBus_UInt32  valc_sat_w15:4;
    };
}pcid_pcid_valc_sat_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  valc_sat_w0:4;
        RBus_UInt32  valc_sat_w1:4;
        RBus_UInt32  valc_sat_w2:4;
        RBus_UInt32  valc_sat_w3:4;
        RBus_UInt32  valc_sat_w4:4;
        RBus_UInt32  valc_sat_w5:4;
        RBus_UInt32  valc_sat_w6:4;
        RBus_UInt32  valc_sat_w7:4;
    };
}pcid_pcid_valc_sat_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_rm:4;
        RBus_UInt32  pcid_lb_test1:1;
        RBus_UInt32  res1:11;
        RBus_UInt32  pcid_tab_rm_0:4;
        RBus_UInt32  pcid_tab_rm_1:4;
        RBus_UInt32  pcid_tab_rm_2:4;
        RBus_UInt32  pcid_tab_test1_0:1;
        RBus_UInt32  pcid_tab_test1_1:1;
        RBus_UInt32  pcid_tab_test1_2:1;
        RBus_UInt32  res2:1;
    };
}pcid_pcid_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_rme:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  pcid_tab_rme_0:1;
        RBus_UInt32  pcid_tab_rme_1:1;
        RBus_UInt32  pcid_tab_rme_2:1;
        RBus_UInt32  res2:9;
        RBus_UInt32  pcid_lb_ls:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  pcid_tab_ls_0:1;
        RBus_UInt32  pcid_tab_ls_1:1;
        RBus_UInt32  pcid_tab_ls_2:1;
        RBus_UInt32  res4:9;
    };
}pcid_pcid_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lb_bist_fail_0:1;
        RBus_UInt32  lb_bist_fail_1:1;
        RBus_UInt32  tab_bist_fail_0:1;
        RBus_UInt32  tab_bist_fail_1:1;
        RBus_UInt32  tab_bist_fail_2:1;
        RBus_UInt32  tab_bist_fail_3:1;
        RBus_UInt32  tab_bist_fail_4:1;
        RBus_UInt32  tab_bist_fail_5:1;
        RBus_UInt32  tab_bist_fail_6:1;
        RBus_UInt32  tab_bist_fail_7:1;
        RBus_UInt32  tab_bist_fail_8:1;
        RBus_UInt32  tab_bist_fail_9:1;
        RBus_UInt32  tab_bist_fail_10:1;
        RBus_UInt32  tab_bist_fail_11:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  lb_drf_fail_0:1;
        RBus_UInt32  lb_drf_fail_1:1;
        RBus_UInt32  tab_drf_fail_0:1;
        RBus_UInt32  tab_drf_fail_1:1;
        RBus_UInt32  tab_drf_fail_2:1;
        RBus_UInt32  tab_drf_fail_3:1;
        RBus_UInt32  tab_drf_fail_4:1;
        RBus_UInt32  tab_drf_fail_5:1;
        RBus_UInt32  tab_drf_fail_6:1;
        RBus_UInt32  tab_drf_fail_7:1;
        RBus_UInt32  tab_drf_fail_8:1;
        RBus_UInt32  tab_drf_fail_9:1;
        RBus_UInt32  tab_drf_fail_10:1;
        RBus_UInt32  tab_drf_fail_11:1;
        RBus_UInt32  res2:2;
    };
}pcid_pcid_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lb_testrwm:1;
        RBus_UInt32  res1:31;
    };
}pcid_pcid_testrwm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lut_column_addr:6;
        RBus_UInt32  pcid_lut_row_addr:6;
        RBus_UInt32  pcid_lut_sel:2;
        RBus_UInt32  pcid_lut_adr_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  pcid_lut_ax_en:1;
        RBus_UInt32  res2:15;
    };
}pcid_pcid_lut_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcid_lut_data:32;
    };
}pcid_pcid_lut_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_read_en:1;
        RBus_UInt32  access_write_en:1;
        RBus_UInt32  access_cross_bar_en:1;
        RBus_UInt32  access_location_sel:1;
        RBus_UInt32  res1:28;
    };
}pcid_pcid_accessdata_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_startx:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_starty:12;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_accessdata_posctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_write_r:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_r:12;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_accessdata_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_write_g:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_g:12;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_accessdata_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_write_b:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_read_b:12;
        RBus_UInt32  res2:4;
    };
}pcid_pcid_accessdata_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  regional_weight_en:1;
        RBus_UInt32  rw_input_size:1;
        RBus_UInt32  rw_shift_sel:2;
        RBus_UInt32  res1:4;
        RBus_UInt32  rw_start_x:12;
        RBus_UInt32  rw_start_y:12;
    };
}pcid_pcid_regionalweight_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_hor_w0:4;
        RBus_UInt32  rw_hor_w1:4;
        RBus_UInt32  rw_hor_w2:4;
        RBus_UInt32  rw_hor_w3:4;
        RBus_UInt32  rw_hor_w4:4;
        RBus_UInt32  rw_hor_w5:4;
        RBus_UInt32  rw_hor_w6:4;
        RBus_UInt32  rw_hor_w7:4;
    };
}pcid_pcid_regionalweight_hor_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_hor_w8:4;
        RBus_UInt32  rw_hor_w9:4;
        RBus_UInt32  rw_hor_w10:4;
        RBus_UInt32  rw_hor_w11:4;
        RBus_UInt32  rw_hor_w12:4;
        RBus_UInt32  rw_hor_w13:4;
        RBus_UInt32  rw_hor_w14:4;
        RBus_UInt32  rw_hor_w15:4;
    };
}pcid_pcid_regionalweight_hor_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_hor_w16:4;
        RBus_UInt32  rw_hor_w17:4;
        RBus_UInt32  rw_hor_w18:4;
        RBus_UInt32  rw_hor_w19:4;
        RBus_UInt32  rw_hor_w20:4;
        RBus_UInt32  rw_hor_w21:4;
        RBus_UInt32  rw_hor_w22:4;
        RBus_UInt32  rw_hor_w23:4;
    };
}pcid_pcid_regionalweight_hor_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_hor_w24:4;
        RBus_UInt32  res1:28;
    };
}pcid_pcid_regionalweight_hor_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_ver_w0:4;
        RBus_UInt32  rw_ver_w1:4;
        RBus_UInt32  rw_ver_w2:4;
        RBus_UInt32  rw_ver_w3:4;
        RBus_UInt32  rw_ver_w4:4;
        RBus_UInt32  rw_ver_w5:4;
        RBus_UInt32  rw_ver_w6:4;
        RBus_UInt32  rw_ver_w7:4;
    };
}pcid_pcid_regionalweight_ver_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rw_ver_w8:4;
        RBus_UInt32  rw_ver_w9:4;
        RBus_UInt32  res1:24;
    };
}pcid_pcid_regionalweight_ver_1_RBUS;




#endif 


#endif 
