/**
* @file Mac7p_DesignSpec_Vby1
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_VBY1_REG_H_
#define _RBUS_VBY1_REG_H_

#include "rbusTypes.h"



//  VBY1 Register Address



#define  VBY1_VIDEO_FORMAT_VADDR                            	(0xb802d700)
#define  VBY1_LANE_STATUS_VADDR                             	(0xb802d704)
#define  VBY1_CTL_VADDR                                     	(0xb802d708)
#define  VBY1_TRANSMIT_CONTROL_VADDR                        	(0xb802d70c)
#define  VBY1_TRANSMIT_STATUS_VADDR                         	(0xb802d710)
#define  VBY1_THREE_FLAG_VADDR                              	(0xb802d714)
#define  VBY1_CRC_CONTROL_VADDR                             	(0xb802d718)
#define  VBY1_CRC_RESULT_VADDR                              	(0xb802d71c)
#define  VBY1_CRC_DES_VADDR                                 	(0xb802d720)
#define  VBY1_CRC_ERROR_CNT_VADDR                           	(0xb802d724)
#define  VBY1_ASYNC_FIFO_RST_VADDR                          	(0xb802d728)
#define  VBY1_VBY1_DEBUG_VADDR                              	(0xb802d72c)
#define  VBY1_VBY1_STATUS_FW_CTRL_VADDR                     	(0xb802d730)
#define  VBY1_DATA_CAPTURE_VADDR                            	(0xb802d734)
#define  VBY1_DATA_CAPTURE_1_VADDR                          	(0xb802d738)
#define  VBY1_DATA_CAPTURE_2_VADDR                          	(0xb802d73c)
#define  VBY1_DBG_EN_VADDR                                  	(0xb802d750)
#define  VBY1_DBG_DATA_VADDR                                	(0xb802d754)
#define  VBY1_DPHY_CTL_VADDR                                	(0xb802d758)
#define  VBY1_DPHY_RD_VADDR                                 	(0xb802d75c)
#define  VBY1_META_CTL_VADDR                                	(0xb802d774)
#define  VBY1_META_CTL_1_VADDR                              	(0xb802d778)
#define  VBY1_META_DATA_0_VADDR                             	(0xb802d788)
#define  VBY1_META_DATA_1_VADDR                             	(0xb802d78c)
#define  VBY1_META_DATA_2_VADDR                             	(0xb802d790)
#define  VBY1_META_DATA_3_VADDR                             	(0xb802d794)
#define  VBY1_META_DATA_4_VADDR                             	(0xb802d798)
#define  VBY1_META_DATA_5_VADDR                             	(0xb802d79c)
#define  VBY1_META_DATA_6_VADDR                             	(0xb802d7a0)
#define  VBY1_META_DATA_7_VADDR                             	(0xb802d7a4)
#define  VBY1_META_DATA_8_VADDR                             	(0xb802d7a8)
#define  VBY1_META_DATA_9_VADDR                             	(0xb802d7ac)
#define  VBY1_META_DATA_10_VADDR                            	(0xb802d7b0)
#define  VBY1_META_DATA_11_VADDR                            	(0xb802d7b4)
#define  VBY1_META_DATA_12_VADDR                            	(0xb802d7b8)
#define  VBY1_META_DATA_13_VADDR                            	(0xb802d7bc)
#define  VBY1_META_DATA_14_VADDR                            	(0xb802d7c0)
#define  VBY1_META_DATA_15_VADDR                            	(0xb802d7c4)
#define  VBY1_META_DATA_16_VADDR                            	(0xb802d7c8)
#define  VBY1_META_DATA_17_VADDR                            	(0xb802d7cc)
#define  VBY1_META_DATA_18_VADDR                            	(0xb802d7d0)
#define  VBY1_META_DATA_19_VADDR                            	(0xb802d7d4)
#define  VBY1_META_DATA_20_VADDR                            	(0xb802d7d8)
#define  VBY1_META_DATA_21_VADDR                            	(0xb802d7dc)
#define  VBY1_META_DATA_22_VADDR                            	(0xb802d7e0)
#define  VBY1_META_DATA_23_VADDR                            	(0xb802d7e4)
#define  VBY1_META_DATA_24_VADDR                            	(0xb802d7e8)
#define  VBY1_META_DATA_25_VADDR                            	(0xb802d7ec)
#define  VBY1_META_DATA_26_VADDR                            	(0xb802d7f0)
#define  VBY1_META_DATA_27_VADDR                            	(0xb802d7f4)
#define  VBY1_META_DATA_28_VADDR                            	(0xb802d7f8)
#define  VBY1_META_DATA_29_VADDR                            	(0xb802d7fc)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======VBY1 register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  vby1_aphy0_7_in_sel:2;
        RBus_UInt32  vby1_aphy8_15_in_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  lclk_inv_sel:1;
        RBus_UInt32  vby1_dclk_div_sel:3;
        RBus_UInt32  color_format:4;
        RBus_UInt32  res3:6;
        RBus_UInt32  win:10;
    };
}vby1_video_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  lane_count:5;
        RBus_UInt32  res2:13;
        RBus_UInt32  byte_mode:3;
    };
}vby1_lane_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctl:16;
    };
}vby1_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_en:1;
        RBus_UInt32  pll_stable:1;
        RBus_UInt32  transfer_en:1;
        RBus_UInt32  video_trans_mode:1;
        RBus_UInt32  debounce_cnt:4;
        RBus_UInt32  bs_after_aln:1;
        RBus_UInt32  be_before_aln:1;
        RBus_UInt32  reg_delay:22;
    };
}vby1_transmit_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d710_31_8:24;
        RBus_UInt32  res1:2;
        RBus_UInt32  aln_finish:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  video_en:1;
        RBus_UInt32  aln_en:1;
        RBus_UInt32  cdr_en:1;
    };
}vby1_transmit_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  three_mode:2;
        RBus_UInt32  three_en:1;
    };
}vby1_three_flag_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  lane_crc_en:8;
        RBus_UInt32  res2:13;
        RBus_UInt32  reg_crc_auto_cmp_en:1;
        RBus_UInt32  reg_crc_conti:1;
        RBus_UInt32  reg_crc_start:1;
    };
}vby1_crc_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}vby1_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_crc_des:32;
    };
}vby1_crc_des_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  crc_err_cnt:16;
    };
}vby1_crc_error_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  fifo_vs_rst_en:2;
        RBus_UInt32  fifo_vs_rst_delay:16;
    };
}vby1_async_fifo_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  dummy1802d72c_3_0:4;
    };
}vby1_vby1_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  htpdn_mode_ctrl:1;
        RBus_UInt32  lockn_mode_ctrl:1;
        RBus_UInt32  fw_htpdn_set:1;
        RBus_UInt32  fw_lockn_set:1;
        RBus_UInt32  htpdn_ie:1;
        RBus_UInt32  lockn_ie:1;
        RBus_UInt32  htpdn_int_status:1;
        RBus_UInt32  lockn_int_status:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  vs_inv:1;
        RBus_UInt32  hs_inv:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  de_only_mode_vs_set:1;
        RBus_UInt32  de_only_mode_hs_set:1;
        RBus_UInt32  de_only_mode:1;
        RBus_UInt32  res3:9;
        RBus_UInt32  metadata_end:1;
        RBus_UInt32  metadata_end_ie:1;
        RBus_UInt32  metadata_end_int_status:1;
        RBus_UInt32  htpdn:1;
        RBus_UInt32  lockn:1;
        RBus_UInt32  hw_htpdn:1;
        RBus_UInt32  hw_lockn:1;
    };
}vby1_vby1_status_fw_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  capture_lane_sel:4;
        RBus_UInt32  capture_active_only:1;
        RBus_UInt32  capture_v:11;
        RBus_UInt32  capture_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  capture_h:13;
    };
}vby1_data_capture_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dummy1802d738_7_0:8;
    };
}vby1_data_capture_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  capture_data_l:32;
    };
}vby1_data_capture_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  dbg_en:1;
    };
}vby1_dbg_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_data:32;
    };
}vby1_dbg_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  e8b10b_en:1;
        RBus_UInt32  e8b10b_initial_running_disparity:1;
        RBus_UInt32  e8b10b_dis_i:1;
        RBus_UInt32  e8b10b_dis_j:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  scr_sel:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  scramble_en:1;
        RBus_UInt32  scramble_initial_value:16;
    };
}vby1_dphy_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  e8b10b_running_disparity:8;
    };
}vby1_dphy_rd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  meta_en:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  meta_start:20;
    };
}vby1_meta_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  meta_sel:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  meta_end:20;
    };
}vby1_meta_ctl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data0:16;
    };
}vby1_meta_data_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data1:16;
    };
}vby1_meta_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data2:16;
    };
}vby1_meta_data_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data3:16;
    };
}vby1_meta_data_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data4:16;
    };
}vby1_meta_data_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data5:16;
    };
}vby1_meta_data_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data6:16;
    };
}vby1_meta_data_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data7:16;
    };
}vby1_meta_data_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data8:16;
    };
}vby1_meta_data_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data9:16;
    };
}vby1_meta_data_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data10:16;
    };
}vby1_meta_data_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data11:16;
    };
}vby1_meta_data_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data12:16;
    };
}vby1_meta_data_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data13:16;
    };
}vby1_meta_data_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data14:16;
    };
}vby1_meta_data_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data15:16;
    };
}vby1_meta_data_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data16:16;
    };
}vby1_meta_data_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data17:16;
    };
}vby1_meta_data_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data18:16;
    };
}vby1_meta_data_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data19:16;
    };
}vby1_meta_data_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data20:16;
    };
}vby1_meta_data_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data21:16;
    };
}vby1_meta_data_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data22:16;
    };
}vby1_meta_data_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data23:16;
    };
}vby1_meta_data_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data24:16;
    };
}vby1_meta_data_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data25:16;
    };
}vby1_meta_data_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data26:16;
    };
}vby1_meta_data_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data27:16;
    };
}vby1_meta_data_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data28:16;
    };
}vby1_meta_data_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  meta_data29:16;
    };
}vby1_meta_data_29_RBUS;

#else //apply LITTLE_ENDIAN

//======VBY1 register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  win:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  color_format:4;
        RBus_UInt32  vby1_dclk_div_sel:3;
        RBus_UInt32  lclk_inv_sel:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  vby1_aphy8_15_in_sel:2;
        RBus_UInt32  vby1_aphy0_7_in_sel:2;
        RBus_UInt32  res3:2;
    };
}vby1_video_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  byte_mode:3;
        RBus_UInt32  res1:13;
        RBus_UInt32  lane_count:5;
        RBus_UInt32  res2:11;
    };
}vby1_lane_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctl:16;
        RBus_UInt32  res1:16;
    };
}vby1_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_delay:22;
        RBus_UInt32  be_before_aln:1;
        RBus_UInt32  bs_after_aln:1;
        RBus_UInt32  debounce_cnt:4;
        RBus_UInt32  video_trans_mode:1;
        RBus_UInt32  transfer_en:1;
        RBus_UInt32  pll_stable:1;
        RBus_UInt32  reg_en:1;
    };
}vby1_transmit_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cdr_en:1;
        RBus_UInt32  aln_en:1;
        RBus_UInt32  video_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  aln_finish:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  dummy1802d710_31_8:24;
    };
}vby1_transmit_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  three_en:1;
        RBus_UInt32  three_mode:2;
        RBus_UInt32  res1:29;
    };
}vby1_three_flag_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_crc_start:1;
        RBus_UInt32  reg_crc_conti:1;
        RBus_UInt32  reg_crc_auto_cmp_en:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  lane_crc_en:8;
        RBus_UInt32  res2:8;
    };
}vby1_crc_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}vby1_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_crc_des:32;
    };
}vby1_crc_des_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_err_cnt:16;
        RBus_UInt32  res1:16;
    };
}vby1_crc_error_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_vs_rst_delay:16;
        RBus_UInt32  fifo_vs_rst_en:2;
        RBus_UInt32  res1:14;
    };
}vby1_async_fifo_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d72c_3_0:4;
        RBus_UInt32  res1:28;
    };
}vby1_vby1_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hw_lockn:1;
        RBus_UInt32  hw_htpdn:1;
        RBus_UInt32  lockn:1;
        RBus_UInt32  htpdn:1;
        RBus_UInt32  metadata_end_int_status:1;
        RBus_UInt32  metadata_end_ie:1;
        RBus_UInt32  metadata_end:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  de_only_mode:1;
        RBus_UInt32  de_only_mode_hs_set:1;
        RBus_UInt32  de_only_mode_vs_set:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  hs_inv:1;
        RBus_UInt32  vs_inv:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  lockn_int_status:1;
        RBus_UInt32  htpdn_int_status:1;
        RBus_UInt32  lockn_ie:1;
        RBus_UInt32  htpdn_ie:1;
        RBus_UInt32  fw_lockn_set:1;
        RBus_UInt32  fw_htpdn_set:1;
        RBus_UInt32  lockn_mode_ctrl:1;
        RBus_UInt32  htpdn_mode_ctrl:1;
    };
}vby1_vby1_status_fw_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  capture_h:13;
        RBus_UInt32  res1:2;
        RBus_UInt32  capture_en:1;
        RBus_UInt32  capture_v:11;
        RBus_UInt32  capture_active_only:1;
        RBus_UInt32  capture_lane_sel:4;
    };
}vby1_data_capture_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d738_7_0:8;
        RBus_UInt32  res1:24;
    };
}vby1_data_capture_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  capture_data_l:32;
    };
}vby1_data_capture_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_en:1;
        RBus_UInt32  res1:31;
    };
}vby1_dbg_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_data:32;
    };
}vby1_dbg_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scramble_initial_value:16;
        RBus_UInt32  scramble_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  scr_sel:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  e8b10b_dis_j:1;
        RBus_UInt32  e8b10b_dis_i:1;
        RBus_UInt32  e8b10b_initial_running_disparity:1;
        RBus_UInt32  e8b10b_en:1;
    };
}vby1_dphy_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  e8b10b_running_disparity:8;
        RBus_UInt32  res1:24;
    };
}vby1_dphy_rd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_start:20;
        RBus_UInt32  res1:8;
        RBus_UInt32  meta_en:1;
        RBus_UInt32  res2:3;
    };
}vby1_meta_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_end:20;
        RBus_UInt32  res1:8;
        RBus_UInt32  meta_sel:1;
        RBus_UInt32  res2:3;
    };
}vby1_meta_ctl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data0:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data1:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data2:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data3:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data4:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data5:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data6:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data7:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data8:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data9:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data10:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data11:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data12:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data13:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data14:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data15:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data16:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data17:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data18:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data19:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data20:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data21:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data22:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data23:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data24:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data25:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data26:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data27:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data28:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  meta_data29:16;
        RBus_UInt32  res1:16;
    };
}vby1_meta_data_29_RBUS;




#endif 


#endif 
