/**
* @file rbusDemuraReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DEMURA_REG_H_
#define _RBUS_DEMURA_REG_H_

#include "rbusTypes.h"



//  DEMURA Register Address



#define  DEMURA_DEMURA_CONTROL_VADDR                        	(0xb802eb00)
#define  DEMURA_DEMURA_R_PLANE_1_CONTROL_VADDR              	(0xb802eb04)
#define  DEMURA_DEMURA_R_PLANE_2_CONTROL_VADDR              	(0xb802eb08)
#define  DEMURA_DEMURA_R_PLANE_3_CONTROL_VADDR              	(0xb802eb0c)
#define  DEMURA_DEMURA_R_PLANE_4_CONTROL_VADDR              	(0xb802eb10)
#define  DEMURA_DEMURA_R_PLANE_5_CONTROL_VADDR              	(0xb802eb14)
#define  DEMURA_DEMURA_G_PLANE_1_CONTROL_VADDR              	(0xb802eb20)
#define  DEMURA_DEMURA_G_PLANE_2_CONTROL_VADDR              	(0xb802eb24)
#define  DEMURA_DEMURA_G_PLANE_3_CONTROL_VADDR              	(0xb802eb28)
#define  DEMURA_DEMURA_G_PLANE_4_CONTROL_VADDR              	(0xb802eb2c)
#define  DEMURA_DEMURA_G_PLANE_5_CONTROL_VADDR              	(0xb802eb30)
#define  DEMURA_DEMURA_B_PLANE_1_CONTROL_VADDR              	(0xb802eb40)
#define  DEMURA_DEMURA_B_PLANE_2_CONTROL_VADDR              	(0xb802eb44)
#define  DEMURA_DEMURA_B_PLANE_3_CONTROL_VADDR              	(0xb802eb48)
#define  DEMURA_DEMURA_B_PLANE_4_CONTROL_VADDR              	(0xb802eb4c)
#define  DEMURA_DEMURA_B_PLANE_5_CONTROL_VADDR              	(0xb802eb50)
#define  DEMURA_DEMURA_DMA_CTRL_1_VADDR                     	(0xb802eb60)
#define  DEMURA_DEMURA_DMA_CTRL_2_VADDR                     	(0xb802eb64)
#define  DEMURA_DEMURA_DMA_LINE_STEP_VADDR                  	(0xb802eb68)
#define  DEMURA_DEMURA_DMA_START_ADDR_VADDR                 	(0xb802eb6c)
#define  DEMURA_DEMURA_DMA_STATUS_VADDR                     	(0xb802eb70)
#define  DEMURA_DEMURA_DMA_BIST_1_VADDR                     	(0xb802eb74)
#define  DEMURA_DEMURA_DMA_BIST_2_VADDR                     	(0xb802eb78)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DEMURA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802eb00_31_6:26;
        RBus_UInt32  demura_table_scale:2;
        RBus_UInt32  demura_block_size:2;
        RBus_UInt32  demura_rgb_table_seperate:1;
        RBus_UInt32  demura_en:1;
    };
}demura_demura_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_r_upper_cutoff:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_r_lower_cutoff:10;
    };
}demura_demura_r_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_r_m_level:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_r_l_level:10;
    };
}demura_demura_r_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  demura_r_h_level:10;
    };
}demura_demura_r_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_div_factor_l_m:16;
        RBus_UInt32  r_div_factor_l:16;
    };
}demura_demura_r_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_div_factor_h:16;
        RBus_UInt32  r_div_factor_m_h:16;
    };
}demura_demura_r_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_g_upper_cutoff:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_g_lower_cutoff:10;
    };
}demura_demura_g_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_g_m_level:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_g_l_level:10;
    };
}demura_demura_g_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  demura_g_h_level:10;
    };
}demura_demura_g_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_div_factor_l_m:16;
        RBus_UInt32  g_div_factor_l:16;
    };
}demura_demura_g_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_div_factor_h:16;
        RBus_UInt32  g_div_factor_m_h:16;
    };
}demura_demura_g_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_b_upper_cutoff:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_b_lower_cutoff:10;
    };
}demura_demura_b_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_b_m_level:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_b_l_level:10;
    };
}demura_demura_b_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  demura_b_h_level:10;
    };
}demura_demura_b_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_div_factor_l_m:16;
        RBus_UInt32  b_div_factor_l:16;
    };
}demura_demura_b_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_div_factor_h:16;
        RBus_UInt32  b_div_factor_m_h:16;
    };
}demura_demura_b_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_read_burst_num:8;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_read_len:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  dma_read_rem:7;
        RBus_UInt32  res3:2;
        RBus_UInt32  water_lv:6;
    };
}demura_demura_dma_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  table_width:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  table_height:9;
    };
}demura_demura_dma_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line_step:29;
        RBus_UInt32  res1:3;
    };
}demura_demura_dma_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  start_addr:29;
        RBus_UInt32  res1:3;
    };
}demura_demura_dma_start_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  fifo_clr:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  fifo_full:1;
        RBus_UInt32  fifo_empty:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  fifo_underflow:1;
    };
}demura_demura_dma_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  ls_dma_fifo:1;
        RBus_UInt32  ls_r1:1;
        RBus_UInt32  ls_g1:1;
        RBus_UInt32  ls_b1:1;
        RBus_UInt32  ls_r0:1;
        RBus_UInt32  ls_g0:1;
        RBus_UInt32  ls_b0:1;
        RBus_UInt32  res2:11;
        RBus_UInt32  rme:1;
        RBus_UInt32  rm:4;
    };
}demura_demura_dma_bist_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  demura_dma_fifo_drf_bist_fail:1;
        RBus_UInt32  demura_r1_drf_bist_fail:1;
        RBus_UInt32  demura_g1_drf_bist_fail:1;
        RBus_UInt32  demura_b1_drf_bist_fail:1;
        RBus_UInt32  demura_r0_drf_bist_fail:1;
        RBus_UInt32  demura_g0_drf_bist_fail:1;
        RBus_UInt32  demura_b0_drf_bist_fail:1;
        RBus_UInt32  res2:9;
        RBus_UInt32  demura_dma_fifo_bist_fail:1;
        RBus_UInt32  demura_r1_bist_fail:1;
        RBus_UInt32  demura_g1_bist_fail:1;
        RBus_UInt32  demura_b1_bist_fail:1;
        RBus_UInt32  demura_r0_bist_fail:1;
        RBus_UInt32  demura_g0_bist_fail:1;
        RBus_UInt32  demura_b0_bist_fail:1;
    };
}demura_demura_dma_bist_2_RBUS;

#else //apply LITTLE_ENDIAN

//======DEMURA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_en:1;
        RBus_UInt32  demura_rgb_table_seperate:1;
        RBus_UInt32  demura_block_size:2;
        RBus_UInt32  demura_table_scale:2;
        RBus_UInt32  dummy1802eb00_31:26;
    };
}demura_demura_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_r_lower_cutoff:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_r_upper_cutoff:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_r_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_r_l_level:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_r_m_level:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_r_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_r_h_level:10;
        RBus_UInt32  res1:22;
    };
}demura_demura_r_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_div_factor_l:16;
        RBus_UInt32  r_div_factor_l_m:16;
    };
}demura_demura_r_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_div_factor_m_h:16;
        RBus_UInt32  r_div_factor_h:16;
    };
}demura_demura_r_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_g_lower_cutoff:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_g_upper_cutoff:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_g_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_g_l_level:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_g_m_level:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_g_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_g_h_level:10;
        RBus_UInt32  res1:22;
    };
}demura_demura_g_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_div_factor_l:16;
        RBus_UInt32  g_div_factor_l_m:16;
    };
}demura_demura_g_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_div_factor_m_h:16;
        RBus_UInt32  g_div_factor_h:16;
    };
}demura_demura_g_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_b_lower_cutoff:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_b_upper_cutoff:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_b_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_b_l_level:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_b_m_level:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_b_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_b_h_level:10;
        RBus_UInt32  res1:22;
    };
}demura_demura_b_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_div_factor_l:16;
        RBus_UInt32  b_div_factor_l_m:16;
    };
}demura_demura_b_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_div_factor_m_h:16;
        RBus_UInt32  b_div_factor_h:16;
    };
}demura_demura_b_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  water_lv:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_read_rem:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  dma_read_len:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  dma_read_burst_num:8;
    };
}demura_demura_dma_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  table_height:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  table_width:9;
        RBus_UInt32  res2:7;
    };
}demura_demura_dma_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  line_step:29;
    };
}demura_demura_dma_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  start_addr:29;
    };
}demura_demura_dma_start_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_underflow:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  fifo_empty:1;
        RBus_UInt32  fifo_full:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  fifo_clr:1;
        RBus_UInt32  res3:23;
    };
}demura_demura_dma_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm:4;
        RBus_UInt32  rme:1;
        RBus_UInt32  res1:11;
        RBus_UInt32  ls_b0:1;
        RBus_UInt32  ls_g0:1;
        RBus_UInt32  ls_r0:1;
        RBus_UInt32  ls_b1:1;
        RBus_UInt32  ls_g1:1;
        RBus_UInt32  ls_r1:1;
        RBus_UInt32  ls_dma_fifo:1;
        RBus_UInt32  res2:9;
    };
}demura_demura_dma_bist_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_b0_bist_fail:1;
        RBus_UInt32  demura_g0_bist_fail:1;
        RBus_UInt32  demura_r0_bist_fail:1;
        RBus_UInt32  demura_b1_bist_fail:1;
        RBus_UInt32  demura_g1_bist_fail:1;
        RBus_UInt32  demura_r1_bist_fail:1;
        RBus_UInt32  demura_dma_fifo_bist_fail:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  demura_b0_drf_bist_fail:1;
        RBus_UInt32  demura_g0_drf_bist_fail:1;
        RBus_UInt32  demura_r0_drf_bist_fail:1;
        RBus_UInt32  demura_b1_drf_bist_fail:1;
        RBus_UInt32  demura_g1_drf_bist_fail:1;
        RBus_UInt32  demura_r1_drf_bist_fail:1;
        RBus_UInt32  demura_dma_fifo_drf_bist_fail:1;
        RBus_UInt32  res2:9;
    };
}demura_demura_dma_bist_2_RBUS;




#endif 


#endif 
