/**
* @file rbusSfgReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SFG_REG_H_
#define _RBUS_SFG_REG_H_

#include "rbusTypes.h"



//  SFG Register Address



#define  SFG_SFG_ZZ_SHIFT_DBG_CTRL_VADDR                    	(0xb802d900)
#define  SFG_SFG_SWAP_CTRL0_VADDR                           	(0xb802d904)
#define  SFG_SFG_CRC_CTRL_VADDR                             	(0xb802d910)
#define  SFG_SFG_CRC_RESULT_VADDR                           	(0xb802d914)
#define  SFG_SFG_CRC_R_RESULT_VADDR                         	(0xb802d918)
#define  SFG_SFG_L_DES_CRC_VADDR                            	(0xb802d91c)
#define  SFG_SFG_R_DES_CRC_VADDR                            	(0xb802d920)
#define  SFG_SFG_CRC_ERR_CNT_VADDR                          	(0xb802d924)
#define  SFG_SFG_FORCE_BG_AT_DIF_VADDR                      	(0xb802d928)
#define  SFG_ZZ_CTRL_VADDR                                  	(0xb802d92c)
#define  SFG_SFG_DUMMY_CTRL_0A_VADDR                        	(0xb802d930)
#define  SFG_SFG_DUMMY_CTRL_0B_VADDR                        	(0xb802d934)
#define  SFG_SFG_DUMMY_CTRL_1A_VADDR                        	(0xb802d938)
#define  SFG_SFG_DUMMY_CTRL_1B_VADDR                        	(0xb802d940)
#define  SFG_SFG_DUMMY_CTRL_8_VADDR                         	(0xb802d944)
#define  SFG_SFG_DUMMY_CTRL_10_VADDR                        	(0xb802d948)
#define  SFG_SFG_DUMMY_CTRL_12_VADDR                        	(0xb802d94c)
#define  SFG_SFG_DUMMY_CTRL_14_VADDR                        	(0xb802d950)
#define  SFG_SFG_CTRL_0_VADDR                               	(0xb802d964)
#define  SFG_SFG_CTRL_1_VADDR                               	(0xb802d968)
#define  SFG_SFG_CTRL_2_VADDR                               	(0xb802d96c)
#define  SFG_SFG_CTRL_3_VADDR                               	(0xb802d970)
#define  SFG_SFG_CTRL_4_VADDR                               	(0xb802d974)
#define  SFG_SFG_START_CTRL_8_VADDR                         	(0xb802d978)
#define  SFG_SFG_START_CTRL_10_VADDR                        	(0xb802d97c)
#define  SFG_SFG_START_CTRL_12_VADDR                        	(0xb802d980)
#define  SFG_SFG_START_CTRL_14_VADDR                        	(0xb802d984)
#define  SFG_SFG_CTRL_6_VADDR                               	(0xb802d988)
#define  SFG_SFG_CTRL_7_VADDR                               	(0xb802d98c)
#define  SFG_SFG_CTRL_8_VADDR                               	(0xb802d990)
#define  SFG_SFG_CTRL_9_VADDR                               	(0xb802d994)
#define  SFG_SFG_CTRL_5_VADDR                               	(0xb802d998)
#define  SFG_SFG_CTRL_A_VADDR                               	(0xb802d99c)
#define  SFG_SFG_CTRL_B_VADDR                               	(0xb802d9a0)
#define  SFG_SFG_CTRL_C_VADDR                               	(0xb802d9a4)
#define  SFG_SFG_TG_AUTO_1_VADDR                            	(0xb802d9a8)
#define  SFG_SFG_TG_AUTO_2_VADDR                            	(0xb802d9ac)
#define  SFG_SFG_TG_AUTO_3_VADDR                            	(0xb802d9b0)
#define  SFG_SFG_TG_AUTO_4_VADDR                            	(0xb802d9b4)
#define  SFG_SFG_DUMMY_VADDR                                	(0xb802d9b8)
#define  SFG_SFG_BISR_SECOND_RUN_VADDR                      	(0xb802d9bc)
#define  SFG_SFG_BISR_DONE_VADDR                            	(0xb802d9c0)
#define  SFG_SFG_BISR_FAIL_GROUP_VADDR                      	(0xb802d9c4)
#define  SFG_SFG_BISR_FAIL_VADDR                            	(0xb802d9c8)
#define  SFG_SFG_DRF_MODE_VADDR                             	(0xb802d9cc)
#define  SFG_SFG_DRF_RESUME_VADDR                           	(0xb802d9d0)
#define  SFG_SFG_DRF_DONE_VADDR                             	(0xb802d9d4)
#define  SFG_SFG_DRF_PAUSE_VADDR                            	(0xb802d9d8)
#define  SFG_SFG_DRF_FAIL_GROUP_VADDR                       	(0xb802d9dc)
#define  SFG_SFG_DRF_FAI_VADDR                              	(0xb802d9e0)
#define  SFG_SFG_BIST_OTHER_VADDR                           	(0xb802d9e4)
#define  SFG_SFG_MID_DUMMY_0_VADDR                          	(0xb802d9e8)
#define  SFG_SFG_MID_DUMMY_1_VADDR                          	(0xb802d9ec)
#define  SFG_SFG_MID_DUMMY_2_VADDR                          	(0xb802d9f0)
#define  SFG_SFG_MID_DUMMY_3_VADDR                          	(0xb802d9f4)
#define  SFG_SFG_MID_DUMMY_8_VADDR                          	(0xb802d9f8)
#define  SFG_SFG_MID_DUMMY_10_VADDR                         	(0xb802d9fc)
#define  SFG_SFG_MID_DUMMY_12_VADDR                         	(0xb802da00)
#define  SFG_SFG_MID_DUMMY_14_VADDR                         	(0xb802da04)
#define  SFG_SFG_DATA_AFTER_DEN_VADDR                       	(0xb802da08)
#define  SFG_SFG_INSERT_SUBPIXEL_0_VADDR                    	(0xb802da0c)
#define  SFG_SFG_INSERT_SUBPIXEL_1_VADDR                    	(0xb802da10)
#define  SFG_SFG_INSERT_SUBPIXEL_2_VADDR                    	(0xb802da14)
#define  SFG_SFG_INSERT_SUBPIXEL_3_VADDR                    	(0xb802da18)
#define  SFG_SFG_CTRL_10_VADDR                              	(0xb802da1c)
#define  SFG_SFG_LAST_EXT_PIXEL_LAST_FLIP_VADDR             	(0xb802da20)
#define  SFG_SFG2_CTRL_0_VADDR                              	(0xb802da30)
#define  SFG_SFG2_STA_0_VADDR                               	(0xb802da34)
#define  SFG_SFG2_STA_1_VADDR                               	(0xb802da38)
#define  SFG_SFG2_STA_2_VADDR                               	(0xb802da3c)
#define  SFG_SFG2_STA_3_VADDR                               	(0xb802da40)
#define  SFG_SFG2_PORT_SWAP_VADDR                           	(0xb802da44)
#define  SFG_SFG2_FORCE_0_VADDR                             	(0xb802da48)
#define  SFG_SFG2_FORCE_1_VADDR                             	(0xb802da4c)
#define  SFG_SFG2_CRC_CTRL_VADDR                            	(0xb802da50)
#define  SFG_SFG2_CRC_RESULT_VADDR                          	(0xb802da54)
#define  SFG_SFG2_CRC_R_RESULT_VADDR                        	(0xb802da58)
#define  SFG_SFG2_CRC_L_DES_CRC_VADDR                       	(0xb802da5c)
#define  SFG_SFG2_CRC_R_DES_CRC_VADDR                       	(0xb802da60)
#define  SFG_SFG2_CRC_ERR_CNT_VADDR                         	(0xb802da64)
#define  SFG_SFG2_TIME_CTRL_0_VADDR                         	(0xb802da68)
#define  SFG_SFG2_TIME_CTRL_1_VADDR                         	(0xb802da6c)
#define  SFG_SFG2_TIME_CTRL_2_VADDR                         	(0xb802da70)
#define  SFG_SFG2_DEN_CTRL_VADDR                            	(0xb802da74)
#define  SFG_SFG2_TIME_CTRL_AUTO_0_VADDR                    	(0xb802da78)
#define  SFG_SFG2_TIME_CTRL_AUTO_1_VADDR                    	(0xb802da7c)
#define  SFG_SFG2_TIME_CTRL_AUTO_2_VADDR                    	(0xb802da80)
#define  SFG_SFG_DEBUG_VADDR                                	(0xb802da84)
#define  SFG_SFG_DATA_CAPTURE_VH_VADDR                      	(0xb802da88)
#define  SFG_SFG_DATA_CAPTURE_SRC_VADDR                     	(0xb802da8c)
#define  SFG_SFG_DATA_CAPTURE_READ_DATA_VADDR               	(0xb802da90)
#define  SFG_SFG_LAST_SEG_0_VADDR                           	(0xb802da94)
#define  SFG_SFG_LAST_SEG_1_VADDR                           	(0xb802da98)
#define  SFG_SFG_DRD_CTRL_0_VADDR                           	(0xb802daa0)
#define  SFG_SFG_DRD_CTRL_1_VADDR                           	(0xb802daa4)
#define  SFG_SFG_DRD_CTRL_2_VADDR                           	(0xb802daa8)
#define  SFG_SFG_DRD_CTRL_6_VADDR                           	(0xb802daac)
#define  SFG_SFG_DRD_CTRL_7_VADDR                           	(0xb802dab0)
#define  SFG_SFG_DRD_CTRL_8_VADDR                           	(0xb802dab4)
#define  SFG_SFG_DRD_CTRL_12_VADDR                          	(0xb802dab8)
#define  SFG_SFG_DRD_CTRL_13_VADDR                          	(0xb802dabc)
#define  SFG_SFG_DRD_CTRL_14_VADDR                          	(0xb802dac0)
#define  SFG_SFG_DRD_CTRL_18_VADDR                          	(0xb802dac4)
#define  SFG_SFG_DRD_CTRL_19_VADDR                          	(0xb802dac8)
#define  SFG_SFG_DRD_CTRL_20_VADDR                          	(0xb802dacc)
#define  SFG_SFG_DRD_CTRL_3_VADDR                           	(0xb802dad0)
#define  SFG_SFG_DRD_CTRL_4_VADDR                           	(0xb802dad4)
#define  SFG_SFG_DRD_CTRL_5_VADDR                           	(0xb802dad8)
#define  SFG_SFG_DRD_CTRL_9_VADDR                           	(0xb802dadc)
#define  SFG_SFG_DRD_CTRL_10_VADDR                          	(0xb802dae0)
#define  SFG_SFG_DRD_CTRL_11_VADDR                          	(0xb802dae4)
#define  SFG_SFG_DRD_CTRL_15_VADDR                          	(0xb802dae8)
#define  SFG_SFG_DRD_CTRL_16_VADDR                          	(0xb802daec)
#define  SFG_SFG_DRD_CTRL_17_VADDR                          	(0xb802daf0)
#define  SFG_SFG_DRD_CTRL_21_VADDR                          	(0xb802daf4)
#define  SFG_SFG_DRD_CTRL_22_VADDR                          	(0xb802daf8)
#define  SFG_SFG_DRD_CTRL_23_VADDR                          	(0xb802dafc)
#define  SFG_SFG_SWAP_CTRL1_VADDR                           	(0xb802db00)
#define  SFG_SFG_SWAP_CTRL2_VADDR                           	(0xb802db04)
#define  SFG_SFG_SWAP_CTRL3_VADDR                           	(0xb802db08)
#define  SFG_SFG_SWAP_CTRL4_VADDR                           	(0xb802db0c)
#define  SFG_SFG_SWAP_CTRL5_VADDR                           	(0xb802db10)
#define  SFG_SFG_SWAP_CTRL6_VADDR                           	(0xb802db14)
#define  SFG_SFG_DUMMY_CTRL_16_VADDR                        	(0xb802db18)
#define  SFG_SFG_DUMMY_CTRL_18_VADDR                        	(0xb802db1c)
#define  SFG_SFG_DUMMY_CTRL_20_VADDR                        	(0xb802db20)
#define  SFG_SFG_DUMMY_CTRL_22_VADDR                        	(0xb802db24)
#define  SFG_SFG_START_CTRL_16_VADDR                        	(0xb802db28)
#define  SFG_SFG_START_CTRL_18_VADDR                        	(0xb802db2c)
#define  SFG_SFG_START_CTRL_20_VADDR                        	(0xb802db30)
#define  SFG_SFG_START_CTRL_22_VADDR                        	(0xb802db34)
#define  SFG_SFG_MID_DUMMY_16_VADDR                         	(0xb802db38)
#define  SFG_SFG_MID_DUMMY_18_VADDR                         	(0xb802db3c)
#define  SFG_SFG_MID_DUMMY_20_VADDR                         	(0xb802db40)
#define  SFG_SFG_MID_DUMMY_22_VADDR                         	(0xb802db44)
#define  SFG_SFG2_DATA_SEL_0_VADDR                          	(0xb802db48)
#define  SFG_SFG2_DATA_SEL_1_VADDR                          	(0xb802db4c)
#define  SFG_SFG2_DATA_SEL_2_VADDR                          	(0xb802db50)
#define  SFG_SFG2_DATA_SEL_3_VADDR                          	(0xb802db54)
#define  SFG_SFG2_DATA_SEL_4_VADDR                          	(0xb802db58)
#define  SFG_SFG2_DATA_SEL_5_VADDR                          	(0xb802db5c)
#define  SFG_SFG2_DATA_SEL_6_VADDR                          	(0xb802db60)
#define  SFG_SFG2_DATA_SEL_7_VADDR                          	(0xb802db64)
#define  SFG_SFG1_EXT_SUBPIXEL_LINE_0_VADDR                 	(0xb802db68)
#define  SFG_SFG1_EXT_SUBPIXEL_LINE_1_VADDR                 	(0xb802db6c)
#define  SFG_SFG1_EXT_SUBPIXEL_LINE_2_VADDR                 	(0xb802db70)
#define  SFG_SFG1_EXT_SUBPIXEL_LINE_3_VADDR                 	(0xb802db74)
#define  SFG_SFG1_DUM_DATA_LINE_0_VADDR                     	(0xb802db78)
#define  SFG_SFG1_DUM_DATA_LINE_1_VADDR                     	(0xb802db7c)
#define  SFG_SFG1_DUM_DATA_LINE_2_VADDR                     	(0xb802db80)
#define  SFG_SFG1_DUM_DATA_LINE_3_VADDR                     	(0xb802db84)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SFG register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  macclk_inv:1;
        RBus_UInt32  pif_clk_sel:1;
        RBus_UInt32  dout_pre_rb_swap:1;
        RBus_UInt32  dispd_debug_mode:3;
        RBus_UInt32  dout_mode:2;
        RBus_UInt32  sfg_dout_en:1;
        RBus_UInt32  dvs_inv:1;
        RBus_UInt32  dhs_inv:1;
        RBus_UInt32  dden_inv:1;
        RBus_UInt32  daclk_inv:1;
        RBus_UInt32  daclk_en:1;
        RBus_UInt32  dout_rb_swap:1;
        RBus_UInt32  dout_bit_swap:1;
        RBus_UInt32  dout_data_inv:1;
        RBus_UInt32  dclk_dly_sel:3;
    };
}sfg_sfg_zz_shift_dbg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dclk_mode_switch:5;
        RBus_UInt32  force_bg_dif_aport:1;
        RBus_UInt32  force_bg_dif_bport:1;
        RBus_UInt32  force_bg_dif_cport:1;
        RBus_UInt32  force_bg_dif_dport:1;
        RBus_UInt32  force_bg_dif_eport:1;
        RBus_UInt32  force_bg_dif_fport:1;
        RBus_UInt32  force_bg_dif_gport:1;
        RBus_UInt32  force_bg_dif_hport:1;
        RBus_UInt32  force_bg_dif_iport:1;
        RBus_UInt32  force_bg_dif_jport:1;
        RBus_UInt32  force_bg_dif_kport:1;
        RBus_UInt32  force_bg_dif_lport:1;
        RBus_UInt32  force_bg_dif_mport:1;
        RBus_UInt32  force_bg_dif_nport:1;
        RBus_UInt32  force_bg_dif_oport:1;
        RBus_UInt32  force_bg_dif_pport:1;
        RBus_UInt32  force_bg_dif_qport:1;
        RBus_UInt32  force_bg_dif_rport:1;
        RBus_UInt32  force_bg_dif_sport:1;
        RBus_UInt32  force_bg_dif_tport:1;
        RBus_UInt32  force_bg_dif_uport:1;
        RBus_UInt32  force_bg_dif_vport:1;
        RBus_UInt32  force_bg_dif_wport:1;
        RBus_UInt32  force_bg_dif_xport:1;
    };
}sfg_sfg_swap_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  sfg_crc_mode:1;
        RBus_UInt32  sfg_crc_l_auto_cmp_en:1;
        RBus_UInt32  sfg_crc_r_auto_cmp_en:1;
        RBus_UInt32  sfg_crc_conti:1;
        RBus_UInt32  sfg_crc_start:1;
    };
}sfg_sfg_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_crc_result_0:32;
    };
}sfg_sfg_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_crc_result_1:32;
    };
}sfg_sfg_crc_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_l_des_crc:32;
    };
}sfg_sfg_l_des_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_r_des_crc:32;
    };
}sfg_sfg_r_des_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_l_crc_err_cnt:16;
        RBus_UInt32  sfg_r_crc_err_cnt:16;
    };
}sfg_sfg_crc_err_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  en_force_bg_dif:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  bg_dif_red:10;
        RBus_UInt32  bg_dif_grn:10;
        RBus_UInt32  bg_dif_blu:10;
    };
}sfg_sfg_force_bg_at_dif_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  zz_shift_sp_0:2;
        RBus_UInt32  zz_shift_sp_1:2;
        RBus_UInt32  zz_shift_sp_2:2;
        RBus_UInt32  zz_shift_sp_3:2;
        RBus_UInt32  zz_shift_mode_0:1;
        RBus_UInt32  zz_shift_mode_1:1;
        RBus_UInt32  zz_shift_mode_2:1;
        RBus_UInt32  zz_shift_mode_3:1;
        RBus_UInt32  res2:4;
    };
}sfg_zz_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_0_front_dummy_num_0:2;
        RBus_UInt32  seg_0_back_dummy_num_0:2;
        RBus_UInt32  seg_0_front_dummy_num_1:2;
        RBus_UInt32  seg_0_back_dummy_num_1:2;
        RBus_UInt32  seg_0_front_dummy_num_2:2;
        RBus_UInt32  seg_0_back_dummy_num_2:2;
        RBus_UInt32  seg_0_front_dummy_num_3:2;
        RBus_UInt32  seg_0_back_dummy_num_3:2;
        RBus_UInt32  seg_1_front_dummy_num_0:2;
        RBus_UInt32  seg_1_back_dummy_num_0:2;
        RBus_UInt32  seg_1_front_dummy_num_1:2;
        RBus_UInt32  seg_1_back_dummy_num_1:2;
        RBus_UInt32  seg_1_front_dummy_num_2:2;
        RBus_UInt32  seg_1_back_dummy_num_2:2;
        RBus_UInt32  seg_1_front_dummy_num_3:2;
        RBus_UInt32  seg_1_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_0a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_2_front_dummy_num_0:2;
        RBus_UInt32  seg_2_back_dummy_num_0:2;
        RBus_UInt32  seg_2_front_dummy_num_1:2;
        RBus_UInt32  seg_2_back_dummy_num_1:2;
        RBus_UInt32  seg_2_front_dummy_num_2:2;
        RBus_UInt32  seg_2_back_dummy_num_2:2;
        RBus_UInt32  seg_2_front_dummy_num_3:2;
        RBus_UInt32  seg_2_back_dummy_num_3:2;
        RBus_UInt32  seg_3_front_dummy_num_0:2;
        RBus_UInt32  seg_3_back_dummy_num_0:2;
        RBus_UInt32  seg_3_front_dummy_num_1:2;
        RBus_UInt32  seg_3_back_dummy_num_1:2;
        RBus_UInt32  seg_3_front_dummy_num_2:2;
        RBus_UInt32  seg_3_back_dummy_num_2:2;
        RBus_UInt32  seg_3_front_dummy_num_3:2;
        RBus_UInt32  seg_3_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_0b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_4_front_dummy_num_0:2;
        RBus_UInt32  seg_4_back_dummy_num_0:2;
        RBus_UInt32  seg_4_front_dummy_num_1:2;
        RBus_UInt32  seg_4_back_dummy_num_1:2;
        RBus_UInt32  seg_4_front_dummy_num_2:2;
        RBus_UInt32  seg_4_back_dummy_num_2:2;
        RBus_UInt32  seg_4_front_dummy_num_3:2;
        RBus_UInt32  seg_4_back_dummy_num_3:2;
        RBus_UInt32  seg_5_front_dummy_num_0:2;
        RBus_UInt32  seg_5_back_dummy_num_0:2;
        RBus_UInt32  seg_5_front_dummy_num_1:2;
        RBus_UInt32  seg_5_back_dummy_num_1:2;
        RBus_UInt32  seg_5_front_dummy_num_2:2;
        RBus_UInt32  seg_5_back_dummy_num_2:2;
        RBus_UInt32  seg_5_front_dummy_num_3:2;
        RBus_UInt32  seg_5_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_1a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_6_front_dummy_num_0:2;
        RBus_UInt32  seg_6_back_dummy_num_0:2;
        RBus_UInt32  seg_6_front_dummy_num_1:2;
        RBus_UInt32  seg_6_back_dummy_num_1:2;
        RBus_UInt32  seg_6_front_dummy_num_2:2;
        RBus_UInt32  seg_6_back_dummy_num_2:2;
        RBus_UInt32  seg_6_front_dummy_num_3:2;
        RBus_UInt32  seg_6_back_dummy_num_3:2;
        RBus_UInt32  seg_7_front_dummy_num_0:2;
        RBus_UInt32  seg_7_back_dummy_num_0:2;
        RBus_UInt32  seg_7_front_dummy_num_1:2;
        RBus_UInt32  seg_7_back_dummy_num_1:2;
        RBus_UInt32  seg_7_front_dummy_num_2:2;
        RBus_UInt32  seg_7_back_dummy_num_2:2;
        RBus_UInt32  seg_7_front_dummy_num_3:2;
        RBus_UInt32  seg_7_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_1b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_8_front_dummy_num_0:2;
        RBus_UInt32  seg_8_back_dummy_num_0:2;
        RBus_UInt32  seg_8_front_dummy_num_1:2;
        RBus_UInt32  seg_8_back_dummy_num_1:2;
        RBus_UInt32  seg_8_front_dummy_num_2:2;
        RBus_UInt32  seg_8_back_dummy_num_2:2;
        RBus_UInt32  seg_8_front_dummy_num_3:2;
        RBus_UInt32  seg_8_back_dummy_num_3:2;
        RBus_UInt32  seg_9_front_dummy_num_0:2;
        RBus_UInt32  seg_9_back_dummy_num_0:2;
        RBus_UInt32  seg_9_front_dummy_num_1:2;
        RBus_UInt32  seg_9_back_dummy_num_1:2;
        RBus_UInt32  seg_9_front_dummy_num_2:2;
        RBus_UInt32  seg_9_back_dummy_num_2:2;
        RBus_UInt32  seg_9_front_dummy_num_3:2;
        RBus_UInt32  seg_9_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_10_front_dummy_num_0:2;
        RBus_UInt32  seg_10_back_dummy_num_0:2;
        RBus_UInt32  seg_10_front_dummy_num_1:2;
        RBus_UInt32  seg_10_back_dummy_num_1:2;
        RBus_UInt32  seg_10_front_dummy_num_2:2;
        RBus_UInt32  seg_10_back_dummy_num_2:2;
        RBus_UInt32  seg_10_front_dummy_num_3:2;
        RBus_UInt32  seg_10_back_dummy_num_3:2;
        RBus_UInt32  seg_11_front_dummy_num_0:2;
        RBus_UInt32  seg_11_back_dummy_num_0:2;
        RBus_UInt32  seg_11_front_dummy_num_1:2;
        RBus_UInt32  seg_11_back_dummy_num_1:2;
        RBus_UInt32  seg_11_front_dummy_num_2:2;
        RBus_UInt32  seg_11_back_dummy_num_2:2;
        RBus_UInt32  seg_11_front_dummy_num_3:2;
        RBus_UInt32  seg_11_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_12_front_dummy_num_0:2;
        RBus_UInt32  seg_12_back_dummy_num_0:2;
        RBus_UInt32  seg_12_front_dummy_num_1:2;
        RBus_UInt32  seg_12_back_dummy_num_1:2;
        RBus_UInt32  seg_12_front_dummy_num_2:2;
        RBus_UInt32  seg_12_back_dummy_num_2:2;
        RBus_UInt32  seg_12_front_dummy_num_3:2;
        RBus_UInt32  seg_12_back_dummy_num_3:2;
        RBus_UInt32  seg_13_front_dummy_num_0:2;
        RBus_UInt32  seg_13_back_dummy_num_0:2;
        RBus_UInt32  seg_13_front_dummy_num_1:2;
        RBus_UInt32  seg_13_back_dummy_num_1:2;
        RBus_UInt32  seg_13_front_dummy_num_2:2;
        RBus_UInt32  seg_13_back_dummy_num_2:2;
        RBus_UInt32  seg_13_front_dummy_num_3:2;
        RBus_UInt32  seg_13_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_14_front_dummy_num_0:2;
        RBus_UInt32  seg_14_back_dummy_num_0:2;
        RBus_UInt32  seg_14_front_dummy_num_1:2;
        RBus_UInt32  seg_14_back_dummy_num_1:2;
        RBus_UInt32  seg_14_front_dummy_num_2:2;
        RBus_UInt32  seg_14_back_dummy_num_2:2;
        RBus_UInt32  seg_14_front_dummy_num_3:2;
        RBus_UInt32  seg_14_back_dummy_num_3:2;
        RBus_UInt32  seg_15_front_dummy_num_0:2;
        RBus_UInt32  seg_15_back_dummy_num_0:2;
        RBus_UInt32  seg_15_front_dummy_num_1:2;
        RBus_UInt32  seg_15_back_dummy_num_1:2;
        RBus_UInt32  seg_15_front_dummy_num_2:2;
        RBus_UInt32  seg_15_back_dummy_num_2:2;
        RBus_UInt32  seg_15_front_dummy_num_3:2;
        RBus_UInt32  seg_15_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_0:1;
        RBus_UInt32  data_map_sel:1;
        RBus_UInt32  data_mode:2;
        RBus_UInt32  dummy_1:2;
        RBus_UInt32  mask_one_eye_black_en:1;
        RBus_UInt32  mask_one_eye_black_left:1;
        RBus_UInt32  dummy_pixel_shift_en:1;
        RBus_UInt32  dummy_line_sel:2;
        RBus_UInt32  last_act_line_en:1;
        RBus_UInt32  last_act_line_num:4;
        RBus_UInt32  pif_2pair_en:1;
        RBus_UInt32  pif_2d2g_sw_line01:1;
        RBus_UInt32  pif_2d2g_sw_line23:1;
        RBus_UInt32  seg_num:5;
        RBus_UInt32  h_flip_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  port_num:5;
    };
}sfg_sfg_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg0_start_res:3;
        RBus_UInt32  seg0_start:13;
        RBus_UInt32  seg1_start_res:3;
        RBus_UInt32  seg1_start:13;
    };
}sfg_sfg_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg2_start_res:3;
        RBus_UInt32  seg2_start:13;
        RBus_UInt32  seg3_start_res:3;
        RBus_UInt32  seg3_start:13;
    };
}sfg_sfg_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg4_start_res:3;
        RBus_UInt32  seg4_start:13;
        RBus_UInt32  seg5_start_res:3;
        RBus_UInt32  seg5_start:13;
    };
}sfg_sfg_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg6_start_res:3;
        RBus_UInt32  seg6_start:13;
        RBus_UInt32  seg7_start_res:3;
        RBus_UInt32  seg7_start:13;
    };
}sfg_sfg_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg8_start_res:3;
        RBus_UInt32  seg8_start:13;
        RBus_UInt32  seg9_start_res:3;
        RBus_UInt32  seg9_start:13;
    };
}sfg_sfg_start_ctrl_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg10_start_res:3;
        RBus_UInt32  seg10_start:13;
        RBus_UInt32  seg11_start_res:3;
        RBus_UInt32  seg11_start:13;
    };
}sfg_sfg_start_ctrl_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg12_start_res:3;
        RBus_UInt32  seg12_start:13;
        RBus_UInt32  seg13_start_res:3;
        RBus_UInt32  seg13_start:13;
    };
}sfg_sfg_start_ctrl_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg14_start_res:3;
        RBus_UInt32  seg14_start:13;
        RBus_UInt32  seg15_start_res:3;
        RBus_UInt32  seg15_start:13;
    };
}sfg_sfg_start_ctrl_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bypass_mode:1;
        RBus_UInt32  tg_auto_cfg:1;
        RBus_UInt32  pif_2d2g_hs_sel:1;
        RBus_UInt32  res1:28;
        RBus_UInt32  downsample_v:1;
    };
}sfg_sfg_ctrl_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  hsync_width:8;
        RBus_UInt32  hsync_delay:16;
    };
}sfg_sfg_ctrl_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  hs_distance:14;
        RBus_UInt32  vsync_end:8;
        RBus_UInt32  vsync_start:8;
    };
}sfg_sfg_ctrl_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_dh_den_sta:16;
        RBus_UInt32  req_start:16;
    };
}sfg_sfg_ctrl_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  seg23_flip:1;
        RBus_UInt32  seg22_flip:1;
        RBus_UInt32  seg21_flip:1;
        RBus_UInt32  seg20_flip:1;
        RBus_UInt32  seg19_flip:1;
        RBus_UInt32  seg18_flip:1;
        RBus_UInt32  seg17_flip:1;
        RBus_UInt32  seg16_flip:1;
        RBus_UInt32  seg15_flip:1;
        RBus_UInt32  seg14_flip:1;
        RBus_UInt32  seg13_flip:1;
        RBus_UInt32  seg12_flip:1;
        RBus_UInt32  seg11_flip:1;
        RBus_UInt32  seg10_flip:1;
        RBus_UInt32  seg9_flip:1;
        RBus_UInt32  seg8_flip:1;
        RBus_UInt32  seg7_flip:1;
        RBus_UInt32  seg6_flip:1;
        RBus_UInt32  seg5_flip:1;
        RBus_UInt32  seg4_flip:1;
        RBus_UInt32  seg3_flip:1;
        RBus_UInt32  seg2_flip:1;
        RBus_UInt32  seg1_flip:1;
        RBus_UInt32  seg0_flip:1;
    };
}sfg_sfg_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  final_line_length:13;
        RBus_UInt32  res2:16;
    };
}sfg_sfg_ctrl_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  residue_pix_split_mode:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  final_addr_split_mode:13;
    };
}sfg_sfg_ctrl_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  hs_den_io_dist:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  hs_io_dist:13;
    };
}sfg_sfg_ctrl_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_dh_den_sta_auto:16;
        RBus_UInt32  req_start_auto:16;
    };
}sfg_sfg_tg_auto_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_read:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  hsync_width_auto:8;
        RBus_UInt32  hsync_delay_auto:16;
    };
}sfg_sfg_tg_auto_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  pif_2d2g_hs_sel_auto:1;
        RBus_UInt32  hs_distance_auto:14;
        RBus_UInt32  vsync_end_auto:8;
        RBus_UInt32  vsync_start_auto:8;
    };
}sfg_sfg_tg_auto_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  hs_den_io_dist_auto:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  hs_io_dist_auto:13;
    };
}sfg_sfg_tg_auto_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  clken_lvds:1;
        RBus_UInt32  clken_epi:1;
        RBus_UInt32  clken_vby1:1;
        RBus_UInt32  dummy_2:12;
        RBus_UInt32  in_data_inv:1;
        RBus_UInt32  res1:16;
    };
}sfg_sfg_dummy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sfg_osd_bisr_second_run_en:1;
        RBus_UInt32  sfg_bisr_second_run_en:1;
    };
}sfg_sfg_bisr_second_run_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sfg_osd_bisr_done:1;
        RBus_UInt32  sfg_bisr_done:1;
    };
}sfg_sfg_bisr_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sfg_osd_bisr_fail_group:1;
        RBus_UInt32  sfg_bisr_fail_group:1;
    };
}sfg_sfg_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_bisr_repaired:1;
        RBus_UInt32  sfg_osd_bisr_repaired:1;
        RBus_UInt32  res1:26;
        RBus_UInt32  sfg_osd_bisr_fail_1:1;
        RBus_UInt32  sfg_osd_bisr_fail_0:1;
        RBus_UInt32  sfg_bisr_fail_1:1;
        RBus_UInt32  sfg_bisr_fail_0:1;
    };
}sfg_sfg_bisr_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sfg_osd_drf_mode:1;
        RBus_UInt32  sfg_drf_mode:1;
    };
}sfg_sfg_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sfg_osd_drf_resume:1;
        RBus_UInt32  sfg_drf_resume:1;
    };
}sfg_sfg_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sfg_osd_drf_done:1;
        RBus_UInt32  sfg_drf_done:1;
    };
}sfg_sfg_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sfg_osd_drf_pause:1;
        RBus_UInt32  sfg_drf_pause:1;
    };
}sfg_sfg_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  sfg_osd_drf_fail_group:1;
        RBus_UInt32  sfg_drf_fail_group:1;
    };
}sfg_sfg_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  sfg_osd_drf_fail_1:1;
        RBus_UInt32  sfg_osd_drf_fail_0:1;
        RBus_UInt32  sfg_drf_fail_1:1;
        RBus_UInt32  sfg_drf_fail_0:1;
    };
}sfg_sfg_drf_fai_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  sfg_bisr_ls:1;
        RBus_UInt32  sfg_bisr_rm:4;
        RBus_UInt32  sfg_bisr_rme:1;
        RBus_UInt32  res2:1;
    };
}sfg_sfg_bist_other_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg0_mid_dummy_place:12;
        RBus_UInt32  seg0_mid_dummy_num:4;
        RBus_UInt32  seg1_mid_dummy_place:12;
        RBus_UInt32  seg1_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg2_mid_dummy_place:12;
        RBus_UInt32  seg2_mid_dummy_num:4;
        RBus_UInt32  seg3_mid_dummy_place:12;
        RBus_UInt32  seg3_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg4_mid_dummy_place:12;
        RBus_UInt32  seg4_mid_dummy_num:4;
        RBus_UInt32  seg5_mid_dummy_place:12;
        RBus_UInt32  seg5_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg6_mid_dummy_place:12;
        RBus_UInt32  seg6_mid_dummy_num:4;
        RBus_UInt32  seg7_mid_dummy_place:12;
        RBus_UInt32  seg7_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg8_mid_dummy_place:12;
        RBus_UInt32  seg8_mid_dummy_num:4;
        RBus_UInt32  seg9_mid_dummy_place:12;
        RBus_UInt32  seg9_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg10_mid_dummy_place:12;
        RBus_UInt32  seg10_mid_dummy_num:4;
        RBus_UInt32  seg11_mid_dummy_place:12;
        RBus_UInt32  seg11_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg12_mid_dummy_place:12;
        RBus_UInt32  seg12_mid_dummy_num:4;
        RBus_UInt32  seg13_mid_dummy_place:12;
        RBus_UInt32  seg13_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg14_mid_dummy_place:12;
        RBus_UInt32  seg14_mid_dummy_num:4;
        RBus_UInt32  seg15_mid_dummy_place:12;
        RBus_UInt32  seg15_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ext_num_fw_mode:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  ext_subpixel_mode:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  active_pixel_rgb:13;
        RBus_UInt32  res3:2;
        RBus_UInt32  last_ext_pixel:6;
    };
}sfg_sfg_data_after_den_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  insert_line0_r_0:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  insert_line0_g_0:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  insert_line0_b_0:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  insert_line0_r_last:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  insert_line0_g_last:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  insert_line0_b_last:3;
        RBus_UInt32  res7:8;
    };
}sfg_sfg_insert_subpixel_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  insert_line1_r_0:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  insert_line1_g_0:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  insert_line1_b_0:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  insert_line1_r_last:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  insert_line1_g_last:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  insert_line1_b_last:3;
        RBus_UInt32  res7:8;
    };
}sfg_sfg_insert_subpixel_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  insert_line2_r_0:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  insert_line2_g_0:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  insert_line2_b_0:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  insert_line2_r_last:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  insert_line2_g_last:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  insert_line2_b_last:3;
        RBus_UInt32  res7:8;
    };
}sfg_sfg_insert_subpixel_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  insert_line3_r_0:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  insert_line3_g_0:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  insert_line3_b_0:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  insert_line3_r_last:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  insert_line3_g_last:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  insert_line3_b_last:3;
        RBus_UInt32  res7:8;
    };
}sfg_sfg_insert_subpixel_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dummy_pixel_data:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  db_sel:1;
        RBus_UInt32  res3:20;
    };
}sfg_sfg_ctrl_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  last_ext_pixel_last_flip_line3:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  last_ext_pixel_last_flip_line2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  last_ext_pixel_last_flip_line1:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  last_ext_pixel_last_flip_line0:6;
    };
}sfg_sfg_last_ext_pixel_last_flip_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_inv:1;
        RBus_UInt32  sfg2_osd_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  sfg2_bypass_mode:1;
        RBus_UInt32  sfg2_tg_auto_cfg:1;
        RBus_UInt32  sfg2_dout_en:1;
        RBus_UInt32  res2:16;
        RBus_UInt32  sfg2_h_flip_en:1;
        RBus_UInt32  sfg2_seg_num:4;
        RBus_UInt32  sfg2_port_num:4;
    };
}sfg_sfg2_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_seg0_start:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_seg1_start:13;
    };
}sfg_sfg2_sta_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_seg2_start:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_seg3_start:13;
    };
}sfg_sfg2_sta_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_seg4_start:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_seg5_start:13;
    };
}sfg_sfg2_sta_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_seg6_start:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_seg7_start:13;
    };
}sfg_sfg2_sta_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_port_0:4;
        RBus_UInt32  sfg2_port_1:4;
        RBus_UInt32  sfg2_port_2:4;
        RBus_UInt32  sfg2_port_3:4;
        RBus_UInt32  sfg2_port_4:4;
        RBus_UInt32  sfg2_port_5:4;
        RBus_UInt32  sfg2_port_6:4;
        RBus_UInt32  sfg2_port_7:4;
    };
}sfg_sfg2_port_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_force_bg_en:1;
        RBus_UInt32  res1:23;
        RBus_UInt32  sfg2_force_bg_port_7:1;
        RBus_UInt32  sfg2_force_bg_port_6:1;
        RBus_UInt32  sfg2_force_bg_port_5:1;
        RBus_UInt32  sfg2_force_bg_port_4:1;
        RBus_UInt32  sfg2_force_bg_port_3:1;
        RBus_UInt32  sfg2_force_bg_port_2:1;
        RBus_UInt32  sfg2_force_bg_port_1:1;
        RBus_UInt32  sfg2_force_bg_port_0:1;
    };
}sfg_sfg2_force_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_bg_a:8;
        RBus_UInt32  sfg2_bg_r:8;
        RBus_UInt32  sfg2_bg_g:8;
        RBus_UInt32  sfg2_bg_b:8;
    };
}sfg_sfg2_force_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  sfg2_crc_mode:1;
        RBus_UInt32  sfg2_crc_l_auto_cmp_en:1;
        RBus_UInt32  sfg2_crc_r_auto_cmp_en:1;
        RBus_UInt32  sfg2_crc_conti:1;
        RBus_UInt32  sfg2_crc_start:1;
    };
}sfg_sfg2_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_crc_result_0:32;
    };
}sfg_sfg2_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_crc_result_1:32;
    };
}sfg_sfg2_crc_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_l_des_crc:32;
    };
}sfg_sfg2_crc_l_des_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_r_des_crc:32;
    };
}sfg_sfg2_crc_r_des_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_l_crc_err_cnt:16;
        RBus_UInt32  sfg2_r_crc_err_cnt:16;
    };
}sfg_sfg2_crc_err_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  sfg2_hsync_width:8;
        RBus_UInt32  sfg2_hsync_delay:16;
    };
}sfg_sfg2_time_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  sfg2_vsync_end:8;
        RBus_UInt32  res2:8;
        RBus_UInt32  sfg2_vsync_start:8;
    };
}sfg_sfg2_time_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_dh_den_sta:16;
        RBus_UInt32  sfg2_req_start:16;
    };
}sfg_sfg2_time_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  sfg2_final_line_length:13;
    };
}sfg_sfg2_den_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  sfg2_hsync_width_auto:8;
        RBus_UInt32  sfg2_hsync_delay_auto:16;
    };
}sfg_sfg2_time_ctrl_auto_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  sfg2_vsync_end_auto:8;
        RBus_UInt32  res2:8;
        RBus_UInt32  sfg2_vsync_start_auto:8;
    };
}sfg_sfg2_time_ctrl_auto_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_dh_den_sta_auto:16;
        RBus_UInt32  sfg2_req_start_auto:16;
    };
}sfg_sfg2_time_ctrl_auto_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  sfg_debug_clk_div:2;
        RBus_UInt32  sfg2_debug_clk_div:2;
    };
}sfg_sfg_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  data_capture_v:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  data_capture_h:14;
    };
}sfg_sfg_data_capture_vh_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  data_capture_src:2;
        RBus_UInt32  res2:22;
        RBus_UInt32  data_capture_apply:1;
        RBus_UInt32  data_capture_en:1;
        RBus_UInt32  data_capture_port:4;
    };
}sfg_sfg_data_capture_src_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  data_capture_data:32;
    };
}sfg_sfg_data_capture_read_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  last_seg_start_res_line0:3;
        RBus_UInt32  last_seg_start_line0:13;
        RBus_UInt32  last_seg_start_res_line1:3;
        RBus_UInt32  last_seg_start_line1:13;
    };
}sfg_sfg_last_seg_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  last_seg_start_res_line2:3;
        RBus_UInt32  last_seg_start_line2:13;
        RBus_UInt32  last_seg_start_res_line3:3;
        RBus_UInt32  last_seg_start_line3:13;
    };
}sfg_sfg_last_seg_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_0_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_0_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_0_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_r_0_line3:5;
    };
}sfg_sfg_drd_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_0_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_0_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_0_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_g_0_line3:5;
    };
}sfg_sfg_drd_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_0_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_0_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_0_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_b_0_line3:5;
    };
}sfg_sfg_drd_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_2_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_2_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_2_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_r_2_line3:5;
    };
}sfg_sfg_drd_ctrl_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_2_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_2_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_2_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_g_2_line3:5;
    };
}sfg_sfg_drd_ctrl_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_2_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_2_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_2_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_b_2_line3:5;
    };
}sfg_sfg_drd_ctrl_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_4_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_4_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_4_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_r_4_line3:5;
    };
}sfg_sfg_drd_ctrl_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_4_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_4_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_4_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_g_4_line3:5;
    };
}sfg_sfg_drd_ctrl_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_4_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_4_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_4_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_b_4_line3:5;
    };
}sfg_sfg_drd_ctrl_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_6_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_6_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_6_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_r_6_line3:5;
    };
}sfg_sfg_drd_ctrl_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_6_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_6_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_6_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_g_6_line3:5;
    };
}sfg_sfg_drd_ctrl_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_6_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_6_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_6_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_b_6_line3:5;
    };
}sfg_sfg_drd_ctrl_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_1_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_1_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_1_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_r_1_line3:5;
    };
}sfg_sfg_drd_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_1_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_1_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_1_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_g_1_line3:5;
    };
}sfg_sfg_drd_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_1_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_1_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_1_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_b_1_line3:5;
    };
}sfg_sfg_drd_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_3_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_3_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_3_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_r_3_line3:5;
    };
}sfg_sfg_drd_ctrl_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_3_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_3_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_3_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_g_3_line3:5;
    };
}sfg_sfg_drd_ctrl_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_3_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_3_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_3_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_b_3_line3:5;
    };
}sfg_sfg_drd_ctrl_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_5_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_5_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_5_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_r_5_line3:5;
    };
}sfg_sfg_drd_ctrl_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_5_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_5_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_5_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_g_5_line3:5;
    };
}sfg_sfg_drd_ctrl_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_5_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_5_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_5_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_b_5_line3:5;
    };
}sfg_sfg_drd_ctrl_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_7_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_7_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_7_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_r_7_line3:5;
    };
}sfg_sfg_drd_ctrl_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_7_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_7_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_7_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_g_7_line3:5;
    };
}sfg_sfg_drd_ctrl_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_7_line0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_7_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_7_line2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  drd_b_7_line3:5;
    };
}sfg_sfg_drd_ctrl_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  output_porta:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portb:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_portc:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  output_portd:5;
    };
}sfg_sfg_swap_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  output_porte:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portf:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_portg:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  output_porth:5;
    };
}sfg_sfg_swap_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  output_porti:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portj:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_portk:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  output_portl:5;
    };
}sfg_sfg_swap_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  output_portm:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portn:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_porto:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  output_portp:5;
    };
}sfg_sfg_swap_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  output_portq:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portr:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_ports:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  output_portt:5;
    };
}sfg_sfg_swap_ctrl5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  output_portu:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portv:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_portw:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  output_portx:5;
    };
}sfg_sfg_swap_ctrl6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_16_front_dummy_num_0:2;
        RBus_UInt32  seg_16_back_dummy_num_0:2;
        RBus_UInt32  seg_16_front_dummy_num_1:2;
        RBus_UInt32  seg_16_back_dummy_num_1:2;
        RBus_UInt32  seg_16_front_dummy_num_2:2;
        RBus_UInt32  seg_16_back_dummy_num_2:2;
        RBus_UInt32  seg_16_front_dummy_num_3:2;
        RBus_UInt32  seg_16_back_dummy_num_3:2;
        RBus_UInt32  seg_17_front_dummy_num_0:2;
        RBus_UInt32  seg_17_back_dummy_num_0:2;
        RBus_UInt32  seg_17_front_dummy_num_1:2;
        RBus_UInt32  seg_17_back_dummy_num_1:2;
        RBus_UInt32  seg_17_front_dummy_num_2:2;
        RBus_UInt32  seg_17_back_dummy_num_2:2;
        RBus_UInt32  seg_17_front_dummy_num_3:2;
        RBus_UInt32  seg_17_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_18_front_dummy_num_0:2;
        RBus_UInt32  seg_18_back_dummy_num_0:2;
        RBus_UInt32  seg_18_front_dummy_num_1:2;
        RBus_UInt32  seg_18_back_dummy_num_1:2;
        RBus_UInt32  seg_18_front_dummy_num_2:2;
        RBus_UInt32  seg_18_back_dummy_num_2:2;
        RBus_UInt32  seg_18_front_dummy_num_3:2;
        RBus_UInt32  seg_18_back_dummy_num_3:2;
        RBus_UInt32  seg_19_front_dummy_num_0:2;
        RBus_UInt32  seg_19_back_dummy_num_0:2;
        RBus_UInt32  seg_19_front_dummy_num_1:2;
        RBus_UInt32  seg_19_back_dummy_num_1:2;
        RBus_UInt32  seg_19_front_dummy_num_2:2;
        RBus_UInt32  seg_19_back_dummy_num_2:2;
        RBus_UInt32  seg_19_front_dummy_num_3:2;
        RBus_UInt32  seg_19_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_20_front_dummy_num_0:2;
        RBus_UInt32  seg_20_back_dummy_num_0:2;
        RBus_UInt32  seg_20_front_dummy_num_1:2;
        RBus_UInt32  seg_20_back_dummy_num_1:2;
        RBus_UInt32  seg_20_front_dummy_num_2:2;
        RBus_UInt32  seg_20_back_dummy_num_2:2;
        RBus_UInt32  seg_20_front_dummy_num_3:2;
        RBus_UInt32  seg_20_back_dummy_num_3:2;
        RBus_UInt32  seg_21_front_dummy_num_0:2;
        RBus_UInt32  seg_21_back_dummy_num_0:2;
        RBus_UInt32  seg_21_front_dummy_num_1:2;
        RBus_UInt32  seg_21_back_dummy_num_1:2;
        RBus_UInt32  seg_21_front_dummy_num_2:2;
        RBus_UInt32  seg_21_back_dummy_num_2:2;
        RBus_UInt32  seg_21_front_dummy_num_3:2;
        RBus_UInt32  seg_21_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_22_front_dummy_num_0:2;
        RBus_UInt32  seg_22_back_dummy_num_0:2;
        RBus_UInt32  seg_22_front_dummy_num_1:2;
        RBus_UInt32  seg_22_back_dummy_num_1:2;
        RBus_UInt32  seg_22_front_dummy_num_2:2;
        RBus_UInt32  seg_22_back_dummy_num_2:2;
        RBus_UInt32  seg_22_front_dummy_num_3:2;
        RBus_UInt32  seg_22_back_dummy_num_3:2;
        RBus_UInt32  seg_23_front_dummy_num_0:2;
        RBus_UInt32  seg_23_back_dummy_num_0:2;
        RBus_UInt32  seg_23_front_dummy_num_1:2;
        RBus_UInt32  seg_23_back_dummy_num_1:2;
        RBus_UInt32  seg_23_front_dummy_num_2:2;
        RBus_UInt32  seg_23_back_dummy_num_2:2;
        RBus_UInt32  seg_23_front_dummy_num_3:2;
        RBus_UInt32  seg_23_back_dummy_num_3:2;
    };
}sfg_sfg_dummy_ctrl_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg16_start_res:3;
        RBus_UInt32  seg16_start:13;
        RBus_UInt32  seg17_start_res:3;
        RBus_UInt32  seg17_start:13;
    };
}sfg_sfg_start_ctrl_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg18_start_res:3;
        RBus_UInt32  seg18_start:13;
        RBus_UInt32  seg19_start_res:3;
        RBus_UInt32  seg19_start:13;
    };
}sfg_sfg_start_ctrl_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg20_start_res:3;
        RBus_UInt32  seg20_start:13;
        RBus_UInt32  seg21_start_res:3;
        RBus_UInt32  seg21_start:13;
    };
}sfg_sfg_start_ctrl_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg22_start_res:3;
        RBus_UInt32  seg22_start:13;
        RBus_UInt32  seg23_start_res:3;
        RBus_UInt32  seg23_start:13;
    };
}sfg_sfg_start_ctrl_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg16_mid_dummy_place:12;
        RBus_UInt32  seg16_mid_dummy_num:4;
        RBus_UInt32  seg17_mid_dummy_place:12;
        RBus_UInt32  seg17_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg18_mid_dummy_place:12;
        RBus_UInt32  seg18_mid_dummy_num:4;
        RBus_UInt32  seg19_mid_dummy_place:12;
        RBus_UInt32  seg19_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg20_mid_dummy_place:12;
        RBus_UInt32  seg20_mid_dummy_num:4;
        RBus_UInt32  seg21_mid_dummy_place:12;
        RBus_UInt32  seg21_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg22_mid_dummy_place:12;
        RBus_UInt32  seg22_mid_dummy_num:4;
        RBus_UInt32  seg23_mid_dummy_place:12;
        RBus_UInt32  seg23_mid_dummy_num:4;
    };
}sfg_sfg_mid_dummy_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_31:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_30:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_29:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  sfg2_in_data_bit_28:5;
    };
}sfg_sfg2_data_sel_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_27:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_26:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_25:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  sfg2_in_data_bit_24:5;
    };
}sfg_sfg2_data_sel_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_23:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_22:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_21:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  sfg2_in_data_bit_20:5;
    };
}sfg_sfg2_data_sel_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_19:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_18:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_17:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  sfg2_in_data_bit_16:5;
    };
}sfg_sfg2_data_sel_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_15:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_14:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_13:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  sfg2_in_data_bit_12:5;
    };
}sfg_sfg2_data_sel_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_11:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_10:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_9:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  sfg2_in_data_bit_8:5;
    };
}sfg_sfg2_data_sel_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_7:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_6:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_5:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  sfg2_in_data_bit_4:5;
    };
}sfg_sfg2_data_sel_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_3:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_2:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_1:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  sfg2_in_data_bit_0:5;
    };
}sfg_sfg2_data_sel_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  fw_ext_subpix_num_line_0:24;
    };
}sfg_sfg1_ext_subpixel_line_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  fw_ext_subpix_num_line_1:24;
    };
}sfg_sfg1_ext_subpixel_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  fw_ext_subpix_num_line_2:24;
    };
}sfg_sfg1_ext_subpixel_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  fw_ext_subpix_num_line_3:24;
    };
}sfg_sfg1_ext_subpixel_line_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dum_data1_line_0:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dum_data0_line_0:12;
    };
}sfg_sfg1_dum_data_line_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dum_data1_line_1:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dum_data0_line_1:12;
    };
}sfg_sfg1_dum_data_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dum_data1_line_2:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dum_data0_line_2:12;
    };
}sfg_sfg1_dum_data_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dum_data1_line_3:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dum_data0_line_3:12;
    };
}sfg_sfg1_dum_data_line_3_RBUS;

#else //apply LITTLE_ENDIAN

//======SFG register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dclk_dly_sel:3;
        RBus_UInt32  dout_data_inv:1;
        RBus_UInt32  dout_bit_swap:1;
        RBus_UInt32  dout_rb_swap:1;
        RBus_UInt32  daclk_en:1;
        RBus_UInt32  daclk_inv:1;
        RBus_UInt32  dden_inv:1;
        RBus_UInt32  dhs_inv:1;
        RBus_UInt32  dvs_inv:1;
        RBus_UInt32  sfg_dout_en:1;
        RBus_UInt32  dout_mode:2;
        RBus_UInt32  dispd_debug_mode:3;
        RBus_UInt32  dout_pre_rb_swap:1;
        RBus_UInt32  pif_clk_sel:1;
        RBus_UInt32  macclk_inv:1;
        RBus_UInt32  res1:12;
    };
}sfg_sfg_zz_shift_dbg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  force_bg_dif_xport:1;
        RBus_UInt32  force_bg_dif_wport:1;
        RBus_UInt32  force_bg_dif_vport:1;
        RBus_UInt32  force_bg_dif_uport:1;
        RBus_UInt32  force_bg_dif_tport:1;
        RBus_UInt32  force_bg_dif_sport:1;
        RBus_UInt32  force_bg_dif_rport:1;
        RBus_UInt32  force_bg_dif_qport:1;
        RBus_UInt32  force_bg_dif_pport:1;
        RBus_UInt32  force_bg_dif_oport:1;
        RBus_UInt32  force_bg_dif_nport:1;
        RBus_UInt32  force_bg_dif_mport:1;
        RBus_UInt32  force_bg_dif_lport:1;
        RBus_UInt32  force_bg_dif_kport:1;
        RBus_UInt32  force_bg_dif_jport:1;
        RBus_UInt32  force_bg_dif_iport:1;
        RBus_UInt32  force_bg_dif_hport:1;
        RBus_UInt32  force_bg_dif_gport:1;
        RBus_UInt32  force_bg_dif_fport:1;
        RBus_UInt32  force_bg_dif_eport:1;
        RBus_UInt32  force_bg_dif_dport:1;
        RBus_UInt32  force_bg_dif_cport:1;
        RBus_UInt32  force_bg_dif_bport:1;
        RBus_UInt32  force_bg_dif_aport:1;
        RBus_UInt32  dclk_mode_switch:5;
        RBus_UInt32  res1:3;
    };
}sfg_sfg_swap_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_crc_start:1;
        RBus_UInt32  sfg_crc_conti:1;
        RBus_UInt32  sfg_crc_r_auto_cmp_en:1;
        RBus_UInt32  sfg_crc_l_auto_cmp_en:1;
        RBus_UInt32  sfg_crc_mode:1;
        RBus_UInt32  res1:27;
    };
}sfg_sfg_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_crc_result_0:32;
    };
}sfg_sfg_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_crc_result_1:32;
    };
}sfg_sfg_crc_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_l_des_crc:32;
    };
}sfg_sfg_l_des_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_r_des_crc:32;
    };
}sfg_sfg_r_des_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_r_crc_err_cnt:16;
        RBus_UInt32  sfg_l_crc_err_cnt:16;
    };
}sfg_sfg_crc_err_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bg_dif_blu:10;
        RBus_UInt32  bg_dif_grn:10;
        RBus_UInt32  bg_dif_red:10;
        RBus_UInt32  res1:1;
        RBus_UInt32  en_force_bg_dif:1;
    };
}sfg_sfg_force_bg_at_dif_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  zz_shift_mode_3:1;
        RBus_UInt32  zz_shift_mode_2:1;
        RBus_UInt32  zz_shift_mode_1:1;
        RBus_UInt32  zz_shift_mode_0:1;
        RBus_UInt32  zz_shift_sp_3:2;
        RBus_UInt32  zz_shift_sp_2:2;
        RBus_UInt32  zz_shift_sp_1:2;
        RBus_UInt32  zz_shift_sp_0:2;
        RBus_UInt32  res2:16;
    };
}sfg_zz_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_1_back_dummy_num_3:2;
        RBus_UInt32  seg_1_front_dummy_num_3:2;
        RBus_UInt32  seg_1_back_dummy_num_2:2;
        RBus_UInt32  seg_1_front_dummy_num_2:2;
        RBus_UInt32  seg_1_back_dummy_num_1:2;
        RBus_UInt32  seg_1_front_dummy_num_1:2;
        RBus_UInt32  seg_1_back_dummy_num_0:2;
        RBus_UInt32  seg_1_front_dummy_num_0:2;
        RBus_UInt32  seg_0_back_dummy_num_3:2;
        RBus_UInt32  seg_0_front_dummy_num_3:2;
        RBus_UInt32  seg_0_back_dummy_num_2:2;
        RBus_UInt32  seg_0_front_dummy_num_2:2;
        RBus_UInt32  seg_0_back_dummy_num_1:2;
        RBus_UInt32  seg_0_front_dummy_num_1:2;
        RBus_UInt32  seg_0_back_dummy_num_0:2;
        RBus_UInt32  seg_0_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_0a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_3_back_dummy_num_3:2;
        RBus_UInt32  seg_3_front_dummy_num_3:2;
        RBus_UInt32  seg_3_back_dummy_num_2:2;
        RBus_UInt32  seg_3_front_dummy_num_2:2;
        RBus_UInt32  seg_3_back_dummy_num_1:2;
        RBus_UInt32  seg_3_front_dummy_num_1:2;
        RBus_UInt32  seg_3_back_dummy_num_0:2;
        RBus_UInt32  seg_3_front_dummy_num_0:2;
        RBus_UInt32  seg_2_back_dummy_num_3:2;
        RBus_UInt32  seg_2_front_dummy_num_3:2;
        RBus_UInt32  seg_2_back_dummy_num_2:2;
        RBus_UInt32  seg_2_front_dummy_num_2:2;
        RBus_UInt32  seg_2_back_dummy_num_1:2;
        RBus_UInt32  seg_2_front_dummy_num_1:2;
        RBus_UInt32  seg_2_back_dummy_num_0:2;
        RBus_UInt32  seg_2_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_0b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_5_back_dummy_num_3:2;
        RBus_UInt32  seg_5_front_dummy_num_3:2;
        RBus_UInt32  seg_5_back_dummy_num_2:2;
        RBus_UInt32  seg_5_front_dummy_num_2:2;
        RBus_UInt32  seg_5_back_dummy_num_1:2;
        RBus_UInt32  seg_5_front_dummy_num_1:2;
        RBus_UInt32  seg_5_back_dummy_num_0:2;
        RBus_UInt32  seg_5_front_dummy_num_0:2;
        RBus_UInt32  seg_4_back_dummy_num_3:2;
        RBus_UInt32  seg_4_front_dummy_num_3:2;
        RBus_UInt32  seg_4_back_dummy_num_2:2;
        RBus_UInt32  seg_4_front_dummy_num_2:2;
        RBus_UInt32  seg_4_back_dummy_num_1:2;
        RBus_UInt32  seg_4_front_dummy_num_1:2;
        RBus_UInt32  seg_4_back_dummy_num_0:2;
        RBus_UInt32  seg_4_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_1a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_7_back_dummy_num_3:2;
        RBus_UInt32  seg_7_front_dummy_num_3:2;
        RBus_UInt32  seg_7_back_dummy_num_2:2;
        RBus_UInt32  seg_7_front_dummy_num_2:2;
        RBus_UInt32  seg_7_back_dummy_num_1:2;
        RBus_UInt32  seg_7_front_dummy_num_1:2;
        RBus_UInt32  seg_7_back_dummy_num_0:2;
        RBus_UInt32  seg_7_front_dummy_num_0:2;
        RBus_UInt32  seg_6_back_dummy_num_3:2;
        RBus_UInt32  seg_6_front_dummy_num_3:2;
        RBus_UInt32  seg_6_back_dummy_num_2:2;
        RBus_UInt32  seg_6_front_dummy_num_2:2;
        RBus_UInt32  seg_6_back_dummy_num_1:2;
        RBus_UInt32  seg_6_front_dummy_num_1:2;
        RBus_UInt32  seg_6_back_dummy_num_0:2;
        RBus_UInt32  seg_6_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_1b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_9_back_dummy_num_3:2;
        RBus_UInt32  seg_9_front_dummy_num_3:2;
        RBus_UInt32  seg_9_back_dummy_num_2:2;
        RBus_UInt32  seg_9_front_dummy_num_2:2;
        RBus_UInt32  seg_9_back_dummy_num_1:2;
        RBus_UInt32  seg_9_front_dummy_num_1:2;
        RBus_UInt32  seg_9_back_dummy_num_0:2;
        RBus_UInt32  seg_9_front_dummy_num_0:2;
        RBus_UInt32  seg_8_back_dummy_num_3:2;
        RBus_UInt32  seg_8_front_dummy_num_3:2;
        RBus_UInt32  seg_8_back_dummy_num_2:2;
        RBus_UInt32  seg_8_front_dummy_num_2:2;
        RBus_UInt32  seg_8_back_dummy_num_1:2;
        RBus_UInt32  seg_8_front_dummy_num_1:2;
        RBus_UInt32  seg_8_back_dummy_num_0:2;
        RBus_UInt32  seg_8_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_11_back_dummy_num_3:2;
        RBus_UInt32  seg_11_front_dummy_num_3:2;
        RBus_UInt32  seg_11_back_dummy_num_2:2;
        RBus_UInt32  seg_11_front_dummy_num_2:2;
        RBus_UInt32  seg_11_back_dummy_num_1:2;
        RBus_UInt32  seg_11_front_dummy_num_1:2;
        RBus_UInt32  seg_11_back_dummy_num_0:2;
        RBus_UInt32  seg_11_front_dummy_num_0:2;
        RBus_UInt32  seg_10_back_dummy_num_3:2;
        RBus_UInt32  seg_10_front_dummy_num_3:2;
        RBus_UInt32  seg_10_back_dummy_num_2:2;
        RBus_UInt32  seg_10_front_dummy_num_2:2;
        RBus_UInt32  seg_10_back_dummy_num_1:2;
        RBus_UInt32  seg_10_front_dummy_num_1:2;
        RBus_UInt32  seg_10_back_dummy_num_0:2;
        RBus_UInt32  seg_10_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_13_back_dummy_num_3:2;
        RBus_UInt32  seg_13_front_dummy_num_3:2;
        RBus_UInt32  seg_13_back_dummy_num_2:2;
        RBus_UInt32  seg_13_front_dummy_num_2:2;
        RBus_UInt32  seg_13_back_dummy_num_1:2;
        RBus_UInt32  seg_13_front_dummy_num_1:2;
        RBus_UInt32  seg_13_back_dummy_num_0:2;
        RBus_UInt32  seg_13_front_dummy_num_0:2;
        RBus_UInt32  seg_12_back_dummy_num_3:2;
        RBus_UInt32  seg_12_front_dummy_num_3:2;
        RBus_UInt32  seg_12_back_dummy_num_2:2;
        RBus_UInt32  seg_12_front_dummy_num_2:2;
        RBus_UInt32  seg_12_back_dummy_num_1:2;
        RBus_UInt32  seg_12_front_dummy_num_1:2;
        RBus_UInt32  seg_12_back_dummy_num_0:2;
        RBus_UInt32  seg_12_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_15_back_dummy_num_3:2;
        RBus_UInt32  seg_15_front_dummy_num_3:2;
        RBus_UInt32  seg_15_back_dummy_num_2:2;
        RBus_UInt32  seg_15_front_dummy_num_2:2;
        RBus_UInt32  seg_15_back_dummy_num_1:2;
        RBus_UInt32  seg_15_front_dummy_num_1:2;
        RBus_UInt32  seg_15_back_dummy_num_0:2;
        RBus_UInt32  seg_15_front_dummy_num_0:2;
        RBus_UInt32  seg_14_back_dummy_num_3:2;
        RBus_UInt32  seg_14_front_dummy_num_3:2;
        RBus_UInt32  seg_14_back_dummy_num_2:2;
        RBus_UInt32  seg_14_front_dummy_num_2:2;
        RBus_UInt32  seg_14_back_dummy_num_1:2;
        RBus_UInt32  seg_14_front_dummy_num_1:2;
        RBus_UInt32  seg_14_back_dummy_num_0:2;
        RBus_UInt32  seg_14_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  port_num:5;
        RBus_UInt32  res1:2;
        RBus_UInt32  h_flip_en:1;
        RBus_UInt32  seg_num:5;
        RBus_UInt32  pif_2d2g_sw_line23:1;
        RBus_UInt32  pif_2d2g_sw_line01:1;
        RBus_UInt32  pif_2pair_en:1;
        RBus_UInt32  last_act_line_num:4;
        RBus_UInt32  last_act_line_en:1;
        RBus_UInt32  dummy_line_sel:2;
        RBus_UInt32  dummy_pixel_shift_en:1;
        RBus_UInt32  mask_one_eye_black_left:1;
        RBus_UInt32  mask_one_eye_black_en:1;
        RBus_UInt32  dummy_1:2;
        RBus_UInt32  data_mode:2;
        RBus_UInt32  data_map_sel:1;
        RBus_UInt32  dummy_0:1;
    };
}sfg_sfg_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg1_start:13;
        RBus_UInt32  seg1_start_res:3;
        RBus_UInt32  seg0_start:13;
        RBus_UInt32  seg0_start_res:3;
    };
}sfg_sfg_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg3_start:13;
        RBus_UInt32  seg3_start_res:3;
        RBus_UInt32  seg2_start:13;
        RBus_UInt32  seg2_start_res:3;
    };
}sfg_sfg_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg5_start:13;
        RBus_UInt32  seg5_start_res:3;
        RBus_UInt32  seg4_start:13;
        RBus_UInt32  seg4_start_res:3;
    };
}sfg_sfg_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg7_start:13;
        RBus_UInt32  seg7_start_res:3;
        RBus_UInt32  seg6_start:13;
        RBus_UInt32  seg6_start_res:3;
    };
}sfg_sfg_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg9_start:13;
        RBus_UInt32  seg9_start_res:3;
        RBus_UInt32  seg8_start:13;
        RBus_UInt32  seg8_start_res:3;
    };
}sfg_sfg_start_ctrl_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg11_start:13;
        RBus_UInt32  seg11_start_res:3;
        RBus_UInt32  seg10_start:13;
        RBus_UInt32  seg10_start_res:3;
    };
}sfg_sfg_start_ctrl_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg13_start:13;
        RBus_UInt32  seg13_start_res:3;
        RBus_UInt32  seg12_start:13;
        RBus_UInt32  seg12_start_res:3;
    };
}sfg_sfg_start_ctrl_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg15_start:13;
        RBus_UInt32  seg15_start_res:3;
        RBus_UInt32  seg14_start:13;
        RBus_UInt32  seg14_start_res:3;
    };
}sfg_sfg_start_ctrl_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  downsample_v:1;
        RBus_UInt32  res1:28;
        RBus_UInt32  pif_2d2g_hs_sel:1;
        RBus_UInt32  tg_auto_cfg:1;
        RBus_UInt32  bypass_mode:1;
    };
}sfg_sfg_ctrl_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hsync_delay:16;
        RBus_UInt32  hsync_width:8;
        RBus_UInt32  res1:8;
    };
}sfg_sfg_ctrl_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vsync_start:8;
        RBus_UInt32  vsync_end:8;
        RBus_UInt32  hs_distance:14;
        RBus_UInt32  res1:2;
    };
}sfg_sfg_ctrl_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  req_start:16;
        RBus_UInt32  sfg_dh_den_sta:16;
    };
}sfg_sfg_ctrl_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg0_flip:1;
        RBus_UInt32  seg1_flip:1;
        RBus_UInt32  seg2_flip:1;
        RBus_UInt32  seg3_flip:1;
        RBus_UInt32  seg4_flip:1;
        RBus_UInt32  seg5_flip:1;
        RBus_UInt32  seg6_flip:1;
        RBus_UInt32  seg7_flip:1;
        RBus_UInt32  seg8_flip:1;
        RBus_UInt32  seg9_flip:1;
        RBus_UInt32  seg10_flip:1;
        RBus_UInt32  seg11_flip:1;
        RBus_UInt32  seg12_flip:1;
        RBus_UInt32  seg13_flip:1;
        RBus_UInt32  seg14_flip:1;
        RBus_UInt32  seg15_flip:1;
        RBus_UInt32  seg16_flip:1;
        RBus_UInt32  seg17_flip:1;
        RBus_UInt32  seg18_flip:1;
        RBus_UInt32  seg19_flip:1;
        RBus_UInt32  seg20_flip:1;
        RBus_UInt32  seg21_flip:1;
        RBus_UInt32  seg22_flip:1;
        RBus_UInt32  seg23_flip:1;
        RBus_UInt32  res1:8;
    };
}sfg_sfg_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  final_line_length:13;
        RBus_UInt32  res2:3;
    };
}sfg_sfg_ctrl_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  final_addr_split_mode:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  residue_pix_split_mode:3;
        RBus_UInt32  res2:13;
    };
}sfg_sfg_ctrl_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hs_io_dist:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  hs_den_io_dist:13;
        RBus_UInt32  res2:3;
    };
}sfg_sfg_ctrl_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  req_start_auto:16;
        RBus_UInt32  sfg_dh_den_sta_auto:16;
    };
}sfg_sfg_tg_auto_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hsync_delay_auto:16;
        RBus_UInt32  hsync_width_auto:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  t_read:1;
    };
}sfg_sfg_tg_auto_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vsync_start_auto:8;
        RBus_UInt32  vsync_end_auto:8;
        RBus_UInt32  hs_distance_auto:14;
        RBus_UInt32  pif_2d2g_hs_sel_auto:1;
        RBus_UInt32  res1:1;
    };
}sfg_sfg_tg_auto_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hs_io_dist_auto:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  hs_den_io_dist_auto:13;
        RBus_UInt32  res2:3;
    };
}sfg_sfg_tg_auto_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  in_data_inv:1;
        RBus_UInt32  dummy_2:12;
        RBus_UInt32  clken_vby1:1;
        RBus_UInt32  clken_epi:1;
        RBus_UInt32  clken_lvds:1;
    };
}sfg_sfg_dummy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_bisr_second_run_en:1;
        RBus_UInt32  sfg_osd_bisr_second_run_en:1;
        RBus_UInt32  res1:30;
    };
}sfg_sfg_bisr_second_run_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_bisr_done:1;
        RBus_UInt32  sfg_osd_bisr_done:1;
        RBus_UInt32  res1:30;
    };
}sfg_sfg_bisr_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_bisr_fail_group:1;
        RBus_UInt32  sfg_osd_bisr_fail_group:1;
        RBus_UInt32  res1:30;
    };
}sfg_sfg_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_bisr_fail_0:1;
        RBus_UInt32  sfg_bisr_fail_1:1;
        RBus_UInt32  sfg_osd_bisr_fail_0:1;
        RBus_UInt32  sfg_osd_bisr_fail_1:1;
        RBus_UInt32  res1:26;
        RBus_UInt32  sfg_osd_bisr_repaired:1;
        RBus_UInt32  sfg_bisr_repaired:1;
    };
}sfg_sfg_bisr_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_drf_mode:1;
        RBus_UInt32  sfg_osd_drf_mode:1;
        RBus_UInt32  res1:30;
    };
}sfg_sfg_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_drf_resume:1;
        RBus_UInt32  sfg_osd_drf_resume:1;
        RBus_UInt32  res1:30;
    };
}sfg_sfg_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_drf_done:1;
        RBus_UInt32  sfg_osd_drf_done:1;
        RBus_UInt32  res1:30;
    };
}sfg_sfg_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_drf_pause:1;
        RBus_UInt32  sfg_osd_drf_pause:1;
        RBus_UInt32  res1:30;
    };
}sfg_sfg_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_drf_fail_group:1;
        RBus_UInt32  sfg_osd_drf_fail_group:1;
        RBus_UInt32  res1:30;
    };
}sfg_sfg_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg_drf_fail_0:1;
        RBus_UInt32  sfg_drf_fail_1:1;
        RBus_UInt32  sfg_osd_drf_fail_0:1;
        RBus_UInt32  sfg_osd_drf_fail_1:1;
        RBus_UInt32  res1:28;
    };
}sfg_sfg_drf_fai_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  sfg_bisr_rme:1;
        RBus_UInt32  sfg_bisr_rm:4;
        RBus_UInt32  sfg_bisr_ls:1;
        RBus_UInt32  res2:25;
    };
}sfg_sfg_bist_other_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg1_mid_dummy_num:4;
        RBus_UInt32  seg1_mid_dummy_place:12;
        RBus_UInt32  seg0_mid_dummy_num:4;
        RBus_UInt32  seg0_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg3_mid_dummy_num:4;
        RBus_UInt32  seg3_mid_dummy_place:12;
        RBus_UInt32  seg2_mid_dummy_num:4;
        RBus_UInt32  seg2_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg5_mid_dummy_num:4;
        RBus_UInt32  seg5_mid_dummy_place:12;
        RBus_UInt32  seg4_mid_dummy_num:4;
        RBus_UInt32  seg4_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg7_mid_dummy_num:4;
        RBus_UInt32  seg7_mid_dummy_place:12;
        RBus_UInt32  seg6_mid_dummy_num:4;
        RBus_UInt32  seg6_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg9_mid_dummy_num:4;
        RBus_UInt32  seg9_mid_dummy_place:12;
        RBus_UInt32  seg8_mid_dummy_num:4;
        RBus_UInt32  seg8_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg11_mid_dummy_num:4;
        RBus_UInt32  seg11_mid_dummy_place:12;
        RBus_UInt32  seg10_mid_dummy_num:4;
        RBus_UInt32  seg10_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg13_mid_dummy_num:4;
        RBus_UInt32  seg13_mid_dummy_place:12;
        RBus_UInt32  seg12_mid_dummy_num:4;
        RBus_UInt32  seg12_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg15_mid_dummy_num:4;
        RBus_UInt32  seg15_mid_dummy_place:12;
        RBus_UInt32  seg14_mid_dummy_num:4;
        RBus_UInt32  seg14_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  last_ext_pixel:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  active_pixel_rgb:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  ext_subpixel_mode:1;
        RBus_UInt32  res3:6;
        RBus_UInt32  ext_num_fw_mode:1;
    };
}sfg_sfg_data_after_den_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  insert_line0_b_last:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  insert_line0_g_last:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  insert_line0_r_last:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  insert_line0_b_0:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  insert_line0_g_0:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  insert_line0_r_0:3;
        RBus_UInt32  res7:1;
    };
}sfg_sfg_insert_subpixel_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  insert_line1_b_last:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  insert_line1_g_last:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  insert_line1_r_last:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  insert_line1_b_0:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  insert_line1_g_0:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  insert_line1_r_0:3;
        RBus_UInt32  res7:1;
    };
}sfg_sfg_insert_subpixel_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  insert_line2_b_last:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  insert_line2_g_last:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  insert_line2_r_last:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  insert_line2_b_0:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  insert_line2_g_0:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  insert_line2_r_0:3;
        RBus_UInt32  res7:1;
    };
}sfg_sfg_insert_subpixel_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  insert_line3_b_last:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  insert_line3_g_last:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  insert_line3_r_last:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  insert_line3_b_0:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  insert_line3_g_0:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  insert_line3_r_0:3;
        RBus_UInt32  res7:1;
    };
}sfg_sfg_insert_subpixel_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  db_sel:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  dummy_pixel_data:1;
        RBus_UInt32  res3:3;
    };
}sfg_sfg_ctrl_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  last_ext_pixel_last_flip_line0:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  last_ext_pixel_last_flip_line1:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  last_ext_pixel_last_flip_line2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  last_ext_pixel_last_flip_line3:6;
        RBus_UInt32  res4:2;
    };
}sfg_sfg_last_ext_pixel_last_flip_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_port_num:4;
        RBus_UInt32  sfg2_seg_num:4;
        RBus_UInt32  sfg2_h_flip_en:1;
        RBus_UInt32  res1:16;
        RBus_UInt32  sfg2_dout_en:1;
        RBus_UInt32  sfg2_tg_auto_cfg:1;
        RBus_UInt32  sfg2_bypass_mode:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  sfg2_osd_en:1;
        RBus_UInt32  sfg2_in_data_inv:1;
    };
}sfg_sfg2_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_seg1_start:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_seg0_start:13;
        RBus_UInt32  res2:3;
    };
}sfg_sfg2_sta_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_seg3_start:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_seg2_start:13;
        RBus_UInt32  res2:3;
    };
}sfg_sfg2_sta_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_seg5_start:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_seg4_start:13;
        RBus_UInt32  res2:3;
    };
}sfg_sfg2_sta_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_seg7_start:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_seg6_start:13;
        RBus_UInt32  res2:3;
    };
}sfg_sfg2_sta_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_port_7:4;
        RBus_UInt32  sfg2_port_6:4;
        RBus_UInt32  sfg2_port_5:4;
        RBus_UInt32  sfg2_port_4:4;
        RBus_UInt32  sfg2_port_3:4;
        RBus_UInt32  sfg2_port_2:4;
        RBus_UInt32  sfg2_port_1:4;
        RBus_UInt32  sfg2_port_0:4;
    };
}sfg_sfg2_port_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_force_bg_port_0:1;
        RBus_UInt32  sfg2_force_bg_port_1:1;
        RBus_UInt32  sfg2_force_bg_port_2:1;
        RBus_UInt32  sfg2_force_bg_port_3:1;
        RBus_UInt32  sfg2_force_bg_port_4:1;
        RBus_UInt32  sfg2_force_bg_port_5:1;
        RBus_UInt32  sfg2_force_bg_port_6:1;
        RBus_UInt32  sfg2_force_bg_port_7:1;
        RBus_UInt32  res1:23;
        RBus_UInt32  sfg2_force_bg_en:1;
    };
}sfg_sfg2_force_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_bg_b:8;
        RBus_UInt32  sfg2_bg_g:8;
        RBus_UInt32  sfg2_bg_r:8;
        RBus_UInt32  sfg2_bg_a:8;
    };
}sfg_sfg2_force_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_crc_start:1;
        RBus_UInt32  sfg2_crc_conti:1;
        RBus_UInt32  sfg2_crc_r_auto_cmp_en:1;
        RBus_UInt32  sfg2_crc_l_auto_cmp_en:1;
        RBus_UInt32  sfg2_crc_mode:1;
        RBus_UInt32  res1:27;
    };
}sfg_sfg2_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_crc_result_0:32;
    };
}sfg_sfg2_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_crc_result_1:32;
    };
}sfg_sfg2_crc_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_l_des_crc:32;
    };
}sfg_sfg2_crc_l_des_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_r_des_crc:32;
    };
}sfg_sfg2_crc_r_des_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_r_crc_err_cnt:16;
        RBus_UInt32  sfg2_l_crc_err_cnt:16;
    };
}sfg_sfg2_crc_err_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_hsync_delay:16;
        RBus_UInt32  sfg2_hsync_width:8;
        RBus_UInt32  res1:8;
    };
}sfg_sfg2_time_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_vsync_start:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  sfg2_vsync_end:8;
        RBus_UInt32  res2:8;
    };
}sfg_sfg2_time_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_req_start:16;
        RBus_UInt32  sfg2_dh_den_sta:16;
    };
}sfg_sfg2_time_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_final_line_length:13;
        RBus_UInt32  res1:19;
    };
}sfg_sfg2_den_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_hsync_delay_auto:16;
        RBus_UInt32  sfg2_hsync_width_auto:8;
        RBus_UInt32  res1:8;
    };
}sfg_sfg2_time_ctrl_auto_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_vsync_start_auto:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  sfg2_vsync_end_auto:8;
        RBus_UInt32  res2:8;
    };
}sfg_sfg2_time_ctrl_auto_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_req_start_auto:16;
        RBus_UInt32  sfg2_dh_den_sta_auto:16;
    };
}sfg_sfg2_time_ctrl_auto_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_debug_clk_div:2;
        RBus_UInt32  sfg_debug_clk_div:2;
        RBus_UInt32  res1:28;
    };
}sfg_sfg_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  data_capture_h:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  data_capture_v:14;
        RBus_UInt32  res2:2;
    };
}sfg_sfg_data_capture_vh_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  data_capture_port:4;
        RBus_UInt32  data_capture_en:1;
        RBus_UInt32  data_capture_apply:1;
        RBus_UInt32  res1:22;
        RBus_UInt32  data_capture_src:2;
        RBus_UInt32  res2:2;
    };
}sfg_sfg_data_capture_src_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  data_capture_data:32;
    };
}sfg_sfg_data_capture_read_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  last_seg_start_line1:13;
        RBus_UInt32  last_seg_start_res_line1:3;
        RBus_UInt32  last_seg_start_line0:13;
        RBus_UInt32  last_seg_start_res_line0:3;
    };
}sfg_sfg_last_seg_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  last_seg_start_line3:13;
        RBus_UInt32  last_seg_start_res_line3:3;
        RBus_UInt32  last_seg_start_line2:13;
        RBus_UInt32  last_seg_start_res_line2:3;
    };
}sfg_sfg_last_seg_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_r_0_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_0_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_0_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_0_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_g_0_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_0_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_0_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_0_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_b_0_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_0_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_0_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_0_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_r_2_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_2_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_2_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_2_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_g_2_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_2_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_2_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_2_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_b_2_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_2_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_2_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_2_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_r_4_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_4_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_4_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_4_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_g_4_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_4_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_4_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_4_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_b_4_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_4_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_4_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_4_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_r_6_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_6_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_6_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_6_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_g_6_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_6_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_6_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_6_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_b_6_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_6_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_6_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_6_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_r_1_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_1_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_1_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_1_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_g_1_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_1_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_1_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_1_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_b_1_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_1_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_1_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_1_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_r_3_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_3_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_3_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_3_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_g_3_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_3_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_3_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_3_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_b_3_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_3_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_3_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_3_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_r_5_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_5_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_5_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_5_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_g_5_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_5_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_5_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_5_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_b_5_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_5_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_5_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_5_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_r_7_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_r_7_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_r_7_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_r_7_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_g_7_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_g_7_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_g_7_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_g_7_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drd_b_7_line3:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  drd_b_7_line2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  drd_b_7_line1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  drd_b_7_line0:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_drd_ctrl_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  output_portd:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  output_portc:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portb:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_porta:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_swap_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  output_porth:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  output_portg:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portf:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_porte:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_swap_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  output_portl:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  output_portk:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portj:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_porti:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_swap_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  output_portp:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  output_porto:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portn:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_portm:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_swap_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  output_portt:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  output_ports:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portr:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_portq:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_swap_ctrl5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  output_portx:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  output_portw:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  output_portv:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  output_portu:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg_swap_ctrl6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_17_back_dummy_num_3:2;
        RBus_UInt32  seg_17_front_dummy_num_3:2;
        RBus_UInt32  seg_17_back_dummy_num_2:2;
        RBus_UInt32  seg_17_front_dummy_num_2:2;
        RBus_UInt32  seg_17_back_dummy_num_1:2;
        RBus_UInt32  seg_17_front_dummy_num_1:2;
        RBus_UInt32  seg_17_back_dummy_num_0:2;
        RBus_UInt32  seg_17_front_dummy_num_0:2;
        RBus_UInt32  seg_16_back_dummy_num_3:2;
        RBus_UInt32  seg_16_front_dummy_num_3:2;
        RBus_UInt32  seg_16_back_dummy_num_2:2;
        RBus_UInt32  seg_16_front_dummy_num_2:2;
        RBus_UInt32  seg_16_back_dummy_num_1:2;
        RBus_UInt32  seg_16_front_dummy_num_1:2;
        RBus_UInt32  seg_16_back_dummy_num_0:2;
        RBus_UInt32  seg_16_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_19_back_dummy_num_3:2;
        RBus_UInt32  seg_19_front_dummy_num_3:2;
        RBus_UInt32  seg_19_back_dummy_num_2:2;
        RBus_UInt32  seg_19_front_dummy_num_2:2;
        RBus_UInt32  seg_19_back_dummy_num_1:2;
        RBus_UInt32  seg_19_front_dummy_num_1:2;
        RBus_UInt32  seg_19_back_dummy_num_0:2;
        RBus_UInt32  seg_19_front_dummy_num_0:2;
        RBus_UInt32  seg_18_back_dummy_num_3:2;
        RBus_UInt32  seg_18_front_dummy_num_3:2;
        RBus_UInt32  seg_18_back_dummy_num_2:2;
        RBus_UInt32  seg_18_front_dummy_num_2:2;
        RBus_UInt32  seg_18_back_dummy_num_1:2;
        RBus_UInt32  seg_18_front_dummy_num_1:2;
        RBus_UInt32  seg_18_back_dummy_num_0:2;
        RBus_UInt32  seg_18_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_21_back_dummy_num_3:2;
        RBus_UInt32  seg_21_front_dummy_num_3:2;
        RBus_UInt32  seg_21_back_dummy_num_2:2;
        RBus_UInt32  seg_21_front_dummy_num_2:2;
        RBus_UInt32  seg_21_back_dummy_num_1:2;
        RBus_UInt32  seg_21_front_dummy_num_1:2;
        RBus_UInt32  seg_21_back_dummy_num_0:2;
        RBus_UInt32  seg_21_front_dummy_num_0:2;
        RBus_UInt32  seg_20_back_dummy_num_3:2;
        RBus_UInt32  seg_20_front_dummy_num_3:2;
        RBus_UInt32  seg_20_back_dummy_num_2:2;
        RBus_UInt32  seg_20_front_dummy_num_2:2;
        RBus_UInt32  seg_20_back_dummy_num_1:2;
        RBus_UInt32  seg_20_front_dummy_num_1:2;
        RBus_UInt32  seg_20_back_dummy_num_0:2;
        RBus_UInt32  seg_20_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg_23_back_dummy_num_3:2;
        RBus_UInt32  seg_23_front_dummy_num_3:2;
        RBus_UInt32  seg_23_back_dummy_num_2:2;
        RBus_UInt32  seg_23_front_dummy_num_2:2;
        RBus_UInt32  seg_23_back_dummy_num_1:2;
        RBus_UInt32  seg_23_front_dummy_num_1:2;
        RBus_UInt32  seg_23_back_dummy_num_0:2;
        RBus_UInt32  seg_23_front_dummy_num_0:2;
        RBus_UInt32  seg_22_back_dummy_num_3:2;
        RBus_UInt32  seg_22_front_dummy_num_3:2;
        RBus_UInt32  seg_22_back_dummy_num_2:2;
        RBus_UInt32  seg_22_front_dummy_num_2:2;
        RBus_UInt32  seg_22_back_dummy_num_1:2;
        RBus_UInt32  seg_22_front_dummy_num_1:2;
        RBus_UInt32  seg_22_back_dummy_num_0:2;
        RBus_UInt32  seg_22_front_dummy_num_0:2;
    };
}sfg_sfg_dummy_ctrl_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg17_start:13;
        RBus_UInt32  seg17_start_res:3;
        RBus_UInt32  seg16_start:13;
        RBus_UInt32  seg16_start_res:3;
    };
}sfg_sfg_start_ctrl_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg19_start:13;
        RBus_UInt32  seg19_start_res:3;
        RBus_UInt32  seg18_start:13;
        RBus_UInt32  seg18_start_res:3;
    };
}sfg_sfg_start_ctrl_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg21_start:13;
        RBus_UInt32  seg21_start_res:3;
        RBus_UInt32  seg20_start:13;
        RBus_UInt32  seg20_start_res:3;
    };
}sfg_sfg_start_ctrl_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg23_start:13;
        RBus_UInt32  seg23_start_res:3;
        RBus_UInt32  seg22_start:13;
        RBus_UInt32  seg22_start_res:3;
    };
}sfg_sfg_start_ctrl_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg17_mid_dummy_num:4;
        RBus_UInt32  seg17_mid_dummy_place:12;
        RBus_UInt32  seg16_mid_dummy_num:4;
        RBus_UInt32  seg16_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg19_mid_dummy_num:4;
        RBus_UInt32  seg19_mid_dummy_place:12;
        RBus_UInt32  seg18_mid_dummy_num:4;
        RBus_UInt32  seg18_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg21_mid_dummy_num:4;
        RBus_UInt32  seg21_mid_dummy_place:12;
        RBus_UInt32  seg20_mid_dummy_num:4;
        RBus_UInt32  seg20_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seg23_mid_dummy_num:4;
        RBus_UInt32  seg23_mid_dummy_place:12;
        RBus_UInt32  seg22_mid_dummy_num:4;
        RBus_UInt32  seg22_mid_dummy_place:12;
    };
}sfg_sfg_mid_dummy_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_bit_28:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_29:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_30:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_31:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg2_data_sel_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_bit_24:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_25:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_26:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_27:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg2_data_sel_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_bit_20:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_21:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_22:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_23:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg2_data_sel_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_bit_16:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_17:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_18:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_19:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg2_data_sel_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_bit_12:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_13:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_14:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_15:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg2_data_sel_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_bit_8:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_9:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_10:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_11:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg2_data_sel_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_bit_4:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_5:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_6:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_7:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg2_data_sel_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sfg2_in_data_bit_0:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  sfg2_in_data_bit_1:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfg2_in_data_bit_2:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  sfg2_in_data_bit_3:5;
        RBus_UInt32  res4:3;
    };
}sfg_sfg2_data_sel_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fw_ext_subpix_num_line_0:24;
        RBus_UInt32  res1:8;
    };
}sfg_sfg1_ext_subpixel_line_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fw_ext_subpix_num_line_1:24;
        RBus_UInt32  res1:8;
    };
}sfg_sfg1_ext_subpixel_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fw_ext_subpix_num_line_2:24;
        RBus_UInt32  res1:8;
    };
}sfg_sfg1_ext_subpixel_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fw_ext_subpix_num_line_3:24;
        RBus_UInt32  res1:8;
    };
}sfg_sfg1_ext_subpixel_line_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dum_data0_line_0:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dum_data1_line_0:12;
        RBus_UInt32  res2:4;
    };
}sfg_sfg1_dum_data_line_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dum_data0_line_1:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dum_data1_line_1:12;
        RBus_UInt32  res2:4;
    };
}sfg_sfg1_dum_data_line_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dum_data0_line_2:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dum_data1_line_2:12;
        RBus_UInt32  res2:4;
    };
}sfg_sfg1_dum_data_line_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dum_data0_line_3:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dum_data1_line_3:12;
        RBus_UInt32  res2:4;
    };
}sfg_sfg1_dum_data_line_3_RBUS;




#endif 


#endif 
