/**
* @file rbusSync_decmpReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SYNC_DECMP_REG_H_
#define _RBUS_SYNC_DECMP_REG_H_

#include "rbusTypes.h"



//  SYNC_DECMP Register Address



#define  SYNC_DECMP_ST_SP_CTRL_VADDR                        	(0xb8062000)
#define  SYNC_DECMP_ST_SP_AUTORST_VADDR                     	(0xb8062004)
#define  SYNC_DECMP_ST_SP_STBCTRL_VADDR                     	(0xb8062008)
#define  SYNC_DECMP_ST_SP_STBRST0_VADDR                     	(0xb806200c)
#define  SYNC_DECMP_ST_SP_STBRST1_VADDR                     	(0xb8062010)
#define  SYNC_DECMP_ST_SP_DCNT_VADDR                        	(0xb8062014)
#define  SYNC_DECMP_ST_SP_FIELD_VADDR                       	(0xb8062018)
#define  SYNC_DECMP_ST_SP_CLMPMSK_VADDR                     	(0xb806201c)
#define  SYNC_DECMP_ST_SP_COASTFTBK_VADDR                   	(0xb8062020)
#define  SYNC_DECMP_ST_MV_CTRL_VADDR                        	(0xb8062024)
#define  SYNC_DECMP_ST_MV_FLD_POS_VADDR                     	(0xb8062028)
#define  SYNC_DECMP_ST_SP_TEST_SEL_VADDR                    	(0xb806202c)
#define  SYNC_DECMP_ST_SP_PAD_STATUS_VADDR                  	(0xb8062030)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SYNC_DECMP register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_dehs_out_en:1;
        RBus_UInt32  dummy18062000_30:1;
        RBus_UInt32  dummy18062000_29:1;
        RBus_UInt32  st_sp_hsraw_inv:1;
        RBus_UInt32  dummy18062000_27:1;
        RBus_UInt32  dummy18062000_26_24:3;
        RBus_UInt32  st_sp_hrecovery_en:1;
        RBus_UInt32  st_sp_adc_vsout_testmd:1;
        RBus_UInt32  st_sp_devs_out_en:1;
        RBus_UInt32  st_sp_sel_clpmsk_as_devs:1;
        RBus_UInt32  st_sp_hsout_inv:1;
        RBus_UInt32  dummy18062000_18:1;
        RBus_UInt32  st_sp_hs_sync_source:1;
        RBus_UInt32  st_sp_hsout_en:1;
        RBus_UInt32  dummy18062000_15_13:3;
        RBus_UInt32  st_sp_seperate_testmode:1;
        RBus_UInt32  st_sp_auto_run_done_ie:1;
        RBus_UInt32  st_sp_auto_run:1;
        RBus_UInt32  st_sp_coast_en:1;
        RBus_UInt32  st_sp_decmp_en:1;
        RBus_UInt32  dummy18062000_7:1;
        RBus_UInt32  st_sp_hs_fb_plswid_md:2;
        RBus_UInt32  st_sp_coast_inv:1;
        RBus_UInt32  reg_ddc_vsync_inv:1;
        RBus_UInt32  reg_ddc_src_sel:1;
        RBus_UInt32  st_sp_polling_en:1;
        RBus_UInt32  st_sp_vhs_source_sel:1;
    };
}sync_decmp_st_sp_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_auto_result_rdy:1;
        RBus_UInt32  dummy18062004_30:1;
        RBus_UInt32  st_sp_unlock_no_vs_str:6;
        RBus_UInt32  st_sp_unlock_no_vs_end:12;
        RBus_UInt32  res1:5;
        RBus_UInt32  st_sp_auto_result:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  st_sp_input_signal_be_inverted:1;
    };
}sync_decmp_st_sp_autorst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  st_sp_cap_win_range_lsb:2;
        RBus_UInt32  st_sp_hsper_realtime_stbline:2;
        RBus_UInt32  st_sp_hsper_realtime_en:1;
        RBus_UInt32  st_sp_cap_win_clo:1;
        RBus_UInt32  st_sp_cap_win_range:5;
        RBus_UInt32  st_sp_per_range:3;
        RBus_UInt32  st_sp_popup_stable_per:1;
        RBus_UInt32  dummy18062008_6_4:3;
        RBus_UInt32  st_sp_cap_win_step:1;
        RBus_UInt32  st_sp_miss_lock_limit:1;
        RBus_UInt32  dummy18062008_1:1;
        RBus_UInt32  st_sp_stable_en:1;
    };
}sync_decmp_st_sp_stbctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_mode_det_of:1;
        RBus_UInt32  st_sp_stb_per_chg:1;
        RBus_UInt32  st_sp_stb_pol_chg:1;
        RBus_UInt32  st_sp_vs_raw_vld:1;
        RBus_UInt32  st_sp_cap_32unlock:1;
        RBus_UInt32  st_sp_eq_occur:1;
        RBus_UInt32  st_sp_hs_pol_chg:1;
        RBus_UInt32  st_sp_cap_unlock:1;
        RBus_UInt32  st_sp_mode_det_stable:1;
        RBus_UInt32  st_sp_stable_pol_out:1;
        RBus_UInt32  st_sp_cap_unlock_no_vs:1;
        RBus_UInt32  st_sp_giltch_in_win:1;
        RBus_UInt32  st_sp_type_det:1;
        RBus_UInt32  st_sp_type_det_ie:1;
        RBus_UInt32  st_sp_mode_det_stable_ie:1;
        RBus_UInt32  res1:17;
    };
}sync_decmp_st_sp_stbrst0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  st_sp_stable_period_out:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  st_sp_stable_plswid_out:11;
    };
}sync_decmp_st_sp_stbrst1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  st_sp_deb_num:5;
        RBus_UInt32  st_sp_dcnt_level:11;
    };
}sync_decmp_st_sp_dcnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  st_sp_field_det_vs_sel:1;
        RBus_UInt32  st_sp_field_det_mode:1;
        RBus_UInt32  st_sp_f_pos_field:1;
        RBus_UInt32  st_sp_f_pos_field_tgle:1;
        RBus_UInt32  st_sp_f_count_field:1;
        RBus_UInt32  st_sp_f_count_field_tgle:1;
        RBus_UInt32  st_sp_l_cnt_lsb1:3;
    };
}sync_decmp_st_sp_field_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  st_sp_mask_clamp_en:1;
        RBus_UInt32  dummy1806201c_14:1;
        RBus_UInt32  st_sp_mask_front:6;
        RBus_UInt32  dummy1806201c_7_6:2;
        RBus_UInt32  st_sp_mask_back:6;
    };
}sync_decmp_st_sp_clmpmsk_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  dummy18062020_9_8:2;
        RBus_UInt32  st_sp_coast_front:4;
        RBus_UInt32  st_sp_coast_back:4;
    };
}sync_decmp_st_sp_coastftbk_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  dummy18062024_15_13:3;
        RBus_UInt32  st_sp_deb_num_mvhs:5;
        RBus_UInt32  st_sp_skip_line_len:4;
        RBus_UInt32  dummy18062024_3_2:2;
        RBus_UInt32  st_sp_mv_occur:1;
        RBus_UInt32  st_sp_mv_enable:1;
    };
}sync_decmp_st_mv_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18062028_31:1;
        RBus_UInt32  st_sp_o_mv_str:7;
        RBus_UInt32  st_sp_o_mv_rdy:1;
        RBus_UInt32  st_sp_o_mv_end:7;
        RBus_UInt32  dummy18062028_15:1;
        RBus_UInt32  st_sp_e_mv_str:7;
        RBus_UInt32  st_sp_e_mv_rdy:1;
        RBus_UInt32  st_sp_e_mv_end:7;
    };
}sync_decmp_st_mv_fld_pos_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  dummy1806202c_4:1;
        RBus_UInt32  st_sp_sync_test_sel:4;
    };
}sync_decmp_st_sp_test_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  st_sp_tog_adc_sog1_ie:1;
        RBus_UInt32  st_sp_tog_pad_avs1_ie:1;
        RBus_UInt32  st_sp_tog_pad_ahs1_ie:1;
        RBus_UInt32  dummy18062030_7_5:3;
        RBus_UInt32  st_sp_tog_adc_sog1:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  st_sp_tog_pad_avs1:1;
        RBus_UInt32  st_sp_tog_pad_ahs1:1;
    };
}sync_decmp_st_sp_pad_status_RBUS;

#else //apply LITTLE_ENDIAN

//======SYNC_DECMP register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_vhs_source_sel:1;
        RBus_UInt32  st_sp_polling_en:1;
        RBus_UInt32  reg_ddc_src_sel:1;
        RBus_UInt32  reg_ddc_vsync_inv:1;
        RBus_UInt32  st_sp_coast_inv:1;
        RBus_UInt32  st_sp_hs_fb_plswid_md:2;
        RBus_UInt32  dummy18062000_7:1;
        RBus_UInt32  st_sp_decmp_en:1;
        RBus_UInt32  st_sp_coast_en:1;
        RBus_UInt32  st_sp_auto_run:1;
        RBus_UInt32  st_sp_auto_run_done_ie:1;
        RBus_UInt32  st_sp_seperate_testmode:1;
        RBus_UInt32  dummy18062000_15:3;
        RBus_UInt32  st_sp_hsout_en:1;
        RBus_UInt32  st_sp_hs_sync_source:1;
        RBus_UInt32  dummy18062000_18:1;
        RBus_UInt32  st_sp_hsout_inv:1;
        RBus_UInt32  st_sp_sel_clpmsk_as_devs:1;
        RBus_UInt32  st_sp_devs_out_en:1;
        RBus_UInt32  st_sp_adc_vsout_testmd:1;
        RBus_UInt32  st_sp_hrecovery_en:1;
        RBus_UInt32  dummy18062000_26:3;
        RBus_UInt32  dummy18062000_27:1;
        RBus_UInt32  st_sp_hsraw_inv:1;
        RBus_UInt32  dummy18062000_29:1;
        RBus_UInt32  dummy18062000_30:1;
        RBus_UInt32  st_sp_dehs_out_en:1;
    };
}sync_decmp_st_sp_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_input_signal_be_inverted:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  st_sp_auto_result:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  st_sp_unlock_no_vs_end:12;
        RBus_UInt32  st_sp_unlock_no_vs_str:6;
        RBus_UInt32  dummy18062004_30:1;
        RBus_UInt32  st_sp_auto_result_rdy:1;
    };
}sync_decmp_st_sp_autorst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_stable_en:1;
        RBus_UInt32  dummy18062008_1:1;
        RBus_UInt32  st_sp_miss_lock_limit:1;
        RBus_UInt32  st_sp_cap_win_step:1;
        RBus_UInt32  dummy18062008_6:3;
        RBus_UInt32  st_sp_popup_stable_per:1;
        RBus_UInt32  st_sp_per_range:3;
        RBus_UInt32  st_sp_cap_win_range:5;
        RBus_UInt32  st_sp_cap_win_clo:1;
        RBus_UInt32  st_sp_hsper_realtime_en:1;
        RBus_UInt32  st_sp_hsper_realtime_stbline:2;
        RBus_UInt32  st_sp_cap_win_range_lsb:2;
        RBus_UInt32  res1:10;
    };
}sync_decmp_st_sp_stbctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  st_sp_mode_det_stable_ie:1;
        RBus_UInt32  st_sp_type_det_ie:1;
        RBus_UInt32  st_sp_type_det:1;
        RBus_UInt32  st_sp_giltch_in_win:1;
        RBus_UInt32  st_sp_cap_unlock_no_vs:1;
        RBus_UInt32  st_sp_stable_pol_out:1;
        RBus_UInt32  st_sp_mode_det_stable:1;
        RBus_UInt32  st_sp_cap_unlock:1;
        RBus_UInt32  st_sp_hs_pol_chg:1;
        RBus_UInt32  st_sp_eq_occur:1;
        RBus_UInt32  st_sp_cap_32unlock:1;
        RBus_UInt32  st_sp_vs_raw_vld:1;
        RBus_UInt32  st_sp_stb_pol_chg:1;
        RBus_UInt32  st_sp_stb_per_chg:1;
        RBus_UInt32  st_sp_mode_det_of:1;
    };
}sync_decmp_st_sp_stbrst0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_stable_plswid_out:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  st_sp_stable_period_out:11;
        RBus_UInt32  res2:5;
    };
}sync_decmp_st_sp_stbrst1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_dcnt_level:11;
        RBus_UInt32  st_sp_deb_num:5;
        RBus_UInt32  res1:16;
    };
}sync_decmp_st_sp_dcnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_l_cnt_lsb1:3;
        RBus_UInt32  st_sp_f_count_field_tgle:1;
        RBus_UInt32  st_sp_f_count_field:1;
        RBus_UInt32  st_sp_f_pos_field_tgle:1;
        RBus_UInt32  st_sp_f_pos_field:1;
        RBus_UInt32  st_sp_field_det_mode:1;
        RBus_UInt32  st_sp_field_det_vs_sel:1;
        RBus_UInt32  res1:23;
    };
}sync_decmp_st_sp_field_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_mask_back:6;
        RBus_UInt32  dummy1806201c_7_6:2;
        RBus_UInt32  st_sp_mask_front:6;
        RBus_UInt32  dummy1806201c_14_14:1;
        RBus_UInt32  st_sp_mask_clamp_en:1;
        RBus_UInt32  res1:16;
    };
}sync_decmp_st_sp_clmpmsk_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_coast_back:4;
        RBus_UInt32  st_sp_coast_front:4;
        RBus_UInt32  dummy18062020_9_8:2;
        RBus_UInt32  res1:22;
    };
}sync_decmp_st_sp_coastftbk_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_mv_enable:1;
        RBus_UInt32  st_sp_mv_occur:1;
        RBus_UInt32  dummy18062024_3:2;
        RBus_UInt32  st_sp_skip_line_len:4;
        RBus_UInt32  st_sp_deb_num_mvhs:5;
        RBus_UInt32  dummy18062024_15:3;
        RBus_UInt32  res1:16;
    };
}sync_decmp_st_mv_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_e_mv_end:7;
        RBus_UInt32  st_sp_e_mv_rdy:1;
        RBus_UInt32  st_sp_e_mv_str:7;
        RBus_UInt32  dummy18062028_15_15:1;
        RBus_UInt32  st_sp_o_mv_end:7;
        RBus_UInt32  st_sp_o_mv_rdy:1;
        RBus_UInt32  st_sp_o_mv_str:7;
        RBus_UInt32  dummy18062028_31_31:1;
    };
}sync_decmp_st_mv_fld_pos_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_sync_test_sel:4;
        RBus_UInt32  dummy1806202c_4_4:1;
        RBus_UInt32  res1:27;
    };
}sync_decmp_st_sp_test_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  st_sp_tog_pad_ahs1:1;
        RBus_UInt32  st_sp_tog_pad_avs1:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  st_sp_tog_adc_sog1:1;
        RBus_UInt32  dummy18062030_7:3;
        RBus_UInt32  st_sp_tog_pad_ahs1_ie:1;
        RBus_UInt32  st_sp_tog_pad_avs1_ie:1;
        RBus_UInt32  st_sp_tog_adc_sog1_ie:1;
        RBus_UInt32  res2:21;
    };
}sync_decmp_st_sp_pad_status_RBUS;




#endif 


#endif 
