/**
* @file Merlin3-DesignSpec-D-Domain_Stage2_TOP_BIST_BISR_control
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/6/9
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DISPD_WI_OSD_BIST_BISR_REG_H_
#define _RBUS_DISPD_WI_OSD_BIST_BISR_REG_H_

#include "rbusTypes.h"



//  DISPD_WI_OSD_BIST_BISR Register Address



#define  DISPD_WI_OSD_BIST_BISR_DISPD_BIST_MODE_VADDR       	(0xb8029f80)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BIST_DONE_VADDR       	(0xb8029f84)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BIST_FAIL_GROUP_VADDR 	(0xb8029f88)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_DRF_MODE_VADDR        	(0xb8029f8c)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_DRF_RESUME_VADDR      	(0xb8029f90)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_DRF_DONE_VADDR        	(0xb8029f94)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_DRF_PAUSE_VADDR       	(0xb8029f98)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_DRF_FAIL_GROUP_VADDR  	(0xb8029f9c)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM_CRC_G1_VADDR      	(0xb8029fa0)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM_CRC_B1_VADDR      	(0xb8029fa4)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM_CRC_R1_VADDR      	(0xb8029fa8)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM_CRC_G2_VADDR      	(0xb8029fac)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM_CRC_B2_VADDR      	(0xb8029fb0)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM_CRC_R2_VADDR      	(0xb8029fb4)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM2_CRC_G1_VADDR     	(0xb8029fb8)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM2_CRC_B1_VADDR     	(0xb8029fbc)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM2_CRC_R1_VADDR     	(0xb8029fc0)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM2_CRC_G2_VADDR     	(0xb8029fc4)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM2_CRC_B2_VADDR     	(0xb8029fc8)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM2_CRC_R2_VADDR     	(0xb8029fcc)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM_BIST_MODE_VADDR   	(0xb8029fd0)
#define  DISPD_WI_OSD_BIST_BISR_MPLUS_ROM_BIST_DONE_VADDR   	(0xb8029fd4)
#define  DISPD_WI_OSD_BIST_BISR_SIW_ROM_CRC_0_VADDR         	(0xb8029fd8)
#define  DISPD_WI_OSD_BIST_BISR_SIW_ROM_CRC_1_VADDR         	(0xb8029fdc)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BISR_SECOND_RUN_EN_VADDR 	(0xb8029fe0)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BISR_FAIL_GROUP_VADDR 	(0xb8029fe4)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BISR_DRF_MODE_VADDR   	(0xb8029fe8)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BISR_DRF_RESUME_VADDR 	(0xb8029fec)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BISR_DRF_DONE_VADDR   	(0xb8029ff0)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BISR_DRF_PAUSE_VADDR  	(0xb8029ff4)
#define  DISPD_WI_OSD_BIST_BISR_DISPD_BISR_DRF_FAIL_GROUP_VADDR 	(0xb8029ff8)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DISPD_WI_OSD_BIST_BISR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  fcic5_bist_mode:1;
        RBus_UInt32  fcic4_bist_mode:1;
        RBus_UInt32  fcic3_bist_mode:1;
        RBus_UInt32  pod2_1p_bist_mode:1;
        RBus_UInt32  pod2_2p_bist_mode:1;
        RBus_UInt32  mplus_sram_3_bist_mode:1;
        RBus_UInt32  mplus_sram_2_bist_mode:1;
        RBus_UInt32  demura_2p_bist_mode:1;
        RBus_UInt32  pqdc2_bist_mode:1;
        RBus_UInt32  pqdc1_bist_mode:1;
        RBus_UInt32  pqc2_bist_mode:1;
        RBus_UInt32  pqc1_bist_mode:1;
        RBus_UInt32  m_plus_sram_bist_mode:1;
        RBus_UInt32  gdma_subt_dispbuf_bist_mode:1;
        RBus_UInt32  gdma_subt_dma_buf_bist_mode:1;
        RBus_UInt32  gdma_subt_lb_bist_mode:1;
        RBus_UInt32  gdma_subt_rbuf_bist_mode:1;
        RBus_UInt32  gdma_subt_clut_bist_mode:1;
        RBus_UInt32  gamma2_bist_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_bist_mode:1;
        RBus_UInt32  pcid_sld_bist_mode:1;
        RBus_UInt32  demura_bist_mode:1;
        RBus_UInt32  od_line_buf_bist_mode:1;
        RBus_UInt32  oddma_bist_mode:1;
        RBus_UInt32  od_bist_mode:1;
        RBus_UInt32  vi_bist_mode:1;
        RBus_UInt32  duzd_bist_mode:1;
        RBus_UInt32  ld_con_bist_mode:1;
        RBus_UInt32  ld_spi_con_bist_mode:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  fcic5_bist_done:1;
        RBus_UInt32  fcic4_bist_done:1;
        RBus_UInt32  fcic3_bist_done:1;
        RBus_UInt32  pod2_1p_bist_done:1;
        RBus_UInt32  pod2_2p_bist_done:1;
        RBus_UInt32  mplus_sram_bist_done_3:1;
        RBus_UInt32  mplus_sram_bist_done_2:1;
        RBus_UInt32  demura_2p_bist_done:1;
        RBus_UInt32  pqdc2_bist_done:1;
        RBus_UInt32  pqdc1_bist_done:1;
        RBus_UInt32  pqc2_bist_done:1;
        RBus_UInt32  pqc1_bist_done:1;
        RBus_UInt32  m_plus_sram_bist_done:1;
        RBus_UInt32  gdma_subt_dispbuf_bist_done:1;
        RBus_UInt32  gdma_subt_dma_buf_bist_done:1;
        RBus_UInt32  gdma_subt_lb_bist_done:1;
        RBus_UInt32  gdma_subt_rbuf_bist_done:1;
        RBus_UInt32  gdma_subt_clut_bist_done:1;
        RBus_UInt32  gamma2_bist_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_bist_done:1;
        RBus_UInt32  pcid_sld_bist_done:1;
        RBus_UInt32  demura_bist_done:1;
        RBus_UInt32  od_line_buf_bist_done:1;
        RBus_UInt32  oddma_bist_done:1;
        RBus_UInt32  od_bist_done:1;
        RBus_UInt32  vi_bist_done:1;
        RBus_UInt32  duzd_bist_done:1;
        RBus_UInt32  ld_con_bist_done:1;
        RBus_UInt32  ld_spi_con_bist_done:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  fcic5_bist_fail_grp:1;
        RBus_UInt32  fcic4_bist_fail_grp:1;
        RBus_UInt32  fcic3_bist_fail_grp:1;
        RBus_UInt32  pod2_1p_bist_fail_group:1;
        RBus_UInt32  pod2_2p_bist_fail_group:1;
        RBus_UInt32  mplus_bist_fail_group_3:1;
        RBus_UInt32  mplus_bist_fail_group_2:1;
        RBus_UInt32  demura_2p_bist_fail_group:1;
        RBus_UInt32  pqdc2_bist_fail_group:1;
        RBus_UInt32  pqdc1_bist_fail_group:1;
        RBus_UInt32  pqc2_bist_fail_group:1;
        RBus_UInt32  pqc1_bist_fail_group:1;
        RBus_UInt32  m_plus_bist_fail_group:1;
        RBus_UInt32  gdma_subt_dispbuf_bist_fail_group:1;
        RBus_UInt32  gdma_subt_dma_buf_bist_fail_group:1;
        RBus_UInt32  gdma_subt_lb_bist_fail_group:1;
        RBus_UInt32  gdma_subt_rbuf_bist_fail_group:1;
        RBus_UInt32  gdma_subt_clut_bist_fail_group:1;
        RBus_UInt32  gamma2_bist_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_bist_fail_group:1;
        RBus_UInt32  pcid_sld_bist_fail_group:1;
        RBus_UInt32  demura_bist_fail_group:1;
        RBus_UInt32  od_line_buf_bist_fail_group:1;
        RBus_UInt32  oddma_bist_fail_group:1;
        RBus_UInt32  od_bist_fail_group:1;
        RBus_UInt32  vi_bist_fail_group:1;
        RBus_UInt32  duzd_bist_fail_group:1;
        RBus_UInt32  ld_con_bist_fail_group:1;
        RBus_UInt32  ld_spi_con_bist_fail_group:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  fcic5_drf_bist_mode:1;
        RBus_UInt32  fcic4_drf_bist_mode:1;
        RBus_UInt32  fcic3_drf_bist_mode:1;
        RBus_UInt32  pod2_1p_drf_mode:1;
        RBus_UInt32  pod2_2p_drf_mode:1;
        RBus_UInt32  mplus_drf_3_bist_mode:1;
        RBus_UInt32  mplus_drf_2_bist_mode:1;
        RBus_UInt32  demura_2p_drf_bist_mode:1;
        RBus_UInt32  pqdc2_drf_bist_mode:1;
        RBus_UInt32  pqdc1_drf_bist_mode:1;
        RBus_UInt32  pqc2_drf_bist_mode:1;
        RBus_UInt32  pqc1_drf_bist_mode:1;
        RBus_UInt32  m_plus_drf_mode:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_mode:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_mode:1;
        RBus_UInt32  gdma_subt_lb_drf_mode:1;
        RBus_UInt32  gdma_subt_rbuf_drf_mode:1;
        RBus_UInt32  gdma_subt_clut_drf_mode:1;
        RBus_UInt32  gamma2_drf_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_drf_mode:1;
        RBus_UInt32  pcid_sld_drf_mode:1;
        RBus_UInt32  demura_drf_bist_mode:1;
        RBus_UInt32  od_line_buf_drf_mode:1;
        RBus_UInt32  oddma_drf_mode:1;
        RBus_UInt32  od_drf_mode:1;
        RBus_UInt32  vi_drf_mode:1;
        RBus_UInt32  duzd_drf_mode:1;
        RBus_UInt32  ld_con_drf_mode:1;
        RBus_UInt32  ld_spi_con_drf_mode:1;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  fcic5_drf_test_resume:1;
        RBus_UInt32  fcic4_drf_test_resume:1;
        RBus_UInt32  fcic3_drf_test_resume:1;
        RBus_UInt32  pod2_1p_drf_resume:1;
        RBus_UInt32  pod2_2p_drf_resume:1;
        RBus_UInt32  mplus_drf_3_test_resume:1;
        RBus_UInt32  mplus_drf_2_test_resume:1;
        RBus_UInt32  demura_2p_test_resume:1;
        RBus_UInt32  pqdc2_drf_test_resume:1;
        RBus_UInt32  pqdc1_drf_test_resume:1;
        RBus_UInt32  pqc2_drf_test_resume:1;
        RBus_UInt32  pqc1_drf_test_resume:1;
        RBus_UInt32  m_plus_drf_resume:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_resume:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_resume:1;
        RBus_UInt32  gdma_subt_lb_drf_resume:1;
        RBus_UInt32  gdma_subt_rbuf_drf_resume:1;
        RBus_UInt32  gdma_subt_clut_drf_resume:1;
        RBus_UInt32  gamma2_drf_resume:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_drf_resume:1;
        RBus_UInt32  pcid_sld_drf_resume:1;
        RBus_UInt32  demura_test_resume:1;
        RBus_UInt32  od_line_buf_drf_resume:1;
        RBus_UInt32  oddma_drf_resume:1;
        RBus_UInt32  od_drf_resume:1;
        RBus_UInt32  vi_drf_resume:1;
        RBus_UInt32  duzd_drf_resume:1;
        RBus_UInt32  ld_con_drf_resume:1;
        RBus_UInt32  ld_spi_con_drf_resume:1;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  fcic5_drf_bist_done:1;
        RBus_UInt32  fcic4_drf_bist_done:1;
        RBus_UInt32  fcic3_drf_bist_done:1;
        RBus_UInt32  pod2_1p_drf_done:1;
        RBus_UInt32  pod2_2p_drf_done:1;
        RBus_UInt32  mplus_drf_bist_done_3:1;
        RBus_UInt32  mplus_drf_bist_done_2:1;
        RBus_UInt32  demura_2p_drf_bist_done:1;
        RBus_UInt32  pqdc2_drf_bist_done:1;
        RBus_UInt32  pqdc1_drf_bist_done:1;
        RBus_UInt32  pqc2_drf_bist_done:1;
        RBus_UInt32  pqc1_drf_bist_done:1;
        RBus_UInt32  m_plus_drf_done:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_done:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_done:1;
        RBus_UInt32  gdma_subt_lb_drf_done:1;
        RBus_UInt32  gdma_subt_rbuf_drf_done:1;
        RBus_UInt32  gdma_subt_clut_drf_done:1;
        RBus_UInt32  gamma2_drf_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_drf_done:1;
        RBus_UInt32  pcid_sld_drf_done:1;
        RBus_UInt32  demura_drf_bist_done:1;
        RBus_UInt32  od_line_buf_drf_done:1;
        RBus_UInt32  oddma_drf_done:1;
        RBus_UInt32  od_drf_done:1;
        RBus_UInt32  vi_drf_done:1;
        RBus_UInt32  duzd_drf_done:1;
        RBus_UInt32  ld_con_drf_done:1;
        RBus_UInt32  ld_spi_con_drf_done:1;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  fcic5_drf_start_pause:1;
        RBus_UInt32  fcic4_drf_start_pause:1;
        RBus_UInt32  fcic3_drf_start_pause:1;
        RBus_UInt32  pod2_1p_drf_pause:1;
        RBus_UInt32  pod2_2p_drf_pause:1;
        RBus_UInt32  mplus_drf_3_start_pause:1;
        RBus_UInt32  mplus_drf_2_start_pause:1;
        RBus_UInt32  demura_2p_drf_start_pause:1;
        RBus_UInt32  pqdc2_drf_start_pause:1;
        RBus_UInt32  pqdc1_drf_start_pause:1;
        RBus_UInt32  pqc2_drf_start_pause:1;
        RBus_UInt32  pqc1_drf_start_pause:1;
        RBus_UInt32  m_plus_drf_pause:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_pause:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_pause:1;
        RBus_UInt32  gdma_subt_lb_drf_pause:1;
        RBus_UInt32  gdma_subt_rbuf_drf_pause:1;
        RBus_UInt32  gdma_subt_clut_drf_pause:1;
        RBus_UInt32  gamma2_drf_pause:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_drf_pause:1;
        RBus_UInt32  pcid_sld_drf_pause:1;
        RBus_UInt32  demura_drf_start_pause:1;
        RBus_UInt32  od_line_buf_drf_pause:1;
        RBus_UInt32  oddma_drf_pause:1;
        RBus_UInt32  od_drf_pause:1;
        RBus_UInt32  vi_drf_pause:1;
        RBus_UInt32  duzd_drf_pause:1;
        RBus_UInt32  ld_con_drf_pause:1;
        RBus_UInt32  ld_spi_con_drf_pause:1;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  fcic5_bist_drf_fail_grp:1;
        RBus_UInt32  fcic4_bist_drf_fail_grp:1;
        RBus_UInt32  fcic3_bist_drf_fail_grp:1;
        RBus_UInt32  pod2_1p_drf_fail_group:1;
        RBus_UInt32  pod2_2p_drf_fail_group:1;
        RBus_UInt32  mplus_drf_fail_group_3:1;
        RBus_UInt32  mplus_drf_fail_group_2:1;
        RBus_UInt32  demura_2p_drf_fail_group:1;
        RBus_UInt32  pqdc2_drf_fail_group:1;
        RBus_UInt32  pqdc1_drf_fail_group:1;
        RBus_UInt32  pqc2_drf_fail_group:1;
        RBus_UInt32  pqc1_drf_fail_group:1;
        RBus_UInt32  m_plus_drf_fail_group:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_fail_group:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_fail_group:1;
        RBus_UInt32  gdma_subt_lb_drf_fail_group:1;
        RBus_UInt32  gdma_subt_rbuf_drf_fail_group:1;
        RBus_UInt32  gdma_subt_clut_drf_fail_group:1;
        RBus_UInt32  gamma2_drf_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  inv_out_gamma_drf_fail_group:1;
        RBus_UInt32  pcid_sld_drf_fail_group:1;
        RBus_UInt32  demura_drf_fail_group:1;
        RBus_UInt32  od_line_buf_drf_fail_group:1;
        RBus_UInt32  oddma_drf_fail_group:1;
        RBus_UInt32  od_drf_fail_group:1;
        RBus_UInt32  vi_drf_fail_group:1;
        RBus_UInt32  duzd_drf_fail_group:1;
        RBus_UInt32  ld_con_drf_fail_group:1;
        RBus_UInt32  ld_spi_con_drf_fail_group:1;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_g1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_g1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_b1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_r1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_g2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_g2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_b2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_r2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_g1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_g1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_b1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_r1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_g2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_g2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_b2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_r2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  siw_rom_bist_mode:1;
        RBus_UInt32  mplus_rom2_bist_mode:1;
        RBus_UInt32  m_plus_rom_bist_mode:1;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  siw_rom_bist_done:1;
        RBus_UInt32  mplus_rom2_bist_done:1;
        RBus_UInt32  m_plus_rom_bist_done:1;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  siw_rom_misr_dataout_0:32;
    };
}dispd_wi_osd_bist_bisr_siw_rom_crc_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  siw_rom_misr_dataout_1:32;
    };
}dispd_wi_osd_bist_bisr_siw_rom_crc_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fcic2_second_run_en:1;
        RBus_UInt32  fcic1_second_run_en:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fcic2_bisr_fail_grp:1;
        RBus_UInt32  fcic1_bisr_fail_grp:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fcic2_drf_bisr_mode:1;
        RBus_UInt32  fcic1_drf_bisr_mode:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fcic2_drf_bisr_test_resume:1;
        RBus_UInt32  fcic1_drf_bisr_test_resume:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fcic2_drf_bisr_done:1;
        RBus_UInt32  fcic1_drf_bisr_done:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fcic2_drf_bisr_start_pause:1;
        RBus_UInt32  fcic1_drf_bisr_start_pause:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fcic2_bisr_drf_fail_grp:1;
        RBus_UInt32  fcic1_bisr_drf_fail_grp:1;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_fail_group_RBUS;

#else //apply LITTLE_ENDIAN

//======DISPD_WI_OSD_BIST_BISR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_spi_con_bist_mode:1;
        RBus_UInt32  ld_con_bist_mode:1;
        RBus_UInt32  duzd_bist_mode:1;
        RBus_UInt32  vi_bist_mode:1;
        RBus_UInt32  od_bist_mode:1;
        RBus_UInt32  oddma_bist_mode:1;
        RBus_UInt32  od_line_buf_bist_mode:1;
        RBus_UInt32  demura_bist_mode:1;
        RBus_UInt32  pcid_sld_bist_mode:1;
        RBus_UInt32  inv_out_gamma_bist_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_bist_mode:1;
        RBus_UInt32  gdma_subt_clut_bist_mode:1;
        RBus_UInt32  gdma_subt_rbuf_bist_mode:1;
        RBus_UInt32  gdma_subt_lb_bist_mode:1;
        RBus_UInt32  gdma_subt_dma_buf_bist_mode:1;
        RBus_UInt32  gdma_subt_dispbuf_bist_mode:1;
        RBus_UInt32  m_plus_sram_bist_mode:1;
        RBus_UInt32  pqc1_bist_mode:1;
        RBus_UInt32  pqc2_bist_mode:1;
        RBus_UInt32  pqdc1_bist_mode:1;
        RBus_UInt32  pqdc2_bist_mode:1;
        RBus_UInt32  demura_2p_bist_mode:1;
        RBus_UInt32  mplus_sram_2_bist_mode:1;
        RBus_UInt32  mplus_sram_3_bist_mode:1;
        RBus_UInt32  pod2_2p_bist_mode:1;
        RBus_UInt32  pod2_1p_bist_mode:1;
        RBus_UInt32  fcic3_bist_mode:1;
        RBus_UInt32  fcic4_bist_mode:1;
        RBus_UInt32  fcic5_bist_mode:1;
        RBus_UInt32  res2:2;
    };
}dispd_wi_osd_bist_bisr_dispd_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_spi_con_bist_done:1;
        RBus_UInt32  ld_con_bist_done:1;
        RBus_UInt32  duzd_bist_done:1;
        RBus_UInt32  vi_bist_done:1;
        RBus_UInt32  od_bist_done:1;
        RBus_UInt32  oddma_bist_done:1;
        RBus_UInt32  od_line_buf_bist_done:1;
        RBus_UInt32  demura_bist_done:1;
        RBus_UInt32  pcid_sld_bist_done:1;
        RBus_UInt32  inv_out_gamma_bist_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_bist_done:1;
        RBus_UInt32  gdma_subt_clut_bist_done:1;
        RBus_UInt32  gdma_subt_rbuf_bist_done:1;
        RBus_UInt32  gdma_subt_lb_bist_done:1;
        RBus_UInt32  gdma_subt_dma_buf_bist_done:1;
        RBus_UInt32  gdma_subt_dispbuf_bist_done:1;
        RBus_UInt32  m_plus_sram_bist_done:1;
        RBus_UInt32  pqc1_bist_done:1;
        RBus_UInt32  pqc2_bist_done:1;
        RBus_UInt32  pqdc1_bist_done:1;
        RBus_UInt32  pqdc2_bist_done:1;
        RBus_UInt32  demura_2p_bist_done:1;
        RBus_UInt32  mplus_sram_bist_done_2:1;
        RBus_UInt32  mplus_sram_bist_done_3:1;
        RBus_UInt32  pod2_2p_bist_done:1;
        RBus_UInt32  pod2_1p_bist_done:1;
        RBus_UInt32  fcic3_bist_done:1;
        RBus_UInt32  fcic4_bist_done:1;
        RBus_UInt32  fcic5_bist_done:1;
        RBus_UInt32  res2:2;
    };
}dispd_wi_osd_bist_bisr_dispd_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_spi_con_bist_fail_group:1;
        RBus_UInt32  ld_con_bist_fail_group:1;
        RBus_UInt32  duzd_bist_fail_group:1;
        RBus_UInt32  vi_bist_fail_group:1;
        RBus_UInt32  od_bist_fail_group:1;
        RBus_UInt32  oddma_bist_fail_group:1;
        RBus_UInt32  od_line_buf_bist_fail_group:1;
        RBus_UInt32  demura_bist_fail_group:1;
        RBus_UInt32  pcid_sld_bist_fail_group:1;
        RBus_UInt32  inv_out_gamma_bist_fail_group:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_bist_fail_group:1;
        RBus_UInt32  gdma_subt_clut_bist_fail_group:1;
        RBus_UInt32  gdma_subt_rbuf_bist_fail_group:1;
        RBus_UInt32  gdma_subt_lb_bist_fail_group:1;
        RBus_UInt32  gdma_subt_dma_buf_bist_fail_group:1;
        RBus_UInt32  gdma_subt_dispbuf_bist_fail_group:1;
        RBus_UInt32  m_plus_bist_fail_group:1;
        RBus_UInt32  pqc1_bist_fail_group:1;
        RBus_UInt32  pqc2_bist_fail_group:1;
        RBus_UInt32  pqdc1_bist_fail_group:1;
        RBus_UInt32  pqdc2_bist_fail_group:1;
        RBus_UInt32  demura_2p_bist_fail_group:1;
        RBus_UInt32  mplus_bist_fail_group_2:1;
        RBus_UInt32  mplus_bist_fail_group_3:1;
        RBus_UInt32  pod2_2p_bist_fail_group:1;
        RBus_UInt32  pod2_1p_bist_fail_group:1;
        RBus_UInt32  fcic3_bist_fail_grp:1;
        RBus_UInt32  fcic4_bist_fail_grp:1;
        RBus_UInt32  fcic5_bist_fail_grp:1;
        RBus_UInt32  res2:2;
    };
}dispd_wi_osd_bist_bisr_dispd_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_spi_con_drf_mode:1;
        RBus_UInt32  ld_con_drf_mode:1;
        RBus_UInt32  duzd_drf_mode:1;
        RBus_UInt32  vi_drf_mode:1;
        RBus_UInt32  od_drf_mode:1;
        RBus_UInt32  oddma_drf_mode:1;
        RBus_UInt32  od_line_buf_drf_mode:1;
        RBus_UInt32  demura_drf_bist_mode:1;
        RBus_UInt32  pcid_sld_drf_mode:1;
        RBus_UInt32  inv_out_gamma_drf_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_drf_mode:1;
        RBus_UInt32  gdma_subt_clut_drf_mode:1;
        RBus_UInt32  gdma_subt_rbuf_drf_mode:1;
        RBus_UInt32  gdma_subt_lb_drf_mode:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_mode:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_mode:1;
        RBus_UInt32  m_plus_drf_mode:1;
        RBus_UInt32  pqc1_drf_bist_mode:1;
        RBus_UInt32  pqc2_drf_bist_mode:1;
        RBus_UInt32  pqdc1_drf_bist_mode:1;
        RBus_UInt32  pqdc2_drf_bist_mode:1;
        RBus_UInt32  demura_2p_drf_bist_mode:1;
        RBus_UInt32  mplus_drf_2_bist_mode:1;
        RBus_UInt32  mplus_drf_3_bist_mode:1;
        RBus_UInt32  pod2_2p_drf_mode:1;
        RBus_UInt32  pod2_1p_drf_mode:1;
        RBus_UInt32  fcic3_drf_bist_mode:1;
        RBus_UInt32  fcic4_drf_bist_mode:1;
        RBus_UInt32  fcic5_drf_bist_mode:1;
        RBus_UInt32  res2:2;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_spi_con_drf_resume:1;
        RBus_UInt32  ld_con_drf_resume:1;
        RBus_UInt32  duzd_drf_resume:1;
        RBus_UInt32  vi_drf_resume:1;
        RBus_UInt32  od_drf_resume:1;
        RBus_UInt32  oddma_drf_resume:1;
        RBus_UInt32  od_line_buf_drf_resume:1;
        RBus_UInt32  demura_test_resume:1;
        RBus_UInt32  pcid_sld_drf_resume:1;
        RBus_UInt32  inv_out_gamma_drf_resume:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_drf_resume:1;
        RBus_UInt32  gdma_subt_clut_drf_resume:1;
        RBus_UInt32  gdma_subt_rbuf_drf_resume:1;
        RBus_UInt32  gdma_subt_lb_drf_resume:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_resume:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_resume:1;
        RBus_UInt32  m_plus_drf_resume:1;
        RBus_UInt32  pqc1_drf_test_resume:1;
        RBus_UInt32  pqc2_drf_test_resume:1;
        RBus_UInt32  pqdc1_drf_test_resume:1;
        RBus_UInt32  pqdc2_drf_test_resume:1;
        RBus_UInt32  demura_2p_test_resume:1;
        RBus_UInt32  mplus_drf_2_test_resume:1;
        RBus_UInt32  mplus_drf_3_test_resume:1;
        RBus_UInt32  pod2_2p_drf_resume:1;
        RBus_UInt32  pod2_1p_drf_resume:1;
        RBus_UInt32  fcic3_drf_test_resume:1;
        RBus_UInt32  fcic4_drf_test_resume:1;
        RBus_UInt32  fcic5_drf_test_resume:1;
        RBus_UInt32  res2:2;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_spi_con_drf_done:1;
        RBus_UInt32  ld_con_drf_done:1;
        RBus_UInt32  duzd_drf_done:1;
        RBus_UInt32  vi_drf_done:1;
        RBus_UInt32  od_drf_done:1;
        RBus_UInt32  oddma_drf_done:1;
        RBus_UInt32  od_line_buf_drf_done:1;
        RBus_UInt32  demura_drf_bist_done:1;
        RBus_UInt32  pcid_sld_drf_done:1;
        RBus_UInt32  inv_out_gamma_drf_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_drf_done:1;
        RBus_UInt32  gdma_subt_clut_drf_done:1;
        RBus_UInt32  gdma_subt_rbuf_drf_done:1;
        RBus_UInt32  gdma_subt_lb_drf_done:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_done:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_done:1;
        RBus_UInt32  m_plus_drf_done:1;
        RBus_UInt32  pqc1_drf_bist_done:1;
        RBus_UInt32  pqc2_drf_bist_done:1;
        RBus_UInt32  pqdc1_drf_bist_done:1;
        RBus_UInt32  pqdc2_drf_bist_done:1;
        RBus_UInt32  demura_2p_drf_bist_done:1;
        RBus_UInt32  mplus_drf_bist_done_2:1;
        RBus_UInt32  mplus_drf_bist_done_3:1;
        RBus_UInt32  pod2_2p_drf_done:1;
        RBus_UInt32  pod2_1p_drf_done:1;
        RBus_UInt32  fcic3_drf_bist_done:1;
        RBus_UInt32  fcic4_drf_bist_done:1;
        RBus_UInt32  fcic5_drf_bist_done:1;
        RBus_UInt32  res2:2;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_spi_con_drf_pause:1;
        RBus_UInt32  ld_con_drf_pause:1;
        RBus_UInt32  duzd_drf_pause:1;
        RBus_UInt32  vi_drf_pause:1;
        RBus_UInt32  od_drf_pause:1;
        RBus_UInt32  oddma_drf_pause:1;
        RBus_UInt32  od_line_buf_drf_pause:1;
        RBus_UInt32  demura_drf_start_pause:1;
        RBus_UInt32  pcid_sld_drf_pause:1;
        RBus_UInt32  inv_out_gamma_drf_pause:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_drf_pause:1;
        RBus_UInt32  gdma_subt_clut_drf_pause:1;
        RBus_UInt32  gdma_subt_rbuf_drf_pause:1;
        RBus_UInt32  gdma_subt_lb_drf_pause:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_pause:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_pause:1;
        RBus_UInt32  m_plus_drf_pause:1;
        RBus_UInt32  pqc1_drf_start_pause:1;
        RBus_UInt32  pqc2_drf_start_pause:1;
        RBus_UInt32  pqdc1_drf_start_pause:1;
        RBus_UInt32  pqdc2_drf_start_pause:1;
        RBus_UInt32  demura_2p_drf_start_pause:1;
        RBus_UInt32  mplus_drf_2_start_pause:1;
        RBus_UInt32  mplus_drf_3_start_pause:1;
        RBus_UInt32  pod2_2p_drf_pause:1;
        RBus_UInt32  pod2_1p_drf_pause:1;
        RBus_UInt32  fcic3_drf_start_pause:1;
        RBus_UInt32  fcic4_drf_start_pause:1;
        RBus_UInt32  fcic5_drf_start_pause:1;
        RBus_UInt32  res2:2;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_spi_con_drf_fail_group:1;
        RBus_UInt32  ld_con_drf_fail_group:1;
        RBus_UInt32  duzd_drf_fail_group:1;
        RBus_UInt32  vi_drf_fail_group:1;
        RBus_UInt32  od_drf_fail_group:1;
        RBus_UInt32  oddma_drf_fail_group:1;
        RBus_UInt32  od_line_buf_drf_fail_group:1;
        RBus_UInt32  demura_drf_fail_group:1;
        RBus_UInt32  pcid_sld_drf_fail_group:1;
        RBus_UInt32  inv_out_gamma_drf_fail_group:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_drf_fail_group:1;
        RBus_UInt32  gdma_subt_clut_drf_fail_group:1;
        RBus_UInt32  gdma_subt_rbuf_drf_fail_group:1;
        RBus_UInt32  gdma_subt_lb_drf_fail_group:1;
        RBus_UInt32  gdma_subt_dma_buf_drf_fail_group:1;
        RBus_UInt32  gdma_subt_dispbuf_drf_fail_group:1;
        RBus_UInt32  m_plus_drf_fail_group:1;
        RBus_UInt32  pqc1_drf_fail_group:1;
        RBus_UInt32  pqc2_drf_fail_group:1;
        RBus_UInt32  pqdc1_drf_fail_group:1;
        RBus_UInt32  pqdc2_drf_fail_group:1;
        RBus_UInt32  demura_2p_drf_fail_group:1;
        RBus_UInt32  mplus_drf_fail_group_2:1;
        RBus_UInt32  mplus_drf_fail_group_3:1;
        RBus_UInt32  pod2_2p_drf_fail_group:1;
        RBus_UInt32  pod2_1p_drf_fail_group:1;
        RBus_UInt32  fcic3_bist_drf_fail_grp:1;
        RBus_UInt32  fcic4_bist_drf_fail_grp:1;
        RBus_UInt32  fcic5_bist_drf_fail_grp:1;
        RBus_UInt32  res2:2;
    };
}dispd_wi_osd_bist_bisr_dispd_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_g1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_g1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_b1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_r1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_g2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_g2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_b2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_crc_r2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_crc_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_g1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_g1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_b1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_r1:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_g2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_g2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_b2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom2_crc_r2:32;
    };
}dispd_wi_osd_bist_bisr_mplus_rom2_crc_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_bist_mode:1;
        RBus_UInt32  mplus_rom2_bist_mode:1;
        RBus_UInt32  siw_rom_bist_mode:1;
        RBus_UInt32  res1:29;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m_plus_rom_bist_done:1;
        RBus_UInt32  mplus_rom2_bist_done:1;
        RBus_UInt32  siw_rom_bist_done:1;
        RBus_UInt32  res1:29;
    };
}dispd_wi_osd_bist_bisr_mplus_rom_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  siw_rom_misr_dataout_0:32;
    };
}dispd_wi_osd_bist_bisr_siw_rom_crc_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  siw_rom_misr_dataout_1:32;
    };
}dispd_wi_osd_bist_bisr_siw_rom_crc_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic1_second_run_en:1;
        RBus_UInt32  fcic2_second_run_en:1;
        RBus_UInt32  res1:30;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic1_bisr_fail_grp:1;
        RBus_UInt32  fcic2_bisr_fail_grp:1;
        RBus_UInt32  res1:30;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic1_drf_bisr_mode:1;
        RBus_UInt32  fcic2_drf_bisr_mode:1;
        RBus_UInt32  res1:30;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic1_drf_bisr_test_resume:1;
        RBus_UInt32  fcic2_drf_bisr_test_resume:1;
        RBus_UInt32  res1:30;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic1_drf_bisr_done:1;
        RBus_UInt32  fcic2_drf_bisr_done:1;
        RBus_UInt32  res1:30;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic1_drf_bisr_start_pause:1;
        RBus_UInt32  fcic2_drf_bisr_start_pause:1;
        RBus_UInt32  res1:30;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic1_bisr_drf_fail_grp:1;
        RBus_UInt32  fcic2_bisr_drf_fail_grp:1;
        RBus_UInt32  res1:30;
    };
}dispd_wi_osd_bist_bisr_dispd_bisr_drf_fail_group_RBUS;




#endif 


#endif 
