/**
* @file Merlin3-DesignSpec-D-Domain_GDMA_BIST_BISR_control
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/6/9
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DISPD_OSD_BIST_REG_H_
#define _RBUS_DISPD_OSD_BIST_REG_H_

#include "rbusTypes.h"



//  DISPD_OSD_BIST Register Address



#define  DISPD_OSD_BIST_GDMA_BIST_MODE_VADDR                	(0xb8029e00)
#define  DISPD_OSD_BIST_GDMA_BIST_DONE_VADDR                	(0xb8029e04)
#define  DISPD_OSD_BIST_GDMA_BIST_FAIL_GROUP_VADDR          	(0xb8029e08)
#define  DISPD_OSD_BIST_GDMA_DRF_MODE_VADDR                 	(0xb8029e0c)
#define  DISPD_OSD_BIST_GDMA_DRF_RESUME_VADDR               	(0xb8029e10)
#define  DISPD_OSD_BIST_GDMA_DRF_DONE_VADDR                 	(0xb8029e14)
#define  DISPD_OSD_BIST_GDMA_DRF_PAUSE_VADDR                	(0xb8029e18)
#define  DISPD_OSD_BIST_GDMA_DRF_FAIL_GROUP_VADDR           	(0xb8029e1c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DISPD_OSD_BIST register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
        RBus_UInt32  gdma_osd_gamma1_bist_mode:1;
        RBus_UInt32  gdma_osd_gamma2_bist_mode:1;
        RBus_UInt32  gdma_fbdc_lb_bist_mode:1;
        RBus_UInt32  gdma_osd1_clut_bist_mode:1;
        RBus_UInt32  gdma_osd2_clut_bist_mode:1;
        RBus_UInt32  gdma_osd3_clut_bist_mode:1;
        RBus_UInt32  gdma_osd_rbuf_bist_mode:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_mode:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_mode:1;
    };
}dispd_osd_bist_gdma_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
        RBus_UInt32  gdma_osd_gamma1_bist_done:1;
        RBus_UInt32  gdma_osd_gamma2_bist_done:1;
        RBus_UInt32  gdma_fbdc_lb_bist_done:1;
        RBus_UInt32  gdma_osd1_clut_bist_done:1;
        RBus_UInt32  gdma_osd2_clut_bist_done:1;
        RBus_UInt32  gdma_osd3_clut_bist_done:1;
        RBus_UInt32  gdma_osd_rbuf_bist_done:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_done:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_done:1;
    };
}dispd_osd_bist_gdma_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
        RBus_UInt32  gdma_osd_gamma1_bist_fail_group:1;
        RBus_UInt32  gdma_osd_gamma2_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_lb_bist_fail_group:1;
        RBus_UInt32  gdma_osd1_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd2_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd3_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_bist_fail_group:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_fail_group:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_fail_group:1;
    };
}dispd_osd_bist_gdma_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
        RBus_UInt32  gdma_osd_gamma1_drf_mode:1;
        RBus_UInt32  gdma_osd_gamma2_drf_mode:1;
        RBus_UInt32  gdma_fbdc_lb_drf_mode:1;
        RBus_UInt32  gdma_osd1_clut_drf_mode:1;
        RBus_UInt32  gdma_osd2_clut_drf_mode:1;
        RBus_UInt32  gdma_osd3_clut_drf_mode:1;
        RBus_UInt32  gdma_osd_rbuf_drf_mode:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_mode:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_mode:1;
    };
}dispd_osd_bist_gdma_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
        RBus_UInt32  gdma_osd_gamma1_drf_resume:1;
        RBus_UInt32  gdma_osd_gamma2_drf_resume:1;
        RBus_UInt32  gdma_fbdc_lb_drf_resume:1;
        RBus_UInt32  gdma_osd1_clut_drf_resume:1;
        RBus_UInt32  gdma_osd2_clut_drf_resume:1;
        RBus_UInt32  gdma_osd3_clut_drf_resume:1;
        RBus_UInt32  gdma_osd_rbuf_drf_resume:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_resume:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_resume:1;
    };
}dispd_osd_bist_gdma_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
        RBus_UInt32  gdma_osd_gamma1_drf_done:1;
        RBus_UInt32  gdma_osd_gamma2_drf_done:1;
        RBus_UInt32  gdma_fbdc_lb_drf_done:1;
        RBus_UInt32  gdma_osd1_clut_drf_done:1;
        RBus_UInt32  gdma_osd2_clut_drf_done:1;
        RBus_UInt32  gdma_osd3_clut_drf_done:1;
        RBus_UInt32  gdma_osd_rbuf_drf_done:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_done:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_done:1;
    };
}dispd_osd_bist_gdma_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
        RBus_UInt32  gdma_osd_gamma1_drf_pause:1;
        RBus_UInt32  gdma_osd_gamma2_drf_pause:1;
        RBus_UInt32  gdma_fbdc_lb_drf_pause:1;
        RBus_UInt32  gdma_osd1_clut_drf_pause:1;
        RBus_UInt32  gdma_osd2_clut_drf_pause:1;
        RBus_UInt32  gdma_osd3_clut_drf_pause:1;
        RBus_UInt32  gdma_osd_rbuf_drf_pause:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_pause:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_pause:1;
    };
}dispd_osd_bist_gdma_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
        RBus_UInt32  gdma_osd_gamma1_drf_fail_group:1;
        RBus_UInt32  gdma_osd_gamma2_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_lb_drf_fail_group:1;
        RBus_UInt32  gdma_osd1_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd2_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd3_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_drf_fail_group:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_fail_group:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_fail_group:1;
    };
}dispd_osd_bist_gdma_drf_fail_group_RBUS;

#else //apply LITTLE_ENDIAN

//======DISPD_OSD_BIST register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_mode:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_mode:1;
        RBus_UInt32  gdma_osd_rbuf_bist_mode:1;
        RBus_UInt32  gdma_osd3_clut_bist_mode:1;
        RBus_UInt32  gdma_osd2_clut_bist_mode:1;
        RBus_UInt32  gdma_osd1_clut_bist_mode:1;
        RBus_UInt32  gdma_fbdc_lb_bist_mode:1;
        RBus_UInt32  gdma_osd_gamma2_bist_mode:1;
        RBus_UInt32  gdma_osd_gamma1_bist_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
    };
}dispd_osd_bist_gdma_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_done:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_done:1;
        RBus_UInt32  gdma_osd_rbuf_bist_done:1;
        RBus_UInt32  gdma_osd3_clut_bist_done:1;
        RBus_UInt32  gdma_osd2_clut_bist_done:1;
        RBus_UInt32  gdma_osd1_clut_bist_done:1;
        RBus_UInt32  gdma_fbdc_lb_bist_done:1;
        RBus_UInt32  gdma_osd_gamma2_bist_done:1;
        RBus_UInt32  gdma_osd_gamma1_bist_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
    };
}dispd_osd_bist_gdma_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_fail_group:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_bist_fail_group:1;
        RBus_UInt32  gdma_osd3_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd2_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd1_clut_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_lb_bist_fail_group:1;
        RBus_UInt32  gdma_osd_gamma2_bist_fail_group:1;
        RBus_UInt32  gdma_osd_gamma1_bist_fail_group:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
    };
}dispd_osd_bist_gdma_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_mode:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_mode:1;
        RBus_UInt32  gdma_osd_rbuf_drf_mode:1;
        RBus_UInt32  gdma_osd3_clut_drf_mode:1;
        RBus_UInt32  gdma_osd2_clut_drf_mode:1;
        RBus_UInt32  gdma_osd1_clut_drf_mode:1;
        RBus_UInt32  gdma_fbdc_lb_drf_mode:1;
        RBus_UInt32  gdma_osd_gamma2_drf_mode:1;
        RBus_UInt32  gdma_osd_gamma1_drf_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
    };
}dispd_osd_bist_gdma_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_resume:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_resume:1;
        RBus_UInt32  gdma_osd_rbuf_drf_resume:1;
        RBus_UInt32  gdma_osd3_clut_drf_resume:1;
        RBus_UInt32  gdma_osd2_clut_drf_resume:1;
        RBus_UInt32  gdma_osd1_clut_drf_resume:1;
        RBus_UInt32  gdma_fbdc_lb_drf_resume:1;
        RBus_UInt32  gdma_osd_gamma2_drf_resume:1;
        RBus_UInt32  gdma_osd_gamma1_drf_resume:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
    };
}dispd_osd_bist_gdma_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_done:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_done:1;
        RBus_UInt32  gdma_osd_rbuf_drf_done:1;
        RBus_UInt32  gdma_osd3_clut_drf_done:1;
        RBus_UInt32  gdma_osd2_clut_drf_done:1;
        RBus_UInt32  gdma_osd1_clut_drf_done:1;
        RBus_UInt32  gdma_fbdc_lb_drf_done:1;
        RBus_UInt32  gdma_osd_gamma2_drf_done:1;
        RBus_UInt32  gdma_osd_gamma1_drf_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
    };
}dispd_osd_bist_gdma_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_pause:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_pause:1;
        RBus_UInt32  gdma_osd_rbuf_drf_pause:1;
        RBus_UInt32  gdma_osd3_clut_drf_pause:1;
        RBus_UInt32  gdma_osd2_clut_drf_pause:1;
        RBus_UInt32  gdma_osd1_clut_drf_pause:1;
        RBus_UInt32  gdma_fbdc_lb_drf_pause:1;
        RBus_UInt32  gdma_osd_gamma2_drf_pause:1;
        RBus_UInt32  gdma_osd_gamma1_drf_pause:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
    };
}dispd_osd_bist_gdma_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_fail_group:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_drf_fail_group:1;
        RBus_UInt32  gdma_osd3_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd2_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd1_clut_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_lb_drf_fail_group:1;
        RBus_UInt32  gdma_osd_gamma2_drf_fail_group:1;
        RBus_UInt32  gdma_osd_gamma1_drf_fail_group:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  res20:1;
        RBus_UInt32  res21:1;
        RBus_UInt32  res22:1;
        RBus_UInt32  res23:1;
    };
}dispd_osd_bist_gdma_drf_fail_group_RBUS;




#endif 


#endif 
