/**
* @file Merlin3-DesignSpec-I-Domain_VGIP
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/6/9
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DMA_VGIP_REG_H_
#define _RBUS_DMA_VGIP_REG_H_

#include "rbusTypes.h"



//  DMA_VGIP Register Address



#define  DMA_VGIP_DMA_VGIP_VCLK_CTRL_VADDR                  	(0xb8022400)
#define  DMA_VGIP_DMA_VGIP_V8_1_CTRL_VADDR                  	(0xb8022404)
#define  DMA_VGIP_DMA_VGIP_V8_2_CTRL_VADDR                  	(0xb8022408)
#define  DMA_VGIP_DMA_VGIP_GLOBAL_CTRL_VADDR                	(0xb802240c)
#define  DMA_VGIP_DMA_VGIP_CTRL_VADDR                       	(0xb8022410)
#define  DMA_VGIP_DMA_VGIP_STATUS_VADDR                     	(0xb8022414)
#define  DMA_VGIP_DMA_VGIP_ACT_HSTA_WIDTH_VADDR             	(0xb8022418)
#define  DMA_VGIP_DMA_VGIP_ACT_VSTA_LENGTH_VADDR            	(0xb802241c)
#define  DMA_VGIP_DMA_VGIP_DELAY_VADDR                      	(0xb8022420)
#define  DMA_VGIP_DMA_VGIP_MISC_VADDR                       	(0xb8022424)
#define  DMA_VGIP_DMA_VGIP_PTN_H_VI_VADDR                   	(0xb8022428)
#define  DMA_VGIP_DMA_VGIP_PTN0_VADDR                       	(0xb802242c)
#define  DMA_VGIP_DMA_VGIP_PTN1_VADDR                       	(0xb8022430)
#define  DMA_VGIP_DMA_VGIP_LC_VADDR                         	(0xb8022434)
#define  DMA_VGIP_DMA_VGIP_CRC_CTRL_VADDR                   	(0xb8022438)
#define  DMA_VGIP_DMA_VGIP_CRC_RESULT_VADDR                 	(0xb802243c)
#define  DMA_VGIP_DMA_VGIP_WDE_VADDR                        	(0xb8022440)
#define  DMA_VGIP_DMA_VGIP_PR_L_R_ONLY_CTRL_VADDR           	(0xb8022450)
#define  DMA_VGIP_DMA_VGIP_PTN2_VADDR                       	(0xb8022460)
#define  DMA_VGIP_DMA_VGIP_PTN3_VADDR                       	(0xb8022464)
#define  DMA_VGIP_DMA_VGIP_PTN4_VADDR                       	(0xb8022468)
#define  DMA_VGIP_DMA_VGIP_PTN5_VADDR                       	(0xb802246c)
#define  DMA_VGIP_DMA_VGIP_PTN6_VADDR                       	(0xb8022470)
#define  DMA_VGIP_DMA_VGIP_ADC_RAW_DATA_DMA_VADDR           	(0xb8022478)
#define  DMA_VGIP_DMA_VGIP_FRAMEPACKING_CTRL1_VADDR         	(0xb802247c)
#define  DMA_VGIP_DMA_VGIP_FRAMEPACKING_CTRL2_VADDR         	(0xb8022480)
#define  DMA_VGIP_DMA_VGIP_CTS_FIFO_CTL_VADDR               	(0xb8022490)
#define  DMA_VGIP_DMA_VGIP_DISPI_TEST_SEL_VADDR             	(0xb8022494)
#define  DMA_VGIP_DMA_VGIP_3D_RIGHT_ACT_HSTA_WIDTH_VADDR    	(0xb8022498)
#define  DMA_VGIP_DMA_VGIP_3D_RIGHT_ACT_VSTA_LENGTH_VADDR   	(0xb802249c)
#define  DMA_VGIP_DMA_VGIP_FRAMEPACKING_INTERLACE_CTRL1_VADDR 	(0xb80224a8)
#define  DMA_VGIP_DMA_VGIP_FRAMEPACKING_INTERLACE_CTRL2_VADDR 	(0xb80224ac)
#define  DMA_VGIP_DMA_VGIP_FRAMEPACKING_INTERLACE_CTRL3_VADDR 	(0xb80224b0)
#define  DMA_VGIP_DMA_VGIP_FRAMEPACKING_INTERLACE_CTRL4_VADDR 	(0xb80224b4)
#define  DMA_VGIP_DMA_VGIP_L_R_ACTIVE_ENABLE_CTRL1_VADDR    	(0xb80224b8)
#define  DMA_VGIP_DMA_VGIP_L_R_ACTIVE_ENABLE_CTRL2_VADDR    	(0xb80224bc)
#define  DMA_VGIP_DMA_VGIP_DOUBLE_BUFFER_CTRL_VADDR         	(0xb80224e4)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DMA_VGIP register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dma_v8_dummy:8;
    };
}dma_vgip_dma_vgip_vclk_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dummy18022404_7_0:8;
    };
}dma_vgip_dma_vgip_v8_1_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  dummy18022408_1:1;
        RBus_UInt32  dma_select_duplicate_lsb:1;
    };
}dma_vgip_dma_vgip_v8_2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_auto_l_flag_delay_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_vs_rise_sample_delay_sel:1;
        RBus_UInt32  dma_auto_l_flag_delay_num:13;
        RBus_UInt32  dma_l_flag_delay_en:1;
        RBus_UInt32  dma_l_flag_field_sample_delay:2;
        RBus_UInt32  dma_l_flag_delay_num:13;
    };
}dma_vgip_dma_vgip_global_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_ivrun:1;
        RBus_UInt32  dma_in_sel:3;
        RBus_UInt32  dma_random_en:1;
        RBus_UInt32  dma_fdrop_en:1;
        RBus_UInt32  dma_vact_end_ie:1;
        RBus_UInt32  dma_vact_start_ie:1;
        RBus_UInt32  dma_field_hs_inv:1;
        RBus_UInt32  dma_field_vd_inv:1;
        RBus_UInt32  dma_field_vd_en:1;
        RBus_UInt32  dma_3dleft_inv:1;
        RBus_UInt32  dma_3dleft_sync_edge:1;
        RBus_UInt32  dma_field_inv:1;
        RBus_UInt32  dma_field_sync_edge:1;
        RBus_UInt32  dma_field_det_en:1;
        RBus_UInt32  dma_hpact_is_hact:1;
        RBus_UInt32  dma_fcap_str_odd:1;
        RBus_UInt32  dma_mask_den_inv:1;
        RBus_UInt32  dma_mask_den_1l:1;
        RBus_UInt32  dma_3d_mode_en:1;
        RBus_UInt32  dma_safe_field_inv:1;
        RBus_UInt32  dma_force_tog:1;
        RBus_UInt32  dma_safe_mode:1;
        RBus_UInt32  dma_3d_right_act_en:1;
        RBus_UInt32  dma_hs_syncedge:1;
        RBus_UInt32  dma_vs_syncedge:1;
        RBus_UInt32  dma_vs_by_hs_en_n:1;
        RBus_UInt32  dma_vs_inv:1;
        RBus_UInt32  dma_hs_inv:1;
        RBus_UInt32  dma_digital_mode:1;
        RBus_UInt32  dma_in_clk_en:1;
    };
}dma_vgip_dma_vgip_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_vs_end:1;
        RBus_UInt32  dma_vs_start:1;
        RBus_UInt32  dma_vact_end:1;
        RBus_UInt32  dma_vact_start:1;
        RBus_UInt32  dummy18022414_23_17:7;
        RBus_UInt32  dma_vlc_status:1;
        RBus_UInt32  dma_rl_err:1;
        RBus_UInt32  dma_vs_err:1;
        RBus_UInt32  dma_hs_err:1;
        RBus_UInt32  dma_field_err:1;
        RBus_UInt32  dma_rl_tog:1;
        RBus_UInt32  dma_l_flag_pol:1;
        RBus_UInt32  dma_vs_tog:1;
        RBus_UInt32  dma_hs_tog:1;
        RBus_UInt32  dma_field_pol:1;
        RBus_UInt32  dma_field_tog:1;
        RBus_UInt32  dma_field_vs_lsb:2;
        RBus_UInt32  dma_more_1line_field:1;
        RBus_UInt32  dma_bounce_status_2:1;
        RBus_UInt32  dma_bounce_status_1:1;
        RBus_UInt32  dma_bounce_status_0:1;
    };
}dma_vgip_dma_vgip_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_ih_act_sta:14;
        RBus_UInt32  res2:1;
        RBus_UInt32  dma_bypass_den:1;
        RBus_UInt32  dma_ih_act_wid:14;
    };
}dma_vgip_dma_vgip_act_hsta_width_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_iv_act_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  dma_iv_act_len:13;
    };
}dma_vgip_dma_vgip_act_vsta_length_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_hs_width:2;
        RBus_UInt32  dma_ihs_dly:14;
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_ivs_dly:13;
    };
}dma_vgip_dma_vgip_delay_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_de_mask_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_vs_dly_1hs:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  dma_hporch_num_sel:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  dma_l_flag_force_tog:1;
        RBus_UInt32  dma_hporch_num:13;
        RBus_UInt32  dma_auto_ihs_dly:2;
        RBus_UInt32  dma_auto_ivs_dly:2;
        RBus_UInt32  dma_hdly_one:1;
        RBus_UInt32  dma_v1_v2_swap:1;
        RBus_UInt32  dma_v2_v3_swap:1;
        RBus_UInt32  dma_v1_v3_swap:1;
    };
}dma_vgip_dma_vgip_misc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_captst_en:1;
        RBus_UInt32  dma_captst_mode:2;
        RBus_UInt32  dma_vcaptst_num:13;
        RBus_UInt32  dma_captst_field_sel:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_hcaptst_num:14;
    };
}dma_vgip_dma_vgip_ptn_h_vi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_r_data:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dma_captst_g_data:12;
    };
}dma_vgip_dma_vgip_ptn0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_hporch_num_sel:14;
        RBus_UInt32  res2:4;
        RBus_UInt32  dma_captst_b_data:12;
    };
}dma_vgip_dma_vgip_ptn1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_vlcen:1;
        RBus_UInt32  dma_vlc_mode:1;
        RBus_UInt32  dma_vlc_ie:1;
        RBus_UInt32  dma_den_crc_sel:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_line_cnt:12;
        RBus_UInt32  dma_vln:12;
    };
}dma_vgip_dma_vgip_lc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  dma_crc_mode:1;
        RBus_UInt32  dma_crc_region:1;
        RBus_UInt32  dma_crc_ctrl_in:1;
        RBus_UInt32  dma_crc_field_edge_sel:1;
        RBus_UInt32  dma_crc_field:1;
        RBus_UInt32  dma_crc_conti:1;
        RBus_UInt32  dma_crc_start:1;
    };
}dma_vgip_dma_vgip_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_crc_result:32;
    };
}dma_vgip_dma_vgip_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_wd_to_main:1;
        RBus_UInt32  dma_wd_to_sub:1;
        RBus_UInt32  dummy18022440_29_19:11;
        RBus_UInt32  dma_vs_err_wde:1;
        RBus_UInt32  dma_hs_err_wde:1;
        RBus_UInt32  dma_field_err_wde:1;
        RBus_UInt32  dma_rl_err_wde:1;
        RBus_UInt32  dummy18022440_14_4:11;
        RBus_UInt32  dma_rl_err_ie:1;
        RBus_UInt32  dma_vs_err_ie:1;
        RBus_UInt32  dma_hs_err_ie:1;
        RBus_UInt32  dma_field_err_ie:1;
    };
}dma_vgip_dma_vgip_wde_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  dma_pr_l_r_only_mask_hs:1;
        RBus_UInt32  dma_pr_l_r_only_rm_den:1;
        RBus_UInt32  dma_pr_l_r_only_en:1;
    };
}dma_vgip_dma_vgip_pr_l_r_only_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_r_data_2:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dma_captst_g_data_2:12;
    };
}dma_vgip_dma_vgip_ptn2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_b_data_3:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dma_captst_b_data_2:12;
    };
}dma_vgip_dma_vgip_ptn3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_r_data_3:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dma_captst_g_data_3:12;
    };
}dma_vgip_dma_vgip_ptn4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_r_data_4:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dma_captst_g_data_4:12;
    };
}dma_vgip_dma_vgip_ptn5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  dma_captst_b_data_4:12;
    };
}dma_vgip_dma_vgip_ptn6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_adc_test_dma_count:28;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_force_den:1;
        RBus_UInt32  dma_force_vsync:1;
        RBus_UInt32  dma_adc_test_dma_mode:1;
    };
}dma_vgip_dma_vgip_adc_raw_data_dma_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_vs_width:13;
        RBus_UInt32  dma_field_alternative_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  dma_frame_packing_en:1;
        RBus_UInt32  dma_vs_position:13;
    };
}dma_vgip_dma_vgip_framepacking_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_den_mask_start:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  dma_den_mask_end:13;
    };
}dma_vgip_dma_vgip_framepacking_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  dma_dummy_ctsfifo_sdnr:1;
        RBus_UInt32  dma_force_ctsfifo_rstn_sdnr:1;
        RBus_UInt32  dma_en_ctsfifo_vsrst_sdnr:1;
        RBus_UInt32  dma_en_ctsfifo_bypass_sdnr:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  dma_ctsfifo_gate_vgip:1;
        RBus_UInt32  dma_force_ctsfifo_rstn_vgip:1;
        RBus_UInt32  dma_en_ctsfifo_vsrst_vgip:1;
        RBus_UInt32  dma_en_ctsfifo_bypass_vgip:1;
    };
}dma_vgip_dma_vgip_cts_fifo_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}dma_vgip_dma_vgip_dispi_test_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_3d_right_ih_act_sta:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  dma_3d_right_ih_act_wid:14;
    };
}dma_vgip_dma_vgip_3d_right_act_hsta_width_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_3d_right_iv_act_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  dma_3d_right_iv_act_len:13;
    };
}dma_vgip_dma_vgip_3d_right_act_vsta_length_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_vs_width_r_odd:13;
        RBus_UInt32  res2:2;
        RBus_UInt32  dma_frame_packing_field_en:1;
        RBus_UInt32  dma_vs_position_r_odd:13;
    };
}dma_vgip_dma_vgip_framepacking_interlace_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_den_mask_start_r_odd:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  dma_den_mask_end_r_odd:13;
    };
}dma_vgip_dma_vgip_framepacking_interlace_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_vs_width_r_even:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  dma_vs_position_r_even:13;
    };
}dma_vgip_dma_vgip_framepacking_interlace_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_den_mask_start_r_even:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  dma_den_mask_end_r_even:13;
    };
}dma_vgip_dma_vgip_framepacking_interlace_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_end_l:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  dma_sta_l:14;
    };
}dma_vgip_dma_vgip_l_r_active_enable_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_l_r_act_en:1;
        RBus_UInt32  dma_h_v_mode:1;
        RBus_UInt32  dma_end_r:14;
        RBus_UInt32  res1:1;
        RBus_UInt32  vodma1toi_i2rnd:1;
        RBus_UInt32  dma_sta_r:14;
    };
}dma_vgip_dma_vgip_l_r_active_enable_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_db_rdy:1;
        RBus_UInt32  dma_db_en:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  dma_db_read_sel:1;
        RBus_UInt32  res2:15;
    };
}dma_vgip_dma_vgip_double_buffer_ctrl_RBUS;

#else //apply LITTLE_ENDIAN

//======DMA_VGIP register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_v8_dummy:8;
        RBus_UInt32  res1:24;
    };
}dma_vgip_dma_vgip_vclk_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18022404_7_0:8;
        RBus_UInt32  res1:24;
    };
}dma_vgip_dma_vgip_v8_1_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_select_duplicate_lsb:1;
        RBus_UInt32  dummy18022408_1:1;
        RBus_UInt32  res1:30;
    };
}dma_vgip_dma_vgip_v8_2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_l_flag_delay_num:13;
        RBus_UInt32  dma_l_flag_field_sample_delay:2;
        RBus_UInt32  dma_l_flag_delay_en:1;
        RBus_UInt32  dma_auto_l_flag_delay_num:13;
        RBus_UInt32  dma_vs_rise_sample_delay_sel:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_auto_l_flag_delay_en:1;
    };
}dma_vgip_dma_vgip_global_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_in_clk_en:1;
        RBus_UInt32  dma_digital_mode:1;
        RBus_UInt32  dma_hs_inv:1;
        RBus_UInt32  dma_vs_inv:1;
        RBus_UInt32  dma_vs_by_hs_en_n:1;
        RBus_UInt32  dma_vs_syncedge:1;
        RBus_UInt32  dma_hs_syncedge:1;
        RBus_UInt32  dma_3d_right_act_en:1;
        RBus_UInt32  dma_safe_mode:1;
        RBus_UInt32  dma_force_tog:1;
        RBus_UInt32  dma_safe_field_inv:1;
        RBus_UInt32  dma_3d_mode_en:1;
        RBus_UInt32  dma_mask_den_1l:1;
        RBus_UInt32  dma_mask_den_inv:1;
        RBus_UInt32  dma_fcap_str_odd:1;
        RBus_UInt32  dma_hpact_is_hact:1;
        RBus_UInt32  dma_field_det_en:1;
        RBus_UInt32  dma_field_sync_edge:1;
        RBus_UInt32  dma_field_inv:1;
        RBus_UInt32  dma_3dleft_sync_edge:1;
        RBus_UInt32  dma_3dleft_inv:1;
        RBus_UInt32  dma_field_vd_en:1;
        RBus_UInt32  dma_field_vd_inv:1;
        RBus_UInt32  dma_field_hs_inv:1;
        RBus_UInt32  dma_vact_start_ie:1;
        RBus_UInt32  dma_vact_end_ie:1;
        RBus_UInt32  dma_fdrop_en:1;
        RBus_UInt32  dma_random_en:1;
        RBus_UInt32  dma_in_sel:3;
        RBus_UInt32  dma_ivrun:1;
    };
}dma_vgip_dma_vgip_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_bounce_status_0:1;
        RBus_UInt32  dma_bounce_status_1:1;
        RBus_UInt32  dma_bounce_status_2:1;
        RBus_UInt32  dma_more_1line_field:1;
        RBus_UInt32  dma_field_vs_lsb:2;
        RBus_UInt32  dma_field_tog:1;
        RBus_UInt32  dma_field_pol:1;
        RBus_UInt32  dma_hs_tog:1;
        RBus_UInt32  dma_vs_tog:1;
        RBus_UInt32  dma_l_flag_pol:1;
        RBus_UInt32  dma_rl_tog:1;
        RBus_UInt32  dma_field_err:1;
        RBus_UInt32  dma_hs_err:1;
        RBus_UInt32  dma_vs_err:1;
        RBus_UInt32  dma_rl_err:1;
        RBus_UInt32  dma_vlc_status:1;
        RBus_UInt32  dummy18022414_23_17:7;
        RBus_UInt32  dma_vact_start:1;
        RBus_UInt32  dma_vact_end:1;
        RBus_UInt32  dma_vs_start:1;
        RBus_UInt32  dma_vs_end:1;
        RBus_UInt32  res1:4;
    };
}dma_vgip_dma_vgip_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_ih_act_wid:14;
        RBus_UInt32  dma_bypass_den:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_ih_act_sta:14;
        RBus_UInt32  res2:2;
    };
}dma_vgip_dma_vgip_act_hsta_width_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_iv_act_len:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_iv_act_sta:13;
        RBus_UInt32  res2:3;
    };
}dma_vgip_dma_vgip_act_vsta_length_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_ivs_dly:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_ihs_dly:14;
        RBus_UInt32  dma_hs_width:2;
    };
}dma_vgip_dma_vgip_delay_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_v1_v3_swap:1;
        RBus_UInt32  dma_v2_v3_swap:1;
        RBus_UInt32  dma_v1_v2_swap:1;
        RBus_UInt32  dma_hdly_one:1;
        RBus_UInt32  dma_auto_ivs_dly:2;
        RBus_UInt32  dma_auto_ihs_dly:2;
        RBus_UInt32  dma_hporch_num:13;
        RBus_UInt32  dma_l_flag_force_tog:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_hporch_num_sel:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  dma_vs_dly_1hs:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  dma_de_mask_en:1;
    };
}dma_vgip_dma_vgip_misc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_hcaptst_num:14;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_captst_field_sel:1;
        RBus_UInt32  dma_vcaptst_num:13;
        RBus_UInt32  dma_captst_mode:2;
        RBus_UInt32  dma_captst_en:1;
    };
}dma_vgip_dma_vgip_ptn_h_vi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_captst_g_data:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_r_data:12;
        RBus_UInt32  res2:4;
    };
}dma_vgip_dma_vgip_ptn0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_captst_b_data:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_hporch_num_sel:14;
        RBus_UInt32  res2:2;
    };
}dma_vgip_dma_vgip_ptn1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_vln:12;
        RBus_UInt32  dma_line_cnt:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_den_crc_sel:1;
        RBus_UInt32  dma_vlc_ie:1;
        RBus_UInt32  dma_vlc_mode:1;
        RBus_UInt32  dma_vlcen:1;
    };
}dma_vgip_dma_vgip_lc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_crc_start:1;
        RBus_UInt32  dma_crc_conti:1;
        RBus_UInt32  dma_crc_field:1;
        RBus_UInt32  dma_crc_field_edge_sel:1;
        RBus_UInt32  dma_crc_ctrl_in:1;
        RBus_UInt32  dma_crc_region:1;
        RBus_UInt32  dma_crc_mode:1;
        RBus_UInt32  res1:25;
    };
}dma_vgip_dma_vgip_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_crc_result:32;
    };
}dma_vgip_dma_vgip_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_field_err_ie:1;
        RBus_UInt32  dma_hs_err_ie:1;
        RBus_UInt32  dma_vs_err_ie:1;
        RBus_UInt32  dma_rl_err_ie:1;
        RBus_UInt32  dummy18022440_14_4:11;
        RBus_UInt32  dma_rl_err_wde:1;
        RBus_UInt32  dma_field_err_wde:1;
        RBus_UInt32  dma_hs_err_wde:1;
        RBus_UInt32  dma_vs_err_wde:1;
        RBus_UInt32  dummy18022440_29_19:11;
        RBus_UInt32  dma_wd_to_sub:1;
        RBus_UInt32  dma_wd_to_main:1;
    };
}dma_vgip_dma_vgip_wde_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_pr_l_r_only_en:1;
        RBus_UInt32  dma_pr_l_r_only_rm_den:1;
        RBus_UInt32  dma_pr_l_r_only_mask_hs:1;
        RBus_UInt32  res1:29;
    };
}dma_vgip_dma_vgip_pr_l_r_only_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_captst_g_data_2:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_r_data_2:12;
        RBus_UInt32  res2:4;
    };
}dma_vgip_dma_vgip_ptn2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_captst_b_data_2:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_b_data_3:12;
        RBus_UInt32  res2:4;
    };
}dma_vgip_dma_vgip_ptn3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_captst_g_data_3:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_r_data_3:12;
        RBus_UInt32  res2:4;
    };
}dma_vgip_dma_vgip_ptn4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_captst_g_data_4:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_captst_r_data_4:12;
        RBus_UInt32  res2:4;
    };
}dma_vgip_dma_vgip_ptn5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_captst_b_data_4:12;
        RBus_UInt32  res1:20;
    };
}dma_vgip_dma_vgip_ptn6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_adc_test_dma_mode:1;
        RBus_UInt32  dma_force_vsync:1;
        RBus_UInt32  dma_force_den:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_adc_test_dma_count:28;
    };
}dma_vgip_dma_vgip_adc_raw_data_dma_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_vs_position:13;
        RBus_UInt32  dma_frame_packing_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_field_alternative_en:1;
        RBus_UInt32  dma_vs_width:13;
        RBus_UInt32  res2:3;
    };
}dma_vgip_dma_vgip_framepacking_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_den_mask_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_den_mask_start:13;
        RBus_UInt32  res2:3;
    };
}dma_vgip_dma_vgip_framepacking_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_en_ctsfifo_bypass_vgip:1;
        RBus_UInt32  dma_en_ctsfifo_vsrst_vgip:1;
        RBus_UInt32  dma_force_ctsfifo_rstn_vgip:1;
        RBus_UInt32  dma_ctsfifo_gate_vgip:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_en_ctsfifo_bypass_sdnr:1;
        RBus_UInt32  dma_en_ctsfifo_vsrst_sdnr:1;
        RBus_UInt32  dma_force_ctsfifo_rstn_sdnr:1;
        RBus_UInt32  dma_dummy_ctsfifo_sdnr:1;
        RBus_UInt32  res2:20;
    };
}dma_vgip_dma_vgip_cts_fifo_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}dma_vgip_dma_vgip_dispi_test_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_3d_right_ih_act_wid:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_3d_right_ih_act_sta:14;
        RBus_UInt32  res2:2;
    };
}dma_vgip_dma_vgip_3d_right_act_hsta_width_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_3d_right_iv_act_len:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_3d_right_iv_act_sta:13;
        RBus_UInt32  res2:3;
    };
}dma_vgip_dma_vgip_3d_right_act_vsta_length_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_vs_position_r_odd:13;
        RBus_UInt32  dma_frame_packing_field_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_vs_width_r_odd:13;
        RBus_UInt32  res2:3;
    };
}dma_vgip_dma_vgip_framepacking_interlace_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_den_mask_end_r_odd:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_den_mask_start_r_odd:13;
        RBus_UInt32  res2:3;
    };
}dma_vgip_dma_vgip_framepacking_interlace_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_vs_position_r_even:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_vs_width_r_even:13;
        RBus_UInt32  res2:3;
    };
}dma_vgip_dma_vgip_framepacking_interlace_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_den_mask_end_r_even:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  dma_den_mask_start_r_even:13;
        RBus_UInt32  res2:3;
    };
}dma_vgip_dma_vgip_framepacking_interlace_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_sta_l:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  dma_end_l:14;
        RBus_UInt32  res2:2;
    };
}dma_vgip_dma_vgip_l_r_active_enable_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_sta_r:14;
        RBus_UInt32  vodma1toi_i2rnd:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_end_r:14;
        RBus_UInt32  dma_h_v_mode:1;
        RBus_UInt32  dma_l_r_act_en:1;
    };
}dma_vgip_dma_vgip_l_r_active_enable_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  dma_db_read_sel:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  dma_db_en:1;
        RBus_UInt32  dma_db_rdy:1;
    };
}dma_vgip_dma_vgip_double_buffer_ctrl_RBUS;




#endif 


#endif 
