#include <linux/string.h>
//#include <platform_lib/board/pcb_mgr.h>
//#include <platform_lib/board/pcb.h>
#include <common.h>
#include <command.h>
#include <malloc.h>
#include <linux/compiler.h>
#include <asm/io.h>
#include "tas5751.h"
#include <drivers/i2c/rtk_i2c_lib.h>

//*************************************************************
// PUBLIC FUNCTIONS
//*************************************************************
#define END_FLAG 	(0xff)
#define AMP_DEBUG 	(0)

typedef struct
{
    unsigned char bAddr;
    unsigned char bArray;
}TAS5751_REG;

static TAS5751_REG TAS5751_InitTbl[] = 
{
// -----------------------------------------------------------------------------
// Initialization Sequence
// -----------------------------------------------------------------------------
    { TAS5751_SOFT_MUTE, 0x07 },
    { TAS5751_SYSTEM_CTRL2, 0x40 },

// -----------------------------------------------------------------------------
// Amplifier Configuration
// -----------------------------------------------------------------------------
    { TAS5751_SYSTEM_CTRL1, 0xa0 },
    { TAS5751_DATA_INTERFACE, 0x05 },
    { CFG_META_BURST, 3 },
    { TAS5751_MASTER_VOLUME, 0x01 },
    { TAS5751_SOFT_MUTE, 0x00 },
    { CFG_META_BURST, 3 },
    { TAS5751_MASTER_VOLUME, 0x00 },
    { 0xc0, 0x00 },
    { CFG_META_BURST, 3 },
    { TAS5751_CHANNEL_2_VOL, 0x00 },
    { 0xc0, 0x00 },
    { CFG_META_BURST, 3 },
    { TAS5751_CHANNEL_3_VOL, 0x00 },
    { 0xc0, 0x00 },
    { TAS5751_VOLUME_CONFIG, 0xf0 },
    { TAS5751_MODULATION_LIMIT, 0x01 },
    { TAS5751_IC_DELAY_CHANNEL1, 0xb8 },
    { TAS5751_IC_DELAY_CHANNEL2, 0x60 },
    { TAS5751_IC_DELAY_CHANNEL3, 0xa0 },
    { TAS5751_IC_DELAY_CHANNEL4, 0x48 },
    { TAS5751_PWM_SHUTDOWN_GROUP, 0x30 },
    { TAS5751_START_STOP_PERIOD, 0x68 },
    { TAS5751_OSCILLATOR_TRIM, 0xc0 },
    { TAS5751_BKND_ERR, 0x57 },
    { CFG_META_BURST, 5 },
    { TAS5751_INPUT_MUX, 0x00 },
    { 0x89, 0x77 },
    { TAS5751_CH1_RIGHT_CHANNEL_MIXER, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_PWM_MUX, 0x01 },
    { TAS5751_ERROR_STATUS, 0x13 },
    { TAS5751_AGL4_ATTACK_RATE, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ0, 0x00 },
    { 0x7f, 0xf0 },
    { 0xd7, 0x03 },
    { TAS5751_CLOCK_CTRL, 0x1e },
    { 0x53, 0x00 },
    { 0x7f, 0xf0 },
    { 0xd7, 0x00 },
    { 0xff, 0xe1 },
    { 0xab, 0x03 },
    { 0x80, 0x1e },
    { TAS5751_CH1_OUTPUT_MIXER, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ1, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ2, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ3, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ4, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ5, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ6, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ7, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ8, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ9, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ0, 0x00 },
    { 0x7f, 0xf0 },
    { 0xd7, 0x03 },
    { TAS5751_CLOCK_CTRL, 0x1e },
    { 0x53, 0x00 },
    { 0x7f, 0xf0 },
    { 0xd7, 0x00 },
    { 0xff, 0xe1 },
    { 0xab, 0x03 },
    { 0x80, 0x1e },
    { TAS5751_CH1_OUTPUT_MIXER, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ1, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ2, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ3, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ4, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ5, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ6, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ7, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ8, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ9, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 9 },
    { TAS5751_AGL1_SOFTENING_FILTER, 0x00 },
    { TAS5751_MASTER_VOLUME, 0x60 },
    { 0x53, 0x00 },
    { 0x78, 0x9f },
    { 0xac, 0x00 },
    { CFG_META_BURST, 9 },
    { TAS5751_AGL1_ATTACK_RATE, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { 0x6d, 0xff },
    { 0xff, 0xff },
    { 0xe5, 0x00 },
    { CFG_META_BURST, 9 },
    { TAS5751_AGL2_SOFTENING_FILTER, 0x00 },
    { TAS5751_MASTER_VOLUME, 0x60 },
    { 0x53, 0x00 },
    { 0x78, 0x9f },
    { 0xac, 0x00 },
    { CFG_META_BURST, 9 },
    { TAS5751_AGL2_ATTACK_RATE, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { 0x6d, 0xff },
    { 0xff, 0xff },
    { 0xe5, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_AGL1_ATTACK_THRESHOLD, 0x08 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_AGL3_ATTACK_THRESHOLD, 0x08 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 9 },
    { TAS5751_AGL3_ATTACK_RATE, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { 0x6d, 0xff },
    { 0xff, 0xff },
    { 0xe5, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_AGL2_ATTACK_THRESHOLD, 0x08 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_AGL4_ATTACK_THRESHOLD, 0x07 },
    { 0x21, 0x48 },
    { TAS5751_CH1_BQ5, 0x00 },
    { CFG_META_BURST, 9 },
    { TAS5751_AGL4_ATTACK_RATE, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { 0x6d, 0xff },
    { 0xff, 0xff },
    { 0xe5, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_AGL_CONTROL, 0x00 },
    { TAS5751_ERROR_STATUS, 0x00 },
    { 0x0f, 0x00 },
    { CFG_META_BURST, 9 },
    { TAS5751_AGL3_SOFTENING_FILTER, 0x00 },
    { TAS5751_MASTER_VOLUME, 0x60 },
    { 0x53, 0x00 },
    { 0x78, 0x9f },
    { 0xac, 0x00 },
    { CFG_META_BURST, 9 },
    { TAS5751_AGL4_SOFTENING_FILTER, 0x00 },
    { TAS5751_MASTER_VOLUME, 0x60 },
    { 0x53, 0x00 },
    { 0x78, 0x9f },
    { 0xac, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_PWM_SWITCH_RATE_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CHANNEL_1_VOL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_BANK_SWITCH_CTRL, 0x0f },
    { TAS5751_CH1_INLINE_MIXER, 0x80 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 13 },
    { TAS5751_CH1_OUTPUT_MIXER, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x03 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 13 },
    { TAS5751_CH2_OUTPUT_MIXER, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x03 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_OUTPUT_POST_SCALE, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_OUTPUT_PRE_SCALE, 0x00 },
    { TAS5751_ERROR_STATUS, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_BQ10, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_CROSS_BQ0, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x0c },
    { TAS5751_CH1_BQ1, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x18 },
    { TAS5751_PWM_SWITCH_RATE_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x0c },
    { TAS5751_CH1_BQ1, 0x00 },
    { 0xf6, 0x23 },
    { 0xa6, 0x03 },
    { 0x89, 0xab },
    { 0xbc, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_CROSS_BQ1, 0x00 },
    { TAS5751_CH1_CROSS_BQ0, 0x0c },
    { 0xdc, 0x03 },
    { 0x4d, 0xe6 },
    { TAS5751_AGL3_SOFTENING_FILTER, 0x00 },
    { TAS5751_CH1_CROSS_BQ0, 0x0c },
    { 0xdc, 0x00 },
    { 0xab, 0x0d },
    { 0xc1, 0x03 },
    { 0xc6, 0xda },
    { TAS5751_PWM_SWITCH_RATE_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { 0x5b, 0x00 },
    { TAS5751_SYSTEM_CTRL1, 0x85 },
    { 0xfc, 0x00 },
    { TAS5751_MASTER_VOLUME, 0x0b },
    { 0xf8, 0x00 },
    { TAS5751_SYSTEM_CTRL1, 0x85 },
    { 0xfc, 0x00 },
    { 0xab, 0x0d },
    { 0xc1, 0x03 },
    { 0xc6, 0xda },
    { TAS5751_PWM_SWITCH_RATE_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH1_CROSS_BQ3, 0x00 },
    { 0x7b, 0x1d },
    { 0xfa, 0x03 },
    { TAS5751_CHANNEL_2_VOL, 0xc4 },
    { 0x0b, 0x00 },
    { 0x7b, 0x1d },
    { 0xfa, 0x00 },
    { 0xf6, 0x23 },
    { 0xa6, 0x03 },
    { 0x89, 0xab },
    { 0xbc, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_BQ10, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_CROSS_BQ0, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x0c },
    { TAS5751_CH1_BQ1, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x18 },
    { 0x4f, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x0c },
    { TAS5751_CH1_BQ1, 0x00 },
    { 0xf6, 0x23 },
    { 0xa6, 0x03 },
    { 0x89, 0xab },
    { 0xbc, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_CROSS_BQ1, 0x00 },
    { TAS5751_CH1_CROSS_BQ0, 0x0c },
    { 0xdc, 0x03 },
    { 0x4d, 0xe6 },
    { 0x47, 0x00 },
    { TAS5751_CH1_CROSS_BQ0, 0x0c },
    { 0xdc, 0x00 },
    { 0xab, 0x0d },
    { 0xc1, 0x03 },
    { 0xc6, 0xda },
    { TAS5751_PWM_SWITCH_RATE_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_CROSS_BQ2, 0x00 },
    { TAS5751_SYSTEM_CTRL1, 0x85 },
    { 0xfc, 0x00 },
    { TAS5751_MASTER_VOLUME, 0x0b },
    { 0xf8, 0x00 },
    { TAS5751_SYSTEM_CTRL1, 0x85 },
    { 0xfc, 0x00 },
    { 0xab, 0x0d },
    { 0xc1, 0x03 },
    { 0xc6, 0xda },
    { TAS5751_PWM_SWITCH_RATE_CTRL, 0x00 },
    { CFG_META_BURST, 21 },
    { TAS5751_CH2_CROSS_BQ3, 0x00 },
    { 0x7b, 0x1d },
    { 0xfa, 0x03 },
    { TAS5751_CHANNEL_2_VOL, 0xc4 },
    { 0x0b, 0x00 },
    { 0x7b, 0x1d },
    { 0xfa, 0x00 },
    { 0xf6, 0x23 },
    { 0xa6, 0x03 },
    { 0x89, 0xab },
    { 0xbc, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_CH1_INLINE_MIXER, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_CH1_INLINE_AGL_EN_MIXER, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_CH1_RIGHT_CHANNEL_MIXER, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_CH1_LEFT_CHANNEL_MIXER, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_CH2_INLINE_MIXER, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_CH2_INLINE_AGL_EN_MIXER, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_CH2_LEFT_CHANNEL_MIXER, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },
    { CFG_META_BURST, 5 },
    { TAS5751_CH2_RIGHT_CHANNEL_MIXER, 0x00 },
    { 0x80, 0x00 },
    { TAS5751_CLOCK_CTRL, 0x00 },

// -----------------------------------------------------------------------------
// Unmute Sequence
// -----------------------------------------------------------------------------
    { TAS5751_CH1_BQ0, 0x00 },
    { TAS5751_SOFT_MUTE, 0x00 },

};

void tas5751_func(int bus_id, unsigned short addr)
{
    unsigned char data[2];
    unsigned char regaddr;
    unsigned char index;
    for(index = 0; ; index ++)
    {
        regaddr = TAS5751_InitTbl[index].bAddr;
        data[0] = TAS5751_InitTbl[index].bAddr;
        data[1] = TAS5751_InitTbl[index].bArray;
        if(regaddr == END_FLAG)
        {
            break;
        }

#if AMP_DEBUG
        printf("\nwrite addr:0x%x----data=0x%x\n",regaddr,data);
#endif
        if (I2C_Write_EX(AMP_I2C, addr ,  2, data ) < 0)
            printf("program TAS5751 failed\n");

#if AMP_DEBUG
        unsigned char readArray[2] = {0,0};
        if (I2C_Read_EX(AMP_I2C, addr , 1,  &regaddr, 2, readArray)!= S_OK)
        {
            printf("\n i2c read fail \n"  );
        }
        printf("\nread addr:0x%x----data[0]=0x%x----data[1]=0x%x\n",regaddr,readArray[0],readArray[1]);
#endif

    }
}

