#ifndef __OTP_ID_H__
#define __OTP_ID_H__
 

#define OTP_ID(msb,lsb)             ((msb<<16) | (lsb))
#define OTP_MSB(x)                  ((x>>16) & 0xFFFF)
#define OTP_LSB(x)                  ((x) & 0xFFFF)
#define OTP_RNG_RTK_LFSR_POLY                         OTP_ID(63, 0) 
#define OTP_CP_KCPU_AES_KEY                           OTP_ID(191, 64) 
#define OTP_CP_HCPU_AES_KEY                           OTP_ID(319, 192) 
#define OTP_DEVICE_UNIQUE_KEY                         OTP_ID(447, 320) 
#define OTP_SecureKey_LockBit                         OTP_ID(448, 448) 
#define OTP_RSAPublicKey_LockBit                      OTP_ID(449, 449) 
#define OTP_Chip_Type_ORI_LockBit                     OTP_ID(450, 450) 
#define OTP_Secure_Boot_Type_LockBit                  OTP_ID(451, 451) 
#define OTP_Secure_Area_LockBit                       OTP_ID(452, 452) 
#define OTP_Secure_IO_LockBit                         OTP_ID(453, 453) 
#define OTP_Secure_IO_DBG_LockBit                     OTP_ID(454, 454) 
#define OTP_PACKAGE_INFO_LockBit                      OTP_ID(455, 455) 
#define OTP_Secure_DBG_LockBit                        OTP_ID(456, 456) 
#define OTP_Wafer_Info_LockBit                        OTP_ID(457, 457) 
#define OTP_RSA_Key_LockBit                           OTP_ID(458, 458) 
#define OTP_Func_Config_HW_LockBit                    OTP_ID(459, 459) 
#define OTP_Func_Config_SW_LockBit                    OTP_ID(460, 460) 
#define OTP_HDCP_1_4_LockBit                          OTP_ID(461, 461) 
#define OTP_HDCP_2_2_LockBit                          OTP_ID(462, 462) 
#define OTP_HW_PAR_LockBit                            OTP_ID(463, 463) 
#define OTP_Chip_Type_REMK_LockBit                    OTP_ID(464, 464) 
#define OTP_OTP_PASSWORD_LockBit                      OTP_ID(465, 465) 
#define OTP_MP_LockBit                                OTP_ID(466, 466) 
#define OTP_Customer_key_0_LockBit                    OTP_ID(467, 467) 
#define OTP_Customer_key_1_LockBit                    OTP_ID(468, 468) 
#define OTP_Customer_key_2_LockBit                    OTP_ID(469, 469) 
#define OTP_Customer_key_3_LockBit                    OTP_ID(470, 470) 
#define OTP_Customer_key_4_LockBit                    OTP_ID(471, 471) 
#define OTP_Customer_key_5_LockBit                    OTP_ID(472, 472) 
#define OTP_Customer_key_6_LockBit                    OTP_ID(473, 473) 
#define OTP_Customer_key_7_LockBit                    OTP_ID(474, 474) 
#define OTP_ROM_PATCH_0_LockBit                       OTP_ID(475, 475) 
#define OTP_ROM_PATCH_1_LockBit                       OTP_ID(476, 476) 
#define OTP_ROM_PATCH_2_LockBit                       OTP_ID(477, 477) 
#define OTP_ROM_PATCH_3_LockBit                       OTP_ID(478, 478) 
#define OTP_ROM_PATCH_4_LockBit                       OTP_ID(479, 479) 
#define OTP_ROM_PATCH_5_LockBit                       OTP_ID(480, 480) 
#define OTP_ROM_PATCH_6_LockBit                       OTP_ID(481, 481) 
#define OTP_Customer_key_kcpu_access_only             OTP_ID(495, 488) 
#define OTP_DBGIF_Protection_Level                    OTP_ID(499, 496) 
#define OTP_CM_level                                  OTP_ID(503, 500) 
#define OTP_Boot_Type_sel                             OTP_ID(515, 512) 
#define OTP_Boot_Type                                 OTP_ID(519, 516) 
#define OTP_Secure_Boot_Type                          OTP_ID(523, 520) 
#define OTP_OTP_Clock_Selection                       OTP_ID(527, 524) 
#define OTP_secure_rbus                               OTP_ID(535, 532) 
#define OTP_RuntimeCodeCheck_Unit                     OTP_ID(544, 544) 
#define OTP_RDBUS_CLK_SRC_SEL                         OTP_ID(551, 550) 
#define OTP_NAND_FLASH_BOOT_TYPE                      OTP_ID(553, 552) 
#define OTP_SCPU_CLK_SRC_SEL                          OTP_ID(555, 554) 
#define OTP_TP_CW_RD_CTRL                             OTP_ID(559, 556) 
#define OTP_Power_Monitor_En                          OTP_ID(563, 560) 
#define OTP_XTAL_Monitor_En                           OTP_ID(567, 564) 
#define OTP_EJTAG_HIF_PlugIn_Detect_En                OTP_ID(571, 568) 
#define OTP_XTAL_detection_range                      OTP_ID(573, 572) 
#define OTP_Mem_Obf_En                                OTP_ID(579, 576) 
#define OTP_PROG_CTRL                                 OTP_ID(583, 580) 
#define OTP_mcu_prog_lock_en                          OTP_ID(587, 584) 
#define OTP_otp_test_mode_disable                     OTP_ID(591, 588) 
#define OTP_crc_restriction                           OTP_ID(595, 592) 
#define OTP_PCMCIA_Disable                            OTP_ID(611, 608) 
#define OTP_eMMC_Disable                              OTP_ID(615, 612) 
#define OTP_CR_Disable                                OTP_ID(619, 616) 
#define OTP_SC_Disable                                OTP_ID(623, 620) 
#define OTP_ETN_Disable                               OTP_ID(627, 624) 
#define OTP_USB2_p0_Disable                           OTP_ID(631, 628) 
#define OTP_USB2_p1_Disable                           OTP_ID(635, 632) 
#define OTP_USB2_p2_Disable                           OTP_ID(639, 636) 
#define OTP_USB2_p3_Disable                           OTP_ID(643, 640) 
#define OTP_USB3_Disable                              OTP_ID(647, 644) 
#define OTP_UART0_Disable                             OTP_ID(675, 672) 
#define OTP_UART1_Disable                             OTP_ID(679, 676) 
#define OTP_UART2_Disable                             OTP_ID(683, 680) 
#define OTP_UART2BUS_Disable                          OTP_ID(687, 684) 
#define OTP_KCPU_Only_EJTAG_Disable                   OTP_ID(691, 688) 
#define OTP_MAIN_EJTAG_Disable                        OTP_ID(695, 692) 
#define OTP_UARTDMA_Disable                           OTP_ID(699, 696) 
#define OTP_EMCU_UART2BUS_Disable                     OTP_ID(703, 700) 
#define OTP_SHIF_Disable                              OTP_ID(707, 704) 
#define OTP_PHIF_Disable                              OTP_ID(711, 708) 
#define OTP_UART2BUS_ACC_DP_Disable                   OTP_ID(713, 712) 
#define OTP_EMCU_JTAG_Disable                         OTP_ID(717, 714) 
#define OTP_CPU_Secure_DBGEN_N                        OTP_ID(743, 740) 
#define OTP_CPU_DBGEN_N                               OTP_ID(747, 744) 
#define OTP_PIN_DBGEN_N                               OTP_ID(751, 748) 
#define OTP_ALL_SCAN_Disable                          OTP_ID(755, 752) 
#define OTP_PORL_EJTAG_Disable                        OTP_ID(759, 756) 
#define OTP_DI_SRAM_Secure                            OTP_ID(763, 760) 
#define OTP_OTP_password                              OTP_ID(895, 768) 
#define OTP_password_sel                              OTP_ID(897, 896) 
#define OTP_password_compare_fail_sel                 OTP_ID(898, 898) 
#define OTP_gpu_num_ori                               OTP_ID(928, 928) 
#define OTP_scpu_num_ori                              OTP_ID(929, 929) 
#define OTP_hdr_disable_ori                           OTP_ID(931, 930) 
#define OTP_Technicolor_disable_ori                   OTP_ID(932, 932) 
#define OTP_BTSC_disable_ori                          OTP_ID(933, 933) 
#define OTP_LGD_M_plus_disable_ori                    OTP_ID(934, 934) 
#define OTP_Altobeam_Demod_disable_ori                OTP_ID(935, 935) 
#define OTP_RM_RMVB_disable_ori                       OTP_ID(936, 936) 
#define OTP_MEMC_disable_ori                          OTP_ID(937, 937) 
#define OTP_YYG_RGBW_IP_disable_ori                   OTP_ID(938, 938) 
#define OTP_Siliconworks_RGBW_IP_disable_ori          OTP_ID(939, 939) 
#define OTP_VE_DIVX3_disable_ori                      OTP_ID(940, 940) 
#define OTP_dtv_qam_disable_ori                       OTP_ID(941, 941) 
#define OTP_hdic_disable_ori                          OTP_ID(942, 942) 
#define OTP_nnip_disable_ori                          OTP_ID(943, 943) 
#define OTP_hdr10p_disable_ori                        OTP_ID(944, 944) 
#define OTP_function_config_SW_0_ori                  OTP_ID(991, 960) 
#define OTP_function_config_SW_1_ori                  OTP_ID(1023, 992) 
#define OTP_function_config_SW_2_ori                  OTP_ID(1055, 1024) 
#define OTP_gpu_num_remk                              OTP_ID(1088, 1088) 
#define OTP_scpu_num_remk                             OTP_ID(1089, 1089) 
#define OTP_hdr_disable_remk                          OTP_ID(1091, 1090) 
#define OTP_Technicolor_disable_remk                  OTP_ID(1092, 1092) 
#define OTP_BTSC_disable_remk                         OTP_ID(1093, 1093) 
#define OTP_LGD_M_plus_disable_remk                   OTP_ID(1094, 1094) 
#define OTP_Altobeam_Demod_disable_remk               OTP_ID(1095, 1095) 
#define OTP_RM_RMVB_disable_remk                      OTP_ID(1096, 1096) 
#define OTP_MEMC_disable_remk                         OTP_ID(1097, 1097) 
#define OTP_YYG_RGBW_IP_disable_remk                  OTP_ID(1098, 1098) 
#define OTP_Siliconworks_RGBW_IP_disable_remk         OTP_ID(1099, 1099) 
#define OTP_VE_DIVX3_disable_remk                     OTP_ID(1100, 1100) 
#define OTP_dtv_qam_disable_remk                      OTP_ID(1101, 1101) 
#define OTP_hdic_disable_remk                         OTP_ID(1102, 1102) 
#define OTP_nnip_disable_remk                         OTP_ID(1103, 1103) 
#define OTP_hdr10p_disable_remk                       OTP_ID(1104, 1104) 
#define OTP_function_config_SW_0_remk                 OTP_ID(1151, 1120) 
#define OTP_function_config_SW_1_remk                 OTP_ID(1183, 1152) 
#define OTP_function_config_SW_2_remk                 OTP_ID(1215, 1184) 
#define OTP_remark_en                                 OTP_ID(1247, 1247) 
#define OTP_DDR_info                                  OTP_ID(1279, 1248) 
#define OTP_ROSC_PAR                                  OTP_ID(1287, 1280) 
#define OTP_Wafer_Info_X                              OTP_ID(1319, 1312) 
#define OTP_Wafer_Info_Y                              OTP_ID(1327, 1320) 
#define OTP_Wafer_Info_Lot_ID                         OTP_ID(1380, 1328) 
#define OTP_Wafer_Info_CRC                            OTP_ID(1391, 1381) 
#define OTP_Disable_Recovery_Function                 OTP_ID(1409, 1408) 
#define OTP_Disable_Show_Error_Msg                    OTP_ID(1411, 1410) 
#define OTP_Enable_Radom_delay_when_Error_Reset       OTP_ID(1413, 1412) 
#define OTP_Disable_quick_boot_mode                   OTP_ID(1415, 1414) 
#define OTP_Enable_nandflash_profile                  OTP_ID(1417, 1416) 
#define OTP_BC_Versioning_REF                         OTP_ID(1471, 1440) 
#define OTP_AUX_Versioning_REF                        OTP_ID(1503, 1472) 
#define OTP_Thermal_Meter_PAR                         OTP_ID(1512, 1504) 
#define OTP_RINT_PAR                                  OTP_ID(1519, 1513) 
#define OTP_CEC_PAR                                   OTP_ID(1523, 1520) 
#define OTP_CBUS_TX_PAR                               OTP_ID(1527, 1524) 
#define OTP_USB_SWING_LEVEL                           OTP_ID(1550, 1534) 
#define OTP_USB                                       OTP_ID(1567, 1551) 
#define OTP_DAC                                       OTP_ID(1598, 1568) 
#define OTP_HDMI                                      OTP_ID(1631, 1600) 
#define OTP_USB_DISCONNECT_LEVEL                      OTP_ID(1663, 1632) 
#define OTP_IDDQ                                      OTP_ID(1681, 1664) 
#define OTP_FT_SVT_PLL3                               OTP_ID(1700, 1694) 
#define OTP_FT_SVT_HVS                                OTP_ID(1726, 1701) 
#define OTP_PIF_Swing_calibration                     OTP_ID(1855, 1728) 
#define OTP_PIF_Driving_Current                       OTP_ID(1951, 1856) 
#define OTP_RSA_HASH_VALUE                            OTP_ID(2207, 1952) 
#define OTP_RSA_HASH_VALUE_REMK                       OTP_ID(2463, 2208) 
#define OTP_package_info                              OTP_ID(2479, 2472) 
#define OTP_mp_status_FT                              OTP_ID(2495, 2480) 
#define OTP_ROM_PATCH_0                               OTP_ID(2559, 2496) 
#define OTP_ROM_PATCH_1                               OTP_ID(2623, 2560) 
#define OTP_ROM_PATCH_2                               OTP_ID(2687, 2624) 
#define OTP_ROM_PATCH_3                               OTP_ID(2751, 2688) 
#define OTP_ROM_PATCH_4                               OTP_ID(2815, 2752) 
#define OTP_ROM_PATCH_5                               OTP_ID(2879, 2816) 
#define OTP_ROM_PATCH_6                               OTP_ID(2943, 2880) 
#define OTP_CP_SVT_HVS                                OTP_ID(2962, 2944) 
#define OTP_CP_SVT_GPIO                               OTP_ID(2969, 2963) 
#define OTP_CP_SVT_PLL3                               OTP_ID(2976, 2970) 
#define OTP_mp_status_CP                              OTP_ID(2985, 2977) 
#define OTP_mp_status_FT2                             OTP_ID(3071, 3040) 
#define OTP_customer_key_0                            OTP_ID(3199, 3072) 
#define OTP_customer_key_1                            OTP_ID(3327, 3200) 
#define OTP_customer_key_2                            OTP_ID(3455, 3328) 
#define OTP_customer_key_3                            OTP_ID(3583, 3456) 
#define OTP_customer_key_4                            OTP_ID(3711, 3584) 
#define OTP_customer_key_5                            OTP_ID(3839, 3712) 
#define OTP_customer_key_6                            OTP_ID(3967, 3840) 
#define OTP_customer_key_7                            OTP_ID(4095, 3968) 
#define OTP_BITMAP_SIZE  4096

#endif // __OTP_ID_H__

