#include <malloc.h>
#include <common.h>
#include <asm/arch/system.h>
#include <drivers/otp/rtk_otp_util.h>
#include <drivers/otp/rtk_otp_region.h>
#include <drivers/otp/rtk_otp_region_api.h>
bool is_NNIP_function_disable(void)
{
    bool ret = false;
    unsigned char data = 0;
    if(rtk_otp_region_read(OTP_REGION_REMARK_EN, &data, 1) != 0)
        goto EXIT;
    
    if(data) {
        data = 0;
        if(rtk_otp_region_read(OTP_REGION_NNIP_DISABLE_REMK, &data, 1) != 0)
            goto EXIT;
    } else {
        data = 0;
        if(rtk_otp_region_read(OTP_REGION_NNIP_DISABLE_ORI, &data, 1) != 0)
            goto EXIT;
    }
    if(data)
        ret = true;

EXIT:
    return ret; 
}

bool rtk_get_ddr_info(unsigned int *p_ddr_info)
{
    bool ret = false;
    
    if(!p_ddr_info)
	return ret;

    if(rtk_otp_region_read(OTP_REGION_DDR_INFO, (unsigned char *)p_ddr_info, 4) == 0)
        ret = true;

    return ret;
}


bool rtk_get_iddq_done(unsigned int *p_iddq_done)
{
    bool ret = false;
    
    if(!p_iddq_done)
	return ret;

    if(rtk_otp_region_read(OTP_REGION_IDDQ_DONE, (unsigned char *)p_iddq_done, 4) == 0)
        ret = true;

    return ret;
}

bool rtk_get_core_iddq(unsigned int *p_core_iddq)
{
    bool ret = false;
    
    if(!p_core_iddq)
	return ret;

    if(rtk_otp_region_read(OTP_REGION_CORE_IDDQ, (unsigned char *)p_core_iddq, 4) == 0)
        ret = true;

    return ret;
}


bool rtk_otp_field_read(OTP_FIELD_ID field_id, unsigned char *data, unsigned int len)
{
    bool ret = false;

    if(!data || !len)
        return ret;

    switch(field_id) {
    case OTP_FIELD_EMMC_FLASH_ENABLE_BOOT_PAK:
        ret = (rtk_otp_region_read(OTP_REGION_EMMC_FLASH_ENABLE_BOOT_PAK, data, len) == 0) ? true : false;
        break;
    case OTP_FIELD_ETN_INTERNAL_ANALOG_LDO:
        ret = (rtk_otp_region_read(OTP_REGION_ETN_INTERNAL_ANALOG_LDO, data, len) == 0) ? true : false;
        break;
    case OTP_FIELD_ETN_INTERNAL_DIGITAL_LDO:
        ret = (rtk_otp_region_read(OTP_REGION_ETN_INTERNAL_DIGITAL_LDO, data, len) == 0) ? true : false;
        break;
    case OTP_FIELD_EMMC_LDO_TRIM_INFO:
        ret = (rtk_otp_region_read(OTP_REGION_EMMC_LDO_TRIM_INFO, data, len) == 0) ? true : false;
        break;    
    default:
        ret = false;
        break;
    }
    
    return ret;
}