#ifndef __RTK_MENU_H__
#define __RTK_MENU_H__

#define MENU_LEVEL_MAX (10) //at most 10 level menus
#define MENU_NAME_LEN (32) //max length for menu name show in path

#define FRED_START "\033[1;31;40m"
#define FGREEN_START "\033[1;32;40m"
#define FYELLOW_START "\033[1;33;40m"
#define FBLUE_START "\033[1;34;40m"
#define FCOLOR_END "\033[0m"

#define DBG_DFT(format, ...) do{ printf(format, ##__VA_ARGS__); }while(0)
#define DBG_RED(format, ...) do{ printf(FRED_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_GREEN(format, ...) do{ printf(FGREEN_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_YELLOW(format, ...) do{ printf(FYELLOW_START format FCOLOR_END, ##__VA_ARGS__); }while(0)
#define DBG_BLUE(format, ...) do{ printf(FBLUE_START format FCOLOR_END, ##__VA_ARGS__); }while(0)

typedef struct rtk_setmenu
{
    char * name;//name
    char * desc;//description
    int (*func)(void);//name
    struct rtk_setmenu * father;//father menu
}rtk_setmenu;

typedef struct rtk_menu_state
{
    rtk_setmenu * menu;
    int level;
    char path[MENU_LEVEL_MAX][MENU_NAME_LEN];
} rtk_menu_state;

void rtk_prepare_go_ahead(rtk_menu_state * p);
void rtk_prepare_go_back(rtk_menu_state * p);
void rtk_show_menu(rtk_setmenu * p);
void rtk_show_now_path(rtk_menu_state * p);
int rtk_get_menu_len(rtk_setmenu * p);
void rtk_menu_wait(rtk_menu_state * p);
int rtk_go_up_menu(rtk_menu_state * p);
int rtk_go_menu_exit(void);

extern int gets(char *s);
extern int fgets(char *s, int n);
extern void *malloc(size_t size);
extern void free(void *ptr);
extern char *getenv(const char *name);
extern int setenv(const char *varname, const char *varvalue);
#endif
