/**
* @file Merlin6-DesignSpec-D-Domain_SDEMURA
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SDEMURA_REG_H_
#define _RBUS_SDEMURA_REG_H_

#include "rbus_types.h"



//  SDEMURA Register Address
#define  SDEMURA_SDEMURA_CTRL                                                   0x181C1000
#define  SDEMURA_SDEMURA_CTRL_reg_addr                                           "0xB81C1000"
#define  SDEMURA_SDEMURA_CTRL_reg                                                0xB81C1000
#define  SDEMURA_SDEMURA_CTRL_inst_addr                                          "0x0000"
#define  set_SDEMURA_SDEMURA_CTRL_reg(data)                                      (*((volatile unsigned int*)SDEMURA_SDEMURA_CTRL_reg)=data)
#define  get_SDEMURA_SDEMURA_CTRL_reg                                            (*((volatile unsigned int*)SDEMURA_SDEMURA_CTRL_reg))
#define  SDEMURA_SDEMURA_CTRL_table_pre_load_sel_shift                           (4)
#define  SDEMURA_SDEMURA_CTRL_arb_en_1_shift                                     (3)
#define  SDEMURA_SDEMURA_CTRL_arb_en_0_shift                                     (2)
#define  SDEMURA_SDEMURA_CTRL_sdemura_double_buffer_apply_shift                  (1)
#define  SDEMURA_SDEMURA_CTRL_sdemura_disable_shift                              (0)
#define  SDEMURA_SDEMURA_CTRL_table_pre_load_sel_mask                            (0x000001F0)
#define  SDEMURA_SDEMURA_CTRL_arb_en_1_mask                                      (0x00000008)
#define  SDEMURA_SDEMURA_CTRL_arb_en_0_mask                                      (0x00000004)
#define  SDEMURA_SDEMURA_CTRL_sdemura_double_buffer_apply_mask                   (0x00000002)
#define  SDEMURA_SDEMURA_CTRL_sdemura_disable_mask                               (0x00000001)
#define  SDEMURA_SDEMURA_CTRL_table_pre_load_sel(data)                           (0x000001F0&((data)<<4))
#define  SDEMURA_SDEMURA_CTRL_arb_en_1(data)                                     (0x00000008&((data)<<3))
#define  SDEMURA_SDEMURA_CTRL_arb_en_0(data)                                     (0x00000004&((data)<<2))
#define  SDEMURA_SDEMURA_CTRL_sdemura_double_buffer_apply(data)                  (0x00000002&((data)<<1))
#define  SDEMURA_SDEMURA_CTRL_sdemura_disable(data)                              (0x00000001&(data))
#define  SDEMURA_SDEMURA_CTRL_get_table_pre_load_sel(data)                       ((0x000001F0&(data))>>4)
#define  SDEMURA_SDEMURA_CTRL_get_arb_en_1(data)                                 ((0x00000008&(data))>>3)
#define  SDEMURA_SDEMURA_CTRL_get_arb_en_0(data)                                 ((0x00000004&(data))>>2)
#define  SDEMURA_SDEMURA_CTRL_get_sdemura_double_buffer_apply(data)              ((0x00000002&(data))>>1)
#define  SDEMURA_SDEMURA_CTRL_get_sdemura_disable(data)                          (0x00000001&(data))

#define  SDEMURA_SDEMUA_TIMING_CTL                                              0x181C1004
#define  SDEMURA_SDEMUA_TIMING_CTL_reg_addr                                      "0xB81C1004"
#define  SDEMURA_SDEMUA_TIMING_CTL_reg                                           0xB81C1004
#define  SDEMURA_SDEMUA_TIMING_CTL_inst_addr                                     "0x0001"
#define  set_SDEMURA_SDEMUA_TIMING_CTL_reg(data)                                 (*((volatile unsigned int*)SDEMURA_SDEMUA_TIMING_CTL_reg)=data)
#define  get_SDEMURA_SDEMUA_TIMING_CTL_reg                                       (*((volatile unsigned int*)SDEMURA_SDEMUA_TIMING_CTL_reg))
#define  SDEMURA_SDEMUA_TIMING_CTL_sdemura_dummy_shift                           (5)
#define  SDEMURA_SDEMUA_TIMING_CTL_hsync_cntr_shift                              (0)
#define  SDEMURA_SDEMUA_TIMING_CTL_sdemura_dummy_mask                            (0xFFFFFFE0)
#define  SDEMURA_SDEMUA_TIMING_CTL_hsync_cntr_mask                               (0x0000001F)
#define  SDEMURA_SDEMUA_TIMING_CTL_sdemura_dummy(data)                           (0xFFFFFFE0&((data)<<5))
#define  SDEMURA_SDEMUA_TIMING_CTL_hsync_cntr(data)                              (0x0000001F&(data))
#define  SDEMURA_SDEMUA_TIMING_CTL_get_sdemura_dummy(data)                       ((0xFFFFFFE0&(data))>>5)
#define  SDEMURA_SDEMUA_TIMING_CTL_get_hsync_cntr(data)                          (0x0000001F&(data))

#define  SDEMURA_SDEMURA_TIMING_SEL                                             0x181C1008
#define  SDEMURA_SDEMURA_TIMING_SEL_reg_addr                                     "0xB81C1008"
#define  SDEMURA_SDEMURA_TIMING_SEL_reg                                          0xB81C1008
#define  SDEMURA_SDEMURA_TIMING_SEL_inst_addr                                    "0x0002"
#define  set_SDEMURA_SDEMURA_TIMING_SEL_reg(data)                                (*((volatile unsigned int*)SDEMURA_SDEMURA_TIMING_SEL_reg)=data)
#define  get_SDEMURA_SDEMURA_TIMING_SEL_reg                                      (*((volatile unsigned int*)SDEMURA_SDEMURA_TIMING_SEL_reg))
#define  SDEMURA_SDEMURA_TIMING_SEL_dummy_31_3_shift                             (3)
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_user_timing_sel_shift                (2)
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_auto_detect_result_shift             (1)
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_auto_detect_en_shift                 (0)
#define  SDEMURA_SDEMURA_TIMING_SEL_dummy_31_3_mask                              (0xFFFFFFF8)
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_user_timing_sel_mask                 (0x00000004)
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_auto_detect_result_mask              (0x00000002)
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_auto_detect_en_mask                  (0x00000001)
#define  SDEMURA_SDEMURA_TIMING_SEL_dummy_31_3(data)                             (0xFFFFFFF8&((data)<<3))
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_user_timing_sel(data)                (0x00000004&((data)<<2))
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_auto_detect_result(data)             (0x00000002&((data)<<1))
#define  SDEMURA_SDEMURA_TIMING_SEL_sdemura_auto_detect_en(data)                 (0x00000001&(data))
#define  SDEMURA_SDEMURA_TIMING_SEL_get_dummy_31_3(data)                         ((0xFFFFFFF8&(data))>>3)
#define  SDEMURA_SDEMURA_TIMING_SEL_get_sdemura_user_timing_sel(data)            ((0x00000004&(data))>>2)
#define  SDEMURA_SDEMURA_TIMING_SEL_get_sdemura_auto_detect_result(data)         ((0x00000002&(data))>>1)
#define  SDEMURA_SDEMURA_TIMING_SEL_get_sdemura_auto_detect_en(data)             (0x00000001&(data))

#define  SDEMURA_SDEMURA_RM                                                     0x181C1010
#define  SDEMURA_SDEMURA_RM_reg_addr                                             "0xB81C1010"
#define  SDEMURA_SDEMURA_RM_reg                                                  0xB81C1010
#define  SDEMURA_SDEMURA_RM_inst_addr                                            "0x0003"
#define  set_SDEMURA_SDEMURA_RM_reg(data)                                        (*((volatile unsigned int*)SDEMURA_SDEMURA_RM_reg)=data)
#define  get_SDEMURA_SDEMURA_RM_reg                                              (*((volatile unsigned int*)SDEMURA_SDEMURA_RM_reg))
#define  SDEMURA_SDEMURA_RM_sdemura_rm_4_0_shift                                 (24)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_3_0_shift                                 (20)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_2_0_shift                                 (16)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_1_0_shift                                 (12)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_2_shift                                 (8)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_1_shift                                 (4)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_0_shift                                 (0)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_4_0_mask                                  (0x0F000000)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_3_0_mask                                  (0x00F00000)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_2_0_mask                                  (0x000F0000)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_1_0_mask                                  (0x0000F000)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_2_mask                                  (0x00000F00)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_1_mask                                  (0x000000F0)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_0_mask                                  (0x0000000F)
#define  SDEMURA_SDEMURA_RM_sdemura_rm_4_0(data)                                 (0x0F000000&((data)<<24))
#define  SDEMURA_SDEMURA_RM_sdemura_rm_3_0(data)                                 (0x00F00000&((data)<<20))
#define  SDEMURA_SDEMURA_RM_sdemura_rm_2_0(data)                                 (0x000F0000&((data)<<16))
#define  SDEMURA_SDEMURA_RM_sdemura_rm_1_0(data)                                 (0x0000F000&((data)<<12))
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_2(data)                                 (0x00000F00&((data)<<8))
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_1(data)                                 (0x000000F0&((data)<<4))
#define  SDEMURA_SDEMURA_RM_sdemura_rm_0_0(data)                                 (0x0000000F&(data))
#define  SDEMURA_SDEMURA_RM_get_sdemura_rm_4_0(data)                             ((0x0F000000&(data))>>24)
#define  SDEMURA_SDEMURA_RM_get_sdemura_rm_3_0(data)                             ((0x00F00000&(data))>>20)
#define  SDEMURA_SDEMURA_RM_get_sdemura_rm_2_0(data)                             ((0x000F0000&(data))>>16)
#define  SDEMURA_SDEMURA_RM_get_sdemura_rm_1_0(data)                             ((0x0000F000&(data))>>12)
#define  SDEMURA_SDEMURA_RM_get_sdemura_rm_0_2(data)                             ((0x00000F00&(data))>>8)
#define  SDEMURA_SDEMURA_RM_get_sdemura_rm_0_1(data)                             ((0x000000F0&(data))>>4)
#define  SDEMURA_SDEMURA_RM_get_sdemura_rm_0_0(data)                             (0x0000000F&(data))

#define  SDEMURA_SDEMURA_RME_LS                                                 0x181C1014
#define  SDEMURA_SDEMURA_RME_LS_reg_addr                                         "0xB81C1014"
#define  SDEMURA_SDEMURA_RME_LS_reg                                              0xB81C1014
#define  SDEMURA_SDEMURA_RME_LS_inst_addr                                        "0x0004"
#define  set_SDEMURA_SDEMURA_RME_LS_reg(data)                                    (*((volatile unsigned int*)SDEMURA_SDEMURA_RME_LS_reg)=data)
#define  get_SDEMURA_SDEMURA_RME_LS_reg                                          (*((volatile unsigned int*)SDEMURA_SDEMURA_RME_LS_reg))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_4_0_shift                             (22)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_3_0_shift                             (21)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_2_0_shift                             (20)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_1_0_shift                             (19)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_2_shift                             (18)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_1_shift                             (17)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_0_shift                             (16)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_4_0_shift                            (6)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_3_0_shift                            (5)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_2_0_shift                            (4)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_1_0_shift                            (3)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_2_shift                            (2)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_1_shift                            (1)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_0_shift                            (0)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_4_0_mask                              (0x00400000)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_3_0_mask                              (0x00200000)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_2_0_mask                              (0x00100000)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_1_0_mask                              (0x00080000)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_2_mask                              (0x00040000)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_1_mask                              (0x00020000)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_0_mask                              (0x00010000)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_4_0_mask                             (0x00000040)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_3_0_mask                             (0x00000020)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_2_0_mask                             (0x00000010)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_1_0_mask                             (0x00000008)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_2_mask                             (0x00000004)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_1_mask                             (0x00000002)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_0_mask                             (0x00000001)
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_4_0(data)                             (0x00400000&((data)<<22))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_3_0(data)                             (0x00200000&((data)<<21))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_2_0(data)                             (0x00100000&((data)<<20))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_1_0(data)                             (0x00080000&((data)<<19))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_2(data)                             (0x00040000&((data)<<18))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_1(data)                             (0x00020000&((data)<<17))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_ls_0_0(data)                             (0x00010000&((data)<<16))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_4_0(data)                            (0x00000040&((data)<<6))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_3_0(data)                            (0x00000020&((data)<<5))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_2_0(data)                            (0x00000010&((data)<<4))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_1_0(data)                            (0x00000008&((data)<<3))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_2(data)                            (0x00000004&((data)<<2))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_1(data)                            (0x00000002&((data)<<1))
#define  SDEMURA_SDEMURA_RME_LS_sdemura_rme_0_0(data)                            (0x00000001&(data))
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_ls_4_0(data)                         ((0x00400000&(data))>>22)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_ls_3_0(data)                         ((0x00200000&(data))>>21)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_ls_2_0(data)                         ((0x00100000&(data))>>20)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_ls_1_0(data)                         ((0x00080000&(data))>>19)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_ls_0_2(data)                         ((0x00040000&(data))>>18)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_ls_0_1(data)                         ((0x00020000&(data))>>17)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_ls_0_0(data)                         ((0x00010000&(data))>>16)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_rme_4_0(data)                        ((0x00000040&(data))>>6)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_rme_3_0(data)                        ((0x00000020&(data))>>5)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_rme_2_0(data)                        ((0x00000010&(data))>>4)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_rme_1_0(data)                        ((0x00000008&(data))>>3)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_rme_0_2(data)                        ((0x00000004&(data))>>2)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_rme_0_1(data)                        ((0x00000002&(data))>>1)
#define  SDEMURA_SDEMURA_RME_LS_get_sdemura_rme_0_0(data)                        (0x00000001&(data))

#define  SDEMURA_SDEMURA_TEST1                                                  0x181C1018
#define  SDEMURA_SDEMURA_TEST1_reg_addr                                          "0xB81C1018"
#define  SDEMURA_SDEMURA_TEST1_reg                                               0xB81C1018
#define  SDEMURA_SDEMURA_TEST1_inst_addr                                         "0x0005"
#define  set_SDEMURA_SDEMURA_TEST1_reg(data)                                     (*((volatile unsigned int*)SDEMURA_SDEMURA_TEST1_reg)=data)
#define  get_SDEMURA_SDEMURA_TEST1_reg                                           (*((volatile unsigned int*)SDEMURA_SDEMURA_TEST1_reg))
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_4_0_shift                           (6)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_3_0_shift                           (5)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_2_0_shift                           (4)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_1_0_shift                           (3)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_2_shift                           (2)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_1_shift                           (1)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_0_shift                           (0)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_4_0_mask                            (0x00000040)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_3_0_mask                            (0x00000020)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_2_0_mask                            (0x00000010)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_1_0_mask                            (0x00000008)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_2_mask                            (0x00000004)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_1_mask                            (0x00000002)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_0_mask                            (0x00000001)
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_4_0(data)                           (0x00000040&((data)<<6))
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_3_0(data)                           (0x00000020&((data)<<5))
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_2_0(data)                           (0x00000010&((data)<<4))
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_1_0(data)                           (0x00000008&((data)<<3))
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_2(data)                           (0x00000004&((data)<<2))
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_1(data)                           (0x00000002&((data)<<1))
#define  SDEMURA_SDEMURA_TEST1_sdemura_test1_0_0(data)                           (0x00000001&(data))
#define  SDEMURA_SDEMURA_TEST1_get_sdemura_test1_4_0(data)                       ((0x00000040&(data))>>6)
#define  SDEMURA_SDEMURA_TEST1_get_sdemura_test1_3_0(data)                       ((0x00000020&(data))>>5)
#define  SDEMURA_SDEMURA_TEST1_get_sdemura_test1_2_0(data)                       ((0x00000010&(data))>>4)
#define  SDEMURA_SDEMURA_TEST1_get_sdemura_test1_1_0(data)                       ((0x00000008&(data))>>3)
#define  SDEMURA_SDEMURA_TEST1_get_sdemura_test1_0_2(data)                       ((0x00000004&(data))>>2)
#define  SDEMURA_SDEMURA_TEST1_get_sdemura_test1_0_1(data)                       ((0x00000002&(data))>>1)
#define  SDEMURA_SDEMURA_TEST1_get_sdemura_test1_0_0(data)                       (0x00000001&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SDEMURA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  table_pre_load_sel:5;
        RBus_UInt32  arb_en_1:1;
        RBus_UInt32  arb_en_0:1;
        RBus_UInt32  sdemura_double_buffer_apply:1;
        RBus_UInt32  sdemura_disable:1;
    };
}sdemura_sdemura_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sdemura_dummy:27;
        RBus_UInt32  hsync_cntr:5;
    };
}sdemura_sdemua_timing_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy181c1008_31_3:29;
        RBus_UInt32  sdemura_user_timing_sel:1;
        RBus_UInt32  sdemura_auto_detect_result:1;
        RBus_UInt32  sdemura_auto_detect_en:1;
    };
}sdemura_sdemura_timing_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  sdemura_rm_4_0:4;
        RBus_UInt32  sdemura_rm_3_0:4;
        RBus_UInt32  sdemura_rm_2_0:4;
        RBus_UInt32  sdemura_rm_1_0:4;
        RBus_UInt32  sdemura_rm_0_2:4;
        RBus_UInt32  sdemura_rm_0_1:4;
        RBus_UInt32  sdemura_rm_0_0:4;
    };
}sdemura_sdemura_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  sdemura_ls_4_0:1;
        RBus_UInt32  sdemura_ls_3_0:1;
        RBus_UInt32  sdemura_ls_2_0:1;
        RBus_UInt32  sdemura_ls_1_0:1;
        RBus_UInt32  sdemura_ls_0_2:1;
        RBus_UInt32  sdemura_ls_0_1:1;
        RBus_UInt32  sdemura_ls_0_0:1;
        RBus_UInt32  res2:9;
        RBus_UInt32  sdemura_rme_4_0:1;
        RBus_UInt32  sdemura_rme_3_0:1;
        RBus_UInt32  sdemura_rme_2_0:1;
        RBus_UInt32  sdemura_rme_1_0:1;
        RBus_UInt32  sdemura_rme_0_2:1;
        RBus_UInt32  sdemura_rme_0_1:1;
        RBus_UInt32  sdemura_rme_0_0:1;
    };
}sdemura_sdemura_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  sdemura_test1_4_0:1;
        RBus_UInt32  sdemura_test1_3_0:1;
        RBus_UInt32  sdemura_test1_2_0:1;
        RBus_UInt32  sdemura_test1_1_0:1;
        RBus_UInt32  sdemura_test1_0_2:1;
        RBus_UInt32  sdemura_test1_0_1:1;
        RBus_UInt32  sdemura_test1_0_0:1;
    };
}sdemura_sdemura_test1_RBUS;

#else //apply LITTLE_ENDIAN

//======SDEMURA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sdemura_disable:1;
        RBus_UInt32  sdemura_double_buffer_apply:1;
        RBus_UInt32  arb_en_0:1;
        RBus_UInt32  arb_en_1:1;
        RBus_UInt32  table_pre_load_sel:5;
        RBus_UInt32  res1:23;
    };
}sdemura_sdemura_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hsync_cntr:5;
        RBus_UInt32  sdemura_dummy:27;
    };
}sdemura_sdemua_timing_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sdemura_auto_detect_en:1;
        RBus_UInt32  sdemura_auto_detect_result:1;
        RBus_UInt32  sdemura_user_timing_sel:1;
        RBus_UInt32  dummy181c1008_31_3:29;
    };
}sdemura_sdemura_timing_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sdemura_rm_0_0:4;
        RBus_UInt32  sdemura_rm_0_1:4;
        RBus_UInt32  sdemura_rm_0_2:4;
        RBus_UInt32  sdemura_rm_1_0:4;
        RBus_UInt32  sdemura_rm_2_0:4;
        RBus_UInt32  sdemura_rm_3_0:4;
        RBus_UInt32  sdemura_rm_4_0:4;
        RBus_UInt32  res1:4;
    };
}sdemura_sdemura_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sdemura_rme_0_0:1;
        RBus_UInt32  sdemura_rme_0_1:1;
        RBus_UInt32  sdemura_rme_0_2:1;
        RBus_UInt32  sdemura_rme_1_0:1;
        RBus_UInt32  sdemura_rme_2_0:1;
        RBus_UInt32  sdemura_rme_3_0:1;
        RBus_UInt32  sdemura_rme_4_0:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  sdemura_ls_0_0:1;
        RBus_UInt32  sdemura_ls_0_1:1;
        RBus_UInt32  sdemura_ls_0_2:1;
        RBus_UInt32  sdemura_ls_1_0:1;
        RBus_UInt32  sdemura_ls_2_0:1;
        RBus_UInt32  sdemura_ls_3_0:1;
        RBus_UInt32  sdemura_ls_4_0:1;
        RBus_UInt32  res2:9;
    };
}sdemura_sdemura_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sdemura_test1_0_0:1;
        RBus_UInt32  sdemura_test1_0_1:1;
        RBus_UInt32  sdemura_test1_0_2:1;
        RBus_UInt32  sdemura_test1_1_0:1;
        RBus_UInt32  sdemura_test1_2_0:1;
        RBus_UInt32  sdemura_test1_3_0:1;
        RBus_UInt32  sdemura_test1_4_0:1;
        RBus_UInt32  res1:25;
    };
}sdemura_sdemura_test1_RBUS;




#endif 


#endif 
